unit ApertureGrid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids,
   MainForm, OptSurface,OptMedium,MayMath;

type
  TApertureForm = class(TForm)
    StringGrid1: TStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure StringGrid1DblClick(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Draw;
    procedure Fix;

  public
    { Public 錾 }
    procedure RefreshDraw;
  end;

var
  ApertureForm: TApertureForm;

implementation

{$R *.dfm}


procedure TApertureForm.Draw;
var row :integer;
begin
  for row:=1 to (OpticalSystem.TotalSurfaceNumber) do begin
    StringGrid1.Cells[0,row]:=' '+IntToStr(row) + ' ';
  end;

  StringGrid1.Cells[1,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    if OpticalSystem.OpticalSurface[row].ApfigureSwitch=true then begin
      StringGrid1.Cells[1,row]:='True';
    end else begin
      StringGrid1.Cells[1,row]:='False';
    end;
  end;

  StringGrid1.Cells[2,0]:='J`';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin

    if (OpticalSystem.OpticalSurface[row].ApertureFigure=Round) then
      StringGrid1.Cells[2,row]:='Round'
      else if OpticalSystem.OpticalSurface[row].ApertureFigure=Rect then
        StringGrid1.Cells[2,row]:='Rect'
          else if OpticalSystem.OpticalSurface[row].ApertureFigure=Oval then
            StringGrid1.Cells[2,row]:='Oval'
              else if OpticalSystem.OpticalSurface[row].ApertureFigure=UpperOval then
                StringGrid1.Cells[2,row]:='UpperOval'
                  else begin
                  end;
  end;

  StringGrid1.Cells[3,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[3,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].ApertureY);
  end;
  StringGrid1.Cells[4,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[4,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].ApertureZ);
  end;
  StringGrid1.Cells[5,0]:='VtgY';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[5,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].ApertureSiftY);
  end;
  StringGrid1.Cells[6,0]:='VtgZ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[6,row]:=FloatToStr(OpticalSystem.OpticalSurface[row].ApertureSiftZ);
  end;
  StringGrid1.Cells[7,0]:='Xp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[7,row]:=FloatToStr( radianToDegree(ArcSin(OpticalSystem.OpticalSurface[row].ApertureSin)) );
  end;

  StringGrid1.Cells[8,0]:='Ռ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid1.Cells[8,row]:=FloatToStr( (OpticalSystem.OpticalSurface[row].ApertureBrockOut) );
  end;



  StringGrid1.Cells[0,OpticalSystem.TotalSurfaceNumber+1]:=' œ_';
  if OpticalSystem.FocusPlane.ApfigureSwitch=true then begin
    StringGrid1.Cells[1,OpticalSystem.TotalSurfaceNumber+1]:='True';
  end else begin
    StringGrid1.Cells[1,OpticalSystem.TotalSurfaceNumber+1]:='False';
  end;

  if (OpticalSystem.FocusPlane.ApertureFigure=Round) then
      StringGrid1.Cells[2,OpticalSystem.TotalSurfaceNumber+1]:='Round'
      else if OpticalSystem.FocusPlane.ApertureFigure=Rect then
        StringGrid1.Cells[2,OpticalSystem.TotalSurfaceNumber+1]:='Rect'
          else if OpticalSystem.FocusPlane.ApertureFigure=Oval then
            StringGrid1.Cells[2,OpticalSystem.TotalSurfaceNumber+1]:='Oval'
              else if OpticalSystem.FocusPlane.ApertureFigure=UpperOval then
                StringGrid1.Cells[2,OpticalSystem.TotalSurfaceNumber+1]:='UpperOval'
                  else begin
                  end;

  StringGrid1.Cells[3,OpticalSystem.TotalSurfaceNumber+1]:=FloatToStr(OpticalSystem.FocusPlane.ApertureY);
  StringGrid1.Cells[4,OpticalSystem.TotalSurfaceNumber+1]:=FloatToStr(OpticalSystem.FocusPlane.ApertureZ);
  StringGrid1.Cells[5,OpticalSystem.TotalSurfaceNumber+1]:=FloatToStr(OpticalSystem.FocusPlane.ApertureSiftY);
  StringGrid1.Cells[6,OpticalSystem.TotalSurfaceNumber+1]:=FloatToStr(OpticalSystem.FocusPlane.ApertureSiftZ);
  StringGrid1.Cells[7,OpticalSystem.TotalSurfaceNumber+1]:=FloatToStr(radianToDegree(ArcSin(OpticalSystem.FocusPlane.ApertureSin)));

end;

procedure TApertureForm.Fix;
var row :integer;
begin

  //'';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    if (StringGrid1.Cells[1,row]='True') or (StringGrid1.Cells[1,row]='true') then begin
      OpticalSystem.OpticalSurface[row].ApfigureSwitch:=true;
    end else begin
      OpticalSystem.OpticalSurface[row].ApfigureSwitch:=false;
    end;
  end;

  //'J`';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin

    if StringGrid1.Cells[2,row]='Round' then
      OpticalSystem.OpticalSurface[row].ApertureFigure:=Round
      else if StringGrid1.Cells[2,row]='Rect' then
        OpticalSystem.OpticalSurface[row].ApertureFigure:=Rect
          else if StringGrid1.Cells[2,row]='Oval' then
              OpticalSystem.OpticalSurface[row].ApertureFigure:=Oval
              else if StringGrid1.Cells[2,row]='UpperOval' then
                OpticalSystem.OpticalSurface[row].ApertureFigure:=UpperOval
                  else begin
                  OpticalSystem.OpticalSurface[row].ApertureFigure:=Round
                  end;
  end;

  //'';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].ApertureY:=StrToFloat(StringGrid1.Cells[3,row]);
  end;
  //'';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].ApertureZ:=StrToFloat(StringGrid1.Cells[4,row]);
  end;
  //'VtgY';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].ApertureSiftY:=StrToFloat(StringGrid1.Cells[5,row]);
  end;
  //'VtgZ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].ApertureSiftZ:=StrToFloat(StringGrid1.Cells[6,row]);
  end;
  //'Xp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].ApertureSin:=sin( degreeToRadian(StrToFloat(StringGrid1.Cells[7,row])) );
    OpticalSystem.OpticalSurface[row].ApertureCos:=cos( degreeToRadian(StrToFloat(StringGrid1.Cells[7,row])) );
  end;
  //Ռ
  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    OpticalSystem.OpticalSurface[row].ApertureBrockOut:=StrToFloat(StringGrid1.Cells[8,row]);
  end;




  //'œ_';
  if (StringGrid1.Cells[1,OpticalSystem.TotalSurfaceNumber+1]='True') or (StringGrid1.Cells[1,OpticalSystem.TotalSurfaceNumber+1]='true') then begin
    OpticalSystem.FocusPlane.ApfigureSwitch:=true;
  end else begin
    OpticalSystem.FocusPlane.ApfigureSwitch:=False;
  end;

  if StringGrid1.Cells[2,OpticalSystem.TotalSurfaceNumber+1]='Round' then
      OpticalSystem.FocusPlane.ApertureFigure:=Round
      else if StringGrid1.Cells[2,OpticalSystem.TotalSurfaceNumber+1]='Rect' then
        OpticalSystem.FocusPlane.ApertureFigure:=Rect
          else if StringGrid1.Cells[2,OpticalSystem.TotalSurfaceNumber+1]='Oval' then
            OpticalSystem.FocusPlane.ApertureFigure:=Oval
              else if StringGrid1.Cells[2,OpticalSystem.TotalSurfaceNumber+1]='UpperOval' then
                OpticalSystem.FocusPlane.ApertureFigure:=UpperOval
                  else begin
                  OpticalSystem.FocusPlane.ApertureFigure:=Round
                  end;

  OpticalSystem.FocusPlane.ApertureY:=StrToFloat(StringGrid1.Cells[3,OpticalSystem.TotalSurfaceNumber+1]);
  OpticalSystem.FocusPlane.ApertureZ:=StrToFloat(StringGrid1.Cells[4,OpticalSystem.TotalSurfaceNumber+1]);
  OpticalSystem.FocusPlane.ApertureSiftY:=StrToFloat(StringGrid1.Cells[5,OpticalSystem.TotalSurfaceNumber+1]);
  OpticalSystem.FocusPlane.ApertureSiftZ:=StrToFloat(StringGrid1.Cells[6,OpticalSystem.TotalSurfaceNumber+1]);
  OpticalSystem.FocusPlane.ApertureSin:=sin( degreeToRadian(StrToFloat(StringGrid1.Cells[7,OpticalSystem.TotalSurfaceNumber+1])) );
  OpticalSystem.FocusPlane.ApertureCos:=cos( degreeToRadian(StrToFloat(StringGrid1.Cells[7,OpticalSystem.TotalSurfaceNumber+1])) );

end;




procedure TApertureForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  visible:=false;
end;

procedure TApertureForm.BitBtn1Click(Sender: TObject);
var col,row:integer;
begin
  StringGrid1.Font.Color:=clBlack;
  BitBtn2.Font.Color:=clBlack;

  for col:=0 to 7 do begin
    for row:=1 to 64+2 do begin
      StringGrid1.Cells[col,row]:='';
    end;
  end;

  Draw;
end;


procedure TApertureForm.BitBtn2Click(Sender: TObject);
begin
  fix;
  BitBtn1.Click;
  FormPOPS.DataIsChanged;
end;

procedure TApertureForm.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  StringGrid1.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;
end;



procedure TApertureForm.FormShow(Sender: TObject);
begin
  ComboBox1.Visible:=false;
  ComboBox2.Visible:=false;
end;

procedure TApertureForm.FormCreate(Sender: TObject);
begin

  StringGrid1.DefaultRowHeight := ComboBox1.Height - StringGrid1.GridLineWidth;
  StringGrid1.DefaultRowHeight := ComboBox2.Height - StringGrid1.GridLineWidth;

end;

procedure TApertureForm.ComboBox1Change(Sender: TObject);
begin
  with StringGrid1 do begin
    Cells[Col, Row] := ComboBox1.Text;
  end;
  StringGrid1.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;
end;

procedure TApertureForm.ComboBox2Change(Sender: TObject);
begin
  with StringGrid1 do begin
    Cells[Col, Row] := ComboBox2.Text;
  end;
  StringGrid1.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;
end;

procedure TApertureForm.StringGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  SetStr: String;
  Header: LongInt;
begin
{  SetStr := StringGrid1.Cells[ACol, ARow];

  if (ACol = 1) and (gdFocused in State) then begin
    SetWindowPos(ComboBox1.Handle, 0,
                 Rect.Left + StringGrid1.Left + 1, Rect.Top + StringGrid1.top + 1,
                 Rect.Right - Rect.Left + 2, Rect.Bottom - Rect.top + 2,
                 SWP_NOZORDER   or SWP_SHOWWINDOW);
    ComboBox1.ItemIndex := ComboBox1.Items.IndexOf(SetStr);
    ComboBox1.Show;
    Exit;
  end;
  if (ACol = 2) and (gdFocused in State) then begin
    SetWindowPos(ComboBox2.Handle, 0,
                 Rect.Left + StringGrid1.Left + 1, Rect.Top + StringGrid1.top + 1,
                 Rect.Right - Rect.Left + 2, Rect.Bottom - Rect.top + 2,
                 SWP_NOZORDER   or SWP_SHOWWINDOW);
    ComboBox2.ItemIndex := ComboBox2.Items.IndexOf(SetStr);
    ComboBox2.Show;
    Exit;
  end;


  if ComboBox1.Visible then
    ComboBox1.Visible := False;

  if ComboBox2.Visible then
    ComboBox2.Visible := False;

  StringGrid1.Canvas.FillRect(Rect);

  if ARow = 0 then
     Header := (DT_CENTER or DT_VCENTER or DT_SINGLELINE)
  else
     Header := (DT_SINGLELINE or DT_VCENTER or DT_LEFT);

  DrawText(StringGrid1.Canvas.Handle, PChar(SetStr), Length(SetStr),
           Rect, Header);
   }
end;


procedure TApertureForm.StringGrid1DblClick(Sender: TObject);
begin

  if StringGrid1.Col=1 then begin
    if StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]='False' then begin
      StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='True';
    end else begin
      StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='False';
    end;
    StringGrid1.Font.Color:=clNavy;
    BitBtn2.Font.Color:=clRed;
  end;

  if StringGrid1.Col=2 then begin
    if StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]='Round' then
      StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='Rect'
      else if StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]='Rect' then
        StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='Oval'
          else if StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]='Oval' then
            StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='UpperOval'
              else if StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]='UpperOval' then
                 StringGrid1.Cells[ StringGrid1.Col,StringGrid1.Row]:='Round';
    
    StringGrid1.Font.Color:=clNavy;
    BitBtn2.Font.Color:=clRed;
  end;
 
end;

procedure TApertureForm.RefreshDraw;
var col,row:integer;
begin
  StringGrid1.Font.Color:=clBlack;
  BitBtn2.Font.Color:=clBlack;
  
  for col:=0 to 8 do begin
    for row:=1 to 64+2 do begin
      StringGrid1.Cells[col,row]:='';
    end;
  end;

  Draw;
  self.Caption:='J`'+' /'+OpticalSystem.OpticalName;
end;

procedure TApertureForm.StringGrid1KeyPress(Sender: TObject;
  var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.Fix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TApertureForm.StringGrid1Click(Sender: TObject);
begin
  BitBtn2Click(Sender);
end;

end.
