unit AutoCorrection;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls,Math , IdGlobal,

  MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray,
  ComCtrls, Spin, Buttons, ExtCtrls;
type
  TMArray=array[0..100,0..100] of double;

  TLSMForm = class(TForm)
    StringGrid1: TStringGrid;
    Panel1: TPanel;
    Button6: TButton;
    Button5: TButton;
    Edit1: TEdit;
    Label5: TLabel;
    Edit2: TEdit;
    Label6: TLabel;
    BitBtn2: TBitBtn;
    Label4: TLabel;
    Label3: TLabel;
    Label1: TLabel;
    Edit3: TEdit;
    SpinButton1: TSpinButton;
    Label2: TLabel;
    Button3: TButton;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    SpinEdit1: TSpinEdit;
    BitBtn3: TBitBtn;
    Label7: TLabel;
    LabeledEdit1: TLabeledEdit;
    SpinButton2: TSpinButton;
    Edit4: TEdit;
    SpinButton3: TSpinButton;
    GroupBox1: TGroupBox;
    Button2: TButton;
    BitBtn4: TBitBtn;
    Button1: TButton;
    Button7: TButton;
    BitBtn1: TBitBtn;
    Button4: TButton;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure Initialize(Sender:Tobject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure StringGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure StringGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure SpinButton3DownClick(Sender: TObject);
    procedure SpinButton3UpClick(Sender: TObject);
    procedure Edit4Change(Sender:Tobject);
    procedure SpinButton2DownClick(Sender: TObject);
    procedure SpinButton2UpClick(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);

  private
    { Private 錾 }
    DeltaIncrease:Array[0.. MaxOptSurface] of double;
    DeltaSA9: Array[0.. MaxOptSurface] of Extended;
    DeltaCO9: Array[0.. MaxOptSurface] of double;
    DeltaMAS: Array[0.. MaxOptSurface] of double;
    DeltaSAS: Array[0.. MaxOptSurface] of double;
    DeltaDS: Array[0.. MaxOptSurface] of double;
    DeltaSA7: Array[0.. MaxOptSurface] of double;
    DeltaCO7: Array[0.. MaxOptSurface] of double;
    DeltaFL: Array[0.. MaxOptSurface] of double;
    DeltaBFL:Array[0..MaxOptSurface] of double;
    DeltaFLC: Array[0.. MaxOptSurface] of double;
    DeltaFLg: Array[0.. MaxOptSurface] of double;
    DeltaMAG: Array[ng..nt,0..MaxOptSurface] of double;

    anInputAngle:Extended;
    BendingStep:  double;
    SA: TSA;
    OSC: TOSC;
    MAS: TMAS;
    SAS: TSAS;
    DIS: TDIS;
    MAG: TMAG;

    MerSA:  TSA;
    MerOSC: TOSC;
    MerMAS: TMAS;
    MerSAS: TSAS;
    MerDIS: TDIS;
    MerMAG: TMAG;

    VarN:integer;
    EquM:integer;

    aLS:Array[1..100,1..100] of double;
    YLS:Array[1..100] of double;
    XLS:Array[1..100,1..100] of double;
    SLS:Array[1..100,1..100] of double;
    TLS:Array[1..100] of double;
    NewData:Array[1..100] of double;
    CofL: Array[0..100] of double;
    CofT: Array[0..100] of double;
    cof: TCof;
    ttg: Tttg;
    MerCof: TCof;
    MerTtg : Tttg;
    DataFixSwitch:Array[1..100] of integer;

    CorrOptSys:TOptSystem;
    BefOptSys:TOptSystem;
    OriginOptSys:TOptSystem;
    MerOptSys:TOptsystem;

    FlagVarg:Boolean;
    FlagMer:Boolean;
    MeritF:double;
    DeltaSum: double;
    WeightAbe:Array[1..100] of double;
    DampingFactor: double;

    TargetFL:double;
    TargetBFL:double;
    CorrFL:double;
    CorrBFL:double;

    a:TMArray;      //pqp
    q:TMArray;
    r:TMArray;
    b:array[0..100] of double;
    c:array[0..100] of double;
    s:double;
    n,m:integer;
    y:array[0..100] of double;

    procedure qr_decomposition(Var a:TMArray;Var n:integer;Var m:integer ;
                               Var q:TMArray;Var r:TMArray);
    procedure gramm_schumidt(Var aTMArray;Var n:integer; Var m:integer;Var q:TMArray);

    procedure CulcBendCoffient;
    procedure DrawCells;
    procedure GridTitleDraw;
    procedure MeritCalculate;
  public
    { Public 錾 }
    procedure RefreshDraw;
  end;

var
  LSMForm: TLSMForm;

implementation

uses UnitedData, Bending2, SpotBrowser;

{$R *.dfm}
procedure TLSMForm.Initialize(Sender:Tobject);
var i:integer;
begin
  LSMForm.Caption:='Correction'+'/'+OpticalSystem.OpticalName;
  CorrOptSys:=TOptSystem.Create;
  CorrOptSys.initialize;

  BefOptSys:=TOptSystem.Create;
  BefOptSys.Initialize;

  OriginOptSys:=TOptSystem.Create;
  OriginOptSys.Initialize;

  MerOptSys:=ToptSystem.Create;
  MerOptSys.Initialize;

  FlagVarg:=True;
  FlagMer:=True;

  BendingStep:=0.001;
  Edit3.Text:=FloatToStr(BendingStep*100);

  for i:=1 to 100 do begin
    DataFixSwitch[i]:=1;
    WeightAbe[i]:=1;
  end;

  DampingFactor:= 0;
  
  anInputAngle:=1;
  Edit4.Text:=FloatToStr(anInputAngle);

end;

procedure TLSMForm.GridTitleDraw;
var i:integer;
begin
  StringGrid1.Cells[0,2]:='Sn';                //[0,2s] [0Col,2Row]
  for i:=1 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[0,i+2]:=IntToStr(i);
  end;
  StringGrid1.Cells[0,CorrOptSys.TotalSurfaceNumber+2+2]:='ω';

  StringGrid1.Cells[1,0]:='Œ';
  for i:=1 to CorrOptSys.TotalSurfaceNumber do begin
   stringGrid1.Cells[1,i+2]:=IntToStr(DataFixSwitch[i]);
  end;

  StringGrid1.Cells[0,CorrOptSys.TotalSurfaceNumber+2+2+1]:='EFCg';
  StringGrid1.Cells[0,CorrOptSys.TotalSurfaceNumber+2+2+2]:='ω*v';
  StringGrid1.Cells[0,CorrOptSys.TotalSurfaceNumber+2+2+3]:='ω*v+o';

end;

procedure TLSMForm.CulcBendCoffient;
var i:integer;
begin



  VarN:=CorrOptSys.TotalSurfaceNumber;
  EquM:=14;                           //  ŏ@̂̒l A퐔

  Edit1.Text:=IntToStr(EquM);
  Edit2.Text:=IntToStr(VarN);

  Edit3.Text:=FloatToStr(BendingStep*100);
  anInputAngle:=StrToFloat(Edit4.text);

  CorrOptSys.ParAxialTrace(FinalOpt);

  CorrFL:=CorrOptSys.FocalLength[nd];
  CorrBFL:=CorrOptSys.BackFocus[nd];

  CorrOptSys.CalculateSphericalAberration( SA, OSC);
  CorrOptSys.CalculateAS( MAS, SAS, anInputAngle );
  CorrOptSys.CalculateDistortion( DIS, anInputAngle);
  CorrOptSys.CalculateCromaticMagnification(MAG, anInputAngle);

  //originData
  DeltaSA9[0]:=SA[nd,trunc(MaxSANumber*0.9)];     //̎
  DeltaCO9[0]:=OSC[trunc(MaxSANumber*0.9)];
  DeltaMAS[0]:=MAS[MaxAngleNumber];
  DeltaSAS[0]:=SAS[MaxAngleNumber];
  DeltaDS[0]:=DIS[MaxAngleNumber];
  DeltaSA7[0]:=SA[nd,trunc(MaxSANumber*0.7)];
  DeltaCO7[0]:=OSC[trunc(MaxSANumber*0.7)];
  DeltaFL[0]:=CorrOptSys.FocalLength[nd];
  DeltaFLC[0]:=CorrOptSys.FocalLength[nC]-CorrOptSys.FocalLength[nd];       //F
  DeltaFLg[0]:=CorrOptSys.FocalLength[ng]-CorrOptSys.FocalLength[nd];
  DeltaBFL[0]:=CorrOptSys.BackFocus[nd];
  DeltaMAG[ng,0]:=MAG[ng,MaxAngleNumber];

  DeltaSum:=0;                                                            //ωʂ̘a
  for i:=1 to CorrOptSys.TotalSurfaceNumber do  begin
    DeltaIncrease[i]:=abs(CorrOptSys.OpticalSurface[i].curvature*BendingStep)*DataFixSwitch[i] ; //abs͂ȂH
    DeltaSum:=DeltaSum+(DeltaIncrease[i]*DeltaIncrease[i]);
  end;

  for i:=1 to CorrOptSys.TotalSurfaceNumber do  begin
    CorrOptSys.copyFrom(OpticalSystem);
    CorrOptSys.OpticalSurface[i].Curvature:=CorrOptSys.OpticalSurface[i].Curvature+(DeltaIncrease[i]);
    CorrOptSys.ParAxialTrace(FinalOpt);
    CorrOptSys.CalculateSphericalAberration( SA, OSC);
    CorrOptSys.CalculateAS( MAS, SAS, anInputAngle );
    CorrOptSys.CalculateDistortion( DIS, anInputAngle);
    CorrOptSys.CalculateCromaticMagnification(MAG,anInputAngle);

    DeltaSA9[i]:=SA[nd,trunc(MaxSANumber*0.9)] - DeltaSA9[0];      //̍
    DeltaCO9[i]:=OSC[trunc(MaxSANumber*0.9)] - DeltaCO9[0];
    DeltaMAS[i]:=MAS[MaxAngleNumber] - DeltaMAS[0];
    DeltaSAS[i]:=SAS[MaxAngleNumber] - DeltaSAS[0];
    DeltaDS[i]:=DIS[MaxAngleNumber] - DeltaDS[0];
    DeltaSA7[i]:=SA[nd,trunc(MaxSANumber*0.7)] -DeltaSA7[0] ;
    DeltaCO7[i]:=OSC[trunc(MaxSANumber*0.7)]  - DeltaCO7[0];
    DeltaFL[i]:=CorrOptSys.FocalLength[nd] - DeltaFL[0];
    DeltaBFL[i]:=CorrOptSys.BackFocus[nd] - DeltaBFL[0];
    DeltaMAG[ng,i]:=MAG[ng,MaxAngleNumber] - DeltaMAG[ng,0];

    DeltaFLC[i]:=(CorrOptSys.FocalLength[nC]-CorrOptSys.FocalLength[nd]) - DeltaFLC[0];
    DeltaFLg[i]:=(CorrOptSys.FocalLength[ng]-CorrOptSys.FocalLength[nd]) - DeltaFLg[0];
  end;

 /////////////////////////////////////////////////////////////////////////////

  CorrOptSys.copyFrom(OpticalSystem);
  CorrOptSys.ParAxialTrace(FinalOpt);
  CorrOptSys. CaluculateCoefficient(Cof,Ttg);

  CofL[0]:=ttg[CorrOptSys.TotalSurfaceNumber+1,1];          //̎W
  CofT[0]:=ttg[CorrOptSys.TotalSurfaceNumber+1,2];

  for i:=1 to CorrOptSys.TotalSurfaceNumber do  begin
    CorrOptSys.copyFrom(OpticalSystem);
    CorrOptSys.OpticalSurface[i].curvature:=CorrOptSys.OpticalSurface[i].curvature
                                          +(CorrOptSys.OpticalSurface[i].curvature*BendingStep);
    CorrOptSys.ParAxialTrace(FinalOpt);
    CorrOptSys. CaluculateCoefficient(Cof,Ttg);

    CofL[i]:=ttg[CorrOptSys.TotalSurfaceNumber+1,1]-CofL[0];    //W̍
    CofT[i]:=ttg[CorrOptSys.TotalSurfaceNumber+1,2]-CofT[0];
  end;

end;



procedure TLSMForm.DrawCells;
var i:integer;
begin

  StringGrid1.Cells[2,0]:='ȗ';                 //[2A0s] [2Row,@0Col]
  for i:=1 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[2,i+2]:=FloatToStrF(CorrOptSys.OpticalSurface[i].Curvature,ffGeneral,5,3);
  end;

  StringGrid1.Cells[3,0]:='';
  for i:=1 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[3,i+2]:=FloatToStrF(DeltaIncrease[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[3,2]:=FloatToStrF(DeltaSum,ffGeneral,5,3);

  StringGrid1.Cells[4,0]:='œ_';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[4,i+2]:=FloatToStrF(DeltaFL[i],ffGeneral,5,3);
  end;
//  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF((TargetFL-CorrFL),ffGeneral,5,3);
  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2]:='0';
  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[4]);

  StringGrid1.Cells[5,0]:='FC';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[5,i+2]:=FloatToStrF(DeltaFLC[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaFLC[0],ffGeneral,5,3);
  StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[5]);

  StringGrid1.Cells[6,0]:='F';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[6,i+2]:=FloatToStrF(DeltaFLg[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaFLg[0],ffGeneral,5,3);
  StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[6]);

  StringGrid1.Cells[7,0]:='aek';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[7,i+2]:=FloatToStrF(DeltaBFL[i],ffGeneral,5,3);
  end;
//  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF((TargetBFL-CorrBFL),ffGeneral,5,3);
  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2]:='0';
  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[7]);

  StringGrid1.Cells[8,0]:='SAX';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[8,i+2]:=FloatToStrF(DeltaSA9[i],ffGeneral,5,2);
  end;
  StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaSA9[0],ffGeneral,5,3);
  StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[8]);

  StringGrid1.Cells[9,0]:='SA7';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[9,i+2]:=FloatToStrF(DeltaSA7[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaSA7[0],ffGeneral,5,3);
  StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[9]);

  StringGrid1.Cells[10,0]:='R}X';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[10,i+2]:=FloatToStrF(DeltaCO9[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaCO9[0],ffGeneral,5,3);
  StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[10]);

  StringGrid1.Cells[11,0]:='R}V' ;
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[11,i+2]:=FloatToStrF(DeltaCO7[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaCO7[0],ffGeneral,5,3);
  StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[11]);

  StringGrid1.Cells[12,0]:='MAX' ;
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[12,i+2]:=FloatToStrF(DeltaMAS[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaMAS[0],ffGeneral,5,3);
  StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[12]);

  StringGrid1.Cells[13,0]:='SAX';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[13,i+2]:=FloatToStrF(DeltaSAS[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaSAS[0],ffGeneral,5,3);
  StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[13]);

  StringGrid1.Cells[14,0]:='c';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[14,i+2]:=FloatToStrF(DeltaDS[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaDS[0],ffGeneral,5,3);
  StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[14]);

  StringGrid1.Cells[15,0]:='FW';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[15,i+2]:=FloatToStrF(CofL[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*CofL[0],ffGeneral,5,3);
  StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[15]);

  StringGrid1.Cells[16,0]:='{FW';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[16,i+2]:=FloatToStrF(CofT[i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*CofT[0],ffGeneral,5,3);
  StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[16]);

  StringGrid1.Cells[17,0]:='{Fg';
  for i:=0 to CorrOptSys.TotalSurfaceNumber do begin
    StringGrid1.Cells[17,i+2]:=FloatToStrF(DeltaMAG[ng,i],ffGeneral,5,3);
  end;
  StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2]:=FloatToStrF(-1*DeltaMAG[ng,0],ffGeneral,5,3);
  StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+1]:=FloatToStr(WeightAbe[17]);



  //EFCg␳s

  WeightAbe[4]:=StrToFloat(StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+1]);
//  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF((TargetFL-CorBFL)*WeightAbe[4],ffGeneral,5,3);
  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+2]:='0';

  WeightAbe[5]:=StrToFloat(StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaFLC[0]*WeightAbe[5],ffGeneral,5,3);

  WeightAbe[6]:=StrToFloat(StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaFLg[0]*WeightAbe[6],ffGeneral,5,3);

  WeightAbe[7]:=StrToFloat(StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+1]);
//  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF((TargetBFL-CorrBFL)*WeightAbe[7],ffGeneral,5,3);
  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+2]:='0';

  WeightAbe[8]:=StrToFloat(StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSA9[0]*WeightAbe[8],ffGeneral,5,3);

  WeightAbe[9]:=StrToFloat(StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSA7[0]*WeightAbe[9],ffGeneral,5,3);

  WeightAbe[10]:=StrToFloat(StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaCO9[0]*WeightAbe[10],ffGeneral,5,3);

  WeightAbe[11]:=StrToFloat(StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaCO7[0]*WeightAbe[11],ffGeneral,5,3);

  WeightAbe[12]:=StrToFloat(StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaMAS[0]*WeightAbe[12],ffGeneral,5,3);

  WeightAbe[13]:=StrToFloat(StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSAS[0]*WeightAbe[13],ffGeneral,5,3);

  WeightAbe[14]:=StrToFloat(StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaDS[0]*WeightAbe[14],ffGeneral,5,3);

  WeightAbe[15]:=StrToFloat(StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*CofL[0]*WeightAbe[15],ffGeneral,5,3);

  WeightAbe[16]:=StrToFloat(StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*CofT[0]*WeightAbe[16],ffGeneral,5,3);


  WeightAbe[17]:=StrToFloat(StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaMAG[ng,0]*WeightAbe[17],ffGeneral,5,3);



  //DLSs
  StringGrid1.Cells[3,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF((DeltaSum*DampingFactor),FFGeneral,5,3);
  
  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2];
  StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+3]:= StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2];
  StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+3]:= StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+3]:= StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+2];
  StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+3]:=StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+2];

  self.Caption:='Correction'+'/'+OpticalSystem.OpticalName;

end;

procedure TLSMForm.Button1Click(Sender: TObject);

begin
  LSMForm.Caption:=(Opticalsystem.OpticalName);

  if FlagVarg=True then   begin
    OriginOptsys.CopyFrom(OpticalSystem);
    FlagVarg:=False;

    TargetFL:=OpticalSystem.FocalLength[nd];
    TargetBFL:=OpticalSystem.BackFocus[nd];
  end;

  CorrOptSys.copyFrom(OpticalSystem);

  GridTitleDraw;
  CulcBendCoffient;
  DrawCells;
  
  StringGrid1.Font.Color:=clBlack;

end;

procedure TLSMForm.Button2Click(Sender: TObject);
var i,j,k,na,n1,na1,kp,siftCol,siftRow,
    solutionCol,solutionRow:integer;
    ss,tt,p,temp,aDLS,aDeltaWeight:double;
begin

  BitBtn1.Font.Color:=clRed;
  WeightAbe[4]:=StrToFloat(StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+1]);
//  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF((TargetFL-CorrFL)*WeightAbe[4],ffGeneral,5,2);
  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+2]:= StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2];

  WeightAbe[5]:=StrToFloat(StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaFLC[0]*WeightAbe[5],ffGeneral,5,2);

  WeightAbe[6]:=StrToFloat(StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaFLg[0]*WeightAbe[6],ffGeneral,5,2);


  WeightAbe[7]:=StrToFloat(StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+1]);
//  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF((TargetBFL-CorrBFL)*WeightAbe[7],ffGeneral,5,2);
  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+2]:= StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2];

  WeightAbe[8]:=StrToFloat(StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSA9[0]*WeightAbe[8],ffGeneral,5,2);

  WeightAbe[9]:=StrToFloat(StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSA7[0]*WeightAbe[9],ffGeneral,5,2);

  WeightAbe[10]:=StrToFloat(StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaCO9[0]*WeightAbe[10],ffGeneral,5,2);

  WeightAbe[11]:=StrToFloat(StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaCO7[0]*WeightAbe[11],ffGeneral,5,2);

  WeightAbe[12]:=StrToFloat(StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaMAS[0]*WeightAbe[12],ffGeneral,5,2);

  WeightAbe[13]:=StrToFloat(StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSAS[0]*WeightAbe[13],ffGeneral,5,2);

  WeightAbe[14]:=StrToFloat(StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaDS[0]*WeightAbe[14],ffGeneral,5,2);

  WeightAbe[15]:=StrToFloat(StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*CofL[0]*WeightAbe[15],ffGeneral,5,2);

  WeightAbe[16]:=StrToFloat(StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*CofT[0]*WeightAbe[16],ffGeneral,5,2);


   WeightAbe[17]:=StrToFloat(StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaMAG[ng,0]*WeightAbe[17],ffGeneral,5,2);

////////////////////////////////////////////////////////////////////////////////////

  for j:=1 to VarN do begin
    for i:=1 to EquM do begin
      aLS[i,j]:=StrToFloat(StringGrid1.Cells[i+3,j+2]); //triplet[4,3]ǂݍ //[j+siftCol,i+siftRow]);
    end;
  end;

  for j:=1 to EquM do begin
    YLS[j]:=StrToFloat(StringGrid1.Cells[j+3,VarN+2+2+2]);//[4,14]ǂ //[VarN+siftCol+2,j+siftRow]);    //ω
  end;

  for k:=1 to VarN do begin
    for j:=1 to VarN do begin
      ss:=0;
      for i:=1 to EquM do  begin
        ss:=ss+aLS[i,j]*aLS[i,k];
      end;
      SLS[j,k]:=ss;                //ɂ邩ɂ邩
    end;
  end;

  for j:=1 to VarN do begin
    tt:=0;
    for i:=1 to EquM do begin
      tt:=tt+aLS[i,j]*(YLS[i] + deltaSum*DampingFactor);//_sOt@N^[C
    end;
    TLS[j]:=tt;
  end;

  for j:=1 to VarN do begin
    for i:=1 to VarN do begin
      XLS[j,i]:=SLS[j,i];
    end;
  end;
  for i:=1 to VarN do begin
    XLS[i,VarN+1]:=TLS[i];
  end;

  n1:=VarN+1;
  for na:=1 to VarN do begin
    p:=0;
    na1:=na+1;
    for i:=na to VarN do begin
      if p>abs(XLS[i,na]) then begin

      end else begin
        p:=abs(XLS[i,na]);
        kp:=i;
      end;
    end;

    if p<1e-200 then begin
      ShowMessage('słB');
    end;

    for j:=na to n1 do begin
      temp:=XLS[na,j];
      XLS[na,j]:=XLS[kp,j];       //kp
      XLS[kp,j]:=temp;
    end;

    for j:=na1 to n1 do begin
      XLS[na,j]:=XLS[na,j]/XLS[na,na];
    end;

    for i:=1 to n1 do begin
      if i=na then begin

      end else begin
        for j:=na1 to n1 do begin
          XLS[i,j]:=XLS[i,j]-XLS[i,na]*XLS[na,j];
        end;
      end;
    end;

  end;

  for i:=1 to VarN do begin
    NewData[i]:= XLS[i,VarN+1]*DeltaIncrease[i]+CorrOptSys.OpticalSurface[i].curvature ;  //DPC
  end;
  

  StringGrid1.Cells[19,0]:='';          //[18,Os]  [18Row,0Col]
  for i:=1 to VarN  do begin
    StringGrid1.Cells[19,i+2]:=FloatToStrF(XLS[i,VarN+1],ffGeneral,5,2);
  end;

  StringGrid1.Cells[20, 0]:='*';
  for i:=1 to VarN  do begin
    StringGrid1.Cells[20,i+2]:=FloatToStrF((XLS[i,VarN+1]*DeltaIncrease[i]),ffGeneral,5,2);
  end;

  StringGrid1.Cells[21, 0]:='Vf[^';
  for i:=1 to VarN  do begin
    StringGrid1.Cells[21,i+2]:=FloatToStrF(NewData[i],ffGeneral,5,2);
  end;

  StringGrid1.Cells[18,0]:='bg';

  StringGrid1.Font.Color:=clBlack;

//DLSs
  StringGrid1.Cells[3,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(DeltaSum*DampingFactor,FFGeneral,5,2);

  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[1] + deltaSum*DampingFactor ,FFGeneral,5,2);
  StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[2] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[3] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[4] + deltaSum*DampingFactor ,FFGeneral,5,2);
  StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[5] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[6] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[7] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[8] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[9] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[10] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[11] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[12] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[13] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(YLS[14] + deltaSum*DampingFactor,FFGeneral,5,2);

 //////////////////////////////////////////////////////////////////////////////////

  MeritCalculate;

end;

procedure TLSMForm.MeritCalculate;
var i:integer;
begin

  MerOptsys.CopyFrom(OpticalSystem);

  anInputAngle:=StrToFloat(Edit4.Text);

  MeritF:=0;
  OpticalSystem.ParAxialTrace(FinalOpt);
  OpticalSystem.CalculateSphericalAberration( SA, OSC);
  OpticalSystem.CalculateAS( MAS, SAS, anInputAngle );
  OpticalSystem.CalculateDistortion( DIS, anInputAngle);
  OpticalSystem. CaluculateCoefficient(Cof,Ttg);
  OpticalSystem.CalculateCromaticMagnification( MAG, anInputAngle );


  for i:=1 to VarN do begin
    MerOptSys.OpticalSurface[i].Curvature:=NewData[i];       //CorrOptɐVf[^
  end;
  MerOptSys.ParAxialTrace(FinalOpt);
  MerOptSys.CalculateSphericalAberration( MerSA, MerOSC);
  MerOptSys.CalculateAS( MerMAS, MerSAS, anInputAngle );
  MerOptSys.CalculateDistortion( MerDIS, anInputAngle);
  MerOptSys.CaluculateCoefficient(MerCof,MerTtg);
  MerOptSys.CalculateCromaticMagnification( MerMAG, anInputAngle );

  MeritF:=Power( (MerOptSys.FocalLength[nC]-OpticalSystem.FocalLength[nC]),2 )+
          Power( (MerOptSys.FocalLength[ng]-OpticalSystem.FocalLength[ng]),2 )+
          Power( (MerSA[nd,trunc(MaxSANumber*0.9)]-SA[nd,trunc(MaxSANumber*0.9)]),2 )+
          Power( (MerSA[nd,trunc(MaxSANumber*0.7)]-SA[nd,trunc(MaxSANumber*0.7)]),2 )+
          Power( (MerOSC[trunc(MaxSANumber*0.9)]-OSC[trunc(MaxSANumber*0.9)]),2 )+
          Power( (MerOSC[trunc(MaxSANumber*0.7)]-OSC[trunc(MaxSANumber*0.7)]),2 )+
          Power( (MerDIS[MaxAngleNumber]-DIS[MaxAngleNumber]),2 )+
          Power( (MerMAS[MaxAngleNumber]-MAS[MaxAngleNumber]),2 )+
          Power( (MerSAS[MaxAngleNumber]-SAS[MaxAngleNumber]),2 )+
          Power( (MerTtg[OpticalSystem.TotalSurfaceNumber+1,1]-Ttg[CorrOptSys.TotalSurfaceNumber+1,1]),2 )+
          Power( (MerTtg[OpticalSystem.TotalSurfaceNumber+1,2]-Ttg[CorrOptSys.TotalSurfaceNumber+1,2]),2 )+
          Power( (MerMAG[ng,MaxAngleNumber]-MAG[ng,MaxAngleNumber]),2) ;

  StringGrid1.Cells[18,2]:=FloatToStrF(MeritF,ffGeneral,4,2);


end;



procedure TLSMForm.Button3Click(Sender: TObject);
begin
  OriginOptSys.CopyFrom(OpticalSystem);
end;

procedure TLSMForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  LSMForm.Visible:=False;
end;
procedure TLSMForm.FormCreate(Sender: TObject);
begin
  self.Initialize(Sender);
end;

procedure TLSMForm.Button4Click(Sender: TObject);
begin
  OpticalSystem.CopyFrom(BefOptSys);

  UnitedDataForm.BitBtn2Click(Sender);
  UnitedDataForm.BitBtn18Click(Sender);

  BendingForm2.Button1.Click
end;

procedure TLSMForm.Button5Click(Sender: TObject);
begin
  OpticalSystem.CopyFrom(OriginOptSys);
  
  UnitedDataForm.BitBtn2Click(Sender);
  UnitedDataForm.BitBtn18Click(Sender);

  BendingForm2.Button1.Click
end;

procedure TLSMForm.Button6Click(Sender: TObject);
var
   RC, CC: Integer;
begin
     for RC := 0 to StringGrid1.RowCount - 1 do
         for CC := 0 to StringGrid1.ColCount - 1 do
             StringGrid1.Cells[CC,RC] := '';


  BefOptSys.CopyFrom(OpticalSystem);
  LSMForm.Caption:=(OpticalSystem.OpticalName);
  OriginOptSys.CopyFrom(OpticalSystem);
end;


procedure TLSMForm.SpinButton1DownClick(Sender: TObject);
begin


   if BendingStep>0.002 then begin
    BendingStep:=BendingStep-0.001;
    Edit3.Text:=FloatToStr(BendingStep*100);
   end else begin
    if BendingStep=0.001 then begin
      BendingStep:=0.001;
      Edit3.Text:=FloatToStr(BendingStep*100);
    end else begin
      BendingStep:=BendingStep-0.0001;
      Edit3.Text:=FloatToStr(BendingStep*100);
    end;
   end;



end;

procedure TLSMForm.SpinButton1UpClick(Sender: TObject);
begin
  if BendingStep>0.001 then begin
   BendingStep:=BendingStep+0.001;
   Edit3.Text:=FloatToStr(BendingStep*100);
  end else begin
   BendingStep:=BendingStep+0.0001;
   Edit3.Text:=FloatToStr(BendingStep*100);
 end;
end;

procedure TLSMForm.BitBtn1Click(Sender: TObject);
var i:integer;
begin
  BefOptSys.CopyFrom(OpticalSystem); //BuckUp

  for i:=1 to VarN do begin
    OpticalSystem.OpticalSurface[i].Curvature:=NewData[i];       //Vf[^
  end;
  UnitedDataForm.BitBtn2Click(Sender);
  UnitedDataForm.BitBtn18Click(Sender);
  BitBtn1.Font.Color:=clBlack;

  BendingForm2.Button1.Click;

  if CheckBox1.Checked=True then
    SpotForm.SpotButton2.Click;

end;

procedure TLSMForm.StringGrid1KeyPress(Sender: TObject; var Key: Char);
var i:integer;
begin
if (Ord(Key) = VK_RETURN)  then begin
    for i:=1 to CorrOptsys.TotalSurfaceNumber  do begin
      DataFixSwitch[i]:=StrToInt(StringGrid1.Cells[1,i+2]);
    end;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
   StringGrid1.Font.Color:=clBlack;
   BitBtn2.Font.Color:=clBlack;
end;
end;

procedure TLSMForm.StringGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  if StringGrid1.col=1 then begin
     StringGrid1.Font.Color:=clNavy;
     BitBtn2.Font.Color:=clRed;
  end;

  if StringGrid1.Row=CorrOptSys.TotalSurfaceNumber+2+2+1 then begin
     StringGrid1.Font.Color:=clNavy;
     BitBtn4.Font.Color:=clRed;
  end;
end;

procedure TLSMForm.BitBtn2Click(Sender: TObject);
var i:integer;
begin
  for i:=1 to CorrOptsys.TotalSurfaceNumber  do begin
      DataFixSwitch[i]:=StrToInt(StringGrid1.Cells[1,i+2]);
  end;
  BitBtn2.Font.Color:=clBlack;
  StringGrid1.Font.Color:=clBlack;
end;


procedure TLSMForm.RefreshDraw;
begin
  Button6.Click;
end;


procedure TLSMForm.Button7Click(Sender: TObject);
var i,j :integer;
begin
  VarN:=CorrOptSys.TotalSurfaceNumber;
  EquM:=14;

  n:=EquM;     //3   pq͍ŏƋt
  m:=VarN;     //2 ʐ
  {
  y[0]:=0;
  y[1]:=0.00001;
  y[2]:=1;
  a[0,0]:=1;
  a[0,1]:=-1;
  a[1,0]:=0;
  a[1,1]:=0.00001;
  a[2,0]:=0;
  a[2,1]:=0; }

  BitBtn1.Font.Color:=clRed;
  WeightAbe[4]:=StrToFloat(StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+1]);
//  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF((TargetFL-CorrFL)*WeightAbe[4],ffGeneral,5,2);
  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+2]:=StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2];

  WeightAbe[5]:=StrToFloat(StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaFLC[0]*WeightAbe[5],ffGeneral,5,2);

  WeightAbe[6]:=StrToFloat(StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaFLg[0]*WeightAbe[6],ffGeneral,5,2);


  WeightAbe[7]:=StrToFloat(StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+1]);
//  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF((TargetBFL-CorrBFL)*WeightAbe[7],ffGeneral,5,2);
  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+2]:= StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2];

  WeightAbe[8]:=StrToFloat(StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSA9[0]*WeightAbe[8],ffGeneral,5,2);

  WeightAbe[9]:=StrToFloat(StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSA7[0]*WeightAbe[9],ffGeneral,5,2);

  WeightAbe[10]:=StrToFloat(StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaCO9[0]*WeightAbe[10],ffGeneral,5,2);

  WeightAbe[11]:=StrToFloat(StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaCO7[0]*WeightAbe[11],ffGeneral,5,2);

  WeightAbe[12]:=StrToFloat(StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaMAS[0]*WeightAbe[12],ffGeneral,5,2);

  WeightAbe[13]:=StrToFloat(StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSAS[0]*WeightAbe[13],ffGeneral,5,2);

  WeightAbe[14]:=StrToFloat(StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaDS[0]*WeightAbe[14],ffGeneral,5,2);

  WeightAbe[15]:=StrToFloat(StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*CofL[0]*WeightAbe[15],ffGeneral,5,2);

  WeightAbe[16]:=StrToFloat(StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*CofT[0]*WeightAbe[16],ffGeneral,5,2);

  WeightAbe[17]:=StrToFloat(StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaMAG[ng,0]*WeightAbe[17],ffGeneral,5,2);



//QR
  for i:=0 to m-1 do begin
    for j:=0 to n-1 do begin
      a[j,i]:=StrToFloat(StringGrid1.Cells[j+3+1,i+2+1]); //triplet[4,3]ǂݍ ;
    end;
  end;

  for j:=0 to n-1 do begin
    y[j]:=StrToFloat(StringGrid1.Cells[j+3+1,m+2+2+2]);//[4,14]ǂ;    //ω
  end;

  self.qr_decomposition(a,n,m,q,r);

  for j:=0 to m-1 do begin
    s:=0;
    for i:=0 to n-1 do begin
      s:=s+q[i,j] * (y[i] + DeltaSum*DampingFactor);    //Ȃ炱
    end;
    b[j]:=s ;
  end;

  for i:=m-1 downto 0 do begin
    c[i]:=b[i];
    for j:=m-1 downto i+1 do begin
      c[i]:=c[i]-r[i,j]*c[j];
    end;
    c[i]:=c[i]/r[i,i];
  end;

{  for i:=0 to m-1 do begin
    Memo1.Lines.Add(FloatToStr(c[i]) + #13#10);

  end;
 }


  for i:=0 to m-1 do begin
    NewData[i+1]:=c[i]*DeltaIncrease[i+1]+CorrOptSys.OpticalSurface[i+1].curvature;
  end;


  StringGrid1.Cells[19,0]:='';          //[18,Os]  [18Row,0Col]
  for i:=0 to m-1  do begin
    StringGrid1.Cells[19,i+1+2]:=FloatToStrF(c[i],ffGeneral,4,2);
  end;

  StringGrid1.Cells[20, 0]:='*';
  for i:=0 to m-1  do begin
    StringGrid1.Cells[20,i+1+2]:=FloatToStrF((c[i]*DeltaIncrease[i+1]),ffGeneral,4,2);
  end;

  StringGrid1.Cells[21, 0]:='Vf[^';
  for i:=1 to m  do begin
    StringGrid1.Cells[21,i+2]:=FloatToStrF(NewData[i],ffGeneral,4,2);
  end;

  StringGrid1.Cells[18,0]:='bg';

  StringGrid1.Font.Color:=clBlack;

  //DSL
  StringGrid1.Cells[3,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(DeltaSum*DampingFactor,FFGeneral,5,2);

  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[0] + deltaSum*DampingFactor ,FFGeneral,5,2);
  StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[1] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[2] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[3] + deltaSum*DampingFactor ,FFGeneral,5,2);
  StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[4] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[5] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[6] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[7] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[8] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[9] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[10] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[11] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[12] + deltaSum*DampingFactor,FFGeneral,5,2);
  StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+3]:=FloatToStrF(y[13] + deltaSum*DampingFactor,FFGeneral,5,2);


  self.MeritCalculate;
end;

procedure TLSMForm.qr_decomposition(Var a:TMArray;Var n:integer;Var m:integer ;
                               Var q:TMArray;Var r:TMArray);

var i,j,k,l:integer;
    s,p:double;
begin

  gramm_schumidt(a,n,m,q);
  for k:=0 to m-1 do begin
    for j:=0 to k-1 do begin
      s:=0;
      for i:=0 to n-1 do begin
        s:=s+a[i,k]*q[i,j];
      end;
      r[j,k]:=s;
    end;
    s:=0;
    for i:=0 to n-1 do begin
      p:=a[i,k];
      for l:=0 to k-1 do begin
        p:=p-r[l,k]*q[i,l];
      end;
      s:=s+p*p;
    end;
      r[k,k]:=Sqrt(s);
    for j:=k+1 to m-1 do begin
      r[j,k]:=0
    end;
  end;
end;

procedure TLSMForm.gramm_schumidt(Var aTMArray;Var n:integer; Var m:integer;Var q:TMArray);
var i,j,k:integer;
    s:double;
begin

  for i:=0 to n-1 do begin
    for j:=0 to m-1 do begin
      q[i,j]:=a[i,j];
    end;
  end;
  for j:=0 to m-1 do begin
    s:=0;
    for i:=0 to n-1 do begin
      s:=s+q[i,j]*q[i,j];
    end;
    s:=1/ Sqrt(s);
    for i:=0 to n-1 do begin
      q[i,j]:=q[i,j]*s
    end;
    for k:=j+1 to m-1 do begin
      s:=0;
      for i:=0to n-1 do begin
        s:=s+q[i,k]*q[i,j];
      end;
      for i:=0 to n-1 do begin
        q[i,k]:=q[i,k]-s*q[i,j]
      end;
    end;
  end;

end;



procedure TLSMForm.BitBtn3Click(Sender: TObject);
var i,times:integer;
begin
  times:=SpinEdit1.Value;

  if Radiobutton1.Checked then begin
    for i:=1 to times do begin
      Button1.Click;
      Button2.Click;
      BitBtn1.Click;

    //  BendingForm2.Button1.Click
    end;
  end;

  if RadioButton2.Checked then begin
    for i:=1 to times do begin
      Button1.Click;
      Button7.Click;
      BitBtn1.Click;

    //  BendingForm2.Button1.Click
    end;
  end;

end;



procedure TLSMForm.BitBtn4Click(Sender: TObject);
begin

  WeightAbe[4]:=StrToFloat(StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+1]);
//  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF((TargetFL-CorrFL)*WeightAbe[4],ffGeneral,5,2);
  StringGrid1.Cells[4,CorrOptSys.TotalSurfaceNumber+2+2+2]:='0';

  WeightAbe[5]:=StrToFloat(StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[5,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaFLC[0]*WeightAbe[5],ffGeneral,5,2);

  WeightAbe[6]:=StrToFloat(StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[6,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaFLg[0]*WeightAbe[6],ffGeneral,5,2);

  WeightAbe[7]:=StrToFloat(StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+1]);
//  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF((TargetBFL-CorrBFL)*WeightAbe[7],ffGeneral,5,2);
  StringGrid1.Cells[7,CorrOptSys.TotalSurfaceNumber+2+2+2]:='0';

  WeightAbe[8]:=StrToFloat(StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[8,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSA9[0]*WeightAbe[8],ffGeneral,5,2);

  WeightAbe[9]:=StrToFloat(StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[9,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSA7[0]*WeightAbe[9],ffGeneral,5,2);

  WeightAbe[10]:=StrToFloat(StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[10,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaCO9[0]*WeightAbe[10],ffGeneral,5,2);

  WeightAbe[11]:=StrToFloat(StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[11,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaCO7[0]*WeightAbe[11],ffGeneral,5,2);

  WeightAbe[12]:=StrToFloat(StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[12,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaMAS[0]*WeightAbe[12],ffGeneral,5,2);

  WeightAbe[13]:=StrToFloat(StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[13,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaSAS[0]*WeightAbe[13],ffGeneral,5,2);

  WeightAbe[14]:=StrToFloat(StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[14,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaDS[0]*WeightAbe[14],ffGeneral,5,2);

  WeightAbe[15]:=StrToFloat(StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[15,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*CofL[0]*WeightAbe[15],ffGeneral,5,2);

  WeightAbe[16]:=StrToFloat(StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[16,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*CofT[0]*WeightAbe[16],ffGeneral,5,2);


  WeightAbe[17]:=StrToFloat(StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+1]);
  StringGrid1.Cells[17,CorrOptSys.TotalSurfaceNumber+2+2+2]:=FloatToStrF(-1*DeltaMAG[ng,0]*WeightAbe[17],ffGeneral,5,2);


  BitBtn4.Font.Color:=clBlack;
  StringGrid1.Font.Color:=clBlack;
end;

procedure TLSMForm.SpinButton2DownClick(Sender: TObject);
begin
   if StrToFloat(LabeledEdit1.Text)<=1E+1 then begin
     LabeledEdit1.Text:='0';
     DampingFactor:=StrToFloat(LabeledEdit1.Text);
   end else begin
     DampingFactor:=DampingFactor/10;
     LabeledEdit1.Text:=FloatToStrF(DampingFactor,ffExponent,2,2);
   end;
 //  Memo1.Text:=Memo1.Text+FloatToStr(DampingFactor)+#13#10;
end;

procedure TLSMForm.SpinButton2UpClick(Sender: TObject);
begin
   if StrToFloat(LabeledEdit1.Text)=0 then begin
     LabeledEdit1.Text:='1E+1';
     DampingFactor:=StrToFloat(LabeledEdit1.Text);
   end else begin
     DampingFactor:=DampingFactor*10;
     LabeledEdit1.Text:=FloatToStrF(DampingFactor,ffExponent,2,2);
   end;
 //   Memo1.Text:=Memo1.Text+FloatToStr(DampingFactor)+#13#10;
end;

procedure TLSMForm.SpinButton3DownClick(Sender: TObject);
begin

     if anInputAngle<=1 then begin
       if anInputAngle=0.1 then begin
         anInputAngle:=0;
         Edit4.Text:=FloatToStr(anInputAngle);
        end else begin
         anInputAngle:=anInputAngle-0.1;
         Edit4.Text:=FloatToStr(anInputAngle);
        end;
     end else begin
       anInputAngle:=anInputAngle-1;
       Edit4.Text:=FloatToStr(anInputAngle);
     end;

end;

procedure TLSMForm.SpinButton3UpClick(Sender: TObject);
begin
   if anInputAngle>=1then begin
     anInputAngle:=anInputAngle+1;
     Edit4.Text:=FloatToStr(anInputAngle);
   end else begin
     anInputAngle:=anInputAngle+0.1;
     Edit4.Text:=FloatToStr(anInputAngle);
   end;

end;

procedure TLSMForm.Edit4Change(Sender:Tobject);
begin
  anInputAngle:=StrToFloat(Edit4.Text);

end;

initialization

end.

