unit Bending;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,
  
  Excel2000,OleServer,

  MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray, Grids,
  ComCtrls, Spin;



type
  TBendingForm = class(TForm)
    Panel1: TPanel;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    Button1: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    StringGrid: TStringGrid;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    SpinEdit3: TSpinEdit;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Button2: TButton;
    Edit1: TEdit;
    Label5: TLabel;
    TabSheet3: TTabSheet;
    Memo1: TMemo;
    Button3: TButton;
    Button4: TButton;
    OpenDialog1: TOpenDialog;
    SpinEdit4: TSpinEdit;
    SpinEdit5: TSpinEdit;
    Label6: TLabel;
    Label7: TLabel;
    Button5: TButton;
    Label8: TLabel;


    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure ScrollBar1Change(Sender:TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);

  private
    { Private 錾 }
    FirstBendingFace:integer;
    SecondBendingFace:integer;
    Cof: TCof;
    Ttg: TTtg;
    BendCofSA: Array[0..10] of single;
    BendCofCO: Array[0..10] of single;
    BendCofAS: Array[0..10] of single;
    BendCofPT: Array[0..10] of single;
    BendCofDS: Array[0..10] of single;
    BendCofL: Array[0..10] of single;
    BendCofT: Array[0..10] of single;
    BendCofFL: Array[0..10] of single;

    FirstCr: Array[0..10] of extended;
    SecondCr: Array[0..10] of extended;

    BendingStep:double;
    Scale: Extended;

    ListCofIncrease: Array[0.. MaxOptSurface] of single;
    ListCofSA: Array[0.. MaxOptSurface] of single;
    ListCofCO: Array[0.. MaxOptSurface] of single;
    ListCofAS: Array[0.. MaxOptSurface] of single;
    ListCofPT: Array[0.. MaxOptSurface] of single;
    ListCofDS: Array[0.. MaxOptSurface] of single;
    ListCofL: Array[0.. MaxOptSurface] of single;
    ListCofT: Array[0.. MaxOptSurface] of single;
    ListCofFL: Array[0.. MaxOptSurface] of single;

    ExcelObj   : OleVariant;
    WorkBook   : OleVariant;
    WorkSheet  : OleVariant;

    aCoffOptSys: TOptSystem;
    aCoffOptSys2: TOptSystem;

    procedure Initialize(sender:TObject);
    procedure Bending;
    procedure Draw;
    procedure DrawGrid;
    procedure DrawLine(color:TColor; data: array of single);
  public
    { Public 錾 }
  end;

var
  BendingForm: TBendingForm;

implementation

uses DataGrid,ComObj, UnitedData;




{$R *.dfm}


procedure TBendingForm.Initialize(sender:Tobject);
var i:integer;
begin
  for i:=0 to 10 do begin
    BendCofSA[i]:=0;
    BendCofCO[i]:=0;
    BendCofAS[i]:=0;
    BendCofPT[i]:=0;
    BendCofDS[i]:=0;
    BendCofL[i]:=0;
    BendCofT[i]:=0;
    FirstCr[i]:=0;
    SecondCr[i]:=0;
    BendCofFL[i]:=0;
  end;

  if OpticalSystem.TotalSurfaceNumber=1 then begin
    SpinEdit1.MaxValue:=2;
    SpinEdit2.MaxValue:=2;
    SpinEdit1.MinValue:=1;
    SpinEdit2.MinValue:=1;

  end else begin
    SpinEdit1.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit2.MaxValue:=OpticalSystem.TotalSurfaceNumber;
  end;
  ScrollBar1Change(Sender);
  DrawGrid;


  aCoffOptSys:=TOptSystem.Create;
  aCoffOptSys.initialize;

  aCoffOptSys2:=TOptSystem.Create;
  aCoffOptSys2.initialize;

end;

procedure TBendingForm.SpinEdit1Change;
begin
  FirstBendingFace:=SpinEdit1.Value;
end;

procedure TBendingForm.SpinEdit2Change(Sender: TObject);
begin
  SecondBendingFace:=SpinEdit2.Value;
end;

procedure TBendingForm.Bending;
var aTotalPower:double;
    i:integer;
begin
  aCoffOptSys.copyFrom(OpticalSystem);
  aCoffOptSys.ParAxialTrace(FinalOpt);
  aCoffOptSys. CaluculateCoefficient(Cof,Ttg);

  aTotalPower:=aCoffOptSys.OpticalSurface[FirstBendingFace].curvature
               -aCoffOptSys.OpticalSurface[SecondBendingFace].curvature;


  for i:=0 to 5 do begin
    if aCoffOptSys.OpticalSurface[FirstBendingFace].curvature=0 then begin
      FirstCr[i]:=aCoffOptSys.OpticalSurface[FirstBendingFace].curvature
                + abs(aCoffOptSys.OpticalSurface[SecondBendingFace].curvature)*i*BendingStep;
    end else begin
      FirstCr[i]:=aCoffOptSys.OpticalSurface[FirstBendingFace].curvature
                + abs(aCoffOptSys.OpticalSurface[FirstBendingFace].curvature)*i*BendingStep;
    end;

    SecondCr[i]:=FirstCr[i]
                - aTotalPower;
  end;

  for i:=6 to 10 do begin
    if aCoffOptSys.OpticalSurface[FirstBendingFace].curvature=0 then begin
      FirstCr[i]:=aCoffOptSys.OpticalSurface[FirstBendingFace].curvature
                - abs(aCoffOptSys.OpticalSurface[SecondBendingFace].curvature)*(i-5)*BendingStep;
    end else begin
      FirstCr[i]:=aCoffOptSys.OpticalSurface[FirstBendingFace].curvature
                 - abs(aCoffOptSys.OpticalSurface[FirstBendingFace].curvature)*(i-5)*BendingStep;
    end;

    SecondCr[i]:=FirstCr[i]
                 - aTotalPower;
  end;




  for i:=0 to 10 do begin
    aCoffOptSys.OpticalSurface[FirstBendingFace].curvature:=FirstCr[i];
    aCoffOptSys.OpticalSurface[SecondBendingFace].curvature:=SecondCr[i] ;

    aCoffOptSys.ParAxialTrace(FinalOpt);
    aCoffOptSys. CaluculateCoefficient(Cof,Ttg);

    BendCofSA[i]:=Cof[aCoffOptSys.TotalSurfaceNumber+1,1];
    BendCofCO[i]:=Cof[aCoffOptSys.TotalSurfaceNumber+1,2];
    BendCofAS[i]:=Cof[aCoffOptSys.TotalSurfaceNumber+1,3];
    BendCofPT[i]:=Cof[aCoffOptSys.TotalSurfaceNumber+1,4];
    BendCofDS[i]:=Cof[aCoffOptSys.TotalSurfaceNumber+1,5];
    BendCofL[i]:=Ttg[aCoffOptSys.TotalSurfaceNumber+1,1];
    BendCofT[i]:=Ttg[aCoffOptSys.TotalSurfaceNumber+1,2];

    BendCofFL[i]:=Cof[aCoffOptSys.TotalSurfaceNumber+1,7];
  end;

end;

procedure TBendingForm.Draw;
begin
  PaintBox1.Canvas.Pen.Color:=clBlack;

  PaintBox1.Canvas.Rectangle(0,0,PaintBox1.width,PaintBox1.height);

  PaintBox1.Canvas.MoveTo(0,trunc(PaintBox1.height/2));
  PaintBox1.Canvas.LineTo(PaintBox1.width ,trunc(PaintBox1.height/2));
  PaintBox1.Canvas.MoveTo(Trunc( PaintBox1.width / 2),0);
  PaintBox1.Canvas.LineTo(Trunc( PaintBox1.width / 2) ,PaintBox1.height);

  if CheckBox1.Checked=true then begin
    self.DrawLine(clWhite,BendCofSA);
  end;

  if CheckBox2.Checked=true then begin
   self.DrawLine(clYellow,BendCofCO);
  end;

  if CheckBox3.Checked=true then begin
   self.DrawLine(clBlue,BendCofAS);
  end;

  if CheckBox4.Checked=true then begin
   self.DrawLine(clLime,BendCofPT);
  end;

  if CheckBox5.Checked=true then begin
   self.DrawLine(clAqua,BendCofDS);
  end;

  if CheckBox6.Checked=true then begin
   self.DrawLine(clRed,BendCofL);
  end;

  if CheckBox7.Checked=true then begin
   self.DrawLine(clPurple,BendCofT);
  end;

  self.Caption:='xfBOɂWω'+'/'+OpticalSystem.OpticalName;
end;


procedure TBendingForm.DrawLine(color:TColor; data : array of single);
var i:integer;
    aYPoint,aXPoint: array[0..10] of longint;
begin
  PaintBox1.Canvas.Pen.Color:=color;
  for i:=0 to 5 do begin
    aYPoint[i]:=trunc(PaintBox1.height/2) - trunc( ( data[i]{-data[0]})/(Scale/(PaintBox1.height / 2)) );
    aXPoint[i]:=trunc(PaintBox1.width / 2) + Trunc( PaintBox1.width / 2 /5 * i );
  end;
  PaintBox1.Canvas.MoveTo(aXPoint[0],aYPoint[0]);
  for i:=0 to 5 do begin
    PaintBox1.Canvas.LineTo(aXPoint[i],aYPoint[i]);
  end;

  for i:=6 to 10 do begin
    aYPoint[i]:=trunc(PaintBox1.height/2) - trunc( ( data[i]{-data[0]})/(Scale/(PaintBox1.height / 2)) );
    aXPoint[i]:=trunc(PaintBox1.width / 2) - Trunc( PaintBox1.width / 2 /5 * (i-5) );
  end;
  PaintBox1.Canvas.MoveTo(aXPoint[0],aYPoint[0]);
  for i:=6 to 10 do begin
    PaintBox1.Canvas.LineTo(aXPoint[i],aYPoint[i]);
  end;

end;

procedure TBendingForm.DrawGrid;
var cel,row,stepNumber: integer;
begin
  for cel:=0 to 10 do begin
    for row:=0 to 12 do begin
     // StringGrid.Cells[cel,row]:='';
    end;
  end;

  stepNumber:=5;
  for row:=0 to 10 do begin
    StringGrid.Cells[0,row+1]:=FloatToStr( BendingStep*(stepNumber-row)*100 )+ '';
  end;

  for cel:=1 to 10 do begin
      case cel of
       1: StringGrid.Cells[1,0]:='ʋȗ';
       2: StringGrid.Cells[2,0]:='Όʋȗ';
       3: StringGrid.Cells[cel,0]:='ʎ';
       4: StringGrid.Cells[cel,0]:='R}';
       5: StringGrid.Cells[cel,0]:='_';
       6: StringGrid.Cells[cel,0]:='ybcp-';
       7: StringGrid.Cells[cel,0]:='cȎ';
       8: StringGrid.Cells[cel,0]:='F';
       9: StringGrid.Cells[cel,0]:='{F';
       10:StringGrid.Cells[cel,0]:='œ_';
      end;
  end;

  for row:=0 to 5 do begin
    StringGrid.Cells[1,row+1]:=FloatToStrF( FirstCr[stepNumber-row]-FirstCr[0],ffGeneral,4,2 );
    if row=5 then begin
      StringGrid.Cells[1,row+1]:=FloatToStrF( FirstCr[stepNumber-row],ffGeneral,4,2 );
    end;
  end;

  for row:=6 to 10 do begin
    StringGrid.Cells[1,row+1]:=FloatToStrF( FirstCr[row]-FirstCr[0],ffGeneral,4,2 );
  end;


  for row:=0 to 5 do begin
    StringGrid.Cells[2,row+1]:=FloatToStrF( SecondCr[stepNumber-row]-SecondCr[0],ffGeneral,4,2 );
    if row=5 then begin
     StringGrid.Cells[2,row+1]:=FloatToStrF( SecondCr[stepNumber-row],ffGeneral,4,2 );
    end;
  end;
  
  for row:=6 to 10 do begin
    StringGrid.Cells[2,row+1]:=FloatToStrF( SecondCr[row]-SecondCr[0],ffGeneral,4,2 );
  end;


  for row:=0 to 5 do begin
    StringGrid.Cells[3,row+1]:=FloatToStrF( BendCofSA[stepNumber-row]-BendCofSA[0],ffGeneral,4,2 );
  end;
  for row:=6 to 10 do begin
    StringGrid.Cells[3,row+1]:=FloatToStrF( BendCofSA[row]-BendCofSA[0],ffGeneral,4,2 );
  end;

  for row:=0 to 5 do begin
    StringGrid.Cells[4,row+1]:=FloatToStrF( BendCofCO[stepNumber-row]-BendCofCO[0],ffGeneral,4,2 );
  end;
  for row:=6 to 10 do begin
    StringGrid.Cells[4,row+1]:=FloatToStrF( BendCofCO[row]-BendCofCO[0],ffGeneral,4,2 );
  end;

  for row:=0 to 5 do begin
    StringGrid.Cells[5,row+1]:=FloatToStrF( BendCofAS[stepNumber-row]-BendCofAS[0],ffGeneral,4,2 );
  end;
  for row:=6 to 10 do begin
    StringGrid.Cells[5,row+1]:=FloatToStrF( BendCofAS[row]-BendCofAS[0],ffGeneral,4,2 );
  end;

  for row:=0 to 5 do begin
    StringGrid.Cells[6,row+1]:=FloatToStrF( BendCofPT[stepNumber-row]-BendCofPT[0],ffGeneral,4,2 );
  end;
  for row:=6 to 10 do begin
    StringGrid.Cells[6,row+1]:=FloatToStrF( BendCofPT[row]-BendCofPT[0],ffGeneral,4,2 );
  end;

  for row:=0 to 5 do begin
    StringGrid.Cells[7,row+1]:=FloatToStrF( BendCofDS[stepNumber-row]-BendCofDS[0],ffGeneral,4,2 );
  end;
  for row:=6 to 10 do begin
    StringGrid.Cells[7,row+1]:=FloatToStrF( BendCofDS[row]-BendCofDS[0],ffGeneral,4,2 );
  end;

   for row:=0 to 5 do begin
    StringGrid.Cells[8,row+1]:=FloatToStrF( BendCofL[stepNumber-row]-BendCofL[0],ffGeneral,4,2 );
  end;
  for row:=6 to 10 do begin
    StringGrid.Cells[8,row+1]:=FloatToStrF( BendCofL[row]-BendCofL[0],ffGeneral,4,2 );
  end;

  for row:=0 to 5 do begin
    StringGrid.Cells[9,row+1]:=FloatToStrF( BendCofT[stepNumber-row]-BendCofT[0],ffGeneral,4,2 );
  end;
  for row:=6 to 10 do begin
    StringGrid.Cells[9,row+1]:=FloatToStrF( BendCofT[row]-BendCofT[0],ffGeneral,4,2 );
  end;

  for row:=0 to 5 do begin
    StringGrid.Cells[10,row+1]:=FloatToStrF( BendCofFL[stepNumber-row]-BendCofFL[0],ffGeneral,4,2 );
  end;
  for row:=6 to 10 do begin
    StringGrid.Cells[10,row+1]:=FloatToStrF( (BendCofFL[row]-BendCofFL[0]),ffGeneral,4,2 );
  end;

end;

procedure TBendingForm.Button1Click(Sender: TObject);
begin
  if OpticalSystem.TotalSurfaceNumber=1 then exit;

  FirstBendingFace:=SpinEdit1.Value;
  SecondBendingFace:=SpinEdit2.Value;
  BendingStep:=SpinEdit3.Value*0.01;

  self.Bending;
  self.Draw;
  self.DrawGrid;
  
end;

procedure TBendingForm.SpinEdit3Change(Sender: TObject);
begin
  BendingStep:=SpinEdit3.Value*0.01;
end;

procedure TBendingForm.ScrollBar1Change(Sender:TObject);
begin
  Scale:=ScrollBar1.Position/100;
  Edit1.Text:=FloatToStr( Scale );
  self.Draw;
end;

procedure TBendingForm.FormCreate(Sender: TObject);
begin
  self.Initialize(sender);
end;

procedure TBendingForm.Button2Click(Sender: TObject);
var i:integer;
begin
  i:=0;
  
  case StringGrid.Row of
    1:  i:=5;
    2:  i:=4;
    3:  i:=3;
    4:  i:=2;
    5:  i:=1;
    6:  i:=0;
    7:  i:=6;
    8:  i:=7;
    9:  i:=8;
    10: i:=9;
    11: i:=10;
  end;

  aCoffOptSys.OpticalSurface[FirstBendingFace].curvature:=FirstCr[i];
  aCoffOptSys.OpticalSurface[SecondBendingFace].curvature:=SecondCr[i];

  OpticalSystem.copyFrom(aCoffOptSys);

  DataGridForm.BitBtn2.Click;
  DataGridForm.BitBtn3.Click;

end;

procedure TBendingForm.PaintBox1Paint(Sender: TObject);
begin
try
  self.Draw;
except
  exit;
end;
end;

procedure TBendingForm.FormShow(Sender: TObject);
begin
  if OpticalSystem.TotalSurfaceNumber=1 then begin
    SpinEdit1.MaxValue:=2;
    SpinEdit2.MaxValue:=2;
    SpinEdit1.MinValue:=1;
    SpinEdit2.MinValue:=1;

  end else begin
    SpinEdit1.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit2.MaxValue:=OpticalSystem.TotalSurfaceNumber;
  end;
  ScrollBar1Change(Sender);
end;


procedure TBendingForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  self.Hide;
end;

procedure TBendingForm.Button3Click(Sender: TObject);
  var i:integer;
begin
  BendingStep:=SpinEdit3.Value*0.01;
  aCoffOptSys2.copyFrom(OpticalSystem);
  aCoffOptSys2.ParAxialTrace(FinalOpt);
  aCoffOptSys2. CaluculateCoefficient(Cof,Ttg);

  ListCofSA[0]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,1];
  ListCofCO[0]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,2];
  ListCofAS[0]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,3];
  ListCofPT[0]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,4];
  ListCofDS[0]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,5];
  ListCofL[0]:=ttg[aCoffOptSys2.TotalSurfaceNumber+1,1];
  ListCofT[0]:=ttg[aCoffOptSys2.TotalSurfaceNumber+1,2];
  ListCofFL[0]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,7];




  for i:=1 to aCoffOptSys2.TotalSurfaceNumber do  begin
    aCoffOptSys2.copyFrom(OpticalSystem);
    aCoffOptSys2.OpticalSurface[i].curvature:=aCoffOptSys2.OpticalSurface[i].curvature
                                          +abs(aCoffOptSys2.OpticalSurface[i].curvature*BendingStep);
    aCoffOptSys2.ParAxialTrace(FinalOpt);
    aCoffOptSys2. CaluculateCoefficient(Cof,Ttg);

    ListCofIncrease[i]:=abs(aCoffOptSys2.OpticalSurface[i].curvature*BendingStep);
    ListCofSA[i]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,1]-ListCofSA[0];
    ListCofCO[i]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,2]-ListCofCO[0];
    ListCofAS[i]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,3]-ListCofAS[0];
    ListCofPT[i]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,4]-ListCofPT[0];
    ListCofDS[i]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,5]-ListCofDS[0];
    ListCofL[i]:=ttg[aCoffOptSys2.TotalSurfaceNumber+1,1]-ListCofL[0];
    ListCofT[i]:=ttg[aCoffOptSys2.TotalSurfaceNumber+1,2]-ListCofT[0];
    ListCofFL[i]:=Cof[aCoffOptSys2.TotalSurfaceNumber+1,7]-ListCofFL[0];
  end;


  Memo1.Lines.Add('        '+'@       @'+'@    R} @'+'@  _ '+'  ybcp[ '+'   c  '+'    F  '+'   {F  '+ '  œ_ ') ;

  for i:=1 to aCoffOptSys2.TotalSurfaceNumber do begin
    Memo1.Lines.Add('r'+IntToStr(i)+'   '
                    +FloatToStrF(ListCofIncrease[i],ffFixed,6,6)+' || '
                    +FloatToStrF(ListCofSA[i],ffFixed,6,6)+' || '
                    +FloatToStrF(ListCofCO[i],ffFixed,6,6)+' || '
                    +FloatToStrF(ListCofAS[i],ffFixed,6,6)+' || '
                    +FloatToStrF(ListCofPT[i],ffFixed,6,6)+' || '
                    +FloatToStrF(ListCofDS[i],ffFixed,6,6)+' || '
                    +FloatToStrF(ListCofL[i],ffFixed,6,6)+' || '
                    +FloatToStrF(ListCofT[i],ffFixed,6,6)+' || '
                    +FloatToStrF(ListCofFL[i],ffFixed,6,6)+' '
                    );
    Memo1.Lines.Add(#13);
  end;

end;


procedure TBendingForm.Button4Click(Sender: TObject);
var i:integer;
begin
 //if VarIsEmpty(ExcelObj) then begin
    //Excel̃IuWFNg쐬(̌x⃁bZ[W\)
    ExcelObj := CreateOleObject('Excel.Application');
    ExcelObj.DisplayAlerts := False;

    //ubN쐬
    WorkBook := ExcelObj.Workbooks.Add;

    //V[gIuWFNg`
    WorkSheet := WorkBook.WorkSheets[1];

    //\
    ExcelObj.Visible := True;

    //ő剻ŕ\
    //ŃGNZPƋNő剻\ƂȂĂ܂̂Œ
  //  ExcelObj.WindowState := xlMiximized;
  for i:=1 to aCoffOptSys.TotalSurfaceNumber do begin
   WorkSheet.Cells[1,i+1]:=i;
  end;

      WorkSheet.Cells[1+1,1]:='ʎ';
      WorkSheet.Cells[2+1,1]:='R}';
      WorkSheet.Cells[3+1,1]:='_';
      WorkSheet.Cells[4+1,1]:='ybcp[';
      WorkSheet.Cells[5+1,1]:='c';
      WorkSheet.Cells[6+1,1]:='F';
      WorkSheet.Cells[7+1,1]:='{F';
      WorkSheet.Cells[8+1,1]:='œ_';

      WorkSheet.Cells[10+1,1]:='ȗ';
      WorkSheet.Cells[11+1,1]:='';

    for i:=1 to aCoffOptSys2.TotalSurfaceNumber do begin
      WorkSheet.Cells[1+1,i+1]:=ListCofSA[i];
      WorkSheet.Cells[2+1,i+1]:=ListCofCO[i];
      WorkSheet.Cells[3+1,i+1]:=ListCofAS[i];
      WorkSheet.Cells[4+1,i+1]:=ListCofPT[i];
      WorkSheet.Cells[5+1,i+1]:=ListCofDS[i];
      WorkSheet.Cells[6+1,i+1]:=ListCofL[i];
      WorkSheet.Cells[7+1,i+1]:=ListCofT[i];
      WorkSheet.Cells[8+1,i+1]:=ListCofFL[i];

      WorkSheet.Cells[10+1,i+1]:=OpticalSystem.OpticalSurface[i].Curvature;
      WorkSheet.Cells[11+1,i+1]:=FloatToStrF(ListCofIncrease[i],ffGeneral,4,2);
    end;



 // end;
end;

procedure TBendingForm.Button5Click(Sender: TObject);
var i,aRow,aCol:integer;
begin
  aRow:=spinEdit4.Value;
  aCol:=SpinEdit5.Value;

  for i:=1 to aCoffOptSys.TotalSurfaceNumber do begin
   OpticalSystem.OpticalSurface[i].Curvature:=StrToFloat(WorkSheet.Cells[aRow-1+i,aCol]);
  end;

  UnitedDataForm.BitBtn2Click(sender);

end;



procedure TBendingForm.PageControl1Change(Sender: TObject);
begin
  if PageControl1.ActivePageIndex=2 then begin
    Button1.Visible:=False;
    Button2.Visible:=False;

    Button3.Visible:=True;
    Button4.Visible:=True;
  //  Button5.Visible:=True;
  //  SpinEdit4.Visible:=True;
  //  SpinEdit5.Visible:=True;
  //  Label6.Visible:=True;
  //  Label7.Visible:=True;
 //   Label8.Visible:=True;
  end else begin
    Button1.Visible:=True;
    Button2.Visible:=True;


    Button3.Visible:=False;
    Button4.Visible:=False;
    Button5.Visible:=False;
    SpinEdit4.Visible:=False;
    SpinEdit5.Visible:=False;
    Label6.Visible:=False;
    Label7.Visible:=False;
    Label8.Visible:=False;
  end;



end;

initialization



  
end.
