unit Bending2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,  Grids, ComCtrls, ExtCtrls,
  MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray, Spin,BendingAberCurve,
  Buttons;

type
  TBendingForm2 = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    SpinEdit1: TSpinEdit;
    Edit4: TEdit;
    ScrollBar1: TScrollBar;
    Label3: TLabel;
    Edit1: TEdit;
    Button1: TButton;
    Label2: TLabel;
    SpinEdit2: TSpinEdit;
    Edit5: TEdit;
    GroupBox2: TGroupBox;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    Edit2: TEdit;
    ScrollBar2: TScrollBar;
    Panel3: TPanel;
    PaintBoxAS: TPaintBox;
    Edit3: TEdit;
    ScrollBar3: TScrollBar;
    Panel4: TPanel;
    PaintBox3: TPaintBox;
    SpinEdit3: TSpinEdit;
    ScrollBar4: TScrollBar;
    Edit6: TEdit;
    Edit7: TEdit;
    Label4: TLabel;
    Label5: TLabel;
    Button3: TButton;
    SpinEdit4: TSpinEdit;
    Label6: TLabel;
    Edit8: TEdit;
    ScrollBar5: TScrollBar;
    Edit9: TEdit;
    SpinButton1: TSpinButton;
    Button5: TButton;
    Edit10: TEdit;
    Label7: TLabel;
    Edit11: TEdit;
    Label8: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Button2: TButton;
    CheckBox1: TCheckBox;
   
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure SpinEdit4Change(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure ScrollBar5Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ScrollBar4Change(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBoxASPaint(Sender: TObject);
    procedure PaintBox3Paint(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    BendOptSys: TOptSystem;

    BendingStep:double;
    SAGraphScale: extended;
    FirstBendingFace:integer;
    SecondBendingFace:integer;
    InputAngle:extended;
    InputAngleDecimal:extended;
    FirstCr,SecondCr:extended;
    clNt,clNs,clNr,clNC,clNd,clNe,clNF,clNg,clNh,clNi :Tcolor;
    Space:integer;
    ASGraphScale: extended;
    DISGraphScale: extended;
    Spacing: extended;
    SpacingIndex: integer;
    Distance: extended;
    
    SA: TSA;
    OSC: TOSC;
    MAS: TMAS;
    SAS: TSAS;
    DIS: TDIS;
 //   MAG: TMAG;

    procedure DrawGraphLine(aPaintBox:TPaintBox; aSpace:integer);
    procedure SADraw;
    procedure ASDraw;
    procedure DrawDistortion;
    procedure Initialize(Sender: TObject);
  public
    { Public 錾 }
    function GetInputAngle:extended;
    function GetBendOptSys:TOptSystem;
  end;

var
  BendingForm2: TBendingForm2;

implementation

uses DataGrid, MediumDataGrid, AutoCorrection, SpotCorrection, PlanBrowser;

{$R *.dfm}
function TBendingForm2.GetBendOptSys:TOptSystem;
begin
  result:=(BendOptSys);
end;

function TBendingForm2.GetInputAngle:extended;
begin
   result:=InputAngle;
end;

procedure TBendingForm2.Initialize(Sender: TObject);
var
  n:TSpectru;
  j:integer;
begin

  BendOptSys:=TOptSystem.Create;
  BendOptSys.initialize;


  for n:=nd to nt do begin
    for j:=1 to MaxSANumber do begin
      SA[n,j]:=0;
    end;
  end;


  for j:=1 to MaxSANumber do begin
    OSC[j]:=0;
  end;

  for j:=1 to MaxAngleNumber do begin
    MAS[j]:=0;
    SAS[j]:=0;
    DIS[j]:=0;
  end;

  clNt:=clMaroon;//$00007B;
  clNs:=$0000B9;
  clNr:=$6A1EE1;
  clNC:=clRed;
  clNd:=clYellow;
  clNe:=$05FF9A;
  clNF:=$40FF00;//clLime;//$8EFF04;
  clNg:=clBlue;
  clNh:=clNavy;
  clNi:=$800080;


  BendOptSys.copyFrom(OpticalSystem);

  if OpticalSystem.TotalSurfaceNumber=1 then begin
    SpinEdit1.MaxValue:=2;
    SpinEdit2.MaxValue:=2;
    SpinEdit1.MinValue:=1;
    SpinEdit2.MinValue:=1;

    SpinEdit3.MaxValue:=1;
    SpinEdit3.MinValue:=0;
  end else begin
    SpinEdit1.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit2.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit1.MinValue:=1;
    SpinEdit2.MinValue:=1;

    SpinEdit3.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit3.MinValue:=1;
  end;

  SpinEdit1Change(Sender);
  SpinEdit2Change(Sender);
  ScrollBar2Change(Sender);
  BendingStep:=0.0;
  Space:=5;
  Spacing:=0.0;

  ScrollBar3Change(Sender);
  ScrollBar5Change(Sender);

  SpacingIndex:=1;
  SpinEdit3Change(Sender);
  Edit10.Text:=FloatToStrF(BendOptSys.FocalLength[nd],ffGeneral,4,2 );
  Edit11.Text:=FloatToStrF(BendOptSys.BackFocus[nd],ffGeneral,4,2 );

  self.Caption:='xfBO'+'/'+OpticalSystem.OpticalName;
end;

procedure TBendingForm2.SpinEdit1Change(Sender: TObject);
begin

  FirstBendingFace:=SpinEdit1.Value;
  Edit4.Text:=FloatToStrF(BendOptSys.OpticalSurface[FirstBendingFace].curvature,ffGeneral,4,2 );
  ScrollBar1.Position:=0;
  Edit1.Text:='0';
  BitBtn1.Font.Color:=clBlack;
end;

procedure TBendingForm2.SpinEdit2Change(Sender: TObject);
begin
  SecondBendingFace:=SpinEdit2.Value;
  Edit5.Text:=FloatToStrF(BendOptSys.OpticalSurface[SecondBendingFace].curvature,ffGeneral,4,2 );
  ScrollBar1.Position:=0;
  Edit1.Text:='0';
  BitBtn1.Font.Color:=clBlack;
end;

procedure TBendingForm2.FormCreate(Sender: TObject);
begin

  self.Initialize(Sender);
{
  clNt:=clMaroon;//$00007B;
  clNs:=$0000B9;
  clNr:=$6A1EE1;
  clNC:=clRed;
  clNd:=clYellow;
  clNe:=$05FF9A;
  clNF:=$40FF00;//clLime;//$8EFF04;
  clNg:=clBlue;
  clNh:=clNavy;
  clNi:=$800080;


  BendOptSys.copyFrom(OpticalSystem);

  if OpticalSystem.TotalSurfaceNumber=1 then begin
    SpinEdit1.MaxValue:=2;
    SpinEdit2.MaxValue:=2;
    SpinEdit1.MinValue:=1;
    SpinEdit2.MinValue:=1;

    SpinEdit3.MaxValue:=1;
    SpinEdit3.MinValue:=0;
  end else begin
    SpinEdit1.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit2.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit1.MinValue:=1;
    SpinEdit2.MinValue:=1;

    SpinEdit3.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit3.MinValue:=1;
  end;

  SpinEdit1Change(Sender);
  SpinEdit2Change(Sender);
  ScrollBar2Change(Sender);
  BendingStep:=0.0;
  Space:=5;
  Spacing:=0.0;

  ScrollBar3Change(Sender);
  ScrollBar5Change(Sender);

  SpacingIndex:=1;
  SpinEdit3Change(Sender);

 }
end;


procedure TBendingForm2.Button1Click(Sender: TObject);
var aTotalPower:extended;
begin
  BendOptSys.copyFrom(OpticalSystem);
  BendOptSys.ParAxialTrace(FinalOpt);


  aTotalPower:=BendOptSys.OpticalSurface[FirstBendingFace].curvature
               -BendOptSys.OpticalSurface[SecondBendingFace].curvature;



  if BendOptSys.OpticalSurface[FirstBendingFace].curvature=0 then begin
      FirstCr:=BendOptSys.OpticalSurface[FirstBendingFace].curvature
                + abs(BendOptSys.OpticalSurface[SecondBendingFace].curvature)*BendingStep;
  end else begin
      FirstCr:=BendOptSys.OpticalSurface[FirstBendingFace].curvature
                + abs(BendOptSys.OpticalSurface[FirstBendingFace].curvature)*BendingStep;
  end;

  SecondCr:=FirstCr
                - aTotalPower;

  BendOptSys.OpticalSurface[FirstBendingFace].curvature:= FirstCr;
  BendOptSys.OpticalSurface[SecondBendingFace].curvature:=SecondCr;

  BendOptSys.ParAxialTrace(FinalOpt);
  BendOptSys.CalculateSphericalAberration( SA, OSC);
  BendOptSys.CalculateAS( MAS, SAS, InputAngle );
  BendOptSys.CalculateDistortion( DIS, InputAngle);

  Edit4.Text:=FloatToStrF(BendOptSys.OpticalSurface[FirstBendingFace].curvature,ffGeneral,4,2 );
  Edit5.Text:=FloatToStrF(BendOptSys.OpticalSurface[SecondBendingFace].curvature,ffGeneral,4,2 );

  DrawGraphLine(PaintBox1,Space);
  SADraw;

  DrawGraphLine(PaintBoxAS,Space);
  ASDraw;
                                                                         
  DrawGraphLine(PaintBox3,Space);
  DrawDistortion;
   Edit10.Text:=FloatToStrF(BendOptSys.FocalLength[nd],ffGeneral,4,2 );
   Edit11.Text:=FloatToStrF(BendOptSys.BackFocus[nd],ffGeneral,4,2 );
end;

procedure TBendingForm2.DrawGraphLine(aPaintBox:TPaintBox; aSpace:integer);
begin
  aPaintBox.Canvas.Pen.Style:=psSolid;
  aPaintBox.Canvas.Pen.Color:=clGray;
  aPaintBox.Canvas.Rectangle(0,0,aPaintBox.width,aPaintBox.height);

  aPaintBox.Canvas.Pen.Color:=clSilver;
  aPaintBox.Canvas.MoveTo( 0, aPaintBox.height-aSpace);
  aPaintBox.Canvas.LineTo( aPaintBox.width, aPaintBox.height-aSpace );

  aPaintBox.Canvas.MoveTo( aPaintBox.width div 2, aPaintBox.height-aSpace );
  aPaintBox.Canvas.LineTo( aPaintBox.width div 2, aPaintBox.height );

  aPaintBox.Canvas.MoveTo( aPaintBox.width div 4, aPaintBox.height-aSpace);
  aPaintBox.Canvas.LineTo( aPaintBox.width div 4, aPaintBox.height );
  aPaintBox.Canvas.MoveTo( aPaintBox.width div 4 * 3, aPaintBox.height-aSpace );
  aPaintBox.Canvas.LineTo( aPaintBox.width div 4 * 3, aPaintBox.height );

  aPaintBox.Canvas.MoveTo( aPaintBox.width div 2, 0 );
  aPaintBox.Canvas.LineTo( aPaintBox.width div 2,  20 );


end;

procedure TBendingForm2.SADraw;
var
  aSpace,k:integer;
  n:TSpectru;
  aYPoint,aXPoint: array[1..MaxSANumber] of integer;
begin
  aSpace:=Space;
  self.DrawGraphLine(PaintBox1,aSpace);

  for n:=nd to OpticalSystem.LastSpectru do begin
    case n of
       nt : PaintBox1.Canvas.Pen.Color:=clNt;
       ns : PaintBox1.Canvas.Pen.Color:=clNs;
       nr : PaintBox1.Canvas.Pen.Color:=clNr;
       nC : PaintBox1.Canvas.Pen.Color:=clNC;
       nd : PaintBox1.Canvas.Pen.Color:=clNd;
       ne : PaintBox1.Canvas.Pen.Color:=clNe;
       nF : PaintBox1.Canvas.Pen.Color:=clNF;
       ng : PaintBox1.Canvas.Pen.Color:=clNg;
       nh : PaintBox1.Canvas.Pen.Color:=clNh;
       ni : PaintBox1.Canvas.Pen.Color:=clNi;
    end;

    PaintBox1.Canvas.Pen.Style:=psSolid;
    for k:=1 to MaxSANumber do begin
      if SA[n,k]=NULL then Break;
      aYPoint[k]:=(PaintBox1.height-aSpace) - trunc( ((PaintBox1.height-aSpace) / (MaxSANumber-1)) *(k-1));
      aXPoint[k]:=trunc(PaintBox1.width / 2) + Trunc( SA[n,k] / ( SAGraphScale/(PaintBox1.width / 4) ) );
    end;
    PaintBox1.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
    for k:=2 to MaxSANumber do begin
      if SA[n,k]=NULL then Break;
      PaintBox1.Canvas.LineTo(aXPoint[k],aYPoint[k]);
    end;

  end;

  PaintBox1.Canvas.Pen.Color:=clWhite;
  PaintBox1.Canvas.Pen.Style:=psDot;
  for k:=1 to MaxSANumber do begin
    if OSC[k]=NULL then Break;
    aYPoint[k]:=(PaintBox1.height-aSpace) - trunc( ( (PaintBox1.height-aSpace) / (MaxSANumber-1) ) * (k-1));
    aXPoint[k]:=trunc(PaintBox1.width / 2) + Trunc( OSC[k] / ( SAGraphScale/(PaintBox1.width / 4) ) );
  end;
  PaintBox1.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
  for k:=2 to MaxSANumber do begin
    if OSC[k]=NULL then Break;
    PaintBox1.Canvas.LineTo(aXPoint[k],aYPoint[k]);
  end;

end;

procedure TBendingForm2.DrawDistortion;
var
  aSpace,k:integer;
  aYPoint,aXPoint: array[1..MaxSANumber] of integer;
begin
  aSpace:=Space;
  DrawGraphLine(PaintBox3, aSpace);

  PaintBox3.Canvas.Pen.Color:=clWhite;
  PaintBox3.Canvas.Pen.Style:=psSolid;
  for k:=1 to MaxAngleNumber do begin
    aYPoint[k]:=(PaintBox3.height-aSpace) - trunc((PaintBox3.height-aSpace) / (MaxAngleNumber-1) *(k-1));
    aXPoint[k]:=PaintBox3.width div 2 + Trunc( DIS[k] / ( DISGraphScale/(PaintBox3.width / 4) ) );
  end;
  PaintBox3.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
  for k:=2 to MaxAngleNumber do begin
    PaintBox3.Canvas.LineTo(aXPoint[k],aYPoint[k]);
  end;

end;

procedure TBendingForm2.ASDraw;
var
  aSpace,k:integer;
  aYPoint,aXPoint: array[1..100] of integer;
begin
  aSpace:=Space;
  DrawGraphLine(PaintBoxAS, aSpace);

  PaintBoxAS.Canvas.Pen.Color:=clYellow;
  PaintBoxAS.Canvas.Pen.Style:=psDot;
  for k:=1 to MaxAngleNumber do begin
    aYPoint[k]:=(PaintBoxAS.height-aSpace) - trunc((PaintBoxAS.height-aSpace) / (MaxAngleNumber-1) *(k-1));
    aXPoint[k]:=PaintBoxAS.width div 2 + Trunc( MAS[k] / ( ASGraphScale/(PaintBoxAS.width / 4) ) );
  end;
  PaintBoxAS.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
  for k:=2 to MaxAngleNumber do begin
    PaintBoxAS.Canvas.LineTo(aXPoint[k],aYPoint[k]);
  end;

  PaintBoxAS.Canvas.Pen.Color:=clWhite;
  PaintBoxAS.Canvas.Pen.Style:=psSolid;
  
  for k:=1 to MaxAngleNumber do begin
    aYPoint[k]:=(PaintBoxAS.height-aSpace) - trunc((PaintBoxAS.height-aSpace) / (MaxAngleNumber-1) *(k-1));
    aXPoint[k]:=PaintBoxAS.width div 2 + Trunc( SAS[k] / ( ASGraphScale/(PaintBoxAS.width / 4) ) );
  end;

  PaintBoxAS.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
  for k:=2 to MaxAngleNumber do begin
    PaintBoxAS.Canvas.LineTo(aXPoint[k],aYPoint[k]);
  end;

end;

procedure TBendingForm2.ScrollBar1Change(Sender: TObject);
begin
  Screen.Cursor:=crNo;
  BendingStep:=ScrollBar1.Position*0.0005;
  Button1Click(Sender);
  Edit1.Text:=FloatToStr(ScrollBar1.Position*0.0005*100)+'';
  Screen.Cursor:=crDefault;
  BitBtn1.Font.Color:=clRed;

  if CheckBox1.Checked=true then begin
    BitBtn1.Click;         //A^C\eXg
    PlanForm.Button3.Click;
    PlanForm.Button2.Click;
  end;

end;

procedure TBendingForm2.ScrollBar2Change(Sender: TObject);
begin
   SAGraphScale:=ScrollBar2.Position*0.01;
   Edit2.Text:=FloatToStr( ScrollBar2.Position*0.01 );
   self.DrawGraphLine(PaintBox1,Space);
   self.SADraw;
end;


procedure TBendingForm2.SpinEdit4Change(Sender: TObject);
begin
  InputAngle:=SpinEdit4.value;
end;

procedure TBendingForm2.ScrollBar3Change(Sender: TObject);
begin
   ASGraphScale:=ScrollBar3.Position*0.01;
   Edit3.Text:=FloatToStr( ScrollBar3.Position*0.01 );
   self.DrawGraphLine(PaintBoxAS,Space);
   self.ASDraw;
end;

procedure TBendingForm2.ScrollBar5Change(Sender: TObject);
begin
   DISGraphScale:=ScrollBar5.Position*0.01;
   Edit8.Text:=FloatToStr( ScrollBar5.Position*0.01 );
   self.DrawGraphLine(PaintBox3,Space);
   self.DrawDistortion;

end;

procedure TBendingForm2.SpinEdit3Change(Sender: TObject);
begin
  SpacingIndex:=SpinEdit3.value;
  Edit6.Text:=FloatToStrF(  BendOptSys.OpticalMedium[SpacingIndex].Distance,ffGeneral,4,2  );
  ScrollBar4.Position:=0;
  Edit7.Text:='0';
  BitBtn2.Font.Color:=clBlack
end;

procedure TBendingForm2.Button3Click(Sender: TObject);
begin
  BendOptSys.copyFrom(OpticalSystem);
  BendOptSys.ParAxialTrace(FinalOpt);

  Distance:=BendOptSys.OpticalMedium[SpacingIndex].Distance+
           BendOptSys.OpticalMedium[SpacingIndex].Distance*Spacing;

  BendOptSys.OpticalMedium[SpacingIndex].Distance:=Distance;

  BendOptSys.ParAxialTrace(FinalOpt);
  BendOptSys.CalculateSphericalAberration( SA, OSC);
  BendOptSys.CalculateAS( MAS, SAS, InputAngle );
  BendOptSys.CalculateDistortion( DIS, InputAngle);

  Edit4.Text:=FloatToStrF(BendOptSys.OpticalSurface[FirstBendingFace].curvature,ffGeneral,4,2 );
  Edit5.Text:=FloatToStrF(BendOptSys.OpticalSurface[SecondBendingFace].curvature,ffGeneral,4,2 );

  DrawGraphLine(PaintBox1,Space);
  SADraw;

  DrawGraphLine(PaintBoxAS,Space);
  ASDraw;

  DrawGraphLine(PaintBox3,Space);
  DrawDistortion;

  
end;


procedure TBendingForm2.ScrollBar4Change(Sender: TObject);
begin
  Screen.Cursor:=crNo;
  Spacing:=ScrollBar4.Position*0.001;
  Edit7.Text:=FloatToStr( Spacing*100 )+ '';
  Button3Click(Sender);
  Edit6.Text:=FloatToStrF(  BendOptSys.OpticalMedium[SpacingIndex].Distance,ffGeneral,4,2  );
  Screen.Cursor:=crDefault;
  BitBtn2.Font.Color:=clRed;
end;


procedure TBendingForm2.PaintBox1Paint(Sender: TObject);
begin
try
  self.SADraw;
except
  exit;
end;
end;

procedure TBendingForm2.PaintBoxASPaint(Sender: TObject);
begin
try
  self.ASDraw;
except
  exit;
end;

end;

procedure TBendingForm2.PaintBox3Paint(Sender: TObject);
begin
try
  self.DrawDistortion;
except
  exit;
end;

end;

procedure TBendingForm2.FormShow(Sender: TObject);
begin
  clNt:=clMaroon;//$00007B;
  clNs:=$0000B9;
  clNr:=$6A1EE1;
  clNC:=clRed;
  clNd:=clYellow;
  clNe:=$05FF9A;
  clNF:=$40FF00;//clLime;//$8EFF04;
  clNg:=clBlue;
  clNh:=clNavy;
  clNi:=$800080;


  BendOptSys.copyFrom(OpticalSystem);

  if OpticalSystem.TotalSurfaceNumber=1 then begin
    SpinEdit1.MaxValue:=2;
    SpinEdit2.MaxValue:=2;
    SpinEdit1.MinValue:=1;
    SpinEdit2.MinValue:=1;

    SpinEdit3.MaxValue:=1;
    SpinEdit3.MinValue:=0;
  end else begin
    SpinEdit1.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit2.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit1.MinValue:=1;
    SpinEdit2.MinValue:=1;

    SpinEdit3.MaxValue:=OpticalSystem.TotalSurfaceNumber;
    SpinEdit3.MinValue:=1;
  end;

  SpinEdit1Change(Sender);
  SpinEdit2Change(Sender);
  ScrollBar2Change(Sender);
  BendingStep:=0.0;
  Space:=5;
  Spacing:=0.0;

  ScrollBar3Change(Sender);
  ScrollBar5Change(Sender);

  SpacingIndex:=1;
  SpinEdit3Change(Sender);


end;


procedure TBendingForm2.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  self.Hide;
end;

procedure TBendingForm2.SpinButton1DownClick(Sender: TObject);
begin
 if InputAngleDecimal>=0.1 then  begin
     InputAngleDecimal:=InputAngleDecimal-0.1;
     Edit9.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=SpinEdit4.Value+InputAngleDecimal;

  end else begin

  end;
  if InputAngleDecimal<0.1 then  begin
     InputAngleDecimal:=0;
     Edit9.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=SpinEdit4.Value+InputAngleDecimal;

  end
end;

procedure TBendingForm2.SpinButton1UpClick(Sender: TObject);
begin
  if InputAngleDecimal<0.9 then  begin
     InputAngleDecimal:=InputAngleDecimal+0.1;
     Edit9.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=SpinEdit4.value+InputAngleDecimal;
     
  end else begin

  end;
end;

procedure TBendingForm2.Button5Click(Sender: TObject);
begin
//  BendAbeForm.visible:=true;
  LSMForm.Visible:=true;
end;

procedure TBendingForm2.BitBtn1Click(Sender: TObject);
begin
  OpticalSystem.copyFrom(BendOptSys);

  DataGridForm.BitBtn2.Click;
  DataGridForm.BitBtn3.Click;
  DataGridForm.BitBtn7.Click;

  ScrollBar1.Position:=0;
  Edit1.Text:='0';

  BitBtn1.Font.Color:=clBlack;

end;

procedure TBendingForm2.BitBtn2Click(Sender: TObject);
begin
  OpticalSystem.copyFrom(BendOptSys);

  DataGridForm.BitBtn2.Click;
  DataGridForm.BitBtn3.Click;
  DataGridForm.BitBtn7.Click;

  ScrollBar4.Position:=0;
  Edit7.Text:='0';
  
  BitBtn2.Font.Color:=clblack;
end;

procedure TBendingForm2.Button2Click(Sender: TObject);
begin
  SPCForm.visible:=True;
end;

initialization


end.
