unit BendingAberCurve;

interface

uses
 { Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls,
  Excel2000,OleServer, ComCtrls,
   MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray,Bending2;
 }
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,
  
  Excel2000,OleServer,Variants,

  MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray, Grids,
  ComCtrls, Spin;



type
  TBendAbeForm = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    SpinEdit1: TSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private 錾 }
    ListIncrease: Array[0.. MaxOptSurface] of single;
    ListSA9: Array[0.. MaxOptSurface] of single;
    ListCO9: Array[0.. MaxOptSurface] of single;
    ListMAS: Array[0.. MaxOptSurface] of single;
    ListSAS: Array[0.. MaxOptSurface] of single;
    ListDS: Array[0.. MaxOptSurface] of single;
    ListSA7: Array[0.. MaxOptSurface] of single;
    ListCO7: Array[0.. MaxOptSurface] of single;
    ListFL: Array[0.. MaxOptSurface] of single;

    BendingStep:  single;
    SA: TSA;
    OSC: TOSC;
    MAS: TMAS;
    SAS: TSAS;
    DIS: TDIS;

    ExcelObj   : OleVariant;
    WorkBook   : OleVariant;
    WorkSheet  : OleVariant;

    procedure initialize(Sender:TObject);

  public
    { Public 錾 }
  end;

var
  BendAbeForm: TBendAbeForm;
  anOptSys: TOptSystem;

implementation

uses Bending2,ComObj, UnitedData;

{$R *.dfm}

procedure TBendAbeForm.initialize(Sender:TObject);
var i:integer;
begin
 for i:=0 to OpticalSystem.TotalSurfaceNumber do begin
    ListSA9[i]:=0;
    ListCO9[i]:=0;
    ListMAS[i]:=0;
    ListSAS[i]:=0;
    ListDS[i]:=0;
    ListSA7[i]:=0;
    ListCO7[i]:=0;
    ListFL[i]:=0;
 end;

end;

procedure TBendAbeForm.Button1Click(Sender: TObject);
var anInputAngle:extended;
    i:integer;
begin
  BendingStep:=SpinEdit1.Value*0.01;
  anInputAngle:=BendingForm2.GetInputAngle;

  anOptSys.copyFrom(OpticalSystem);
  anOptSys.ParAxialTrace(FinalOpt);
  anOptSys.CalculateSphericalAberration( SA, OSC);
  anOptSys.CalculateAS( MAS, SAS, anInputAngle );
  anOptSys.CalculateDistortion( DIS, anInputAngle);

  //originData
  ListSA9[0]:=SA[nd,trunc(MaxSANumber*0.9)];
  ListCO9[0]:=OSC[trunc(MaxSANumber*0.9)];
  ListMAS[0]:=MAS[10];
  ListSAS[0]:=SAS[10];
  ListDS[0]:=DIS[10];
  ListSA7[0]:=SA[nd,trunc(MaxSANumber*0.7)];
  ListCO7[0]:=OSC[trunc(MaxSANumber*0.7)];
  ListFL[0]:=anOptSys.FocalLength[nd];

  for i:=1 to anOptSys.TotalSurfaceNumber do  begin
    ListIncrease[i]:=abs(anOptSys.OpticalSurface[i].curvature*BendingStep);
  end;

  for i:=1 to anOptSys.TotalSurfaceNumber do  begin
    anOptSys.copyFrom(OpticalSystem);
    anOptSys.OpticalSurface[i].Curvature:=anOptSys.OpticalSurface[i].Curvature+ListIncrease[i];
    anOptSys.ParAxialTrace(FinalOpt);
    anOptSys.CalculateSphericalAberration( SA, OSC);
    anOptSys.CalculateAS( MAS, SAS, anInputAngle );
    anOptSys.CalculateDistortion( DIS, anInputAngle);

    ListSA9[i]:=SA[nd,trunc(MaxSANumber*0.9)] - ListSA9[0];
    ListCO9[i]:=OSC[trunc(MaxSANumber*0.9)] - ListCO9[0];
    ListMAS[i]:=MAS[10] - ListMAS[0];
    ListSAS[i]:=SAS[10] - ListSAS[0];
    ListDS[i]:=DIS[10] - ListDS[0];
    ListSA7[i]:=SA[nd,trunc(MaxSANumber*0.7)] -ListSA7[0] ;
    ListCO7[i]:=OSC[trunc(MaxSANumber*0.7)]  - ListCO7[0];
    ListFL[i]:=anOptSys.FocalLength[nd] - ListFL[0];
  end;

  Memo1.Lines.Add('      '+'@   9 @'+'@ R}9 @'+'@AXij '+'  AXiTWj '+ '  œ_ '+'     7  '+'  R}7  '+'   c  ') ;

  for i:=1 to anOptSys.TotalSurfaceNumber do begin
    Memo1.Lines.Add('r'+IntToStr(i)+'   '
                    +FloatToStrF(ListIncrease[i],ffGeneral,4,2)+' || '
                    +FloatToStrF(ListSA9[i],ffGeneral,4,2)+' || '
                    +FloatToStrF(ListCO9[i],ffGeneral,4,2)+' || '
                    +FloatToStrF(ListMAS[i],ffGeneral,4,2)+' || '
                    +FloatToStrF(ListSAS[i],ffGeneral,4,2)+' || '
                    +FloatToStrF(ListFL[i],ffGeneral,4,2)+' || '
                    +FloatToStrF(ListSA7[i],ffGeneral,4,2)+' || '
                    +FloatToStrF(ListCO7[i],ffGeneral,4,2)+' || '
                    +FloatToStrF(ListDS[i],ffGeneral,4,2)+'  '




                    );
    Memo1.Lines.Add(#13);
  end;
  self.Caption:='cxfBOω\'+'/'+OpticalSystem.OpticalName;
end;


procedure TBendAbeForm.SpinEdit1Change(Sender: TObject);
begin
 BendingStep:=SpinEdit1.Value*0.01;
end;

procedure TBendAbeForm.Button2Click(Sender: TObject);
var i:integer;
begin

 if VarIsEmpty(ExcelObj) then begin
    //Excel̃IuWFNg쐬(̌x⃁bZ[W\)
    ExcelObj :=CreateOleObject('Excel.Application');
    ExcelObj.DisplayAlerts := False;

    //ubN쐬
    WorkBook := ExcelObj.Workbooks.Add;

    //V[gIuWFNg`
    WorkSheet := WorkBook.WorkSheets[1];

    //\
    ExcelObj.Visible := True;

    //ő剻ŕ\
    //ŃGNZPƋNő剻\ƂȂĂ܂̂Œ
  //  ExcelObj.WindowState := xlMiximized;

    for i:=1 to anOptSys.TotalSurfaceNumber do begin
     WorkSheet.Cells[1,i+1]:=i;
    end;
    WorkSheet.Cells[1+1,1]:='9';
    WorkSheet.Cells[2+1,1]:='7';
    WorkSheet.Cells[3+1,1]:='R}9';
    WorkSheet.Cells[4+1,1]:='R}7';
    WorkSheet.Cells[5+1,1]:='lAX';
    WorkSheet.Cells[6+1,1]:='rAX';
    WorkSheet.Cells[7+1,1]:='c';
    WorkSheet.Cells[8+1,1]:='œ_';

    WorkSheet.Cells[10+1,1]:='ȗ';
    WorkSheet.Cells[11+1,1]:='';

    for i:=1 to anOptSys.TotalSurfaceNumber do begin
      WorkSheet.Cells[1+1,i+1]:=ListSA9[i];
      WorkSheet.Cells[2+1,i+1]:=ListSA7[i];
      WorkSheet.Cells[3+1,i+1]:=ListCO9[i];
      WorkSheet.Cells[4+1,i+1]:=ListCO7[i];
      WorkSheet.Cells[5+1,i+1]:=ListMAS[i];
      WorkSheet.Cells[6+1,i+1]:=ListSAS[i];
      WorkSheet.Cells[7+1,i+1]:=ListDS[i];
      WorkSheet.Cells[8+1,i+1]:=ListFL[i];

      WorkSheet.Cells[10+1,i+1]:=OpticalSystem.OpticalSurface[i].Curvature;
      WorkSheet.Cells[11+1,i+1]:=FloatToStrF(ListIncrease[i],ffGeneral,4,2);
    end;

  end else begin
   for i:=1 to anOptSys.TotalSurfaceNumber do begin
     WorkSheet.Cells[1,i+1]:=i;
    end;
    WorkSheet.Cells[1+1,1]:='9';
    WorkSheet.Cells[2+1,1]:='7';
    WorkSheet.Cells[3+1,1]:='R}9';
    WorkSheet.Cells[4+1,1]:='R}7';
    WorkSheet.Cells[5+1,1]:='lAX';
    WorkSheet.Cells[6+1,1]:='rAX';
    WorkSheet.Cells[7+1,1]:='c';
    WorkSheet.Cells[8+1,1]:='œ_';

    WorkSheet.Cells[10+1,1]:='ȗ';
    WorkSheet.Cells[11+1,1]:='';

    for i:=1 to anOptSys.TotalSurfaceNumber do begin
      WorkSheet.Cells[1+1,i+1]:=ListSA9[i];
      WorkSheet.Cells[2+1,i+1]:=ListSA7[i];
      WorkSheet.Cells[3+1,i+1]:=ListCO9[i];
      WorkSheet.Cells[4+1,i+1]:=ListCO7[i];
      WorkSheet.Cells[5+1,i+1]:=ListMAS[i];
      WorkSheet.Cells[6+1,i+1]:=ListSAS[i];
      WorkSheet.Cells[7+1,i+1]:=ListDS[i];
      WorkSheet.Cells[8+1,i+1]:=ListFL[i];

      WorkSheet.Cells[10+1,i+1]:=OpticalSystem.OpticalSurface[i].Curvature;
      WorkSheet.Cells[11+1,i+1]:=FloatToStrF(ListIncrease[i],ffGeneral,4,2);
    end;
  end;

end;

procedure TBendAbeForm.Button3Click(Sender: TObject);
var i,aRow,aCol:integer;
begin
  aRow:=spinEdit2.Value;
  aCol:=SpinEdit3.Value;

  for i:=1 to anOptSys.TotalSurfaceNumber do begin
   OpticalSystem.OpticalSurface[i].Curvature:=StrToFloat(WorkSheet.Cells[aRow-1+i,aCol]);
  end;
  UnitedDataForm.BitBtn2Click(Sender);
end;

initialization

  anOptSys:=TOptSystem.Create;
  anOptSys.initialize;

end.
