unit CoAxialGrid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids,
  MainForm, OptSurface,OptMedium,MayMath;
type
  TCoAxialForm = class(TForm)
    DataGrid1: TStringGrid;
    DataGrid2: TStringGrid;
    DataGrid3: TStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure DataGrid1SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure DataGrid2SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure DataGrid3SetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure DataGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure DataGrid2DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DataGrid3DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure DataGrid1DblClick(Sender: TObject);
    procedure DataGrid2DblClick(Sender: TObject);
    procedure DataGrid3DblClick(Sender: TObject);
    procedure DataGrid1KeyPress(Sender: TObject; var Key: Char);
    procedure DataGrid2KeyPress(Sender: TObject; var Key: Char);
    procedure DataGrid3KeyPress(Sender: TObject; var Key: Char);
    procedure DataGrid1Click(Sender: TObject);
    procedure DataGrid2Click(Sender: TObject);
    procedure DataGrid3Click(Sender: TObject);
  private
    { Private 錾 }
    procedure CoAxialDraw;
    procedure TiltDraw;
    procedure SiftDraw;
    procedure Fix;
    procedure CoAxialFix;
    procedure SiftFix;
    procedure TiltFix;

  public
    { Public 錾 }
    procedure RefreshDraw;
  end;

var
  CoAxialForm: TCoAxialForm;

implementation

{$R *.dfm}




procedure TCoAxialForm.CoAxialDraw;
var row:integer;
begin
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid1.Cells[0,row]:=' _';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid1.Cells[0,row]:=' œ_';
      end else begin
        DataGrid1.Cells[0,row]:=' '+IntToStr(row-1);
      end;
    end;
  end;

  DataGrid1.Cells[1,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      if(OpticalSystem.ObjectPlane.BiasSwitch=true) then begin
        DataGrid1.Cells[1,row]:='True';
      end else begin
        DataGrid1.Cells[1,row]:='False';
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        if(OpticalSystem.FocusPlane.BiasSwitch=true) then begin
          DataGrid1.Cells[1,row]:='True';
        end else begin
          DataGrid1.Cells[1,row]:='False';
        end;
      end else begin
        if(OpticalSystem.OpticalSurface[row-1].BiasSwitch=true) then begin
          DataGrid1.Cells[1,row]:='True';
        end else begin
          DataGrid1.Cells[1,row]:='False';
        end;
      end;
    end;
  end;   

  DataGrid1.Cells[2,0]:='Xp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid1.Cells[2,row]:=FloatToStr(OpticalSystem.ObjectPlane.BiasSheeta);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid1.Cells[2,row]:=FloatToStr(OpticalSystem.FocusPlane.BiasSheeta);
      end else begin
        DataGrid1.Cells[2,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].BiasSheeta);
      end;
    end;
  end;
  DataGrid1.Cells[3,0]:='ʊp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid1.Cells[3,row]:=FloatToStr(OpticalSystem.ObjectPlane.BiasPhai);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid1.Cells[3,row]:=FloatToStr(OpticalSystem.FocusPlane.BiasPhai);
      end else begin
        DataGrid1.Cells[3,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].BiasPhai);
      end;
    end;
  end;
  DataGrid1.Cells[4,0]:=' X';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid1.Cells[4,row]:=FloatToStr(OpticalSystem.ObjectPlane.BiasSiftVector['X']);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid1.Cells[4,row]:=FloatToStr(OpticalSystem.FocusPlane.BiasSiftVector['X']);
      end else begin
        DataGrid1.Cells[4,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].BiasSiftVector['X']);
      end;
    end;
  end;
  DataGrid1.Cells[5,0]:=' Y';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid1.Cells[5,row]:=FloatToStr(OpticalSystem.ObjectPlane.BiasSiftVector['Y']);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid1.Cells[5,row]:=FloatToStr(OpticalSystem.FocusPlane.BiasSiftVector['Y']);
      end else begin
        DataGrid1.Cells[5,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].BiasSiftVector['Y']);
      end;
    end;
  end;
  DataGrid1.Cells[6,0]:=' Z';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid1.Cells[6,row]:=FloatToStr(OpticalSystem.ObjectPlane.BiasSiftVector['Z']);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid1.Cells[6,row]:=FloatToStr(OpticalSystem.FocusPlane.BiasSiftVector['Z']);
      end else begin
        DataGrid1.Cells[6,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].BiasSiftVector['Z']);
      end;
    end;
  end;
end;

procedure TCoAxialForm.TiltDraw;
var row:integer;
begin
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid3.Cells[0,row]:=' _';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid3.Cells[0,row]:=' œ_';
      end else begin
        DataGrid3.Cells[0,row]:=' '+IntToStr(row-1);
      end;
    end;
  end;

  DataGrid3.Cells[1,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      if(OpticalSystem.ObjectPlane.TiltSwitch=true) then begin
        DataGrid3.Cells[1,row]:='True';
      end else begin
        DataGrid3.Cells[1,row]:='False';
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        if(OpticalSystem.FocusPlane.TiltSwitch=true) then begin
          DataGrid3.Cells[1,row]:='True';
        end else begin
          DataGrid3.Cells[1,row]:='False';
        end;
      end else begin
        if(OpticalSystem.OpticalSurface[row-1].TiltSwitch=true) then begin
          DataGrid3.Cells[1,row]:='True';
        end else begin
          DataGrid3.Cells[1,row]:='False';
        end;
      end;
    end;
  end;

  DataGrid3.Cells[2,0]:='Xp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid3.Cells[2,row]:=FloatToStr(OpticalSystem.ObjectPlane.TiltSheeta);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid3.Cells[2,row]:=FloatToStr(OpticalSystem.FocusPlane.TiltSheeta);
      end else begin
        DataGrid3.Cells[2,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].TiltSheeta);
      end;
    end;
  end;
  DataGrid3.Cells[3,0]:='ʊp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid3.Cells[3,row]:=FloatToStr(OpticalSystem.ObjectPlane.TiltPhai);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid3.Cells[3,row]:=FloatToStr(OpticalSystem.FocusPlane.TiltPhai);
      end else begin
        DataGrid3.Cells[3,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].TiltPhai);
      end;
    end;
  end;


end;

procedure TCoAxialForm.SiftDraw;
var row:integer;
begin
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid2.Cells[0,row]:=' _';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid2.Cells[0,row]:=' œ_';
      end else begin
        DataGrid2.Cells[0,row]:=' '+IntToStr(row-1);
      end;
    end;
  end;

  DataGrid2.Cells[1,0]:='';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      if(OpticalSystem.ObjectPlane.SiftSwitch=true) then begin
        DataGrid2.Cells[1,row]:='True';
      end else begin
        DataGrid2.Cells[1,row]:='False';
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        if(OpticalSystem.FocusPlane.SiftSwitch=true) then begin
          DataGrid2.Cells[1,row]:='True';
        end else begin
          DataGrid2.Cells[1,row]:='False';
        end;
      end else begin
        if(OpticalSystem.OpticalSurface[row-1].SiftSwitch=true) then begin
          DataGrid2.Cells[1,row]:='True';
        end else begin
          DataGrid2.Cells[1,row]:='False';
        end;
      end;
    end;
  end;


  DataGrid2.Cells[2,0]:=' X';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid2.Cells[2,row]:=FloatToStr(OpticalSystem.ObjectPlane.SiftVector['X']);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid2.Cells[2,row]:=FloatToStr(OpticalSystem.FocusPlane.SiftVector['X']);
      end else begin
        DataGrid2.Cells[2,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].SiftVector['X']);
      end;
    end;
  end;   
  DataGrid2.Cells[3,0]:=' Y';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid2.Cells[3,row]:=FloatToStr(OpticalSystem.ObjectPlane.SiftVector['Y']);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid2.Cells[3,row]:=FloatToStr(OpticalSystem.FocusPlane.SiftVector['Y']);
      end else begin
        DataGrid2.Cells[3,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].SiftVector['Y']);
      end;
    end;
  end;
  DataGrid2.Cells[4,0]:=' Z';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        DataGrid2.Cells[4,row]:=FloatToStr(OpticalSystem.ObjectPlane.SiftVector['Z']);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid2.Cells[4,row]:=FloatToStr(OpticalSystem.FocusPlane.SiftVector['Z']);
      end else begin
        DataGrid2.Cells[4,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].SiftVector['Z']);
      end;
    end;
  end;


end;


procedure TCoAxialForm.Fix;
begin
  CoAxialFix;
  SiftFix;
  TiltFix;
end;

procedure TCoAxialForm.CoAxialFix;
var row:integer;
    i:char;
begin

//'';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      if((DataGrid1.Cells[1,row]='True')or(DataGrid1.Cells[1,row]='true')) then begin
        OpticalSystem.ObjectPlane.BiasSwitch:=true;
      end else begin
        OpticalSystem.ObjectPlane.BiasSwitch:=false;
      end;

    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        if((DataGrid1.Cells[1,row]='True')or(DataGrid1.Cells[1,row]='true'))then begin
          OpticalSystem.FocusPlane.BiasSwitch:=true;
        end else begin
          OpticalSystem.FocusPlane.BiasSwitch:=false;
        end;
      end else begin
        if((DataGrid1.Cells[1,row]='True')or(DataGrid1.Cells[1,row]='true'))then begin
          OpticalSystem.OpticalSurface[row-1].BiasSwitch:=true;
        end else begin
          OpticalSystem.OpticalSurface[row-1].BiasSwitch:=false;
        end;
      end;
    end;
  end;   

  //'Xp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.BiasSheeta:=StrToFloat(DataGrid1.Cells[2,row]);

        OpticalSystem.ObjectPlane.BiasVector['X']:=Cos( degreeToRadian(OpticalSystem.ObjectPlane.BiasSheeta) );
        OpticalSystem.ObjectPlane.BiasVector['Y']:=Sin(degreeToRadian(OpticalSystem.ObjectPlane.BiasSheeta))*Cos(degreeToRadian(OpticalSystem.ObjectPlane.BiasPhai));
        OpticalSystem.ObjectPlane.BiasVector['Z']:=Sin(degreeToRadian(OpticalSystem.ObjectPlane.BiasSheeta))*Sin(degreeToRadian(OpticalSystem.ObjectPlane.BiasPhai));
        for i:='X' to 'Z' do begin
        if abs(OpticalSystem.ObjectPlane.BiasVector[i])<0.0000001 then
          OpticalSystem.ObjectPlane.BiasVector[i]:=0;
        end;

    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.BiasSheeta:=StrToFloat(DataGrid1.Cells[2,row]);

        OpticalSystem.FocusPlane.BiasVector['X']:=Cos( degreeToRadian(OpticalSystem.FocusPlane.BiasSheeta) );
        OpticalSystem.FocusPlane.BiasVector['Y']:=Sin(degreeToRadian(OpticalSystem.FocusPlane.BiasSheeta))*Cos(degreeToRadian(OpticalSystem.FocusPlane.BiasPhai));
        OpticalSystem. FocusPlane.BiasVector['Z']:=Sin(degreeToRadian(OpticalSystem.FocusPlane.BiasSheeta))*Sin(degreeToRadian(OpticalSystem.FocusPlane.BiasPhai));
        for i:='X' to 'Z' do begin
        if abs(OpticalSystem.FocusPlane.BiasVector[i])<0.0000001 then
          OpticalSystem.FocusPlane.BiasVector[i]:=0;
        end;

      end else begin
        OpticalSystem.OpticalSurface[row-1].BiasSheeta:=StrToFloat(DataGrid1.Cells[2,row]);

        OpticalSystem.OpticalSurface[row-1].BiasVector['X']:=Cos( degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasSheeta) );
        OpticalSystem.OpticalSurface[row-1].BiasVector['Y']:=Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasSheeta))*Cos(degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasPhai));
        OpticalSystem.OpticalSurface[row-1].BiasVector['Z']:=Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasSheeta))*Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasPhai));
        for i:='X' to 'Z' do begin
          if abs(OpticalSystem.OpticalSurface[row-1].BiasVector[i])<0.0000001 then
            OpticalSystem.OpticalSurface[row-1].BiasVector[i]:=0;
        end;

      end;
    end;
  end;   
  //'ʊp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.BiasPhai:=StrToFloat(DataGrid1.Cells[3,row]);

        OpticalSystem.ObjectPlane.BiasVector['X']:=Cos( degreeToRadian(OpticalSystem.ObjectPlane.BiasSheeta) );
        OpticalSystem.ObjectPlane.BiasVector['Y']:=Sin(degreeToRadian(OpticalSystem.ObjectPlane.BiasSheeta))*Cos(degreeToRadian(OpticalSystem.ObjectPlane.BiasPhai));
        OpticalSystem.ObjectPlane.BiasVector['Z']:=Sin(degreeToRadian(OpticalSystem.ObjectPlane.BiasSheeta))*Sin(degreeToRadian(OpticalSystem.ObjectPlane.BiasPhai));
        for i:='X' to 'Z' do begin
          if abs(OpticalSystem.ObjectPlane.BiasVector[i])<0.0000001 then
            OpticalSystem.ObjectPlane.BiasVector[i]:=0;
        end;

    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.BiasPhai:=StrToFloat(DataGrid1.Cells[3,row]);

        OpticalSystem.FocusPlane.BiasVector['X']:=Cos( degreeToRadian(OpticalSystem.FocusPlane.BiasSheeta) );
        OpticalSystem.FocusPlane.BiasVector['Y']:=Sin(degreeToRadian(OpticalSystem.FocusPlane.BiasSheeta))*Cos(degreeToRadian(OpticalSystem.FocusPlane.BiasPhai));
        OpticalSystem.FocusPlane.BiasVector['Z']:=Sin(degreeToRadian(OpticalSystem.FocusPlane.BiasSheeta))*Sin(degreeToRadian(OpticalSystem.FocusPlane.BiasPhai));
        for i:='X' to 'Z' do begin
          if abs(OpticalSystem.FocusPlane.BiasVector[i])<0.0000001 then
            OpticalSystem.FocusPlane.BiasVector[i]:=0;
        end;

      end else begin
       OpticalSystem.OpticalSurface[row-1].BiasPhai:=StrToFloat(DataGrid1.Cells[3,row]);

       OpticalSystem.OpticalSurface[row-1].BiasVector['X']:=Cos( degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasSheeta) );
       OpticalSystem.OpticalSurface[row-1].BiasVector['Y']:=Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasSheeta))*Cos(degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasPhai));
       OpticalSystem.OpticalSurface[row-1].BiasVector['Z']:=Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasSheeta))*Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].BiasPhai));
       for i:='X' to 'Z' do begin
        if abs(OpticalSystem.OpticalSurface[row-1].BiasVector[i])<0.0000001 then
         OpticalSystem. OpticalSurface[row-1].BiasVector[i]:=0;
       end;

      end;
    end;
  end;   
  //' X';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.BiasSiftVector['X']:=StrToFloat(DataGrid1.Cells[4,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.BiasSiftVector['X']:=StrToFloat(DataGrid1.Cells[4,row]);
      end else begin
        OpticalSystem.OpticalSurface[row-1].BiasSiftVector['X']:=StrToFloat(DataGrid1.Cells[4,row]);
      end;
    end;
  end;   
  //' Y';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.BiasSiftVector['Y']:=StrToFloat(DataGrid1.Cells[5,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.BiasSiftVector['Y']:=StrToFloat(DataGrid1.Cells[5,row]);
      end else begin
        OpticalSystem.OpticalSurface[row-1].BiasSiftVector['Y']:=StrToFloat(DataGrid1.Cells[5,row]);
      end;
    end;
  end;
  //' X';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.BiasSiftVector['Z']:=StrToFloat(DataGrid1.Cells[6,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.BiasSiftVector['Z']:=StrToFloat(DataGrid1.Cells[6,row]);
      end else begin
        OpticalSystem.OpticalSurface[row-1].BiasSiftVector['Z']:=StrToFloat(DataGrid1.Cells[6,row]);
      end;
    end;
  end;
end;

procedure TCoAxialForm.SiftFix;
var row:integer;
begin
  //'';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      if((DataGrid2.Cells[1,row]='True')or(DataGrid2.Cells[1,row]='true')) then begin
        OpticalSystem.ObjectPlane.SiftSwitch:=true;
      end else begin
        OpticalSystem.ObjectPlane.SiftSwitch:=false;
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        if((DataGrid2.Cells[1,row]='True')or(DataGrid2.Cells[1,row]='true')) then begin
          OpticalSystem.FocusPlane.SiftSwitch:=true;
        end else begin
          OpticalSystem.FocusPlane.SiftSwitch:=false;
        end;
      end else begin
        if((DataGrid2.Cells[1,row]='True')or(DataGrid2.Cells[1,row]='true')) then begin
          OpticalSystem.OpticalSurface[row-1].SiftSwitch:=true;
        end else begin
          OpticalSystem.OpticalSurface[row-1].SiftSwitch:=false;
        end;
      end;
    end;
  end;


  //' X';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.SiftVector['X']:=StrToFloat(DataGrid2.Cells[2,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.SiftVector['X']:=StrToFloat(DataGrid2.Cells[2,row]);
      end else begin
        OpticalSystem.OpticalSurface[row-1].SiftVector['X']:=StrToFloat(DataGrid2.Cells[2,row]);
      end;
    end;
  end;   
  //' Y';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.SiftVector['Y']:=StrToFloat(DataGrid2.Cells[3,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.SiftVector['Y']:=StrToFloat(DataGrid2.Cells[3,row]);
      end else begin
        OpticalSystem.OpticalSurface[row-1].SiftVector['Y']:=StrToFloat(DataGrid2.Cells[3,row]);
      end;
    end;
  end;
  //:=' X';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.SiftVector['Z']:=StrToFloat(DataGrid2.Cells[4,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.SiftVector['Z']:=StrToFloat(DataGrid2.Cells[4,row]);
      end else begin
        OpticalSystem.OpticalSurface[row-1].SiftVector['Z']:=StrToFloat(DataGrid2.Cells[4,row]);
      end;
    end;
  end;

end;

procedure TCoAxialForm.TiltFix;
var row,kk,jj:integer;
  aVector:TVector;
  aMatrix:TMatrix;

begin
  //'';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      if((DataGrid3.Cells[1,row]='True')or(DataGrid3.Cells[1,row]='true')) then begin
        OpticalSystem.ObjectPlane.TiltSwitch:=true;
      end else begin
        OpticalSystem.ObjectPlane.TiltSwitch:=false;
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        if((DataGrid3.Cells[1,row]='True')or(DataGrid3.Cells[1,row]='true'))  then begin
          OpticalSystem.FocusPlane.TiltSwitch:=true;
        end else begin
          OpticalSystem.FocusPlane.TiltSwitch:=false;
        end;
      end else begin
        if((DataGrid3.Cells[1,row]='True')or(DataGrid3.Cells[1,row]='true')) then begin
          OpticalSystem.OpticalSurface[row-1].TiltSwitch:=true;
        end else begin
          OpticalSystem.OpticalSurface[row-1].TiltSwitch:=false;
        end;
      end;
    end;
  end;

  //'Xp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.TiltSheeta:=StrToFloat(DataGrid3.Cells[2,row]);

        aVector['X']:=Cos( degreeToRadian(OpticalSystem.ObjectPlane.TiltSheeta) );
        aVector['Y']:=Sin(degreeToRadian(OpticalSystem.ObjectPlane.TiltSheeta))*Cos(degreeToRadian(OpticalSystem.ObjectPlane.TiltPhai));
        aVector['Z']:=Sin(degreeToRadian(OpticalSystem.ObjectPlane.TiltSheeta))*Sin(degreeToRadian(OpticalSystem.ObjectPlane.TiltPhai));

        TiltMakeRotation( aMatrix, aVector);
        for jj:=1 to 3 do begin
          for kk:=1 to 3 do begin
            OpticalSystem.ObjectPlane.TiltMatrix[jj,kk]:=aMatrix[jj,kk];
          end;
        end;

    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.TiltSheeta:=StrToFloat(DataGrid3.Cells[2,row]);

        aVector['X']:=Cos( degreeToRadian(OpticalSystem.FocusPlane.TiltSheeta) );
        aVector['Y']:=Sin(degreeToRadian(OpticalSystem.FocusPlane.TiltSheeta))*Cos(degreeToRadian(OpticalSystem.FocusPlane.TiltPhai));
        aVector['Z']:=Sin(degreeToRadian(OpticalSystem.FocusPlane.TiltSheeta))*Sin(degreeToRadian(OpticalSystem.FocusPlane.TiltPhai));

        TiltMakeRotation( aMatrix, aVector);
        for jj:=1 to 3 do begin
          for kk:=1 to 3 do begin
            OpticalSystem.FocusPlane.TiltMatrix[jj,kk]:=aMatrix[jj,kk];
          end;
        end;

      end else begin
        OpticalSystem.OpticalSurface[row-1].TiltSheeta:=StrToFloat(DataGrid3.Cells[2,row]);

        aVector['X']:=Cos( degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltSheeta) );
        aVector['Y']:=Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltSheeta))*Cos(degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltPhai));
        aVector['Z']:=Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltSheeta))*Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltPhai));

        TiltMakeRotation( aMatrix, aVector);
        for jj:=1 to 3 do begin
          for kk:=1 to 3 do begin
            OpticalSystem.OpticalSurface[row-1].TiltMatrix[jj,kk]:=aMatrix[jj,kk];
          end;
        end;

      end;
    end;
  end;
  //'ʊp';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
        OpticalSystem.ObjectPlane.TiltPhai:=StrToFloat(DataGrid3.Cells[3,row]);

        aVector['X']:=Cos( degreeToRadian(OpticalSystem.ObjectPlane.TiltSheeta) );
        aVector['Y']:=Sin(degreeToRadian(OpticalSystem.ObjectPlane.TiltSheeta))*Cos(degreeToRadian(OpticalSystem.ObjectPlane.TiltPhai));
        aVector['Z']:=Sin(degreeToRadian(OpticalSystem.ObjectPlane.TiltSheeta))*Sin(degreeToRadian(OpticalSystem.ObjectPlane.TiltPhai));

        TiltMakeRotation( aMatrix, aVector);
        for jj:=1 to 3 do begin
          for kk:=1 to 3 do begin
            OpticalSystem.ObjectPlane.TiltMatrix[jj,kk]:=aMatrix[jj,kk];
          end;
        end;

    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        OpticalSystem.FocusPlane.TiltPhai:=StrToFloat(DataGrid3.Cells[3,row]);

        aVector['X']:=Cos( degreeToRadian(OpticalSystem.FocusPlane.TiltSheeta) );
        aVector['Y']:=Sin(degreeToRadian(OpticalSystem.FocusPlane.TiltSheeta))*Cos(degreeToRadian(OpticalSystem.FocusPlane.TiltPhai));
        aVector['Z']:=Sin(degreeToRadian(OpticalSystem.FocusPlane.TiltSheeta))*Sin(degreeToRadian(OpticalSystem.FocusPlane.TiltPhai));

        TiltMakeRotation( aMatrix, aVector);
        for jj:=1 to 3 do begin
          for kk:=1 to 3 do begin
            OpticalSystem.FocusPlane.TiltMatrix[jj,kk]:=aMatrix[jj,kk];
          end;
        end;

      end else begin
        OpticalSystem.OpticalSurface[row-1].TiltPhai:=StrToFloat(DataGrid3.Cells[3,row]);

        aVector['X']:=Cos( degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltSheeta) );
        aVector['Y']:=Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltSheeta))*Cos(degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltPhai));
        aVector['Z']:=Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltSheeta))*Sin(degreeToRadian(OpticalSystem.OpticalSurface[row-1].TiltPhai));

        TiltMakeRotation( aMatrix, aVector);

        for jj:=1 to 3 do begin
          for kk:=1 to 3 do begin
            OpticalSystem.OpticalSurface[row-1].TiltMatrix[jj,kk]:=aMatrix[jj,kk];
          end;
        end;

      end;
    end;
  end;

end;



procedure TCoAxialForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  visible:=false;
end;

procedure TCoAxialForm.BitBtn1Click(Sender: TObject);
var col,row:integer;
begin
  DataGrid1.Font.Color:=clBlack;
  DataGrid2.Font.Color:=clBlack;
  DataGrid3.Font.Color:=clBlack;
  BitBtn2.Font.Color:=clBlack;


  for col:=0 to 7 do begin
    for row:=1 to 64+2 do begin
      DataGrid1.Cells[col,row]:='';
      DataGrid2.Cells[col,row]:='';
      DataGrid3.Cells[col,row]:='';
    end;
  end;

  self.CoAxialDraw;
  self.SiftDraw;
  self.TiltDraw;

end;


procedure TCoAxialForm.BitBtn2Click(Sender: TObject);
begin
  self.Fix;

  BitBtn1.Click;

  OpticalSystem.SynmetrySwitch:=OpticalSystem.SynmetrySerch;
//  FormPops.CheckBox1.Checked:=OpticalSystem.SynmetrySwitch;

  FormPOPS.DataIsChanged;

end;

procedure TCoAxialForm.DataGrid1SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  DataGrid1.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;

end;

procedure TCoAxialForm.DataGrid2SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  DataGrid2.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;

end;

procedure TCoAxialForm.DataGrid3SetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  DataGrid3.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;

end;

//******************************************************************

procedure TCoAxialForm.DataGrid1DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  SetStr: String;
  Header: LongInt;
begin
{  SetStr := DataGrid1.Cells[ACol, ARow];

  if (ACol = 1) and (gdFocused in State) then begin
    SetWindowPos(ComboBox1.Handle, 0,
                 Rect.Left + DataGrid1.Left + 1, Rect.Top + DataGrid1.top + 1,
                 Rect.Right - Rect.Left + 2, Rect.Bottom - Rect.top + 2,
                 SWP_NOZORDER   or SWP_SHOWWINDOW);
    ComboBox1.ItemIndex := ComboBox1.Items.IndexOf(SetStr);
    ComboBox1.Show;
    Exit;
  end;

  if ComboBox1.Visible then
    ComboBox1.Visible := False;

  DataGrid1.Canvas.FillRect(Rect);

  if ARow = 0 then
     Header := (DT_CENTER or DT_VCENTER or DT_SINGLELINE)
  else
     Header := (DT_SINGLELINE or DT_VCENTER or DT_LEFT);

  DrawText(DataGrid1.Canvas.Handle, PChar(SetStr), Length(SetStr),
           Rect, Header);
  }
end;


procedure TCoAxialForm.FormCreate(Sender: TObject);
begin

  DataGrid1.DefaultRowHeight := ComboBox1.Height - DataGrid1.GridLineWidth;
  DataGrid2.DefaultRowHeight := ComboBox2.Height - DataGrid2.GridLineWidth;
  DataGrid3.DefaultRowHeight := ComboBox3.Height - DataGrid3.GridLineWidth;
end;

procedure TCoAxialForm.FormShow(Sender: TObject);
begin
  ComboBox1.Visible:=false;
  ComboBox2.Visible:=false;
  ComboBox3.Visible:=false;
end;

procedure TCoAxialForm.ComboBox1Change(Sender: TObject);
begin
  with DataGrid1 do begin
    Cells[Col, Row] := ComboBox1.Text;
  end;
  DataGrid1.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;

end;

//******************************************************************



procedure TCoAxialForm.DataGrid2DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  SetStr: String;
  Header: LongInt;
begin
{  SetStr := DataGrid2.Cells[ACol, ARow];

  if (ACol = 1) and (gdFocused in State) then begin
    SetWindowPos(ComboBox2.Handle, 0,
                 Rect.Left + DataGrid2.Left + 1, Rect.Top + DataGrid2.top + 1,
                 Rect.Right - Rect.Left + 2, Rect.Bottom - Rect.top + 2,
                 SWP_NOZORDER   or SWP_SHOWWINDOW);
    ComboBox2.ItemIndex := ComboBox2.Items.IndexOf(SetStr);
    ComboBox2.Show;
    Exit;
  end;

  if ComboBox2.Visible then
    ComboBox2.Visible := False;

  DataGrid2.Canvas.FillRect(Rect);

  if ARow = 0 then
     Header := (DT_CENTER or DT_VCENTER or DT_SINGLELINE)
  else
     Header := (DT_SINGLELINE or DT_VCENTER or DT_LEFT);

  DrawText(DataGrid2.Canvas.Handle, PChar(SetStr), Length(SetStr),
           Rect, Header);
  }
end;



procedure TCoAxialForm.ComboBox2Change(Sender: TObject);
begin
  with DataGrid2 do begin
    Cells[Col, Row] := ComboBox2.Text;
  end;
  DataGrid2.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;
end;



//******************************************************************

procedure TCoAxialForm.ComboBox3Change(Sender: TObject);
begin
  with DataGrid3 do begin
    Cells[Col, Row] := ComboBox3.Text;
  end;
  DataGrid3.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;
end;


procedure TCoAxialForm.DataGrid3DrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
var
  SetStr: String;
  Header: LongInt;
begin
{  SetStr := DataGrid3.Cells[ACol, ARow];

  if (ACol = 1) and (gdFocused in State) then begin
    SetWindowPos(ComboBox3.Handle, 0,
                 Rect.Left + DataGrid3.Left + 1, Rect.Top + DataGrid3.top + 1,
                 Rect.Right - Rect.Left + 2, Rect.Bottom - Rect.top + 2,
                 SWP_NOZORDER   or SWP_SHOWWINDOW);
    ComboBox3.ItemIndex := ComboBox3.Items.IndexOf(SetStr);
    ComboBox3.Show;
    Exit;
  end;

  if ComboBox3.Visible then
    ComboBox3.Visible := False;

  DataGrid3.Canvas.FillRect(Rect);

  if ARow = 0 then
     Header := (DT_CENTER or DT_VCENTER or DT_SINGLELINE)
  else
     Header := (DT_SINGLELINE or DT_VCENTER or DT_LEFT);

  DrawText(DataGrid3.Canvas.Handle, PChar(SetStr), Length(SetStr),
           Rect, Header);
  }
end;
procedure TCoAxialForm.DataGrid1DblClick(Sender: TObject);
begin
  if DataGrid1.Col=1 then begin
    if DataGrid1.Cells[ DataGrid1.Col,DataGrid1.Row]='False' then begin
      DataGrid1.Cells[ DataGrid1.Col,DataGrid1.Row]:='True';
    end else begin
      DataGrid1.Cells[ DataGrid1.Col,DataGrid1.Row]:='False';
    end;
    DataGrid1.Font.Color:=clNavy;
    BitBtn2.Font.Color:=clRed;
  end;

end;

procedure TCoAxialForm.DataGrid2DblClick(Sender: TObject);
begin
  if DataGrid2.Col=1 then begin
    if DataGrid2.Cells[ DataGrid2.Col,DataGrid2.Row]='False' then begin
      DataGrid2.Cells[ DataGrid2.Col,DataGrid2.Row]:='True';
    end else begin
      DataGrid2.Cells[ DataGrid2.Col,DataGrid2.Row]:='False';
    end;
    DataGrid2.Font.Color:=clNavy;
    BitBtn2.Font.Color:=clRed;
  end;
  
end;

procedure TCoAxialForm.DataGrid3DblClick(Sender: TObject);
begin
  if DataGrid3.Col=1 then begin
    if DataGrid3.Cells[ DataGrid3.Col,DataGrid3.Row]='False' then begin
      DataGrid3.Cells[ DataGrid3.Col,DataGrid3.Row]:='True';
    end else begin
      DataGrid3.Cells[ DataGrid3.Col,DataGrid3.Row]:='False';
    end;
    DataGrid3.Font.Color:=clNavy;
    BitBtn2.Font.Color:=clRed;
  end;

end;

procedure TCoAxialForm.RefreshDraw;
var col,row:integer;
begin
  DataGrid1.Font.Color:=clBlack;
  DataGrid2.Font.Color:=clBlack;
  DataGrid3.Font.Color:=clBlack;
  BitBtn2.Font.Color:=clBlack;


  for col:=0 to 7 do begin
    for row:=1 to 64+2 do begin
      DataGrid1.Cells[col,row]:='';
      DataGrid2.Cells[col,row]:='';
      DataGrid3.Cells[col,row]:='';
    end;
  end;

  self.CoAxialDraw;
  self.SiftDraw;
  self.TiltDraw;
  self.Caption:='񋤎'+'/'+OpticalSystem.OpticalName;
end;


procedure TCoAxialForm.DataGrid1KeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.Fix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TCoAxialForm.DataGrid2KeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.Fix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TCoAxialForm.DataGrid3KeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.Fix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TCoAxialForm.DataGrid1Click(Sender: TObject);
begin
  BitBtn2Click(Sender );
end;

procedure TCoAxialForm.DataGrid2Click(Sender: TObject);
begin
  BitBtn2Click(Sender );
end;

procedure TCoAxialForm.DataGrid3Click(Sender: TObject);
begin
  BitBtn2Click(Sender );
end;

end.
