unit Cofficient;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids,
    MainForm, OptSystem,OptSurface,OptMedium,MayMath;

type
  TCoefficientForm = class(TForm)
    StringGrid1: TStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    Cof: TCof;
//    PCof: array[1..MaxOptSurface,1..6] of single;
//    Cof5D: array[1..MaxOptSurface,1..12] of single;
//    PCof5D: array[1..MaxOptSurface,1..12] of single;
    Ttg: TTtg;
    procedure CaluculateCoefficientByOptSysMethod;
    procedure Draw;
    procedure Initialize;
  public
    { Public 錾 }
  end;

var
  CoefficientForm: TCoefficientForm;

implementation

{$R *.dfm}

procedure TCoefficientForm.Initialize;
var i,k :integer;
begin
  for i:=1 to MaxOptSurface+1 do begin
    for k:=1 to 6 do begin
      Cof[i,k]:=0;
    end;
  end;
  for i:=1 to MaxOptSurface+1 do begin
    for k:=1 to 2 do begin
      ttg[i,k]:=0;
    end;
  end;

  self.Draw;

end;

procedure TCoefficientForm.CaluculateCoefficientByOptSysMethod;
var i,k :integer;
begin
  for i:=1 to MaxOptSurface+1 do begin
    for k:=1 to 6 do begin
      Cof[i,k]:=0;
    end;
  end;
  for i:=1 to MaxOptSurface+1 do begin
    for k:=1 to 2 do begin
      ttg[i,k]:=0;
    end;
  end;

  OpticalSystem.CaluculateCoefficient(Cof,Ttg);

end;


procedure TCoefficientForm.Draw;
var col,row:integer;
begin
  StringGrid1.Cells[1,0]:='ʎ';
  StringGrid1.Cells[2,0]:='R}';
  StringGrid1.Cells[3,0]:='_';
  StringGrid1.Cells[4,0]:='Petzval Sum';
  StringGrid1.Cells[5,0]:='cȎ';
  StringGrid1.Cells[6,0]:='ʘp';
  StringGrid1.Cells[7,0]:='F';
  StringGrid1.Cells[8,0]:='{F';

  for col:=0 to 8 do begin
    for row:=1 to 67do begin
      StringGrid1.Cells[col,row]:=' ';
    end;
  end;

  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if row=OpticalSystem.TotalSurfaceNumber+1 then begin
      StringGrid1.Cells[0,row]:='g[^';
    end else begin
      StringGrid1.Cells[0,row]:=IntToStr(row)+' ';
    end;
  end;



  for col:=1 to 6 do begin
    for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
      StringGrid1.Cells[col,row]:=FloatToStrF(Cof[row,col],ffGeneral,3,2);
    end;
  end;
  for col:=7 to 8 do begin
    for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
      StringGrid1.Cells[col,row]:=FloatToStrF(Ttg[row,col-6],ffGeneral,3,2);
    end;
  end;

  self.Caption:='3W'+'/'+OpticalSystem.OpticalName;
end;


procedure TCoefficientForm.BitBtn1Click(Sender: TObject);
begin
  CaluculateCoefficientByOptSysMethod;
  Draw;

end;

procedure TCoefficientForm.BitBtn2Click(Sender: TObject);
begin
  Draw;

end;

procedure TCoefficientForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  visible:=False;
end;

procedure TCoefficientForm.FormCreate(Sender: TObject);
begin
  self.Initialize;
end;

end.
