unit CurveBrowser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,
  MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray, ComCtrls,
  Spin;
const
{  MaxSANumber=40;
  MaxAngleNumber=10;     }
  Space=15;
  OVER=123456789;//  2147483647;

type
  TCurveForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    Panel2: TPanel;
    PaintBox2: TPaintBox;
    Panel3: TPanel;
    PaintBox3: TPaintBox;
    Panel4: TPanel;
    PaintBox4: TPaintBox;
    Panel5: TPanel;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    SAEdit: TEdit;
    SAScrollBar: TScrollBar;
    SACurveButton: TButton;
    Label16: TLabel;
    Panel6: TPanel;
    Label3: TLabel;
    Edit3: TEdit;
    Label4: TLabel;
    Edit4: TEdit;
    Label15: TLabel;
    ASSpinEdit: TSpinEdit;
    ASEdit: TEdit;
    ASScrollBar: TScrollBar;
    ASButton: TButton;
    Label9: TLabel;
    Label17: TLabel;
    Panel7: TPanel;
    Label5: TLabel;
    Edit5: TEdit;
    Label12: TLabel;
    Label6: TLabel;
    Edit6: TEdit;
    Label13: TLabel;
    DISSpinEdit: TSpinEdit;
    Label10: TLabel;
    DISEdit: TEdit;
    DISScrollBar: TScrollBar;
    DISButton: TButton;
    Label18: TLabel;
    Panel8: TPanel;
    Label7: TLabel;
    Edit7: TEdit;
    Label8: TLabel;
    Edit8: TEdit;
    Label14: TLabel;
    MAGSpinEdit: TSpinEdit;
    Label11: TLabel;
    MAGEdit: TEdit;
    MAGScrollBar: TScrollBar;
    MAGButton: TButton;
    Label19: TLabel;
    SpinButton1: TSpinButton;
    Edit9: TEdit;
    Edit10: TEdit;
    Edit11: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SAScrollBarChange(Sender: TObject);
    procedure SACurveButtonClick(Sender: TObject);
    procedure ASSpinEditChange(Sender: TObject);
    procedure ASButtonClick(Sender: TObject);
    procedure ASScrollBarChange(Sender: TObject);
    procedure DISScrollBarChange(Sender: TObject);
    procedure DISButtonClick(Sender: TObject);
    procedure DISSpinEditChange(Sender: TObject);
    procedure MAGScrollBarChange(Sender: TObject);
    procedure MAGButtonClick(Sender: TObject);
    procedure MAGSpinEditChange(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox2MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox3MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox4MouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure PaintBox2Paint(Sender: TObject);
    procedure PaintBox3Paint(Sender: TObject);
    procedure PaintBox4Paint(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
      
      
  private
    { Private 錾 }
    SAGraphScale: extended;
    ASGraphScale: extended;
    DISGraphScale: extended;
    MAGGraphScale: extended;
    InputAngle:extended;
    InputAngleDecimal:extended;
    SA: array[nd..nt,1..MaxSANumber] of extended;
    OSC: array[1..MaxSANumber] of extended;
    MAS: array[1..MaxAngleNumber] of extended;
    SAS: array[1..MaxAngleNumber] of extended;
    DIS: array[1..MaxAngleNumber] of extended;
    MAG: array[nd..nt,1..MaxAngleNumber] of extended;
    clNt,clNs,clNr,clNC,clNd,clNe,clNF,clNg,clNh,clNi :Tcolor;
    {'nt' 'ns' 'nr' 'nC' 'nd' 'ne' 'nF' 'ng' 'nh' 'ni'}

    procedure Initialize(Sender: TObject);
    procedure SADraw;
    procedure CalculateSphericalAberration;
    procedure DrawGraphLine(aPaintBox:TPaintBox; aSpace:integer);
    procedure CalculateAS;
    procedure ASDraw;
    procedure DrawDistortion;
    procedure CalculateDistortion;
    procedure CalculateCromaticMagnification;
    procedure DrawMag;
  public

    { Public 錾 }
  end;

var
  CurveForm: TCurveForm;

implementation

{$R *.dfm}

procedure TCurveForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// Action:=caFree;
  CurveForm.Visible:=False;
end;

procedure TCurveForm.FormCreate(Sender: TObject);
begin
  Initialize(Sender);
end;

procedure TCurveForm.Initialize(Sender: TObject);
var
  n:TSpectru;
  j:integer;
begin

  for n:=nd to nt do begin
    for j:=1 to MaxSANumber do begin
      SA[n,j]:=0;
    end;
  end;

  for n:=nd to nt do begin
    for j:=1 to MaxAngleNumber do begin
      MAG[n,j]:=0;
    end;
  end;

  for j:=1 to MaxSANumber do begin
    OSC[j]:=0;
  end;

  for j:=1 to MaxAngleNumber do begin
    MAS[j]:=0;
    SAS[j]:=0;
    DIS[j]:=0;
  end;
  
  clNt:=clMaroon;//$00007B;
  clNs:=$0000B9;
  clNr:=$6A1EE1;
  clNC:=clRed;
  clNd:=clYellow;
  clNe:=$05FF9A;
  clNF:=$40FF00;//clLime;//$8EFF04;
  clNg:=clBlue;
  clNh:=clNavy;
  clNi:=$800080;
  
  InputAngle:=0;
  SAGraphScale:=0.1;
  ASGraphScale:=0.1;
  DISGraphScale:=0.1;
  MAGGraphScale:=0.1;

  SAEdit.Text:=FloatToStr(SAGraphScale);
  ASEdit.Text:=FloatToStr(SAGraphScale);
  DISEdit.Text:=FloatToStr(SAGraphScale);
  MAGEdit.Text:=FloatToStr(SAGraphScale);  
{  XN[o[ɘAăOt`Lꍇ
  L̏R[hg}

  SAScrollBarChange(Sender);
  ASScrollBarChange(Sender);
  DISScrollBarChange(Sender);
  MAGScrollBarChange(Sender);

  ASSpinEditChange(Sender );

  self.Caption:='cȐ'+'/'+OpticalSystem.OpticalName;
end;

procedure TCurveForm.SAScrollBarChange(Sender: TObject);
begin
  SAGraphScale:=SAScrollBar.Position/100;
  SAEdit.Text:=FloatToStr(SAGraphScale);
  self.SADraw;
end;

procedure TCurveForm.SACurveButtonClick(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
try
  self.CalculateSphericalAberration;
  self.SADraw;
finally
  Screen.Cursor:=crDefault;
end;
end;

procedure TCurveForm.CalculateSphericalAberration;
var
  a3DRay:TD3Ray;
  aDr, aStep, aInitiDataAy, aInitiDataDxi,
  aFl:extended;
  n:TSpectru;
  k:integer;
begin

  aFl:=OpticalSystem.FocalLength[nd];

  if OpticalSystem.EffectiveAperture=0 then begin
    aDr:=OpticalSystem.OpticalSurface[1].Diameter;
  end else begin
    aDr:=OpticalSystem.EffectiveAperture;
  end;

  aStep:=aDr/2/(MaxSANumber-1);

  a3DRay:=TD3Ray.create;
try
  for n:=nd to OpticalSystem.LastSpectru do begin
    for k:=2 to MaxSANumber do begin
      a3DRay.Initialize;
      a3DRay.qntp:=OpticalSystem.EntrancePupil;
      if OpticalSystem.ObjectDistance<-1.0e10 then begin
        a3DRay.InitializeForSphericalAberration(aStep*(k - 1));
      end else begin
        a3DRay.InitializeForSAFiniteCase((aStep*(k - 1)), OpticalSystem.objectDistance,0,0);
      end;

      aInitiDataAy:=a3DRay.ay;
      aInitiDataDxi:=a3DRay.dxi;
      OpticalSystem.RayTraceInAspherical(a3DRay, n);

      if a3DRay.ay{ax} = NULL then begin

        //SA[n, k]:=0;
        SA[n, k]:=NULL;

        if n=nd then OSC[k]:=NULL;

      end else begin

        SA[n,k]:={abs} (a3DRay.ax-(a3DRay.dxi/a3DRay.dyi*a3DRay.ay))
                                   -{abs} ( OpticalSystem.BackFocus[nd]);
                                   
  {      if OpticalSystem.OpticalMedium[OPticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0 then begin
          SA[n,k]:=-1*SA[n,k];   //E̎
        end;       }  //E̎ ł̂܂܂ɖ߂2022/5/11



        if n=nd then begin
          if OpticalSystem.ObjectDistance<-1.0e10 then begin
            OSC[k]:=(-1.0 * aInitiDataAy *aInitiDataDxi/(a3DRay.dyi)) - aFl;
            OSC[1]:=0;
          end else begin
          {  OSC[k]:=(-1.0 * aInitiDataAy *aInitiDataDxi/(a3DRay.dyi)) - ( OpticalSystem.BackFocus[nd]);
            OSC[1]:=0; }
           OSC[k]:=0;
          end;
        end;

      end;

    end;

    SA[n,1]:={abs} (OpticalSystem.BackFocus[n])  - {abs} (OpticalSystem.backFocus[nd]);
{    if OpticalSystem.OpticalMedium[OPticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0 then begin
      SA[n,1]:=-1*SA[n,1];   //E̎
    end;    }      //E̎ ł̂܂܂ɖ߂2022/5/11


    if n=nd then begin
      if OpticalSystem.ObjectDistance<-1.0e10 then begin
        OSC[1]:=0;
      end else begin
        OSC[1]:=0;
      end;
    end;

  end;
finally
  a3DRay.Free;
end;

end;

procedure TCurveForm.SADraw;
var
  aSpace,k:integer;
  n:TSpectru;
  aYPoint,aXPoint: array[1..MaxSANumber] of integer;
begin
  aSpace:=Space;
  self.DrawGraphLine(PaintBox1,aSpace);

  for n:=nd to OpticalSystem.LastSpectru do begin
    case n of
       nt : PaintBox1.Canvas.Pen.Color:=clNt;
       ns : PaintBox1.Canvas.Pen.Color:=clNs;
       nr : PaintBox1.Canvas.Pen.Color:=clNr;
       nC : PaintBox1.Canvas.Pen.Color:=clNC;
       nd : PaintBox1.Canvas.Pen.Color:=clNd;
       ne : PaintBox1.Canvas.Pen.Color:=clNe;
       nF : PaintBox1.Canvas.Pen.Color:=clNF;
       ng : PaintBox1.Canvas.Pen.Color:=clNg;
       nh : PaintBox1.Canvas.Pen.Color:=clNh;
       ni : PaintBox1.Canvas.Pen.Color:=clNi;
    end;

    for k:=1 to MaxSANumber do begin
      if SA[n,k]=NULL then Break;
      aYPoint[k]:=(PaintBox1.height-aSpace) - trunc( ((PaintBox1.height-aSpace) / (MaxSANumber-1)) *(k-1));
      aXPoint[k]:=trunc(PaintBox1.width / 2) + Trunc( SA[n,k] / ( SAGraphScale/(PaintBox1.width / 4) ) );
    end;
    PaintBox1.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
    for k:=2 to MaxSANumber do begin
      if SA[n,k]=NULL then Break;
      PaintBox1.Canvas.LineTo(aXPoint[k],aYPoint[k]);
    end;

  end;

  PaintBox1.Canvas.Pen.Color:=clWhite;
  PaintBox1.Canvas.Pen.Style:=psDot;
  for k:=1 to MaxSANumber do begin
    if OSC[k]=NULL then Break;
    aYPoint[k]:=(PaintBox1.height-aSpace) - trunc( ( (PaintBox1.height-aSpace) / (MaxSANumber-1) ) * (k-1));
    aXPoint[k]:=trunc(PaintBox1.width / 2) + Trunc( OSC[k] / ( SAGraphScale/(PaintBox1.width / 4) ) );
  end;
  PaintBox1.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
  for k:=2 to MaxSANumber do begin
    if OSC[k]=NULL then Break;
    PaintBox1.Canvas.LineTo(aXPoint[k],aYPoint[k]);
  end;

end;

procedure TCurveForm.DrawGraphLine(aPaintBox:TPaintBox; aSpace:integer);
begin
  aPaintBox.Canvas.Pen.Style:=psSolid;
  aPaintBox.Canvas.Pen.Color:=clGray;
  aPaintBox.Canvas.Rectangle(0,0,aPaintBox.width,aPaintBox.height);

  aPaintBox.Canvas.Pen.Color:=clSilver;
  aPaintBox.Canvas.MoveTo( 0, aPaintBox.height-aSpace);
  aPaintBox.Canvas.LineTo( aPaintBox.width, aPaintBox.height-aSpace );

  aPaintBox.Canvas.MoveTo( aPaintBox.width div 2, aPaintBox.height-aSpace );
  aPaintBox.Canvas.LineTo( aPaintBox.width div 2, aPaintBox.height );

  aPaintBox.Canvas.MoveTo( aPaintBox.width div 4, aPaintBox.height-aSpace);
  aPaintBox.Canvas.LineTo( aPaintBox.width div 4, aPaintBox.height );
  aPaintBox.Canvas.MoveTo( aPaintBox.width div 4 * 3, aPaintBox.height-aSpace );
  aPaintBox.Canvas.LineTo( aPaintBox.width div 4 * 3, aPaintBox.height );

  aPaintBox.Canvas.MoveTo( aPaintBox.width div 2, 0 );
  aPaintBox.Canvas.LineTo( aPaintBox.width div 2,  20 );


end;

procedure TCurveForm.ASSpinEditChange(Sender: TObject);
begin

  InputAngle:=ASSpinEdit.Value+InputAngleDecimal;
   
  Edit10.Text:=FloatToStr(InputAngle) ;
  Edit11.Text:=FloatToStr(InputAngle) ;

end;


procedure TCurveForm.ASButtonClick(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
try
  self.CalculateAS;
  self.ASDraw;
finally
  Screen.Cursor:=crDefault;
end;
end;


procedure TCurveForm.CalculateAS;
var
  anAngle:array[1..MaxAngleNumber] of extended;
  a3DRay:TD3Ray;
  k:integer;
begin
  a3DRay:=TD3Ray.create;
try
  for k:=1 to MaxAngleNumber do begin
    if k=1 then
      anAngle[1]:=0
    else
      anAngle[k]:=InputAngle * ((k-1)/(MaxAngleNumber-1));
  end;

  for k:=2 to MaxAngleNumber do begin
    a3DRay.initialize;
    a3DRay.qntp:=OpticalSystem.EntrancePupil;

    OpticalSystem.CalculatePrincipalRay(a3DRay,anAngle[k]);

    a3DRay.asSwitch:=true;
    a3DRay.InitializeForAs;
    OpticalSystem.RayTraceInAspherical(a3DRay,nd);

    MAS[k]:={abs} (a3DRay.tas) - {abs} (OpticalSystem.BackFocus[nd]);
    SAS[k]:={abs} (a3DRay.sas) - {abs} (OpticalSystem.BackFocus[nd]);
  end;

  MAS[1]:=0;
  SAS[1]:=0;
finally
a3DRay.free;
end;

end;

procedure TCurveForm.ASDraw;
var
  aSpace,k:integer;
  aYPoint,aXPoint: array[1..MaxAngleNumber] of integer;
begin
  aSpace:=Space;
  DrawGraphLine(PaintBox2, aSpace);

  PaintBox2.Canvas.Pen.Color:=clYellow;
  PaintBox2.Canvas.Pen.Style:=psDot;
  for k:=1 to MaxAngleNumber do begin
    aYPoint[k]:=(PaintBox2.height-aSpace) - trunc((PaintBox2.height-aSpace) / (MaxAngleNumber-1) *(k-1));
    aXPoint[k]:=PaintBox2.width div 2 + Trunc( MAS[k] / ( ASGraphScale/(PaintBox2.width / 4) ) );
  end;
  PaintBox2.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
  for k:=2 to MaxAngleNumber do begin
    PaintBox2.Canvas.LineTo(aXPoint[k],aYPoint[k]);
  end;

  PaintBox2.Canvas.Pen.Color:=clWhite;
  PaintBox2.Canvas.Pen.Style:=psSolid;
  for k:=1 to MaxAngleNumber do begin
    aYPoint[k]:=(PaintBox2.height-aSpace) - trunc((PaintBox2.height-aSpace) / (MaxAngleNumber-1) *(k-1));
    aXPoint[k]:=PaintBox2.width div 2 + Trunc( SAS[k] / ( ASGraphScale/(PaintBox2.width / 4) ) );
  end;
  PaintBox2.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
  for k:=2 to MaxAngleNumber do begin
    PaintBox2.Canvas.LineTo(aXPoint[k],aYPoint[k]);
  end;

end;

procedure TCurveForm.ASScrollBarChange(Sender: TObject);
begin
  ASGraphScale:=ASScrollBar.Position/100;
  ASEdit.Text:=FloatToStr(ASGraphScale);
  self.ASDraw;

end;

procedure TCurveForm.DISScrollBarChange(Sender: TObject);
begin
  DISGraphScale:=DISScrollBar.Position/100;
  DISEdit.Text:=FloatToStr(DISGraphScale);
  self.DrawDistortion;
end;

procedure TCurveForm.DISButtonClick(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
try
  self.CalculateDistortion;
  self.DrawDistortion;
finally
  Screen.Cursor:=crDefault;
end;
end;

procedure TCurveForm.CalculateDistortion;
var
  anAngle:array[1..MaxAngleNumber] of extended;
  aY, aYbar:array[1..MaxAngleNumber] of extended;
  a3DRay:TD3Ray;
  k:integer;
  aBfl:extended;
  aFl:extended;
begin
  aBfl:=OpticalSystem.BackFocus[nd];
  aFl:=OpticalSystem.FocalLength[nd];
  a3DRay:=TD3Ray.create;
try
  for k:=1 to MaxAngleNumber do begin
    if k=1 then
      anAngle[1]:=0
    else
      anAngle[k]:=InputAngle * ((k-1)/(MaxAngleNumber-1));
  end;

  for k:=2 to MaxAngleNumber do begin
    aYbar[k]:= aFl * tan( degreeToRadian(anAngle[k]) );
  end;

  for k:=2 to MaxAngleNumber do begin
    a3DRay.initialize;
    a3DRay.qntp:=OpticalSystem.EntrancePupil;
    OpticalSystem.CalculatePrincipalRay(a3DRay,anAngle[k]);

    OpticalSystem.RayTraceInAspherical(a3DRay,nd);

    aY[k]:=a3DRay.ay + (a3DRay.dyi/a3DRay.dxi) * (aBfl - a3DRay.ax);
    if abs(aYbar[k])>1.0e-30 then
      DIS[k]:= ( abs(aY[k]) - abs(aYbar[k]) ) / abs(aYbar[k]) * 100;
  end;

  DIS[1]:=0;

finally
  a3DRay.free;
end;

end;

procedure TCurveForm.DrawDistortion;
var
  aSpace,k:integer;
  aYPoint,aXPoint: array[1..MaxSANumber] of integer;
begin
  aSpace:=Space;
  DrawGraphLine(PaintBox3, aSpace);

  PaintBox3.Canvas.Pen.Color:=clWhite;
  PaintBox3.Canvas.Pen.Style:=psSolid;
  for k:=1 to MaxAngleNumber do begin
    aYPoint[k]:=(PaintBox3.height-aSpace) - trunc((PaintBox3.height-aSpace) / (MaxAngleNumber-1) *(k-1));
    aXPoint[k]:=PaintBox3.width div 2 + Trunc( DIS[k] / ( DISGraphScale/(PaintBox3.width / 4) ) );
  end;
  PaintBox3.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
  for k:=2 to MaxAngleNumber do begin
    PaintBox3.Canvas.LineTo(aXPoint[k],aYPoint[k]);
  end;

end;

procedure TCurveForm.DISSpinEditChange(Sender: TObject);
begin
  InputAngle:=DISSpinEdit.Value;
  ASSpinEdit.Value:=DISSpinEdit.Value;
  MAGSpinEdit.Value:=DISSpinEdit.Value;
end;

procedure TCurveForm.MAGScrollBarChange(Sender: TObject);
begin
  MAGGraphScale:=MAGScrollBar.Position/100;
  MAGEdit.Text:=FloatToStr(MAGGraphScale);
  self.DrawMag;
end;

procedure TCurveForm.MAGButtonClick(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
try
  self.CalculateCromaticMagnification;
  self.DrawMag;
finally
  Screen.Cursor:=crDefault;
end;
end;

procedure TCurveForm.CalculateCromaticMagnification;
var
  a3DRay:TD3Ray;
  aBfl,aY:extended;
  anAngle:array[1..MaxAngleNumber] of extended;
  aYnd:array[1..MaxAngleNumber] of extended;
  n:TSpectru;
  k:integer;
begin
  aBfl:=OpticalSystem.BackFocus[nd];

  for k:=1 to MaxAngleNumber do begin
    if k=1 then
      anAngle[1]:=0
    else
      anAngle[k]:=InputAngle * ((k-1)/(MaxAngleNumber-1));
  end;

  a3DRay:=TD3Ray.create;
try
  for k:=2 to MaxAngleNumber do begin
    a3DRay.initialize;
    a3DRay.qntp:=OpticalSystem.EntrancePupil;
    OpticalSystem.CalculatePrincipalRay(a3DRay,anAngle[k]);
    OpticalSystem.RayTraceInAspherical(a3DRay,nd);
    aYnd[k]:=a3DRay.ay + (a3DRay.dyi/a3DRay.dxi) * (aBfl - a3DRay.ax);
  end;

  for n:=nd to OpticalSystem.LastSpectru do begin
    MAG[n,1]:=0;
    for k:=2 to MaxAngleNumber do begin
      if n=nd then begin
        MAG[n,k]:=0;
      end else begin
        a3DRay.initialize;
        a3DRay.qntp:=OpticalSystem.EntrancePupil;
        OpticalSystem.CalculatePrincipalRay(a3DRay,anAngle[k]);
        OpticalSystem.RayTraceInAspherical(a3DRay,n);
        aY:=a3DRay.ay + (a3DRay.dyi/a3DRay.dxi) * (aBfl - a3DRay.ax);
        MAG[n,k]:=aYnd[k] - aY;
      end;
    end;
  end;

finally
  a3DRay.Free;
end;

end;

procedure TCurveForm.DrawMag;
var
  aSpace,k:integer;
  n:TSpectru;
  aYPoint,aXPoint: array[1..MaxSANumber] of integer;
begin
  aSpace:=Space;
  self.DrawGraphLine(PaintBox4,aSpace);

  for n:=nd to OpticalSystem.LastSpectru do begin
    case n of
       nt : PaintBox4.Canvas.Pen.Color:=clNt;
       ns : PaintBox4.Canvas.Pen.Color:=clNs;
       nr : PaintBox4.Canvas.Pen.Color:=clNr;
       nC : PaintBox4.Canvas.Pen.Color:=clNC;
       nd : PaintBox4.Canvas.Pen.Color:=clNd;
       ne : PaintBox4.Canvas.Pen.Color:=clNe;
       nF : PaintBox4.Canvas.Pen.Color:=clNF;
       ng : PaintBox4.Canvas.Pen.Color:=clNg;
       nh : PaintBox4.Canvas.Pen.Color:=clNh;
       ni : PaintBox4.Canvas.Pen.Color:=clNi;
    end;

    for k:=1 to MaxAngleNumber do begin
      aYPoint[k]:=(PaintBox4.height-aSpace) - trunc((PaintBox4.height-aSpace) / (MaxAngleNumber-1) *(k-1));
      aXPoint[k]:=PaintBox4.width div 2 + Trunc( MAG[n,k] / ( MAGGraphScale/(PaintBox4.width / 4) ) );
    end;
    PaintBox4.Canvas.MoveTo(aXPoint[1],aYPoint[1]);
    for k:=2 to MaxAngleNumber do begin
      PaintBox4.Canvas.LineTo(aXPoint[k],aYPoint[k]);
    end;

  end;

end;


procedure TCurveForm.MAGSpinEditChange(Sender: TObject);
begin
  InputAngle:=MagSpinEdit.Value;
  ASSpinEdit.Value:=MagSpinEdit.Value;
  DISSpinEdit.Value:=MagSpinEdit.Value;
end;

procedure TCurveForm.PaintBox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  aDotScaleX, aDotScaleY:extended;
  aPointX, aPointY:extended;
  aMouthPointX, aMouthPointY: integer;
begin
  aDotScaleX:=SAGraphScale/(PaintBox1.width / 4);
  aMouthPointX:=X - (PaintBox1.width div 2);
  aPointX:=aMouthPointX * aDotScaleX;
  Edit1.Text:=FloatToStr( aPointX );

  aDotScaleY:=(OpticalSystem.EffectiveAperture/2) / (PaintBox1.height-Space);
  aMouthPointY:=(PaintBox1.height-Space) - Y;
  aPointY:=aMouthPointY * aDotScaleY;
  Edit2.Text:=FloatToStr( aPointY );


end;

procedure TCurveForm.PaintBox2MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  aDotScaleX, aDotScaleY:extended;
  aPointX, aPointY:extended;
  aMouthPointX, aMouthPointY: integer;
begin
  aDotScaleX:=ASGraphScale/(PaintBox2.width / 4);
  aMouthPointX:=X - (PaintBox2.width div 2);
  aPointX:=aMouthPointX * aDotScaleX;
  Edit3.Text:=FloatToStr( aPointX );

  aDotScaleY:=(InputAngle) / (PaintBox2.height-Space);
  aMouthPointY:=(PaintBox2.height-Space) - Y;
  aPointY:=aMouthPointY * aDotScaleY;
  Edit4.Text:=FloatToStr( aPointY );


end;

procedure TCurveForm.PaintBox3MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  aDotScaleX, aDotScaleY:extended;
  aPointX, aPointY:extended;
  aMouthPointX, aMouthPointY: integer;
begin
  aDotScaleX:=DISGraphScale/(PaintBox3.width / 4);
  aMouthPointX:=X - (PaintBox3.width div 2);
  aPointX:=aMouthPointX * aDotScaleX;
  Edit5.Text:=FloatToStr( aPointX );

  aDotScaleY:=(InputAngle) / (PaintBox3.height-Space);
  aMouthPointY:=(PaintBox3.height-Space) - Y;
  aPointY:=aMouthPointY * aDotScaleY;
  Edit6.Text:=FloatToStr( aPointY );


end;


procedure TCurveForm.PaintBox4MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  aDotScaleX, aDotScaleY:extended;
  aPointX, aPointY:extended;
  aMouthPointX, aMouthPointY: integer;
begin
  aDotScaleX:=MAGGraphScale/(PaintBox4.width / 4);
  aMouthPointX:=X - (PaintBox4.width div 2);
  aPointX:=aMouthPointX * aDotScaleX;
  Edit7.Text:=FloatToStr( aPointX );

  aDotScaleY:=(InputAngle) / (PaintBox4.height-Space);
  aMouthPointY:=(PaintBox4.height-Space) - Y;
  aPointY:=aMouthPointY * aDotScaleY;
  Edit8.Text:=FloatToStr( aPointY );


end;


procedure TCurveForm.PaintBox1Paint(Sender: TObject);
begin
try
  self.SADraw;
except
  exit;
end;
end;

procedure TCurveForm.PaintBox2Paint(Sender: TObject);
begin
try
    self.ASDraw;
except
    exit;
end;
end;

procedure TCurveForm.PaintBox3Paint(Sender: TObject);
begin
try
  self.DrawDistortion;
except
  exit;
end;
end;

procedure TCurveForm.PaintBox4Paint(Sender: TObject);
begin
try
  self.DrawMag;
except
  exit;
end;
end;

procedure TCurveForm.SpinButton1DownClick(Sender: TObject);
begin
if InputAngleDecimal>=0.1 then  begin
     InputAngleDecimal:=InputAngleDecimal-0.1;
     Edit9.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=ASSpinEdit.Value+InputAngleDecimal;

  end else begin

  end;
  if InputAngleDecimal<0.1 then  begin
     InputAngleDecimal:=0;
     Edit9.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=ASSpinEdit.Value+InputAngleDecimal;

  end;
    Edit10.Text:=FloatToStr(InputAngle) ;
     Edit11.Text:=FloatToStr(InputAngle) ;
end;

procedure TCurveForm.SpinButton1UpClick(Sender: TObject);
begin
  if InputAngleDecimal<0.9 then  begin
     InputAngleDecimal:=InputAngleDecimal+0.1;
     Edit9.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=ASSpinEdit.value+InputAngleDecimal;
     Edit10.Text:=FloatToStr(InputAngle) ;
     Edit11.Text:=FloatToStr(InputAngle) ;
  end else begin

  end;

    Edit10.Text:=FloatToStr(InputAngle) ;
     Edit11.Text:=FloatToStr(InputAngle) ;
end;

end.

