unit D3VewBrowser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons,
  MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray,
   Spin;

type
  TD3Vew = class(TForm)
    Panel1: TPanel;
    D3PaintBox: TPaintBox;
    Panel2: TPanel;
    ScrollBar1: TScrollBar;
    Edit6: TEdit;
    Label6: TLabel;
    Label5: TLabel;
    Edit5: TEdit;
    ScrollBar2: TScrollBar;
    Label7: TLabel;
    SpinEdit1: TSpinEdit;
    Edit7: TEdit;
    SpinButton1: TSpinButton;
    Button1: TButton;
    Button2: TButton;
    Label4: TLabel;
    ScrollBar3: TScrollBar;
    Edit1: TEdit;
    Label3: TLabel;
    Label2: TLabel;
    Edit4: TEdit;
    ScrollBar6: TScrollBar;
    Edit3: TEdit;
    ScrollBar5: TScrollBar;
    Label1: TLabel;
    Edit2: TEdit;
    ScrollBar4: TScrollBar;
    BitBtn1: TBitBtn;
    CheckBox1: TCheckBox;
    ScrollBar7: TScrollBar;
    Panel3: TPanel;
    ScrollBar8: TScrollBar;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ScrollBar4Change(Sender: TObject);
    procedure ScrollBar5Change(Sender: TObject);
    procedure ScrollBar6Change(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar8Change(Sender: TObject);
    procedure ScrollBar7Change(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure D3PaintBoxPaint(Sender: TObject);
  private
    ScreenDistance:integer;
    Magnification:extended;
    Rx,Ry,Rz:extended;
    OriginDistance:integer;
    MeriColor, SagiColor,FigColor, MarkColor,
    RayColor, SagiRayColor,PriRayColor : Tcolor;
    D3StartPointX,D3StartPointY:integer;
    RayAngle: extended;
    RayAngleDecimal: extended;

    RayStartX, RayStartY, RayStartZ: longInt;
    RayPointX: array[1..MaxOptSurface+1] of longInt;
    RayPointY: array[1..MaxOptSurface+1] of longInt;
    RayPointZ: array[1..MaxOptSurface+1] of longInt;
//    SurfacePeakPoint: array[1..MaxOptSurface+1,'X'..'Z'] of integer;

    FigPoint:array[1..MaxOptSurface,1..MaxOutLine,'X'..'Z'] of integer;
    MeriPoint: array[1..MaxOptSurface,1..MaxCurveLine,'X'..'Z'] of integer;
    SagiPoint: array[1..MaxOptSurface,1..MaxCurveLine,'X'..'Z'] of integer;
    SurfaceDistance:array[1..MaxOptSurface] of longInt;
    
    RayOriginX:array[1..MaxOptSurface] of longInt;
    RayOriginY:array[1..MaxOptSurface] of longInt;
    RayOriginZ:array[1..MaxOptSurface] of longInt;

    FocusFigPoint:array[1..MaxOutLine,'X'..'Z'] of integer;
    FocusMeriPoint: array[1..MaxCurveLine,'X'..'Z'] of integer;
    FocusSagiPoint: array[1..MaxCurveLine,'X'..'Z'] of integer;

    ObjeFigPoint:array[1..MaxOutLine,'X'..'Z'] of integer;
    ObjeMeriPoint: array[1..MaxCurveLine,'X'..'Z'] of integer;
    ObjeSagiPoint: array[1..MaxCurveLine,'X'..'Z'] of integer;

    procedure CenterProjection;
    procedure VewPointRotation(Rx:extended;Ry:extended;Rz:extended);
    procedure Draw;
    procedure RayDraw;
    procedure SagiRayDraw;
    procedure CulculateUpperRay;
    procedure CulculateLowerRay;
    procedure CulculatePrincipalRay;
    procedure CulculateSagitalRayMinus;
    procedure CulculateSagitalRayPrus;

    procedure DispositionRayPointTiltSift;
    procedure Rotation(var aX:integer; var aY:integer; var aZ:integer; aMatrix:TMatrix; aFlag:integer);

    procedure RayPointRotation(Rx:extended;Ry:extended;Rz:extended);
    procedure RayPointTransferInVewCoordinates(aX:integer; aY:integer; aZ:integer);
    procedure RayPointTransferVewCoordinates;
    procedure RayPointCenterProjection;
  public

    FinitRayPointX :  extended;
    FinitRayPointY :  extended;
    FinitRayPointZ :  extended;

  end;

var
  D3Vew: TD3Vew;

implementation

{$R *.dfm}

procedure TD3vew.Draw;
var
  i,k:integer;
  aN,aNn:extended;
begin
 // OpticalSystem.CaluculateWorldCoordinates(Magnification);

  OpticalSystem.CaluculateWorldCoordinatesInReal;
  OpticalSystem.ConvertWorldCoordinatesRealToInt(magnification);

  OpticalSystem.RotationInWorldCoordinates( (degreeToRadian(Rx)),(DegreeToRadian(Ry)), (DegreeToRadian(Rz)) );
  OpticalSystem.TransferVewCoordinates;
  OpticalSystem.TransferInVewCoordinates(0,0,OriginDistance);

  self.VewPointRotation( (degreeToRadian(0)),(DegreeToRadian(0)), (DegreeToRadian(0)) );

  self.CenterProjection;
//*******************************************************


  D3PaintBox.Canvas.Pen.Style:=psSolid;
  D3PaintBox.Canvas.Pen.Color:=clGray;
  D3PaintBox.Canvas.Rectangle(0,0,D3PaintBox.width,D3PaintBox.height);

  D3PaintBox.Canvas.Pen.Color:=MeriColor;
  for k:=1 to OpticalSystem.TotalSurfaceNumber do begin
    D3PaintBox.Canvas.MoveTo(D3StartPointX + MeriPoint[k,1,'X'],D3StartPointY - MeriPoint[k,1,'Y']);
    for i:=2 to MaxCurveLine do begin
      if i=2 then D3PaintBox.Canvas.Pen.Color:=MarkColor
        else  D3PaintBox.Canvas.Pen.Color:=MeriColor ;
      D3PaintBox.Canvas.LineTo(D3StartPointX + MeriPoint[k,i,'X'],D3StartPointY - MeriPoint[k,i,'Y']);
    end;
  end;

  D3PaintBox.Canvas.MoveTo(D3StartPointX + FocusMeriPoint[1,'X'],D3StartPointY - FocusMeriPoint[1,'Y']);
  for i:=2 to MaxCurveLine do begin
   if i=2 then D3PaintBox.Canvas.Pen.Color:=MarkColor
      else  D3PaintBox.Canvas.Pen.Color:=MeriColor ;
    D3PaintBox.Canvas.LineTo(D3StartPointX + FocusMeriPoint[i,'X'],D3StartPointY - FocusMeriPoint[i,'Y']);
  end;

 D3PaintBox.Canvas.Pen.Color:=SagiColor;
  for k:=1 to OpticalSystem.TotalSurfaceNumber do begin
    D3PaintBox.Canvas.MoveTo(D3StartPointX + SagiPoint[k,1,'X'],D3StartPointY - SagiPoint[k,1,'Y']);
    for i:=2 to MaxCurveLine do begin
      if i=2 then  D3PaintBox.Canvas.Pen.Color:=MarkColor
        else  D3PaintBox.Canvas.Pen.Color:=SagiColor ;
      D3PaintBox.Canvas.LineTo(D3StartPointX + SagiPoint[k,i,'X'],D3StartPointY - SagiPoint[k,i,'Y']);
    end;
  end;

  D3PaintBox.Canvas.MoveTo(D3StartPointX + FocusSagiPoint[1,'X'],D3StartPointY - FocusSagiPoint[1,'Y']);
  for i:=2 to MaxCurveLine do begin
    if i=2 then D3PaintBox.Canvas.Pen.Color:=MarkColor
      else  D3PaintBox.Canvas.Pen.Color:=SagiColor ;
    D3PaintBox.Canvas.LineTo(D3StartPointX + FocusSagiPoint[i,'X'],D3StartPointY - FocusSagiPoint[i,'Y']);
  end;


  D3PaintBox.Canvas.Pen.Color:=FigColor;
  for k:=1 to OpticalSystem.TotalSurfaceNumber do begin
    D3PaintBox.Canvas.MoveTo(D3StartPointX + FigPoint[k,1,'X'],D3StartPointY - FigPoint[k,1,'Y']);
    for i:=2 to MaxOutLine do begin
      D3PaintBox.Canvas.LineTo(D3StartPointX + FigPoint[k,i,'X'],D3StartPointY - FigPoint[k,i,'Y']);
    end;
    D3PaintBox.Canvas.LineTo(D3StartPointX + FigPoint[k,1,'X'],D3StartPointY - FigPoint[k,1,'Y']);
  end;

 D3PaintBox.Canvas.MoveTo(D3StartPointX + FocusFigPoint[1,'X'],D3StartPointY - FocusFigPoint[1,'Y']);
 for i:=2 to MaxOutLine do begin
    D3PaintBox.Canvas.LineTo(D3StartPointX + FocusFigPoint[i,'X'],D3StartPointY - FocusFigPoint[i,'Y']);
  end;
  D3PaintBox.Canvas.LineTo(D3StartPointX + FocusFigPoint[1,'X'],D3StartPointY - FocusFigPoint[1,'Y']);


  D3PaintBox.Canvas.Pen.Color:=MeriColor;
  for k:=1 to OpticalSystem.TotalSurfaceNumber-1 do begin
    aN:=OpticalSystem.OpticalMedium[k-1].refractiveindex[nd];
    aNn:=OpticalSystem.OpticalMedium[k].refractiveindex[nd];
    if ( (aN*aNn>0) and (aNn<>1) and (aNn<>-1 ) )then begin
      D3PaintBox.Canvas.MoveTo(MeriPoint[k,1,'X']+D3StartPointX,D3StartPointY - MeriPoint[k,1,'Y']);
      D3PaintBox.Canvas.LineTo(MeriPoint[k+1,1,'X']+D3StartPointX,D3StartPointY - MeriPoint[k+1,1,'Y']);
      D3PaintBox.Canvas.MoveTo(MeriPoint[k,MaxCurveLine,'X']+D3StartPointX,D3StartPointY - MeriPoint[k,MaxCurveLine,'Y']);
      D3PaintBox.Canvas.LineTo(MeriPoint[k+1,MaxCurveLine,'X']+D3StartPointX,D3StartPointY - MeriPoint[k+1,MaxCurveLine,'Y']);
     end;
  end;
  D3PaintBox.Canvas.Pen.Color:=SagiColor;
  for k:=1 to OpticalSystem.TotalSurfaceNumber-1 do begin
    aN:=OpticalSystem.OpticalMedium[k-1].refractiveindex[nd];
    aNn:=OpticalSystem.OpticalMedium[k].refractiveindex[nd];
    if ( (aN*aNn>0) and (aNn<>1) and (aNn<>-1 ) )then begin
      D3PaintBox.Canvas.MoveTo(SagiPoint[k,1,'X']+D3StartPointX,D3StartPointY - SagiPoint[k,1,'Y']);
      D3PaintBox.Canvas.LineTo(SagiPoint[k+1,1,'X']+D3StartPointX,D3StartPointY - SagiPoint[k+1,1,'Y']);
      D3PaintBox.Canvas.MoveTo(SagiPoint[k,MaxCurveLine,'X']+D3StartPointX,D3StartPointY - SagiPoint[k,MaxCurveLine,'Y']);
      D3PaintBox.Canvas.LineTo(SagiPoint[k+1,MaxCurveLine,'X']+D3StartPointX,D3StartPointY - SagiPoint[k+1,MaxCurveLine,'Y']);
    end;
  end;

  self.Caption:='3DVew'+'/'+OpticalSystem.OpticalName;
end;


procedure TD3Vew.VewPointRotation(Rx:extended;Ry:extended;Rz:extended);
var
  Xx,Xy,Xz, Yx,Yy,Yz, Zx,Zy,Zz:extended;
  X, Y, Z:integer;
  k,i:integer;
begin
  Xx:= cos(Ry)*cos(Rz)+sin(Rx)*sin(Ry)*sin(Rz) ;
  Xy:= cos(Rx)*sin(Rz) ;
  Xz:= -sin(Ry)*cos(Rz)+sin(Rx)*cos(Ry)*sin(Rz) ;

  Yx:= -cos(Ry)*sin(Rz)+sin(Rx)*sin(Ry)*cos(Rz);
  Yy:= cos(Rx)*cos(Rz);
  Yz:= sin(Ry)*sin(Rz)+sin(Rx)*cos(Ry)*cos(Rz);

  Zx:= cos(Rx)*sin(Ry);
  Zy:= -sin(Rx);
  Zz:= cos(Rx)*cos(Ry);

  for k:=1 to OpticalSystem.TotalSurfaceNumber do begin
    for i:=1 to MaxCurveLine do begin
      X:=trunc(OpticalSystem.OpticalSurface[k].MeridionalLine[i,'X']*Xx+
                                OpticalSystem.OpticalSurface[k].MeridionalLine[i,'Y']*Xy+
                                OpticalSystem.OpticalSurface[k].MeridionalLine[i,'Z']*Xz );

      Y:=trunc(OpticalSystem.OpticalSurface[k].MeridionalLine[i,'X']*Yx+
                                OpticalSystem.OpticalSurface[k].MeridionalLine[i,'Y']*Yy+
                                OpticalSystem.OpticalSurface[k].MeridionalLine[i,'Z']*Yz);

      Z:=trunc(OpticalSystem.OpticalSurface[k].MeridionalLine[i,'X']*Zx+
                                OpticalSystem.OpticalSurface[k].MeridionalLine[i,'Y']*Zy+
                                OpticalSystem.OpticalSurface[k].MeridionalLine[i,'Z']*Zz);
      MeriPoint[k,i,'X']:=X;
      MeriPoint[k,i,'Y']:=Y;
      MeriPoint[k,i,'Z']:=Z;

      X:=trunc(OpticalSystem.OpticalSurface[k].SagittalLine[i,'X']*Xx+
                                OpticalSystem.OpticalSurface[k].SagittalLine[i,'Y']*Xy+
                                OpticalSystem.OpticalSurface[k].SagittalLine[i,'Z']*Xz);

      Y:=trunc(OpticalSystem.OpticalSurface[k].SagittalLine[i,'X']*Yx+
                                OpticalSystem.OpticalSurface[k].SagittalLine[i,'Y']*Yy+
                                OpticalSystem.OpticalSurface[k].SagittalLine[i,'Z']*Yz);

      Z:=trunc(OpticalSystem.OpticalSurface[k].SagittalLine[i,'X']*Zx+
                                OpticalSystem.OpticalSurface[k].SagittalLine[i,'Y']*Zy+
                                OpticalSystem.OpticalSurface[k].SagittalLine[i,'Z']*Zz);
      SagiPoint[k,i,'X']:=X;
      SagiPoint[k,i,'Y']:=Y;
      SagiPoint[k,i,'Z']:=Z;
    end;

    for i:=1 to MaxOutLine do begin

      X:=trunc(OpticalSystem.OpticalSurface[k].OutLine[i,'X']*Xx+
                               OpticalSystem.OpticalSurface[k].OutLine[i,'Y']*Xy+
                               OpticalSystem.OpticalSurface[k].OutLine[i,'Z']*Xz);

      Y:=trunc(OpticalSystem.OpticalSurface[k].OutLine[i,'X']*Yx+
                               OpticalSystem.OpticalSurface[k].OutLine[i,'Y']*Yy+
                               OpticalSystem.OpticalSurface[k].OutLine[i,'Z']*Yz);

      Z:=trunc(OpticalSystem.OpticalSurface[k].OutLine[i,'X']*Zx+
                               OpticalSystem.OpticalSurface[k].OutLine[i,'Y']*Zy+
                               OpticalSystem.OpticalSurface[k].OutLine[i,'Z']*Zz);
      FigPoint[k,i,'X']:=X;
      FigPoint[k,i,'Y']:=Y;
      FigPoint[k,i,'Z']:=Z;
    end;
  end;

  for i:=1 to MaxCurveLine do begin

    X:=Trunc(OpticalSystem.FocusPlane.MeridionalLine[i,'X']*Xx+
                                 OpticalSystem.FocusPlane.MeridionalLine[i,'Y']*Xy+
                                 OpticalSystem.FocusPlane.MeridionalLine[i,'Z']*Xz);

    Y:=trunc(OpticalSystem.FocusPlane.MeridionalLine[i,'X']*Yx+
                                 OpticalSystem.FocusPlane.MeridionalLine[i,'Y']*Yy+
                                 OpticalSystem.FocusPlane.MeridionalLine[i,'Z']*Yz);

    Z:=trunc(OpticalSystem.FocusPlane.MeridionalLine[i,'X']*Zx+
                                 OpticalSystem.FocusPlane.MeridionalLine[i,'Y']*Zy+
                                 OpticalSystem.FocusPlane.MeridionalLine[i,'Z']*Zz);
    FocusMeriPoint[i,'X']:=X;
    FocusMeriPoint[i,'Y']:=Y;
    FocusMeriPoint[i,'Z']:=Z;


    X:=trunc(OpticalSystem.FocusPlane.SagittalLine[i,'X']*Xx+
                                 OpticalSystem.FocusPlane.SagittalLine[i,'Y']*Xy+
                                 OpticalSystem.FocusPlane.SagittalLine[i,'Z']*Xz);

    Y:=Trunc(OpticalSystem.FocusPlane.SagittalLine[i,'X']*Yx+
                                 OpticalSystem.FocusPlane.SagittalLine[i,'Y']*Yy+
                                 OpticalSystem.FocusPlane.SagittalLine[i,'Z']*Yz);

    Z:=trunc(OpticalSystem.FocusPlane.SagittalLine[i,'X']*Zx+
                                 OpticalSystem.FocusPlane.SagittalLine[i,'Y']*Zy+
                                 OpticalSystem.FocusPlane.SagittalLine[i,'Z']*Zz);
    FocusSagiPoint[i,'X']:=X;
    FocusSagiPoint[i,'Y']:=Y;
    FocusSagiPoint[i,'Z']:=Z;

    X:=trunc(OpticalSystem.ObjectPlane.MeridionalLine[i,'X']*Xx+
                                OpticalSystem.ObjectPlane.MeridionalLine[i,'Y']*XY+
                                OpticalSystem.ObjectPlane.MeridionalLine[i,'Z']*Xz);

    Y:=trunc(OpticalSystem.ObjectPlane.MeridionalLine[i,'X']*Yx+
                                OpticalSystem.ObjectPlane.MeridionalLine[i,'Y']*Yy+
                                OpticalSystem.ObjectPlane.MeridionalLine[i,'Z']*Yz);

    Z:=trunc(OpticalSystem.ObjectPlane.MeridionalLine[i,'X']*Zx+
                                OpticalSystem.ObjectPlane.MeridionalLine[i,'Y']*Zy+
                                OpticalSystem.ObjectPlane.MeridionalLine[i,'Z']*Zz);
    ObjeMeriPoint[i,'X']:=X;
    ObjeMeriPoint[i,'Y']:=Y;
    ObjeMeriPoint[i,'Z']:=Z;

    X:=trunc(Opticalsystem.ObjectPlane.SagittalLine[i,'X']*Xx+
                                Opticalsystem.ObjectPlane.SagittalLine[i,'Y']*Xy+
                                Opticalsystem.ObjectPlane.SagittalLine[i,'Z']*Xz);

    Y:=trunc(Opticalsystem.ObjectPlane.SagittalLine[i,'X']*Yx+
                                Opticalsystem.ObjectPlane.SagittalLine[i,'Y']*Yy+
                                Opticalsystem.ObjectPlane.SagittalLine[i,'Z']*Yz);

    Z:=trunc(Opticalsystem.ObjectPlane.SagittalLine[i,'X']*Zx+
                                Opticalsystem.ObjectPlane.SagittalLine[i,'Y']*Zy+
                                Opticalsystem.ObjectPlane.SagittalLine[i,'Z']*Zz);
    ObjeSagiPoint[i,'X']:=X;
    ObjeSagiPoint[i,'Y']:=Y;
    ObjeSagiPoint[i,'Z']:=Z;
  end;

  for i:=1 to MaxOutLine do begin

    X:=trunc(OpticalSystem.FocusPlane.OutLine[i,'X']*Xx+
                                OpticalSystem.FocusPlane.OutLine[i,'Y']*Xy+
                                OpticalSystem.FocusPlane.OutLine[i,'Z']*Xz);

    Y:=trunc(OpticalSystem.FocusPlane.OutLine[i,'X']*Yx+
                                OpticalSystem.FocusPlane.OutLine[i,'Y']*Yy+
                                OpticalSystem.FocusPlane.OutLine[i,'Z']*Yz);

    Z:=trunc(OpticalSystem.FocusPlane.OutLine[i,'X']*Zx+
                                OpticalSystem.FocusPlane.OutLine[i,'Y']*Zy+
                                OpticalSystem.FocusPlane.OutLine[i,'Z']*Zz);
    FocusFigPoint[i,'X']:=X;
    FocusFigPoint[i,'Y']:=Y;
    FocusFigPoint[i,'Z']:=Z;


    X:=trunc(OpticalSystem.FocusPlane.OutLine[i,'X']*Xx+
                               OpticalSystem.FocusPlane.OutLine[i,'Y']*Xy+
                               OpticalSystem.FocusPlane.OutLine[i,'Z']*Xz);

    Y:=trunc(OpticalSystem.FocusPlane.OutLine[i,'X']*Yx+
                               OpticalSystem.FocusPlane.OutLine[i,'Y']*Yy+
                               OpticalSystem.FocusPlane.OutLine[i,'Z']*Yz);

    Z:=trunc(OpticalSystem.FocusPlane.OutLine[i,'X']*Zx+
                               OpticalSystem.FocusPlane.OutLine[i,'Y']*Zy+
                               OpticalSystem.FocusPlane.OutLine[i,'Z']*Zz);
    ObjeFigPoint[i,'X']:=X;
    ObjeFigPoint[i,'Y']:=Y;
    ObjeFigPoint[i,'Z']:=Z;
  end;

end;

procedure TD3Vew.CenterProjection;
var
  i,k:integer;
  aDpZ:extended;

begin

  for k:=1 to OpticalSystem.TotalSurfaceNumber do begin
    for i:=1 to MaxCurveLine do begin
      if MeriPoint[k,i,'Z'] = 0 then
        MeriPoint[k,i,'Z'] :=  MeriPoint[k,i,'Z']+1;
      aDpZ:=ScreenDistance / MeriPoint[k,i,'Z'];
      MeriPoint[k,i,'X']:=trunc(MeriPoint[k,i,'X']*aDpZ);
      MeriPoint[k,i,'Y']:=trunc(MeriPoint[k,i,'Y']*aDpZ);
      if MeriPoint[k,i,'Z']<ScreenDistance then  //NbsO
         MeriPoint[k,i,'Z']:=0;
      MeriPoint[k,i,'Z']:=MeriPoint[k,i,'Z']-ScreenDistance;

      if SagiPoint[k,i,'Z'] = 0 then
        SagiPoint[k,i,'Z']:=SagiPoint[k,i,'Z']+1;
      aDpZ:=ScreenDistance /  SagiPoint[k,i,'Z'];
      SagiPoint[k,i,'X']:=trunc(SagiPoint[k,i,'X']*aDpZ);
      SagiPoint[k,i,'Y']:=trunc(SagiPoint[k,i,'Y']*aDpZ);
      if SagiPoint[k,i,'Z']<ScreenDistance then
        SagiPoint[k,i,'Z']:=0;
      SagiPoint[k,i,'Z']:=SagiPoint[k,i,'Z']-ScreenDistance;
    end;
    
    for i:=1 to MaxOutLine do begin
      if  FigPoint[k,i,'Z']=0 then
         FigPoint[k,i,'Z']:= FigPoint[k,i,'Z']+1;
      aDpZ:=ScreenDistance / FigPoint[k,i,'Z'];
      FigPoint[k,i,'X']:=trunc(FigPoint[k,i,'X']*aDpZ);
      FigPoint[k,i,'Y']:=trunc(FigPoint[k,i,'Y']*aDpZ);
      if FigPoint[k,i,'Z']<ScreenDistance then
        FigPoint[k,i,'Z']:=0;
      FigPoint[k,i,'Z']:=FigPoint[k,i,'Z']-ScreenDistance;
    end;
  end;

  for i:=1 to MaxCurveLine do begin
    if FocusMeriPoint[i,'Z']=0 then
      FocusMeriPoint[i,'Z']:=FocusMeriPoint[i,'Z']+1;
    aDpZ:=ScreenDistance / FocusMeriPoint[i,'Z'];
    FocusMeriPoint[i,'X']:=trunc(FocusMeriPoint[i,'X']*aDpZ);
    FocusMeriPoint[i,'Y']:=trunc(FocusMeriPoint[i,'Y']*aDpZ);
    if FocusMeriPoint[i,'Z']<SCreenDistance then
      FocusMeriPoint[i,'Z']:=0;
    FocusMeriPoint[i,'Z']:=FocusMeriPoint[i,'Z']-SCreenDistance;

    if FocusSagiPoint[i,'Z']=0 then
      FocusSagiPoint[i,'Z']:=FocusSagiPoint[i,'Z']+1;
    aDpZ:=ScreenDistance / FocusSagiPoint[i,'Z'];
    FocusSagiPoint[i,'X']:=trunc(FocusSagiPoint[i,'X']*aDpZ);
    FocusSagiPoint[i,'Y']:=trunc(FocusSagiPoint[i,'Y']*aDpZ);
    if FocusSagiPoint[i,'Z']<ScreenDistance then
      FocusSagiPoint[i,'Z']:=0;
    FocusSagiPoint[i,'Z']:=FocusSagiPoint[i,'Z']-ScreenDistance;

    if ObjeMeriPoint[i,'Z']=0 then
       ObjeMeriPoint[i,'Z']:= ObjeMeriPoint[i,'Z']+1;
    aDpZ:=ScreenDistance / ObjeMeriPoint[i,'Z'];
    ObjeMeriPoint[i,'X']:=trunc(ObjeMeriPoint[i,'X']*aDpZ);
    ObjeMeriPoint[i,'Y']:=trunc(ObjeMeriPoint[i,'Y']*aDpZ);
    if ObjeMeriPoint[i,'Z']<ScreenDistance then
      ObjeMeriPoint[i,'Z']:=0;
    ObjeMeriPoint[i,'Z']:=ObjeMeriPoint[i,'Z']-ScreenDistance;

    if ObjeSagiPoint[i,'Z']=0 then
      ObjeSagiPoint[i,'Z']:=ObjeSagiPoint[i,'Z']+1;
    aDpZ:=ScreenDistance / ObjeSagiPoint[i,'Z'];
    ObjeSagiPoint[i,'X']:=trunc(ObjeSagiPoint[i,'X']*aDpZ);
    ObjeSagiPoint[i,'Y']:=trunc(ObjeSagiPoint[i,'Y']*aDpZ);
    if ObjeSagiPoint[i,'Z']<ScreenDistance then
      ObjeSagiPoint[i,'Z']:=0;
    ObjeSagiPoint[i,'Z']:=ObjeSagiPoint[i,'Z']-ScreenDistance;
  end;

  for i:=1 to MaxOutLine do begin
    if FocusFigPoint[i,'Z']=0 then
      FocusFigPoint[i,'Z']:=FocusFigPoint[i,'Z']+1;
    aDpZ:=ScreenDistance / FocusFigPoint[i,'Z'];
    FocusFigPoint[i,'X']:=trunc(FocusFigPoint[i,'X']*aDpZ);
    FocusFigPoint[i,'Y']:=trunc(FocusFigPoint[i,'Y']*aDpZ);
    if FocusFigPoint[i,'Z']<ScreenDistance then
      FocusFigPoint[i,'Z']:=0;
    FocusFigPoint[i,'Z']:=FocusFigPoint[i,'Z']-ScreenDistance;

    if ObjeFigPoint[i,'Z']=0 then
      ObjeFigPoint[i,'Z']:=ObjeFigPoint[i,'Z']+1;
    aDpZ:=ScreenDistance / ObjeFigPoint[i,'Z'];
    ObjeFigPoint[i,'X']:=trunc(ObjeFigPoint[i,'X']*aDpZ);
    ObjeFigPoint[i,'Y']:=trunc(ObjeFigPoint[i,'Y']*aDpZ);
    if ObjeFigPoint[i,'Z']<ScreenDistance then
      ObjeFigPoint[i,'Z']:=0;
    ObjeFigPoint[i,'Z']:=ObjeFigPoint[i,'Z']-ScreenDistance;
  end;

end;

procedure TD3Vew.BitBtn1Click(Sender: TObject);
begin
self.Draw;
end;

procedure TD3Vew.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//Action:=CaFree;
  D3Vew.Visible:=False;
end;
{procedure TD3Vew.CenterProjection;
var
  i,k,aDpZ:integer;

begin

  D3Vew.ScreenDistance:=200;

  for k:=1 to OpticalSystem.TotalSurfaceNumber do begin
    for i:=1 to MaxCurveLine do begin
      aDpZ:=D3Vew.ScreenDistance div OpticalSystem.OpticalSurface[k].MeridionalLine[i,'Z'];
      D3Vew.MeriPoint[k,i,'X']:=OpticalSystem.OpticalSurface[k].MeridionalLine[i,'X']*aDpZ;
      D3Vew.MeriPoint[k,i,'Y']:=OpticalSystem.OpticalSurface[k].MeridionalLine[i,'Y']*aDpZ;
      D3Vew.MeriPoint[k,i,'Z']:=OpticalSystem.OpticalSurface[k].MeridionalLine[i,'Z']-D3Vew.ScreenDistance;

      aDpZ:=D3Vew.ScreenDistance div Opticalsystem.OpticalSurface[k].SagittalLine[i,'Z'];
      D3Vew.SagiPoint[k,i,'X']:=OpticalSystem.OpticalSurface[k].SagittalLine[i,'X']*aDpZ;
      D3Vew.SagiPoint[k,i,'Y']:=OpticalSystem.OpticalSurface[k].SagittalLine[i,'Y']*aDpZ;
      D3Vew.SagiPoint[k,i,'Z']:=OpticalSystem.OpticalSurface[k].SagittalLine[i,'Z']-D3Vew.ScreenDistance;
    end;
    for i:=1 to MaxOutLine do begin
      aDpZ:=D3Vew.ScreenDistance div OpticalSystem.OpticalSurface[k].OutLine[i,'Z'];
      D3Vew.FigPoint[k,i,'X']:=OpticalSystem.OpticalSurface[k].OutLine[i,'X']*aDpZ;
      D3Vew.FigPoint[k,i,'Y']:=OpticalSystem.OpticalSurface[k].OutLine[i,'Y']*aDpZ;
      D3Vew.FigPoint[k,i,'Z']:=OpticalSystem.OpticalSurface[k].OutLine[i,'Z']-D3Vew.ScreenDistance;
    end;
  end;

  for i:=1 to MaxCurveLine do begin
    aDpZ:=D3Vew.ScreenDistance div Opticalsystem.FocusPlane.MeridionalLine[i,'Z'];
    D3Vew.FocusMeriPoint[i,'X']:=OpticalSystem.FocusPlane.MeridionalLine[i,'X']*aDpZ;
    D3Vew.FocusMeriPoint[i,'Y']:=OpticalSystem.FocusPlane.MeridionalLine[i,'Y']*aDpZ;
    D3Vew.FocusMeriPoint[i,'Z']:=OpticalSystem.FocusPlane.MeridionalLine[i,'Z']-D3Vew.SCreenDistance;

    aDpZ:=D3Vew.ScreenDistance div Opticalsystem.FocusPlane.SagittalLine[i,'Z'];
    D3Vew.FocusSagiPoint[i,'X']:=Opticalsystem.FocusPlane.SagittalLine[i,'X']*aDpZ;
    D3Vew.FocusSagiPoint[i,'Y']:=Opticalsystem.FocusPlane.SagittalLine[i,'Y']*aDpZ;
    D3Vew.FocusSagiPoint[i,'Z']:=Opticalsystem.FocusPlane.SagittalLine[i,'Z']-D3Vew.ScreenDistance;

    aDpZ:=D3Vew.ScreenDistance div Opticalsystem.ObjectPlane.MeridionalLine[i,'Z'];
    D3Vew.ObjeMeriPoint[i,'X']:=OpticalSystem.ObjectPlane.MeridionalLine[i,'X']*aDpZ;
    D3Vew.ObjeMeriPoint[i,'Y']:=OpticalSystem.ObjectPlane.MeridionalLine[i,'Y']*aDpZ;
    D3Vew.ObjeMeriPoint[i,'Z']:=OpticalSystem.ObjectPlane.MeridionalLine[i,'Z']-D3Vew.ScreenDistance;

    aDpZ:=D3Vew.ScreenDistance div Opticalsystem.ObjectPlane.SagittalLine[i,'Z'];
    D3Vew.ObjeSagiPoint[i,'X']:=Opticalsystem.ObjectPlane.SagittalLine[i,'X']*aDpZ;
    D3Vew.ObjeSagiPoint[i,'Y']:=Opticalsystem.ObjectPlane.SagittalLine[i,'Y']*aDpZ;
    D3Vew.ObjeSagiPoint[i,'Z']:=Opticalsystem.ObjectPlane.SagittalLine[i,'Z']-D3Vew.ScreenDistance;
  end;

  for i:=1 to MaxOutLine do begin
    aDpZ:=D3Vew.ScreenDistance div OpticalSystem.FocusPlane.OutLine[i,'Z'];
    D3Vew.FocusFigPoint[i,'X']:=OpticalSystem.FocusPlane.OutLine[i,'X']*aDpZ;
    D3Vew.FocusFigPoint[i,'Y']:=OpticalSystem.FocusPlane.OutLine[i,'Y']*aDpZ;
    D3Vew.FocusFigPoint[i,'Z']:=OpticalSystem.FocusPlane.OutLine[i,'Z']-D3Vew.ScreenDistance;

    aDpZ:=D3Vew.ScreenDistance div OpticalSystem.FocusPlane.OutLine[i,'Z'];
    D3Vew.ObjeFigPoint[i,'X']:=OpticalSystem.FocusPlane.OutLine[i,'X']*aDpZ;
    D3Vew.ObjeFigPoint[i,'Y']:=OpticalSystem.FocusPlane.OutLine[i,'Y']*aDpZ;
    D3Vew.ObjeFigPoint[i,'Z']:=OpticalSystem.FocusPlane.OutLine[i,'Z']-D3Vew.ScreenDistance;
  end;

end;
}
procedure TD3Vew.ScrollBar4Change(Sender: TObject);
begin
  Rx:=Scrollbar4.position*1.0;
  Edit2.Text:=FloatToStr(Rx);
  BitBtn1Click(Sender);
end;

procedure TD3Vew.ScrollBar5Change(Sender: TObject);
begin
  Ry:=ScrollBar5.position*1.0;
  Edit3.Text:=FloatToStr(Ry);
  BitBtn1Click(Sender);
end;

procedure TD3Vew.ScrollBar6Change(Sender: TObject);
begin
  Rz:=ScrollBar6.position*1.0;
  Edit4.Text:=FloatToStr(Rz);
  BitBtn1Click(Sender);
end;

procedure TD3Vew.ScrollBar3Change(Sender: TObject);
begin
  Magnification:=ScrollBar3.position*0.1;
  Edit1.Text:=FloatToStr(Magnification);
  BitBtn1Click(Sender);
end;

procedure TD3Vew.ScrollBar2Change(Sender: TObject);
begin
  ScreenDistance:=ScrollBar2.position;
  Edit5.text:=IntToStr( ScreenDistance);
end;

procedure TD3Vew.ScrollBar1Change(Sender: TObject);
begin
  OriginDistance:=ScrollBar1.Position * 10;
  Edit6.Text:=IntToStr(OriginDistance);
end;

procedure TD3Vew.FormCreate(Sender: TObject);
begin
  ScrollBar1Change(Sender);
  ScrollBar2Change(Sender);

  D3StartPointX:=D3PaintBox.width div 2;
  D3StartPointY:=D3PaintBox.height div 2;

  ScrollBar3Change(Sender);
  ScrollBar4Change(Sender);
  ScrollBar5Change(Sender);
  ScrollBar6Change(Sender);

  RayAngle:=0;
  RayAngleDecimal:=0.0;
  Edit7.text:=FloatToStr(RayAngle);
  //clAqua, clBlack, clBlue, clDkGray, clFuchsia,
//clGray, clGreen, clLime, clLtGray, clMaroon,
//clNavy, clOlive, clPurple, clRed, clSilver, clTeal, clWhite, clYellow

  MeriColor:=clBlue;
  SagiColor:=clNavy;
  FigColor:=clSilver;
  MarkColor:=clRed;
  RayColor:=MeriColor;
  SagiRayColor:=SagiColor;
  PriRayColor:=clYellow;

  FinitRayPointX :=OpticalSystem.ObjectDistance;
  FinitRayPointY :=0;
  FinitRayPointZ :=0;

  SpinEdit1.Value:=0;
  
end;

procedure TD3Vew.ScrollBar8Change(Sender: TObject);
begin
  D3StartPointY:=(D3PaintBox.Height div 2) - ScrollBar8.Position;
  BitBtn1Click(Sender);
end;

procedure TD3Vew.ScrollBar7Change(Sender: TObject);
begin
  D3StartPointX:=(D3PaintBox.width div 2) + ScrollBar7.Position;
  BitBtn1Click(Sender);
end;

procedure TD3Vew.SpinButton1DownClick(Sender: TObject);
begin
  if (RayAngleDecimal=0) or (RayAngleDecimal<=0.9) then  begin
     RayAngleDecimal:=RayAngleDecimal-0.1;
     Edit7.text:=FloatToStr(RayAngleDecimal);
     RayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if (RayAngleDecimal>0) and (RayAngleDecimal<0.1) then  begin
     RayAngleDecimal:=0.0;
     Edit7.text:=FloatToStr(RayAngleDecimal);
     RayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if RayAngleDecimal<-0.9 then  begin
     RayAngleDecimal:=-0.9;
     Edit7.text:=FloatToStr(RayAngleDecimal);
     RayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if (RayAngleDecimal<0) and (RayAngleDecimal>-0.1)then  begin
     RayAngleDecimal:=0.0;
     Edit7.text:=FloatToStr(RayAngleDecimal);
     RayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;



end
;
procedure TD3Vew.SpinButton1UpClick(Sender: TObject);
begin
  if (RayAngleDecimal=0) or (RayAngleDecimal>=-0.9) then  begin
     RayAngleDecimal:=RayAngleDecimal+0.1;
     Edit7.text:=FloatToStr(RayAngleDecimal);
     RayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if (RayAngleDecimal>0) and (RayAngleDecimal<0.1) then  begin
     RayAngleDecimal:=0.0;
     Edit7.text:=FloatToStr(RayAngleDecimal);
     RayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if RayAngleDecimal>0.9 then  begin
     RayAngleDecimal:=0.9;
     Edit7.text:=FloatToStr(RayAngleDecimal);
     RayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if (RayAngleDecimal<0) and (RayAngleDecimal>-0.1)then  begin
     RayAngleDecimal:=0.0;
     Edit7.text:=FloatToStr(RayAngleDecimal);
     RayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;



end;
procedure TD3Vew.SpinEdit1Change(Sender: TObject);
begin
  RayAngle:=SpinEdit1.Value+RayAngleDecimal;
end;


//******************************************************************
procedure TD3Vew.CulculateSagitalRayMinus;
var
  k: integer;
  aObex,aObey,aObez,aTobe,aTobei,
  aY, aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW: extended;
  aRay, aFinalRay: TD3Ray;
begin

  aTanW:=Tan( DegreeToRadian(RayAngle) );
  aRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;  
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


try
  aRay.initialize;
  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;

    OpticalSystem.CalculateSagitalRayMinus(aRay, RayAngle);

    aRay.qntp:=OpticalSystem.EntrancePupil;

  end else begin
    aY:=OpticalSystem.SurchSagittarRayMinusFinite(FinitRayPointX,FinitRayPointY,FinitRayPointZ);

    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=aY;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
          aTobe:=-1*aTobe;
    aTobei:=1 / aTobe;
    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;
  end;

  OpticalSystem.RayTraceInAspherical(aRay,nd);

  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

  if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

  aSurfaceOrigin:=0;
  SurfaceDistance[1]:=0;
  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;
      SurfaceDistance[k]:=trunc(aSurfaceOrigin*magnification);
    end;


    RayPointX[k]:=trunc( (aRay.hxv[k] + aSurfaceOrigin)*Magnification );
    RayPointY[k]:=trunc( aRay.hyv[k]*Magnification );
    RayPointZ[k]:=trunc( aRay.hzv[k]*Magnification );


  end;
  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;  
  aFocusPointX:=aSurfaceOrigin + aBfl + aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;
  SurfaceDistance[OpticalSystem.TotalsurfaceNumber+1]:=trunc( (aSurfaceOrigin + aBfl)*Magnification );

  RayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*Magnification );
  RayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*Magnification );
  RayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*Magnification );

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    RayStartX:=RayPointX[1] - trunc((OriginDistance-ScreenDistance)*0.8 );
    RayStartY:=RayPointY[1] + trunc((OriginDistance-ScreenDistance)*0.8 * aTanW);
    RayStartZ:=RayPointZ[1];
  end else begin
    RayStartX:=trunc(D3Vew.FinitRayPointX*Magnification);
    if RayStartX<-18000 then RayStartX:=-18000;
    RayStartY:=trunc(D3Vew.FinitRayPointY*Magnification);
    RayStartZ:=trunc(D3Vew.FinitRayPointZ*Magnification);
  end;

  DispositionRayPointTiltSift;

finally
aRay.free;
aFinalRay.free;

end;

end;

procedure TD3Vew.CulculateSagitalRayPrus;
var
  k: integer;
  aObex,aObey,aObez,aTobe,aTobei,
  aY, aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW: extended;
  aRay, aFinalRay: TD3Ray;
begin

  aTanW:=Tan( DegreeToRadian(RayAngle) );
  aRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


try

  aRay.initialize;

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;

    OpticalSystem.CalculateSagitalRayPrus(aRay, RayAngle);

    aRay.qntp:=OpticalSystem.EntrancePupil;
  end else begin
    aY:=OpticalSystem.SurchSagittarRayPrusFinite(FinitRayPointX,FinitRayPointY,FinitRayPointZ);

    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=aY;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
          aTobe:=-1*aTobe;
    aTobei:=1 / aTobe;
    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;
  end;

  OpticalSystem.RayTraceInAspherical(aRay,nd);



  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

 if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

  aSurfaceOrigin:=0;
  SurfaceDistance[1]:=0;
  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;
      SurfaceDistance[k]:=trunc(aSurfaceOrigin*magnification);
    end;


    RayPointX[k]:=trunc( (aRay.hxv[k] + aSurfaceOrigin)*Magnification );
    RayPointY[k]:=trunc( aRay.hyv[k]*Magnification );
    RayPointZ[k]:=trunc( aRay.hzv[k]*Magnification );


  end;
  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end; 
  aFocusPointX:=aSurfaceOrigin + aBfl + aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;
  SurfaceDistance[OpticalSystem.TotalsurfaceNumber+1]:=trunc( (aSurfaceOrigin + aBfl)*Magnification );

  RayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*Magnification );
  RayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*Magnification );
  RayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*Magnification );

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    RayStartX:=RayPointX[1] - trunc((OriginDistance-ScreenDistance)*0.8);
    RayStartY:=RayPointY[1] + trunc((OriginDistance-ScreenDistance)*0.8 * aTanW);
    RayStartZ:=RayPointZ[1];
  end else begin
    RayStartX:=trunc(D3Vew.FinitRayPointX*Magnification);
    if RayStartX<-18000 then RayStartX:=-18000;
    RayStartY:=trunc(D3Vew.FinitRayPointY*Magnification);
    RayStartZ:=trunc(D3Vew.FinitRayPointZ*Magnification);
  end;

  DispositionRayPointTiltSift;

finally
aRay.free;
aFinalRay.free;

end;

end;


procedure TD3Vew.CulculatePrincipalRay;
var
  k: integer;
  aObex,aObey,aObez,aTobe,aTobei,
  aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW: extended;
  aRay, aFinalRay: TD3Ray;
begin

  aTanW:=Tan( DegreeToRadian(RayAngle) );
  aRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;  
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


try
  aRay.initialize;
  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;

    OpticalSystem.CalculatePrincipalRay(aRay, RayAngle);
    aRay.qntp:=OpticalSystem.EntrancePupil;
  end else begin

    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;

    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );

    if aObex<0 then
          aTobe:=-1*aTobe;

    aTobei:=1 / aTobe;

    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;


  end;


  OpticalSystem.RayTraceInAspherical(aRay,nd);



  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

  if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

  aSurfaceOrigin:=0;
  SurfaceDistance[1]:=0;
  RayOriginX[1]:=0;
  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;
      SurfaceDistance[k]:=trunc(aSurfaceOrigin*magnification);
      RayOriginX[k]:=trunc(aSurfaceOrigin*magnification);
    end;


    RayPointX[k]:=trunc( (aRay.hxv[k] + aSurfaceOrigin)*Magnification );
    RayPointY[k]:=trunc( aRay.hyv[k]*Magnification );
    RayPointZ[k]:=trunc( aRay.hzv[k]*Magnification );

    RayOriginY[k]:=0;
    RayOriginZ[k]:=0;


  end;
  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  aFocusPointX:=aSurfaceOrigin + aBfl + aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;
  SurfaceDistance[OpticalSystem.TotalsurfaceNumber+1]:=trunc( (aSurfaceOrigin + aBfl)*Magnification );
  RayOriginX[OpticalSystem.TotalsurfaceNumber+1]:=SurfaceDistance[OpticalSystem.TotalsurfaceNumber+1];

  RayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*Magnification );
  RayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*Magnification );
  RayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*Magnification );

  RayOriginY[OpticalSystem.TotalsurfaceNumber+1]:=0;
  RayOriginZ[OpticalSystem.TotalsurfaceNumber+1]:=0;

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    RayStartX:=RayPointX[1] - trunc((OriginDistance-ScreenDistance)*0.8);
    RayStartY:=RayPointY[1] + trunc((OriginDistance-ScreenDistance)*0.8 * aTanW);
    RayStartZ:=0;
  end else begin
    RayStartX:=trunc(D3Vew.FinitRayPointX*Magnification);
    if RayStartX<-18000 then RayStartX:=-18000;    
    RayStartY:=trunc(D3Vew.FinitRayPointY*Magnification);
    RayStartZ:=trunc(D3Vew.FinitRayPointZ*Magnification);
  end;


  DispositionRayPointTiltSift;

finally
aRay.free;
aFinalRay.free;

end;

end;



procedure TD3Vew.CulculateLowerRay;
var
  k: integer;
  aObex,aObey,aObez,aTobe,aTobei,
  aY, aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW: extended;
  aRay, aFinalRay: TD3Ray;
begin

  aTanW:=Tan( DegreeToRadian(RayAngle) );
  aRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;  
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


try
  aRay.initialize;

 if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;
    aY:=OpticalSystem.SearchLowerRay(aRay);
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
  end else begin

    aY:=OpticalSystem.SearchLowerRayInFinite(FinitRayPointX,FinitRayPointY,FinitRayPointZ);

    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
          aTobe:=-1*aTobe;
    aTobei:=1 / aTobe;
    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;
  end;

  OpticalSystem.RayTraceInAspherical(aRay,nd);

  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

  if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

  aSurfaceOrigin:=0;
  SurfaceDistance[1]:=0;
  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;
      SurfaceDistance[k]:=trunc(aSurfaceOrigin*magnification);
    end;


    RayPointX[k]:=trunc( (aRay.hxv[k] + aSurfaceOrigin)*Magnification );
    RayPointY[k]:=trunc( aRay.hyv[k]*Magnification );
    RayPointZ[k]:=trunc( aRay.hzv[k]*Magnification );


  end;
  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end; 
  aFocusPointX:=aSurfaceOrigin + aBfl + aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;
  SurfaceDistance[OpticalSystem.TotalsurfaceNumber+1]:=trunc( (aSurfaceOrigin + aBfl)*Magnification );

  RayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*Magnification );
  RayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*Magnification );
  RayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*Magnification );

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    RayStartX:=RayPointX[1] - trunc((OriginDistance-ScreenDistance)*0.8);
    RayStartY:=RayPointY[1] + trunc((OriginDistance-ScreenDistance)*0.8 * aTanW);
    RayStartZ:=0;
  end else begin
    RayStartX:=trunc(D3Vew.FinitRayPointX*Magnification);
    if RayStartX<-18000 then RayStartX:=-18000;
    RayStartY:=trunc(D3Vew.FinitRayPointY*Magnification);
    RayStartZ:=trunc(D3Vew.FinitRayPointZ*Magnification);
  end;


  DispositionRayPointTiltSift;

finally
aRay.free;
aFinalRay.free;

end;

end;




procedure TD3Vew.CulculateUpperRay;
var
  k: integer;
  aObex,aObey,aObez,aTobe,aTobei,
  aY, aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW: extended;
  aRay, aFinalRay: TD3Ray;
begin

  aTanW:=Tan( DegreeToRadian(RayAngle) );
  aRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


try
  aRay.initialize;
  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;
    aY:=OpticalSystem.SearchUpperRay(aRay);
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
  end else begin

    aY:=OpticalSystem.SearchUpperRayInFinite(FinitRayPointX,FinitRayPointY,FinitRayPointZ);

    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
          aTobe:=-1*aTobe;
    aTobei:=1 / aTobe;
    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;
  end;
    
  OpticalSystem.RayTraceInAspherical(aRay,nd);

  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

 if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

  aSurfaceOrigin:=0;
  SurfaceDistance[1]:=0;
  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;
      SurfaceDistance[k]:=trunc(aSurfaceOrigin*magnification);
    end;


    RayPointX[k]:=trunc( (aRay.hxv[k] + aSurfaceOrigin)*Magnification );
    RayPointY[k]:=trunc( aRay.hyv[k]*Magnification );
    RayPointZ[k]:=trunc( aRay.hzv[k]*Magnification );


  end;
  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  aFocusPointX:=aSurfaceOrigin + aBfl + aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;
  SurfaceDistance[OpticalSystem.TotalsurfaceNumber+1]:=trunc( (aSurfaceOrigin + aBfl)*Magnification );

  RayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*Magnification );
  RayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*Magnification );
  RayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*Magnification );

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    RayStartX:=RayPointX[1] - trunc((OriginDistance-ScreenDistance)*0.8);
    RayStartY:=RayPointY[1] + trunc((OriginDistance-ScreenDistance)*0.8 * aTanW);
    RayStartZ:=0;
  end else begin
    RayStartX:=trunc(D3Vew.FinitRayPointX*Magnification);
    if RayStartX<-18000 then RayStartX:=-18000;
    RayStartY:=trunc(D3Vew.FinitRayPointY*Magnification);
    RayStartZ:=trunc(D3Vew.FinitRayPointZ*Magnification);
  end;

  DispositionRayPointTiltSift;

finally
aRay.free;
aFinalRay.free;

end;

end;

//*************************************************************************
//*************************************************************************

procedure TD3Vew.RayDraw;
var
  k:integer;
begin

 // OpticalSystem.CaluculateWorldCoordinates(Magnification);

  OpticalSystem.CaluculateWorldCoordinatesInReal;
  OpticalSystem.ConvertWorldCoordinatesRealToInt(magnification);

  CulculatePrincipalRay;

  RayPointRotation( (degreeToRadian(Rx)),(DegreeToRadian(Ry)), (DegreeToRadian(Rz)) );
  RayPointTransferVewCoordinates;
  RayPointTransferInVewCoordinates(0,0,OriginDistance);
  RayPointCenterProjection;

  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    RayPointX[k]:=D3StartPointX + RayPointX[k];
    RayPointY[k]:=D3StartPointY - RayPointY[k];

  end;

  D3PaintBox.Canvas.Pen.Color:= PriRayColor;
  D3PaintBox.Canvas.Pen.Style:= psSolid;
  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    D3PaintBox.Canvas.LineTo(RayPointX[k],RayPointY[k]);
  end;

  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);
  D3PaintBox.Canvas.LineTo(D3StartPointX+RayStartX,D3StartPointY -RayStartY);


  CulculateUpperRay;

  RayPointRotation( (degreeToRadian(Rx)),(DegreeToRadian(Ry)), (DegreeToRadian(Rz)) );
  RayPointTransferVewCoordinates;
  RayPointTransferInVewCoordinates(0,0,OriginDistance);
  RayPointCenterProjection;

  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    RayPointX[k]:=D3StartPointX + RayPointX[k];
    RayPointY[k]:=D3StartPointY - RayPointY[k];

  end;

  D3PaintBox.Canvas.Pen.Color:= RayColor;
  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    D3PaintBox.Canvas.LineTo(RayPointX[k],RayPointY[k]);
  end;

  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);
  D3PaintBox.Canvas.LineTo(D3StartPointX+RayStartX,D3StartPointY -RayStartY);
 
  CulculateLowerRay;

  RayPointRotation( (degreeToRadian(Rx)),(DegreeToRadian(Ry)), (DegreeToRadian(Rz)) );
  RayPointTransferVewCoordinates;
  RayPointTransferInVewCoordinates(0,0,OriginDistance);
  RayPointCenterProjection;

  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    RayPointX[k]:=D3StartPointX + RayPointX[k];
    RayPointY[k]:=D3StartPointY - RayPointY[k];

  end;

  D3PaintBox.Canvas.Pen.Color:= RayColor;
  D3PaintBox.Canvas.Pen.Style:= psSolid;
  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    D3PaintBox.Canvas.LineTo(RayPointX[k],RayPointY[k]);
  end;

  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);
  D3PaintBox.Canvas.LineTo(D3StartPointX+RayStartX,D3StartPointY -RayStartY);

 

 end;

procedure TD3Vew.SagiRayDraw;
var
  k:integer;
begin
  OpticalSystem.CaluculateWorldCoordinates(Magnification);

  CulculatePrincipalRay;

  RayPointRotation( (degreeToRadian(Rx)),(DegreeToRadian(Ry)), (DegreeToRadian(Rz)) );
  RayPointTransferVewCoordinates;
  RayPointTransferInVewCoordinates(0,0,OriginDistance);
  RayPointCenterProjection;

  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    RayPointX[k]:=D3StartPointX + RayPointX[k];
    RayPointY[k]:=D3StartPointY - RayPointY[k];

  end;

  D3PaintBox.Canvas.Pen.Color:= PriRayColor;
  D3PaintBox.Canvas.Pen.Style:= psSolid;
  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    D3PaintBox.Canvas.LineTo(RayPointX[k],RayPointY[k]);
  end;

  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);
  D3PaintBox.Canvas.LineTo(D3StartPointX+RayStartX,D3StartPointY -RayStartY);

  CulculateSagitalRayMinus;

  RayPointRotation( (degreeToRadian(Rx)),(DegreeToRadian(Ry)), (DegreeToRadian(Rz)) );
  RayPointTransferVewCoordinates;
  RayPointTransferInVewCoordinates(0,0,OriginDistance);
  RayPointCenterProjection;

  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    RayPointX[k]:=D3StartPointX + RayPointX[k];
    RayPointY[k]:=D3StartPointY - RayPointY[k];

  end;

  D3PaintBox.Canvas.Pen.Color:= SagiRayColor;
  D3PaintBox.Canvas.Pen.Style:= psSolid;
  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    D3PaintBox.Canvas.LineTo(RayPointX[k],RayPointY[k]);
  end;

  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);
  D3PaintBox.Canvas.LineTo(D3StartPointX+RayStartX,D3StartPointY -RayStartY);

  CulculateSagitalRayPrus;

  RayPointRotation( (degreeToRadian(Rx)),(DegreeToRadian(Ry)), (DegreeToRadian(Rz)) );
  RayPointTransferVewCoordinates;
  RayPointTransferInVewCoordinates(0,0,OriginDistance);
  RayPointCenterProjection;

  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    RayPointX[k]:=D3StartPointX + RayPointX[k];
    RayPointY[k]:=D3StartPointY - RayPointY[k];

  end;

  D3PaintBox.Canvas.Pen.Color:= SagiRayColor;
  D3PaintBox.Canvas.Pen.Style:= psSolid;
  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    D3PaintBox.Canvas.LineTo(RayPointX[k],RayPointY[k]);
  end;
  D3PaintBox.Canvas.Pen.Style:= psSolid;
  D3PaintBox.Canvas.MoveTo(RayPointX[1],RayPointY[1]);
  D3PaintBox.Canvas.LineTo(D3StartPointX+RayStartX,D3StartPointY -RayStartY);


end;


procedure TD3Vew.DispositionRayPointTiltSift;
var
  k,jj :integer;
  aMatrix: TMatrix;
  x,y,z,Px,Py,Pz:longint;
begin


   for k:=OpticalSystem.TotalSurfaceNumber+1 downto 1 do begin

   if k<=OpticalSystem.TotalSurfaceNumber then begin

     if OpticalSystem.OpticalSurface[k].tiltSwitch=True then begin
       aMatrix:=OpticalSystem.OpticalSurface[k].popTiltMatrix;
       x:=RayOriginX[k];
       y:=RayOriginY[k];
       z:=RayOriginZ[k];

       for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin


           RayPointX[jj]:=RayPointX[jj]-x;
           RayPointY[jj]:=RayPointY[jj]-y;
           RayPointZ[jj]:=RayPointZ[jj]-z;

           Px:=RayPointX[jj];
           Py:=RayPointY[jj];
           Pz:=RayPointZ[jj];


           Rotation(Px,Py,Pz,aMatrix,1);

           RayPointX[jj]:=Px;
           RayPointY[jj]:=Py;
           RayPointZ[jj]:=Pz;


           RayPointX[jj]:=RayPointX[jj]+x;
           RayPointY[jj]:=RayPointY[jj]+y;
           RayPointZ[jj]:=RayPointZ[jj]+z;

       end;
     end;
   end else begin
     if OpticalSystem.focusPlane.TiltSwitch=True then begin
        aMatrix:=OpticalSystem.FocusPlane.popTiltMatrix;
        x:=RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
        y:=RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
        z:=RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];

        RayPointX[OpticalSystem.TotalSurfaceNumber+1]:=RayPointX[OpticalSystem.TotalSurfaceNumber+1]-x;
        RayPointY[OpticalSystem.TotalSurfaceNumber+1]:=RayPointY[OpticalSystem.TotalSurfaceNumber+1]-y;
        RayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=RayPointZ[OpticalSystem.TotalSurfaceNumber+1]-z;


        Rotation(RayPointX[OpticalSystem.TotalSurfaceNumber+1],
               RayPointY[OpticalSystem.TotalSurfaceNumber+1],
               RayPointZ[OpticalSystem.TotalSurfaceNumber+1],aMatrix,1);

        RayPointX[OpticalSystem.TotalSurfaceNumber+1]:=RayPointX[OpticalSystem.TotalSurfaceNumber+1]+x;
        RayPointY[OpticalSystem.TotalSurfaceNumber+1]:=RayPointY[OpticalSystem.TotalSurfaceNumber+1]+y;
        RayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=RayPointZ[OpticalSystem.TotalSurfaceNumber+1]+z;
     end;
   end;
   end;

   for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
   if k<=OpticalSystem.TotalSurfaceNumber then begin
     if OpticalSystem.OpticalSurface[k].SiftSwitch=True then begin
        for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
          RayPointX[jj]:=RayPointX[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['X']*Magnification);
          RayPointY[jj]:=RayPointY[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Y']*Magnification);
          RayPointZ[jj]:=RayPointZ[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Z']*Magnification);
        end;
     end;
   end else begin
     if OpticalSystem.focusPlane.SiftSwitch=True then begin
       RayPointX[OpticalSystem.TotalSurfaceNumber+1]:=RayPointX[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['X']*Magnification);
       RayPointY[OpticalSystem.TotalSurfaceNumber+1]:=RayPointY[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Y']*Magnification);
       RayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=RayPointZ[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Z']*Magnification);
      end;
   end;
   end;



end;




procedure TD3Vew.Rotation(var aX:integer; var aY:integer; var aZ:integer; aMatrix:TMatrix; aFlag:integer);
var
  aStockDataX, aStockDataY, aStockDataZ:longint;
begin

  aStockDataX:=aX;
  aStockDataY:=aY;
  aStockDataZ:=aZ;
  if aFlag=0 then begin
   aX:=trunc(aMatrix[1,1]*aStockDataX + aMatrix[1,2]*aStockDataY + aMatrix[1,3]*aStockDataZ);
   aY:=trunc(aMatrix[2,1]*aStockDataX + aMatrix[2,2]*aStockDataY + aMatrix[2,3]*aStockDataZ);
   aZ:=trunc(aMatrix[3,1]*aStockDataX + aMatrix[3,2]*aStockDataY + aMatrix[3,3]*aStockDataZ);
  end else begin
   aX:=trunc(aMatrix[1,1]*aStockDataX + aMatrix[2,1]*aStockDataY + aMatrix[3,1]*aStockDataZ);
   aY:=trunc(aMatrix[1,2]*aStockDataX + aMatrix[2,2]*aStockDataY + aMatrix[3,2]*aStockDataZ);
   aZ:=trunc(aMatrix[1,3]*aStockDataX + aMatrix[2,3]*aStockDataY + aMatrix[3,3]*aStockDataZ);
  end;

end;
procedure TD3Vew.Button1Click(Sender: TObject);
begin
  self.RayDraw;
end;


procedure TD3Vew.RayPointRotation(Rx:extended;Ry:extended;Rz:extended);
var
  Xx,Xy,Xz, Yx,Yy,Yz, Zx,Zy,Zz:extended;
  X, Y, Z:integer;
  k:integer;
begin
  Rx:=-Rx;
  Ry:=-Ry;
  Rz:=-Rz;

  Xx:= cos(Ry)*cos(Rz)+sin(Rx)*sin(Ry)*sin(Rz) ;
  Xy:= cos(Rx)*sin(Rz) ;
  Xz:= -sin(Ry)*cos(Rz)+sin(Rx)*cos(Ry)*sin(Rz) ;

  Yx:= -cos(Ry)*sin(Rz)+sin(Rx)*sin(Ry)*cos(Rz);
  Yy:= cos(Rx)*cos(Rz);
  Yz:= sin(Ry)*sin(Rz)+sin(Rx)*cos(Ry)*cos(Rz);

  Zx:= cos(Rx)*sin(Ry);
  Zy:= -sin(Rx);
  Zz:= cos(Rx)*cos(Ry);

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin

    X:=trunc(RayPointX[k]*Xx+RayPointY[k]*Xy+RayPointZ[k]*Xz );

    Y:=trunc(RayPointX[k]*Yx+RayPointY[k]*Yy+RayPointZ[k]*Yz);

    Z:=trunc(RayPointX[k]*Zx+RayPointY[k]*Zy+RayPointZ[k]*Zz);

    RayPointX[k]:=X;
    RayPointY[k]:=Y;
    RayPointZ[k]:=Z;

  end;

  X:=trunc(RayStartX*Xx+RayStartY*Xy+RayStartZ*Xz );

  Y:=trunc(RayStartX*Yx+RayStartY*Yy+RayStartZ*Yz);

  Z:=trunc(RayStartX*Zx+RayStartY*Zy+RayStartZ*Zz);

  RayStartX:=X;
  RayStartY:=Y;
  RayStartZ:=Z;

end;


procedure TD3Vew.RayPointTransferVewCoordinates;
var
  k :integer;
begin
  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
     RayPointZ[k]:=-RayPointZ[k];
  end;
  RayStartZ:=-RayStartZ;
end;

procedure TD3Vew.RayPointTransferInVewCoordinates(aX:integer; aY:integer; aZ:integer);
var
  k :integer;
begin
  for k:=1 to  OpticalSystem.TotalSurfaceNumber+1 do begin
    RayPointX[k]:=RayPointX[k]+aX;
    RayPointY[k]:=RayPointY[k]+aY;
    RayPointZ[k]:=RayPointZ[k]+aZ;
  end;
  RayStartX:=RayStartX+aX;
  RayStartY:=RayStartY+aY;
  RayStartZ:=RayStartZ+aZ;
end;

procedure TD3Vew.RayPointCenterProjection;
var
  k:integer;
  aDpZ:extended;

begin

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    aDpZ:=ScreenDistance / RayPointZ[k];
    RayPointX[k]:=trunc(RayPointX[k]*aDpZ);
    RayPointY[k]:=trunc(RayPointY[k]*aDpZ);
    RayPointZ[k]:=RayPointZ[k]-ScreenDistance;
  end;
  aDpZ:=ScreenDistance / RayStartZ;
  RayStartX:=trunc(RayStartX*aDpZ);
  RayStartY:=trunc(RayStartY*aDpZ);
  RayStartZ:=RayStartZ-ScreenDistance;

end;


procedure TD3Vew.Button2Click(Sender: TObject);
begin
  SagiRayDraw;
end;

procedure TD3Vew.Button3Click(Sender: TObject);
begin
//clAqua, clBlack, clBlue, clDkGray, clFuchsia,
//clGray, clGreen, clLime, clLtGray, clMaroon,
//clNavy, clOlive, clPurple, clRed, clSilver, clTeal, clWhite, clYellow

end;

procedure TD3Vew.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked=True then begin
    MeriColor:=clGray;
    SagiColor:=clGray;
    FigColor:=clSilver;
    MarkColor:=clGray;

    BitBtn1Click(Sender);

  end else begin
    MeriColor:=clBlue;
    SagiColor:=clNavy;
    FigColor:=clSilver;
    MarkColor:=clRed;

    BitBtn1Click(Sender);

  end;
end;

procedure TD3Vew.D3PaintBoxPaint(Sender: TObject);
begin
  try
    self.Draw;
  except
    exit;
  end;

end;

end.
