unit DataGrid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, ExtCtrls,
  MainForm, OptSurface,OptMedium,
  GlassData;

const
    RADIUS=1;
    APERTURE=2;
    DISTANCE=3;
    SPECTRU=4;
    GLASS=5;

type
  TDataGridForm = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    Label2: TLabel;
    DataGrid: TStringGrid;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Button1: TButton;
    BitBtn7: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure DataGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure DataGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure DataGridDblClick(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DataGridClick(Sender: TObject);
    procedure DataGridKeyPress(Sender: TObject; var Key: Char);
    procedure BitBtn7Click(Sender: TObject);
  private
    { Private 錾 }

    FlagDataDraw: Boolean;
    procedure DrawByRadius;
    procedure DrawMediumData;
    procedure DrawByCurvature;
    procedure DataFix;
    procedure RefractiveIndexFileIn;
  public
    { Public 錾 }
    FlagOfDataType: shortString;

    function GetFlagOfDataType:shortString;
    function GetFlagDataDraw:Boolean;
    procedure setFlagDataDraw(aFlag:Boolean);
    procedure RefreshDraw;
  end;

var
  DataGridForm: TDataGridForm;

implementation

uses MediumDataGrid, ParAxialForm, AspDataGrid, CoAxialGrid, ApertureGrid,
  CurveBrowser, LataralBrowser, SpotBrowser, Cofficient, Bending, Bending2,
  D3VewBrowser, PlanBrowser, UnitedData;



{$R *.dfm}

function TDataGridForm.GetFlagDataDraw;
begin
  result:=FlagDataDraw;
end;

procedure TDataGridForm.setFlagDataDraw(aFlag:Boolean);
begin
  FlagDataDraw:=aFlag;
end;

function TDataGridForm.GetFlagOfDataType;
begin
  Result:=FlagOfDataType;
end;

procedure TDataGridForm.DrawByCurvature;
var row:integer;
begin


  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[0,row]:='_';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[0,row]:='œ_';
      end else begin
        DataGrid.Cells[0,row]:=IntToStr(row-1);
      end;
    end;
  end;

  DataGrid.Cells[RADIUS,0]:='ȗ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[RADIUS,row]:=FloatToStr(OpticalSystem.ObjectPlane.Curvature);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[RADIUS,row]:=FloatToStr(OpticalSystem.FocusPlane.Curvature);
      end else begin
        DataGrid.Cells[RADIUS,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].Curvature);
      end;
    end;
  end;

end;

procedure TDataGridForm.DrawByRadius;
var row:integer;
begin


  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[0,row]:='_';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[0,row]:='œ_';
      end else begin
        DataGrid.Cells[0,row]:=IntToStr(row-1);
      end;
    end;
  end;

  DataGrid.Cells[RADIUS,0]:='ȗa';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[RADIUS,row]:=FloatToStr(OpticalSystem.ObjectPlane.Radius);
      if (OpticalSystem.ObjectPlane.Radius>=FLAT) then
        DataGrid.Cells[RADIUS,row]:='FLAT';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[RADIUS,row]:=FloatToStr(OpticalSystem.FocusPlane.Radius);
        if (OpticalSystem.FocusPlane.Radius>=FLAT) then
          DataGrid.Cells[RADIUS,row]:='FLAT';
      end else begin
        DataGrid.Cells[RADIUS,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].Radius);
         if (OpticalSystem.OpticalSurface[row-1].Radius>=FLAT) then
           DataGrid.Cells[RADIUS,row]:='FLAT';
      end;
    end;
  end;



end;

procedure TDataGridForm.DrawMediumData;
var row:integer;
begin
 DataGrid.Cells[DISTANCE,0]:='ʊԊu';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if row=1 then begin
      DataGrid.Cells[DISTANCE,row]:=FloatToStr(OpticalSystem.ObjectDistance);
      if OpticalSystem.ObjectDistance<=-1.0e100 then
        DataGrid.Cells[DISTANCE,row]:='INFINITY';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+1) then begin
//        DataGrid.Cells[DISTANCE,row]:=FloatToStr(OpticalSystem.BackFocus[nd]);
      end else begin
        DataGrid.Cells[DISTANCE,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].Distance);
      end;
    end;
  end;

  DataGrid.Cells[SPECTRU,0]:='ܗ';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
        DataGrid.Cells[SPECTRU,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[nd]);
  end;

  DataGrid.Cells[GLASS,0]:='KX';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
        DataGrid.Cells[GLASS,row]:=OpticalSystem.OpticalMedium[row-1].GlassName;
  end;


  DataGrid.Cells[APERTURE,0]:='a';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
    if row=1 then begin
      DataGrid.Cells[APERTURE,row]:=' ';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
        DataGrid.Cells[APERTURE,row]:=FloatToStr(OpticalSystem.FocusPlane.Diameter);
      end else begin
        DataGrid.Cells[APERTURE,row]:=FloatToStr(OpticalSystem.OpticalSurface[row-1].Diameter);
      end;
    end;
  end;

end;


procedure TDataGridForm.DataFix;
var row:integer;
begin

  if (FlagDataDraw=False) then begin
    exit;
  end;

  if (FlagOfDataType='Radius') then begin
    for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
      if row=1 then begin
        if DataGrid.Cells[RADIUS,row]='FLAT' then begin
          OpticalSystem.ObjectPlane.Radius:=FLAT;
          OpticalSystem.ObjectPlane.Curvature:=0;
        end else begin
          OpticalSystem.ObjectPlane.Radius:=StrToFloat(DataGrid.Cells[RADIUS,row]);
          if (OpticalSystem.ObjectPlane.Radius>1e10) then begin
            OpticalSystem.ObjectPlane.Radius:=FLAT;
            OpticalSystem.ObjectPlane.Curvature:=0;
          end else begin
            OpticalSystem.ObjectPlane.Curvature:=1/OpticalSystem.ObjectPlane.Radius;
          end;
        end;
      end else begin
        if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
          if DataGrid.Cells[RADIUS,row]='FLAT' then begin
            OpticalSystem.FocusPlane.Radius:=FLAT;
            OpticalSystem.FocusPlane.Diameter:=StrToFloat(DataGrid.Cells[APERTURE,row]);
            OpticalSystem.FocusPlane.Curvature:=0;
          end else begin
            OpticalSystem.FocusPlane.Radius:=StrToFloat(DataGrid.Cells[RADIUS,row]);
            OpticalSystem.FocusPlane.Diameter:=StrToFloat(DataGrid.Cells[APERTURE,row]);
            if (OpticalSystem.FocusPlane.Radius>1e10) then begin
              OpticalSystem.FocusPlane.Radius:=FLAT;
              OpticalSystem.FocusPlane.Curvature:=0;
            end else begin
              OpticalSystem.FocusPlane.Curvature:=1/OpticalSystem.FocusPlane.Radius;
            end;
          end;
        end else begin
          if DataGrid.Cells[RADIUS,row]='FLAT' then begin
            OpticalSystem.OpticalSurface[row-1].Radius:=FLAT;
            OpticalSystem.OpticalSurface[row-1].Diameter:=StrToFloat(DataGrid.Cells[APERTURE,row]);
            OpticalSystem.OpticalSurface[row-1].Curvature:=0;
          end else begin
            OpticalSystem.OpticalSurface[row-1].Radius:=StrToFloat(DataGrid.Cells[RADIUS,row]);
            OpticalSystem.OpticalSurface[row-1].Diameter:=StrToFloat(DataGrid.Cells[APERTURE,row]);
            if (OpticalSystem.OpticalSurface[row-1].Radius>1e10) then begin
              OpticalSystem.OpticalSurface[row-1].Radius:=FLAT;
              OpticalSystem.OpticalSurface[row-1].Curvature:=0;
            end else begin
              OpticalSystem.OpticalSurface[row-1].Curvature:=1/OpticalSystem.OpticalSurface[row-1].Radius;
            end;
          end;
        end;
      end;
    end;
  end;

  if (FlagOfDataType='Curvature') then  begin
    for row:=1 to OpticalSystem.TotalSurfaceNumber+2 do begin
      if row=1 then begin
        OpticalSystem.ObjectPlane.Curvature:=StrToFloat(DataGrid.Cells[RADIUS,row]);
        if (OpticalSystem.ObjectPlane.Curvature=0) then begin
          OpticalSystem.ObjectPlane.Radius:=FLAT;
          OpticalSystem.ObjectPlane.Curvature:=0;
        end else begin
          OpticalSystem.ObjectPlane.Radius:=1/OpticalSystem.ObjectPlane.Curvature;
        end;
      end else begin
        if (row=OpticalSystem.TotalSurfaceNumber+2) then begin
          OpticalSystem.FocusPlane.Curvature:=StrToFloat(DataGrid.Cells[RADIUS,row]);
          OpticalSystem.FocusPlane.Diameter:=StrToFloat(DataGrid.Cells[APERTURE,row]);
          if (OpticalSystem.FocusPlane.Curvature=0) then begin
            OpticalSystem.FocusPlane.Radius:=FLAT;
            OpticalSystem.FocusPlane.Curvature:=0;
          end else begin
            OpticalSystem.FocusPlane.Radius:=1/OpticalSystem.FocusPlane.Curvature;
          end;
        end else begin
          OpticalSystem.OpticalSurface[row-1].Curvature:=StrToFloat(DataGrid.Cells[RADIUS,row]);
          OpticalSystem.OpticalSurface[row-1].Diameter:=StrToFloat(DataGrid.Cells[APERTURE,row]);
          if (OpticalSystem.OpticalSurface[row-1].Curvature=0) then begin
            OpticalSystem.OpticalSurface[row-1].Radius:=FLAT;
            OpticalSystem.OpticalSurface[row-1].Curvature:=0;
          end else begin
            OpticalSystem.OpticalSurface[row-1].Radius:=1/OpticalSystem.OpticalSurface[row-1].Curvature;
          end;
        end;
      end;
    end;
  end;


   for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if row=1 then begin
      if DataGrid.Cells[DISTANCE,row]='INFINITY' then begin
        OpticalSystem.ObjectDistance:=INFINITY;
      end else begin
        OpticalSystem.ObjectDistance:=StrToFloat(DataGrid.Cells[DISTANCE,row]);
        D3Vew.FinitRayPointX:=OpticalSystem.ObjectDistance;
        PlanForm.FinitRayPointX:=OpticalSystem.ObjectDistance;
        SpotForm.Edit3.Text:=DataGrid.Cells[DISTANCE,row];
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+1) then begin

      end else begin
        OpticalSystem.OpticalMedium[row-1].Distance:=StrToFloat(DataGrid.Cells[DISTANCE,row]);
      end;
    end;

  end;

  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if row=1 then begin
      OpticalSystem.OpticalMedium[row-1].RefractiveIndex[nd]:=StrToFloat(DataGrid.Cells[SPECTRU,row]);
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+1) then begin
        OpticalSystem.OpticalMedium[row-1].RefractiveIndex[nd]:=StrToFloat(DataGrid.Cells[SPECTRU,row]);
      end else begin
        OpticalSystem.OpticalMedium[row-1].RefractiveIndex[nd]:=StrToFloat(DataGrid.Cells[SPECTRU,row]);
      end;
    end;
  end;


  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    OpticalSystem.OpticalMedium[row-1].GlassName:=DataGrid.Cells[GLASS,row];
  end;


end;


procedure TDataGridForm.RefractiveIndexFileIn;
var InputFile:Textfile;
  aData:String;
  Medium: TOpticalMedium;
  i: integer;
  aName:string;
begin
  if DataGrid.Row>OpticalSystem.TotalSurfaceNumber+1 then exit;

  Medium:=OpticalSystem.OpticalMedium[DataGrid.Row-1];

  if OpenDialog1.Execute then
    begin
    Screen.Cursor:=crHourGlass;
    AssignFile(InputFile,OpenDialog1.FileName);
    Reset(InputFile);
    aName:=ExtractFileName(OpenDialog1.FileName);
    aName:=ChangeFileExt(aName, ' ');

    try
      for i:=1 to 23 do begin
        Readln(InputFile, aData);
        case i of
          1: Medium.GlassName:=TrimRight(aData);

          3: Medium.AbbeNumber:=StrToFloat(TrimRight(aData));

          5: Medium.RefractiveIndex[nt]:=StrToFloat(TrimRight(aData));

          7: Medium.RefractiveIndex[ns]:=StrToFloat(TrimRight(aData));

          9: Medium.RefractiveIndex[nr]:=StrToFloat(TrimRight(aData));

          11: Medium.RefractiveIndex[nC]:=StrToFloat(TrimRight(aData));

          13: Medium.RefractiveIndex[nd]:=StrToFloat(TrimRight(aData));

          15: Medium.RefractiveIndex[ne]:=StrToFloat(TrimRight(aData));

          17: Medium.RefractiveIndex[nF]:=StrToFloat(TrimRight(aData));

          19: Medium.RefractiveIndex[ng]:=StrToFloat(TrimRight(aData));

          21: Medium.RefractiveIndex[nh]:=StrToFloat(TrimRight(aData));

          23: Medium.RefractiveIndex[ni]:=StrToFloat(TrimRight(aData));
        end;
      end;

    finally
    System.CloseFile(InputFile);
    Screen.Cursor:=crDefault;
    end;
  end;
 

end;





procedure TDataGridForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Visible:=False;
end;

procedure TDataGridForm.BitBtn1Click(Sender: TObject);
var cel,row:integer;
begin
  DataGrid.Font.Color:=clBlack;
  BitBtn3.Font.Color:=clBlack;
  for cel:=0 to 5 do begin
    for row:=1 to 64+2 do begin
      DataGrid.Cells[cel,row]:='';
    end;
  end;

  FlagOfDataType:='Radius';
  FlagDataDraw:=true;
  self.DrawByRadius;
  self.DrawMediumData;
end;

procedure TDataGridForm.BitBtn2Click(Sender: TObject);
var cel,row:integer;
begin
  DataGrid.Font.Color:=clBlack;
  BitBtn3.Font.Color:=clBlack;
  for cel:=0 to 5 do begin
    for row:=1 to 64+2 do begin
      DataGrid.Cells[cel,row]:='';
    end;
  end;

  FlagOfDataType:='Curvature';
  FlagDataDraw:=true;
  self.DrawByCurvature;
  self.DrawMediumData;
end;

procedure TDataGridForm.FormCreate(Sender: TObject);
begin
  FlagDataDraw:=false;
end;

procedure TDataGridForm.BitBtn3Click(Sender: TObject);
begin
  self.DataFix;
  FormPOPS.DataIsChanged;
end;
 
procedure TDataGridForm.BitBtn4Click(Sender: TObject);
begin
{  self.DataFix;
  self.RefractiveIndexFileIn;

  if (FlagOfDataType='Radius') then begin
    DataGridForm.BitBtn1.Click;
  end else begin
    DataGridForm.BitBtn2.Click;
  end;

  MediumGrid.BitBtn1.Click;
  MediumGrid.BitBtn1.Click; }
end;

procedure TDataGridForm.DataGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
  DataGrid.Font.Color:=clNavy;
  BitBtn3.Font.Color:=clRed;
  BitBtn7.Font.Color:=clRed;
end;


procedure TDataGridForm.DataGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
{   if aCol=5 then begin
    DataGrid.Options:=DataGrid.Options - [goEditing];
   end else begin
    DataGrid.Options:=DataGrid.Options + [goEditing];
   end;     }
end;

procedure TDataGridForm.DataGridDblClick(Sender: TObject);
begin
  if DataGrid.Col=5 then begin
    Button1.Click;
  end;
end;

procedure TDataGridForm.BitBtn5Click(Sender: TObject);
var i:integer;
begin

  if (DataGrid.Row>=2) and  (DataGrid.Row<=(OpticalSystem.TotalSurfaceNumber+1)) then begin
    if MessageDlg('wʂ폜܂B',mtConfirmation,mbYesNoCancel,0)= mrYes then begin

      if (OpticalSystem.TotalSurfaceNumber - 1=0) then begin
        MessageDlg('̖ʂ͍폜ł܂B',mtInformation, [mbOk], 0);
        exit;
      end;

      FinalOpt.CopyFrom(OpticalSystem);

      OpticalSystem.TotalSurfaceNumber:=OpticalSystem.TotalSurfaceNumber - 1;

      for i:=DataGrid.Row-1 to OpticalSystem.TotalsurfaceNumber do begin
        Opticalsystem.OpticalSurface[i].CopyFrom(FinalOpt.OpticalSurface[i+1]);
      end;

      for i:=DataGrid.Row-1 to OpticalSystem.TotalsurfaceNumber+1 do begin
        OpticalSystem.OpticalMedium[i-1].CopyFrom(FinalOpt.OpticalMedium[i]);
      end;

      FormPOPS.DataIsChanged;

      ParAxialDataForm.BitBtn5.Click;

      CurveForm.FormCreate(Sender);
      LataralForm.FormCreate(Sender);
      SpotForm.FormCreate(Sender);
      CoefficientForm.FormCreate(Sender);
      BendingForm.FormCreate(Sender);
      BendingForm2.FormCreate(Sender);

    end;
  end else begin

  end;

end;



procedure TDataGridForm.BitBtn6Click(Sender: TObject);
var i:integer;
begin

if (DataGrid.Row>=1) and  (DataGrid.Row<=(OpticalSystem.TotalSurfaceNumber)) then begin

  if MessageDlg('wʂ}܂B',mtConfirmation,mbYesNoCancel,0)= mrYes then begin

    FinalOpt.CopyFrom(OpticalSystem);

    OpticalSystem.TotalSurfaceNumber:=OpticalSystem.TotalSurfaceNumber + 1;

    for i:=DataGrid.Row+1 to OpticalSystem.TotalsurfaceNumber do begin
      Opticalsystem.OpticalSurface[i].CopyFrom(FinalOpt.OpticalSurface[i-1]);
    end;
    Opticalsystem.OpticalSurface[DataGrid.Row].initialize;
    Opticalsystem.OpticalSurface[DataGrid.Row].Diameter
                      :=Opticalsystem.OpticalSurface[DataGrid.Row+1].Diameter;

    for i:=DataGrid.Row to OpticalSystem.TotalsurfaceNumber do begin
      OpticalSystem.OpticalMedium[i].CopyFrom(FinalOpt.OpticalMedium[i-1]);
    end;


      FormPOPS.DataIsChanged;

      ParAxialDataForm.BitBtn5.Click;

      CurveForm.FormCreate(Sender);
      LataralForm.FormCreate(Sender);
      SpotForm.FormCreate(Sender);
      CoefficientForm.FormCreate(Sender);
      BendingForm.FormCreate(Sender);
      BendingForm2.FormCreate(Sender);

  end;

end;

end;


procedure TDataGridForm.Button1Click(Sender: TObject);
begin

  GlassDataForm.SelectedDataIndex:=(DataGrid.Row )-1;
  GlassDataForm.Visible:=True;
  GlassDataForm.show;
end;

procedure TDataGridForm.DataGridClick(Sender: TObject);
begin
  GlassDataForm.SelectedDataIndex:=(DataGrid.Row )-1;

  self.DataFix;
  FormPOPS.DataIsChanged;
end;

procedure TDataGridForm.RefreshDraw;
begin

 if FlagOfDataType='Curvature'then begin
   BitBtn2.Click;
 end else begin
   BitBtn1.Click;
 end;

 self.Caption:='{f[^'+'/'+OpticalSystem.OpticalName;
end;


procedure TDataGridForm.DataGridKeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.DataFix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TDataGridForm.BitBtn7Click(Sender: TObject);
begin

  BitBtn3.Click;
  ParAxialDataForm.BitBtn1.Click;
  
  DataGrid.Font.Color:=clBlack;
  BitBtn3.Font.Color:=clBlack;
  BitBtn7.Font.Color:=clBlack;

end;

end.

