unit LataralBrowser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls,
   MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray, ComCtrls;
const
  MaxLateralNumber=50;
  MaxLateralAngle=5;
type
  TLataralForm = class(TForm)
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    PaintBox2: TPaintBox;
    PaintBox3: TPaintBox;
    PaintBox4: TPaintBox;
    PaintBox5: TPaintBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    LateralSpinEdit: TSpinEdit;
    LateralButton: TButton;
    LateralEdit: TEdit;
    LateralScrollBar: TScrollBar;
    Label1: TLabel;
    Label2: TLabel;
    LateralDrawButton: TButton;
    DecimalEdit: TEdit;
    SpinButton1: TSpinButton;
    PBReDrawControler: TPaintBox;
    procedure LateralSpinEditChange(Sender: TObject);
    procedure LateralScrollBarChange(Sender: TObject);
    procedure LateralButtonClick(Sender: TObject);
    procedure LateralDrawButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure PBReDrawControlerPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    InputAngle:extended;
    InputAngleDecimal:extended;
    LateralGraphScale: extended;
    LateralAberation: array[nd..nt,1..MaxLateralAngle,1..MaxLateralNumber] of extended;
    LateralAberationSag: array[nd..nt,1..MaxLateralAngle,1..MaxLateralNumber] of extended;
    InitialHeight: array[1..MaxLateralAngle,1..MaxLateralNumber] of extended;
    InitialPointSag: array[1..MaxLateralAngle,1..MaxLateralNumber] of extended;
    clNt,clNs,clNr,clNC,clNd,clNe,clNF,clNg,clNh,clNi :Tcolor;
    procedure Initialize(Sender: TObject);
    procedure CalculateLateralAberation;
    procedure CalculateLateralAberationSag;
  public
    { Public 錾 }
  end;

var
  LataralForm: TLataralForm;

implementation

{$R *.dfm}

procedure TLataralForm.LateralSpinEditChange(Sender: TObject);
begin

    InputAngle:=LateralSpinEdit.Value+InputAngleDecimal;
  
end;

procedure TLataralForm.LateralScrollBarChange(Sender: TObject);
begin
  LateralGraphScale:=LateralScrollBar.Position/100;
  LateralEdit.Text:=FloatToStr(LateralGraphScale);
  self.LateralDrawButtonClick(Sender);
end;

procedure TLataralForm.LateralButtonClick(Sender: TObject);
begin
try
  Screen.Cursor:=crHourGlass;
  self.CalculateLateralAberation;
  self.CalculateLateralAberationSag;
  self.LateralDrawButton.Click;
finally
  Screen.Cursor:=crDefault;
end;
end;

procedure TLataralForm.LateralDrawButtonClick(Sender: TObject);

var
  n:TSpectru;
  aCenterX, aCenterY:longInt;
  aDodPointX,aDodPointY: array[1..MaxLateralNumber] of longInt;
  k, i:integer;
  aDodScale, aDr:extended;
  aPaintBox:TPaintBox;
  anAngle: array[1..MaxLateralAngle] of extended;
begin
  aPaintBox:=PaintBox1;

  for k:=1 to MaxLateralAngle do begin
    if k=1 then
      anAngle[1]:=0
    else
      anAngle[k]:=InputAngle * ((k-1)/(MaxLateralAngle-1));
  end;

  Edit1.text:=floatToStr(anAngle[1]);
  Edit2.text:=floatToStr(anAngle[2]);
  Edit3.text:=floatToStr(anAngle[3]);
  Edit4.text:=floatToStr(anAngle[4]);
  Edit5.text:=floatToStr(anAngle[5]);

  if OpticalSystem.EffectiveAperture<>0 then
    aDr:=OpticalSystem.EffectiveAperture
  else
    aDr:=OpticalSystem.OpticalSurface[1].Diameter;
  if aDr=0 then
    aDr:=0.01;

  for k:=1 to MaxLateralAngle do begin
      case k of
        1 : aPaintBox:=PaintBox1;
        2 : aPaintBox:=PaintBox2;
        3 : aPaintBox:=PaintBox3;
        4 : aPaintBox:=PaintBox4;
        5 : aPaintBox:=PaintBox5;
      else

      end;
      aPaintBox.Canvas.Pen.Style:=psSolid;
      aPaintBox.Canvas.Pen.Color:=clSilver;
      aPaintBox.Canvas.Rectangle(0,0,aPaintBox.width,aPaintBox.height);
      aPaintBox.Canvas.Pen.Color:=clSilver;
      aPaintBox.Canvas.MoveTo(0,aPaintBox.height div 2);
      aPaintBox.Canvas.LineTo(aPaintBox.width,aPaintBox.height div 2);
      aPaintBox.Canvas.MoveTo(aPaintBox.width div 2,0);
      aPaintBox.Canvas.LineTo(aPaintBox.width div 2,aPaintBox.height);
  end;

  for n:=nd to OpticalSystem.LastSpectru do begin
    for k:=1 to MaxLateralAngle do begin
      case k of
        1 : aPaintBox:=PaintBox1;
        2 : aPaintBox:=PaintBox2;
        3 : aPaintBox:=PaintBox3;
        4 : aPaintBox:=PaintBox4;
        5 : aPaintBox:=PaintBox5;
      else

      end;
      aDodScale:=LateralGraphScale / (aPaintBox.height div 2);
      aCenterX:=aPaintBox.width div 2;
      aCenterY:=aPaintBox.height div 2;
      for i:=1 to MaxLateralNumber do begin
        if LateralAberation[n,k,i]=NULL then Break;
        aDodPointX[i]:=aCenterX + trunc( InitialHeight[k,i] / (aDr / aPaintBox.width) );
        aDodPointY[i]:=aCenterY - trunc(LateralAberation[n,k,i]/aDodScale);
      end;
      aPaintBox.Canvas.MoveTo(aDodPointX[1],aDodPointY[1]);
      for i:=2 to MaxLateralNumber do begin
        if LateralAberation[n,k,i]=NULL then Break;
        case n of
         nt : aPaintBox.Canvas.Pen.Color:=clNt;
         ns : aPaintBox.Canvas.Pen.Color:=clNs;
         nr : aPaintBox.Canvas.Pen.Color:=clNr;
         nC : aPaintBox.Canvas.Pen.Color:=clNC;
         nd : aPaintBox.Canvas.Pen.Color:=clNd;
         ne : aPaintBox.Canvas.Pen.Color:=clNe;
         nF : aPaintBox.Canvas.Pen.Color:=clNF;
         ng : aPaintBox.Canvas.Pen.Color:=clNg;//clBlue;
         nh : aPaintBox.Canvas.Pen.Color:=clNh;//Navy;
         ni : aPaintBox.Canvas.Pen.Color:=clNi;
        end;
        aPaintBox.Canvas.LineTo(aDodPointX[i],aDodPointY[i]);
      end;

    end;
  end;

//Sagital Curve Draw
  for n:=nd to nd do begin
    for k:=1 to MaxLateralAngle do begin
      case k of
        1 : aPaintBox:=PaintBox1;
        2 : aPaintBox:=PaintBox2;
        3 : aPaintBox:=PaintBox3;
        4 : aPaintBox:=PaintBox4;
        5 : aPaintBox:=PaintBox5;
      else

      end;
      aDodScale:=LateralGraphScale / (aPaintBox.height div 2);
      aCenterX:=aPaintBox.width div 2;
      aCenterY:=aPaintBox.height div 2;
      for i:=1 to MaxLateralNumber do begin
        if LateralAberationSag[n,k,i]=NULL then Break;
        aDodPointX[i]:=aCenterX + trunc( InitialPointSag[k,i] / (aDr / aPaintBox.width) );
        aDodPointY[i]:=aCenterY - trunc(LateralAberationSag[n,k,i]/aDodScale);
      end;
      aPaintBox.Canvas.MoveTo(aDodPointX[1],aDodPointY[1]);
      for i:=2 to MaxLateralNumber do begin
        if LateralAberationSag[n,k,i]=NULL then Break;
        case n of
         nt : aPaintBox.Canvas.Pen.Color:=clNt;
         ns : aPaintBox.Canvas.Pen.Color:=clNs;
         nr : aPaintBox.Canvas.Pen.Color:=clNr;
         nC : aPaintBox.Canvas.Pen.Color:=clNC;
         nd : aPaintBox.Canvas.Pen.Color:=clWhite;
         ne : aPaintBox.Canvas.Pen.Color:=clNe;
         nF : aPaintBox.Canvas.Pen.Color:=clNF;
         ng : aPaintBox.Canvas.Pen.Color:=clNg;//clBlue;
         nh : aPaintBox.Canvas.Pen.Color:=clNh;//Navy;
         ni : aPaintBox.Canvas.Pen.Color:=clNi;
        end;
        aPaintBox.Canvas.LineTo(aDodPointX[i],aDodPointY[i]);
      end;

    end;


  end;





end;

procedure TLataralForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//  Action:=caFree;
  LataralForm.Visible:=False;
end;

procedure TLataralForm.Initialize(Sender: TObject);
var
  n:TSpectru;
  i,k:integer;
begin

  InputAngle:=0;
  InputAngleDecimal:=0;
  LateralSpinEdit.Value:=0;
  DecimalEdit.Text:='0';

  LateralScrollBar.Position:=10;



  for n:=nd to nt do begin
    for k:=1 to MaxLateralAngle do begin
      for i:=1 to MaxLateralNumber do begin
        LateralAberation[n,k,i]:=0;
      end;
    end;
  end;
  for n:=nd to nt do begin
    for k:=1 to MaxLateralAngle do begin
      for i:=1 to MaxLateralNumber do begin
        LateralAberationSag[n,k,i]:=0;
      end;
    end;
  end;


  clNt:=clMaroon;//$00007B;
  clNs:=$0000B9;
  clNr:=$6A1EE1;
  clNC:=clRed;
  clNd:=clYellow;
  clNe:=$05FF9A;
  clNF:=$40FF00;//clLime;//$8EFF04;
  clNg:=clBlue;
  clNh:=clNavy;
  clNi:=$800080;

  LateralScrollBarChange(Sender);

  self.Caption:='Ȑ'+'/'+OpticalSystem.OpticalName;

end;


procedure TLataralForm.CalculateLateralAberationSag;
var
  a3DRay, aFinalRay: TD3Ray;
  anAngle, aPrincipalPoint: array[1..MaxLateralAngle] of extended;
  k,i: integer;
  n: TSpectru;
  aRadian, aWidth, aStep: extended;
begin

  for k:=1 to MaxLateralAngle do begin
    if k=1 then
      anAngle[1]:=0
    else
      anAngle[k]:=InputAngle * ((k-1)/(MaxLateralAngle-1));
  end;

  a3DRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;
try
  for k:=1 to MaxLateralAngle do begin
    for i:=2 to MaxLateralNumber do begin
      aWidth:=OpticalSystem.EffectiveAperture/2;
      aStep:=aWidth / (MaxLateralNumber-1);
      InitialPointSag[k,i]:=InitialPointSag[k,1] + aStep*(i-1);
    end;
  end;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=OpticalSystem.totalSpectruNumber;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd])*-1;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;

  for k:=1 to MaxLateralAngle do begin
    a3DRay.initialize;
    a3DRay.qntp:=OpticalSystem.EntrancePupil;
    OpticalSystem.CalculatePrincipalRay(a3DRay,anAngle[k]);
    OpticalSystem.RayTraceInAspherical(a3DRay,nd);
        aFinalRay.Initialize;
        aFinalRay.qntp:=FinalOpt.EntrancePupil;

        aFinalRay.ax:=a3DRay.ax;
        aFinalRay.ay:=a3DRay.ay;
        aFinalRay.az:=a3DRay.az;
        aFinalRay.dxi:=a3DRay.dxi;
        aFinalRay.dyi:=a3DRay.dyi;
        aFinalRay.dzi:=a3DRay.dzi;
        FinalOpt.RayTraceInAspherical(aFinalRay ,nd);
    aPrincipalPoint[k]:=aFinalRay.az;

  end;


  for n:=nd to nd do begin
    for k:=1 to MaxLateralAngle do begin
      for i:=1 to MaxLateralNumber do begin
        aRadian:=DegreeToRadian(anAngle[k]);
        a3DRay.initialize;
        a3DRay.qntp:=OpticalSystem.EntrancePupil;
        a3DRay.initialize;
        a3DRay.ax:=0;
        a3DRay.ay:=0;
        a3DRay.az:=InitialPointSag[k,i];
        a3DRay.dxi:= 1 / sqrt( 1 + sqr(tan(aRadian)) );
        a3DRay.dyi:= -1*(a3DRay.dxi) * tan(aRadian) ;
        a3DRay.dzi:=0;

        OpticalSystem.RayTraceInAspherical(a3DRay,n);

        aFinalRay.Initialize;
        aFinalRay.qntp:=FinalOpt.EntrancePupil;

        aFinalRay.ax:=a3DRay.ax;
        aFinalRay.ay:=a3DRay.ay;
        aFinalRay.az:=a3DRay.az;
        aFinalRay.dxi:=a3DRay.dxi;
        aFinalRay.dyi:=a3DRay.dyi;
        aFinalRay.dzi:=a3DRay.dzi;

        if aFinalRay.ay<>NULL then begin
          FinalOpt.RayTraceInAspherical(aFinalRay ,n);
          if aFinalRay.ay=NUll then begin
             LateralAberationSag[n,k,i]:=NULL;
          end else begin
             LateralAberationSag[n,k,i]:=aFinalRay.az-aPrincipalPoint[k];
          end;
        end else begin
          LateralAberationSag[n,k,i]:=NULL;
        end;
      end;
    end;
  end;

finally
  a3DRay.free;
  aFinalRay.free;

end;

end;



procedure TLataralForm.CalculateLateralAberation;
var
  a3DRay, aFinalRay: TD3Ray;
  {aFinalOpt: TOptSystem;}
  anAngle, aPrincipalPoint: array[1..MaxLateralAngle] of extended;
  k,i: integer;
  n: TSpectru;
  aRadian, aHeight, aStep: extended;
begin

  for n:=nd to nt do begin
    for k:=1 to MaxLateralAngle do begin
      for i:=1 to MaxLateralNumber do begin
        LateralAberation[n,k,i]:=0;
      end;
    end;
  end;
  for n:=nd to nt do begin
    for k:=1 to MaxLateralAngle do begin
      for i:=1 to MaxLateralNumber do begin
        LateralAberationSag[n,k,i]:=0;
      end;
    end;
  end;


  for k:=1 to MaxLateralAngle do begin
    if k=1 then  begin
      anAngle[1]:=0;
    end  else  begin
      anAngle[k]:=InputAngle * ((k-1)/(MaxLateralAngle-1));
    end;
  end;

  a3DRay:=TD3Ray.create;
  {aFinalOpt:=TOptSystem.create;}
  aFinalRay:=TD3Ray.create;
try
  for k:=1 to MaxLateralAngle do begin
    aRadian:=DegreeToRadian(anAngle[k]);
    a3DRay.initialize;
    a3DRay.qntp:=OpticalSystem.EntrancePupil;
    a3DRay.ax:=0;
    a3DRay.ay:=0;
    a3DRay.az:=0;
    a3DRay.dxi:= 1 / sqrt( 1 + sqr(tan(aRadian)) );
    a3DRay.dyi:= -1*(a3DRay.dxi) * tan(aRadian) ;
    a3DRay.dzi:=0;
    InitialHeight[k,1]:=OpticalSystem.SearchLowerRay(a3DRay);
    InitialHeight[k,MaxLateralNumber]:=OpticalSystem.SearchUpperRay(a3DRay);
    for i:=2 to MaxLateralNumber-1 do begin
      aHeight:=abs(InitialHeight[k,MaxLateralNumber]-InitialHeight[k,1]);
      aStep:=aHeight / (MaxLateralNumber-1);
      InitialHeight[k,i]:=InitialHeight[k,1] + aStep*(i-1);
    end;
  end;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=OpticalSystem.totalSpectruNumber;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] {+ defocus})*-1;
                                                       {@fBtH[JX́@KvH  }
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;

  for k:=1 to MaxLateralAngle do begin
    a3DRay.initialize;
    a3DRay.qntp:=OpticalSystem.EntrancePupil;
    OpticalSystem.CalculatePrincipalRay(a3DRay,anAngle[k]);
    OpticalSystem.RayTraceInAspherical(a3DRay,nd);
        aFinalRay.Initialize;
        aFinalRay.qntp:=FinalOpt.EntrancePupil;

        aFinalRay.ax:=a3DRay.ax;
        aFinalRay.ay:=a3DRay.ay;
        aFinalRay.az:=a3DRay.az;
        aFinalRay.dxi:=a3DRay.dxi;
        aFinalRay.dyi:=a3DRay.dyi;
        aFinalRay.dzi:=a3DRay.dzi;
        FinalOpt.RayTraceInAspherical(aFinalRay ,nd);
    aPrincipalPoint[k]:=aFinalRay.ay;
    {a3DRay.ay + (a3DRay.dyi/a3DRay.dxi) * (aBfl - a3DRay.ax); }
  end;

  for n:=nd to OpticalSystem.LastSpectru do begin
    for k:=1 to MaxLateralAngle do begin
      for i:=1 to MaxLateralNumber do begin
        aRadian:=DegreeToRadian(anAngle[k]);
        a3DRay.initialize;
        a3DRay.qntp:=OpticalSystem.EntrancePupil;
        a3DRay.initialize;
        a3DRay.ax:=0;
        a3DRay.ay:=InitialHeight[k,i];
        a3DRay.az:=0;
        a3DRay.dxi:= 1 / sqrt( 1 + sqr(tan(aRadian)) );
        a3DRay.dyi:= -1*(a3DRay.dxi) * tan(aRadian) ;
        a3DRay.dzi:=0;

        OpticalSystem.RayTraceInAspherical(a3DRay,n);

        aFinalRay.Initialize;
        aFinalRay.qntp:=FinalOpt.EntrancePupil;

        aFinalRay.ax:=a3DRay.ax;
        aFinalRay.ay:=a3DRay.ay;
        aFinalRay.az:=a3DRay.az;
        aFinalRay.dxi:=a3DRay.dxi;
        aFinalRay.dyi:=a3DRay.dyi;
        aFinalRay.dzi:=a3DRay.dzi;

        if aFinalRay.ay<>NULL then begin
          FinalOpt.RayTraceInAspherical(aFinalRay ,n);
          if aFinalRay.ay=NUll then begin
            LateralAberation[n,k,i]:=NULL;
          end else begin
             LateralAberation[n,k,i]:=aFinalRay.ay-aPrincipalPoint[k];
          end;
        end else begin
          LateralAberation[n,k,i]:=NULL;
        end;
      end;
    end;
  end;

finally
  a3DRay.free;
  aFinalRay.free;
 { aFinalOpt.free;}
end;

end;



procedure TLataralForm.SpinButton1DownClick(Sender: TObject);
begin
  if InputAngleDecimal>=-0.9 then  begin
     InputAngleDecimal:=InputAngleDecimal-0.1;
     DecimalEdit.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=LateralSpinEdit.Value+InputAngleDecimal;
  end else begin

  end;
  if abs(InputAngleDecimal)<0.1 then  begin
     InputAngleDecimal:=0;
     DecimalEdit.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=LateralSpinEdit.Value+InputAngleDecimal;
  end;
end;

procedure TLataralForm.SpinButton1UpClick(Sender: TObject);
begin
//}CiXl݂̂Ɍ
  if InputAngleDecimal=0 then begin

  end else begin
     DecimalEdit.text:=FloatToStr(InputAngleDecimal);
     InputAngleDecimal:=InputAngleDecimal+0.1;
     DecimalEdit.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=LateralSpinEdit.Value+InputAngleDecimal;
  end;
  if abs(InputAngleDecimal)<0.1 then  begin
     InputAngleDecimal:=0;
     DecimalEdit.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=LateralSpinEdit.Value+InputAngleDecimal;
  end;

 { if InputAngleDecimal<0.9 then  begin
     DecimalEdit.text:=FloatToStr(InputAngleDecimal);
     InputAngleDecimal:=InputAngleDecimal+0.1;
     InputAngle:=LateralSpinEdit.Value+InputAngleDecimal;
  end else begin

  end;
  if abs(InputAngleDecimal)<0.1 then  begin
     InputAngleDecimal:=0;
     DecimalEdit.text:=FloatToStr(InputAngleDecimal);
     InputAngle:=LateralSpinEdit.Value+InputAngleDecimal;
  end; }
end;


procedure TLataralForm.PBReDrawControlerPaint(Sender: TObject);
begin
  try
    LateralDrawButtonClick(Sender);
  except
   exit;
  end;
end;

procedure TLataralForm.FormCreate(Sender: TObject);
begin
  Initialize(Sender);
end;

end.
