unit MTF;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls,OptSystem,SpotBrowser,MainForm;

type
  TMTFform = class(TForm)
    Panel1: TPanel;
    PaintBox1: TPaintBox;
    Button2: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
   
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
   { Private 錾 }
   Rt10:array[1..MaxMTFAngle] of extended;
   Rs10:array[1..MaxMTFAngle] of extended;
   Rt30:array[1..MaxMTFAngle] of extended;
   Rs30:array[1..MaxMTFAngle] of extended;

   procedure MTFDraw;
   procedure DrawGraphLine(aPaintBox:TPaintBox; aSpace:integer);
  public
    { Public 錾 }
  end;

var
  MTFform: TMTFform;

implementation




{$R *.dfm}

procedure TMTFform.MTFDraw;
var
  aSpace,k:integer;
begin
  aSpace:=10;

  for k:=1 to MaxMTFAngle do begin
   Rt10[k]:=SpotForm.GetRt10(k);
   Rs10[k]:=SpotForm.GetRs10(k);
   Rt30[k]:=SpotForm.GetRt30(k);
   Rs30[k]:=SpotForm.GetRs30(k);
  end;
  self.DrawGraphLine(PaintBox1,aSpace);
end;



procedure TMTFform.DrawGraphLine(aPaintBox:TPaintBox; aSpace:integer);
var
   k:integer;
   aStepX,aStepY:integer;
   aGraphPointX:array[1..MaxMTFAngle] of integer;
   aGraphPointY:array[1..MaxMTFAngle] of integer;

begin
  aPaintBox.Canvas.Pen.Style:=psSolid;
  aPaintBox.Canvas.Pen.Color:=clWhite;
  aPaintBox.Canvas.Rectangle(0,0,aPaintBox.width,aPaintBox.height);

  aStepY:=Trunc(aPaintBox.height/10);
  aStepX:=Trunc(aPaintBox.Width/ 4);

  aPaintBox.Canvas.Pen.Color:=clWhite;
  for k:=1 to 9 do begin
    aPaintBox.Canvas.MoveTo(0, aStepY*k);
    aPaintBox.Canvas.LineTo(aPaintBox.width, aStepY*k);
  end;

  aPaintBox.Canvas.Pen.Color:=clWhite;
  for k:=1 to 3 do begin
    aPaintBox.Canvas.MoveTo(aStepX*k, 0);
    aPaintBox.Canvas.LineTo(aStepX*k, aPaintBox.height);
  end;

  //sagital-10
  aPaintBox.Canvas.Pen.Color:=clRed;
  for k:=1 to MaxMTFAngle do begin
    aGraphPointX[k]:=trunc( (aPaintBox.width / ( MaxMTFAngle-1))*(k-1) ) ;
    aGraphPointY[k]:=trunc( aPaintBox.height-aPaintBox.height*Rs10[k] );
  end;

  aPaintBox.Canvas.MoveTo(aGraphPointX[1],aGraphPointY[1]);
  for k:=2 to MaxMTFAngle do begin
   aPaintBox.Canvas.LineTo(aGraphPointX[k],aGraphPointY[k]);
  end;

  aPaintBox.Canvas.Pen.Color:=clRed;
  aPaintBox.Canvas.Pen.Style:=psDot;
  for k:=1 to MaxMTFAngle do begin
    aGraphPointX[k]:=trunc( (aPaintBox.width / ( MaxMTFAngle-1))*(k-1) ) ;
    aGraphPointY[k]:=trunc( aPaintBox.height-aPaintBox.height*Rt10[k] );
  end;

  aPaintBox.Canvas.MoveTo(aGraphPointX[1],aGraphPointY[1]);
  for k:=2 to MaxMTFAngle do begin
   aPaintBox.Canvas.LineTo(aGraphPointX[k],aGraphPointY[k]);
  end;

 //sagital-30
  aPaintBox.Canvas.Pen.Color:=clGreen;
  aPaintBox.Canvas.Pen.Style:=psSolid;
  for k:=1 to MaxMTFAngle do begin
    aGraphPointX[k]:=trunc( (aPaintBox.width / ( MaxMTFAngle-1))*(k-1) ) ;
    aGraphPointY[k]:=trunc( aPaintBox.height-aPaintBox.height*Rs30[k] );
  end;

  aPaintBox.Canvas.MoveTo(aGraphPointX[1],aGraphPointY[1]);
  for k:=2 to MaxMTFAngle do begin
   aPaintBox.Canvas.LineTo(aGraphPointX[k],aGraphPointY[k]);
  end;

  aPaintBox.Canvas.Pen.Color:=clGreen;
  aPaintBox.Canvas.Pen.Style:=psDot;
  for k:=1 to MaxMTFAngle do begin
    aGraphPointX[k]:=trunc( (aPaintBox.width / ( MaxMTFAngle-1))*(k-1) ) ;
    aGraphPointY[k]:=trunc( aPaintBox.height-aPaintBox.height*Rt30[k] );
  end;

  aPaintBox.Canvas.MoveTo(aGraphPointX[1],aGraphPointY[1]);
  for k:=2 to MaxMTFAngle do begin
   aPaintBox.Canvas.LineTo(aGraphPointX[k],aGraphPointY[k]);
  end;

   Edit1.text:=FloatToStrF(Spotform.ImagehightHarf,ffGeneral,4,2);
   Edit2.text:=FloatToStrF((Spotform.Imagehight),ffGeneral,4,2);


end;



procedure TMTFform.Button2Click(Sender: TObject);
begin
  self.MTFDraw;
  self.Caption:='MTF'+'/'+OpticalSystem.OpticalName;
end;

procedure TMTFform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MTFform.Visible:=False;
end;

procedure TMTFform.FormShow(Sender: TObject);
begin
 self.Caption:='MTF'+'/'+OpticalSystem.OpticalName;
end;

end.
