unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ExtCtrls, Spin, StdCtrls,
  OptSystem, OptSurface,OptMedium,MayMath,Ray, Buttons, StdActns, ActnList,
  ActnMan;

type
  TFormPOPS = class(TForm)
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    Help1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    Open2: TMenuItem;
    Save2: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N15: TMenuItem;
    SpotDiagram1: TMenuItem;
    N16: TMenuItem;
    N17: TMenuItem;
    N18: TMenuItem;
    N19: TMenuItem;
    N21: TMenuItem;
    N31: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    SpinEdit3: TSpinEdit;
    Edit2: TEdit;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    BitBtn1: TBitBtn;
    N20: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    ActionManager1: TActionManager;
    Action1: TAction;
    HelpOnHelp1: THelpOnHelp;
    HelpContents1: THelpContents;
    N24: TMenuItem;
    N25: TMenuItem;
    N26: TMenuItem;
    N27: TMenuItem;
    Ver1: TMenuItem;
    N28: TMenuItem;
    procedure Edit1Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure SpinEdit1Click(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
    procedure SpinEdit3Change(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N13Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure N20Click(Sender: TObject);
    procedure N15Click(Sender: TObject);
    procedure SpotDiagram1Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure N18Click(Sender: TObject);
    procedure N19Click(Sender: TObject);
    procedure N21Click(Sender: TObject);
    procedure N31Click(Sender: TObject);
    procedure N22Click(Sender: TObject);
    procedure Open2Click(Sender: TObject);
    procedure Save2Click(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N23Click(Sender: TObject);
    procedure HelpContents1Execute(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure N24Click(Sender: TObject);
    procedure N25Click(Sender: TObject);
    procedure N27Click(Sender: TObject);
    procedure Ver1Click(Sender: TObject);
    procedure N28Click(Sender: TObject);
  private
    { Private 錾 }
    procedure AllDataFormRefresh;
    procedure ReDraw;
    procedure AllGraphFormInitialize;
  public
    { Public 錾 }
    ParAxialTraceFlag:boolean;
    procedure DataIsChanged;

  end;

var
  FormPOPS: TFormPOPS;
  OpticalSystem: TOptSystem;
  FinalOpt: TOptSystem;

implementation

uses DataGrid, MediumDataGrid, AspDataGrid, CoAxialGrid, ApertureGrid,
  ParAxialForm, Cofficient, CurveBrowser, SpotBrowser, LataralBrowser,
  Bending, Bending2, PlanBrowser, D3VewBrowser, ScalingBrowser, UnitedData,
  AutoCorrection, SpotCorrection;

{$R *.dfm}

procedure TFormPOPS.Edit1Change(Sender: TObject);
begin
  OpticalSystem.OpticalName:=Edit1.Text;
  FormPOPS.Caption:=(OpticalSystem.OpticalName);
end;


procedure TFormPOPS.SpinEdit1Change(Sender: TObject);
begin
  OpticalSystem.TotalSurfaceNumber:=SpinEdit1.value;

  SpinEdit2.MaxValue:=OpticalSystem.TotalSurfaceNumber;
  if SpinEdit2.Value>OpticalSystem.TotalSurfaceNumber then begin
    SpinEdit2.Value:=1;
  end;

  AllDataFormRefresh;

  ParAxialDataForm.BitBtn5.Click;
  

end;

procedure TFormPOPS.SpinEdit1Click(Sender: TObject);
begin
  OpticalSystem.TotalSurfaceNumber:=SpinEdit1.value;

  SpinEdit2.MaxValue:=OpticalSystem.TotalSurfaceNumber;
  if SpinEdit2.Value>OpticalSystem.TotalSurfaceNumber then begin
    SpinEdit2.Value:=1;
  end;

end;

procedure TFormPOPS.SpinEdit2Change(Sender: TObject);
begin
  if OpticalSystem.TotalSurfaceNumber=1 then
    SpinEdit2.Value:=1;

  OpticalSystem.Stop:=SpinEdit2.Value;

end;

procedure TFormPOPS.SpinEdit3Change(Sender: TObject);
var s:shortString;
begin
  OpticalSystem.TotalSpectruNumber:=SpinEdit3.Value;
  OpticalSystem.LastSpectru:=OpticalSystem.SpectruList[OpticalSystem.TotalSpectruNumber];

  s:='';

    case SpinEdit3.Value of
      1:s:='nd';
      2:s:='nC,nd';
      3:s:='nC,nd,nF';
      4:s:='nC,nd,nF,ng';
      5:s:='nC,nd,ne,nF,ng';
      6:s:='nC,nd,ne,nF,ng,nh';
      7:s:='nC,nd,ne,nF,ng,nh,ni';
      8:s:='nr,nC,nd,ne,nF,ng,nh,ni';
      9:s:='ns,nr,nC,nd,ne,nF,ng,nh,ni';
      10:s:='nt,ns,nr,nC,nd,ne,nF,ng,nh,ni';
    end;

  Edit2.Text:=s;
  AllDataFormRefresh;

  ParAxialDataForm.BitBtn2.Click;

end;


procedure TFormPOPS.Open1Click(Sender: TObject);
var InputFile:file;
begin

if OpenDialog1.Execute then
  begin
    Screen.Cursor:=crHourGlass;
    AssignFile(InputFile,OpenDialog1.FileName);
    Reset(InputFile,1);
    try
    OpticalSystem.initialize;
    OpticalSystem.InputFromFile(InputFile);
    finally
    System.CloseFile(InputFile);
    Screen.Cursor:=crDefault;
    end;
  end;

  AllDataFormRefresh;

  ParAxialDataForm.BitBtn2.Click;

  CurveForm.FormCreate(Sender);
  LataralForm.FormCreate(Sender);
  SpotForm.FormCreate(Sender);
  CoefficientForm.FormCreate(Sender);
  BendingForm.FormCreate(Sender);
  BendingForm2.FormCreate(Sender);
  PlanForm.Initialize(Sender);
  D3Vew.FormCreate(Sender);

  LSMForm.RefreshDraw;
  SPCForm.Button1.Click;
  
end;

procedure TFormPOPS.Save1Click(Sender: TObject);
var OutFile:file;
begin
 SaveDialog1.FileName:=OpticalSystem.OpticalName;
 if SaveDialog1.Execute then
  begin
    Screen.Cursor:=crHourGlass;
    AssignFile(OutFile,SaveDialog1.FileName);
    Rewrite(OutFile,1);
    try
    OpticalSystem.OutputToFile(OutFile);
    finally
    System.CloseFile(OutFile);
    Screen.Cursor:=crDefault;
    end;
  end;
end;


procedure TFormPOPS.N10Click(Sender: TObject);
begin
  DataGridForm.Visible:=True;
  DataGridForm.BitBtn1.Click;

end;

procedure TFormPOPS.N11Click(Sender: TObject);
begin
  MediumGridForm.Visible:=true;
  MediumGridForm.BitBtn1.Click;

end;

procedure TFormPOPS.N12Click(Sender: TObject);
begin
  AsphericalDataGrid.Visible:=true;
  AsphericalDataGrid.BitBtn1.Click;
  AsphericalDataGrid.BitBtn3.Click;
  AsphericalDataGrid.BitBtn5.Click;
  AsphericalDataGrid.BitBtn7.Click;
end;

procedure TFormPOPS.N13Click(Sender: TObject);
begin
  CoAxialForm.Visible:=true;
  CoAxialForm.BitBtn1.Click;
  

end;

procedure TFormPOPS.N14Click(Sender: TObject);
begin
 ApertureForm.visible:=True;
 ApertureForm.BitBtn1.Click;
 ApertureForm.Visible:=True;

end;

procedure TFormPOPS.N2Click(Sender: TObject);
begin
  ParAxialDataForm.Visible:=true;
  ParAxialDataForm.BitBtn2.Click;
  ParAxialDataForm.BitBtn4.Click;
  ParAxialDataForm.BitBtn5.Click;
  ParAxialDataForm.Visible:=True;;
end;

procedure TFormPOPS.N3Click(Sender: TObject);
begin
  CoefficientForm.BitBtn2.click;
  CoefficientForm.Visible:=True;
end;

procedure TFormPOPS.CheckBox2Click(Sender: TObject);
begin
  OpticalSystem.AfocalSwitch:=CheckBox2.Checked;
end;

procedure TFormPOPS.CheckBox3Click(Sender: TObject);
begin
  OpticalSystem.NaInputSwitch:=CheckBox3.Checked;
end;

procedure TFormPOPS.CheckBox6Click(Sender: TObject);
begin
  OpticalSystem.RayCheckSwitch:=CheckBox6.Checked;
end;

procedure TFormPOPS.CheckBox4Click(Sender: TObject);
begin
  OpticalSystem.MxSinSwitch:=CheckBox4.Checked;
end;

procedure TFormPOPS.CheckBox5Click(Sender: TObject);
begin
  OpticalSystem.FishEyeSwitch:=CheckBox5.Checked;
end;

procedure TFormPOPS.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if MessageDlg('Close POPS ?', mtConfirmation,
    [mbYes, mbNo], 0) = mrYes then
    Action := caFree
  else
    Action := caNone;
end;

procedure TFormPOPS.FormCreate(Sender: TObject);
begin
  OpticalSystem.TotalSurfaceNumber:=1;
  OpticalSystem.TotalSpectruNumber:=1;
  OpticalSystem.LastSpectru:=OpticalSystem.SpectruList[OpticalSystem.TotalSpectruNumber];

  ParAxialTraceFlag:=False;
end;

procedure TFormPOPS.BitBtn1Click(Sender: TObject);
begin
  OpticalSystem.initialize;
  OpticalSystem.TotalSurfaceNumber:=1;
  OpticalSystem.TotalSpectruNumber:=1;
  OpticalSystem.LastSpectru:=OpticalSystem.SpectruList[OpticalSystem.TotalSpectruNumber];


  AllDataFormRefresh;

  ParAxialDataForm.BitBtn5.Click;

  CurveForm.FormCreate(Sender);
  LataralForm.FormCreate(Sender);
  SpotForm.FormCreate(Sender);
  CoefficientForm.FormCreate(Sender);
  BendingForm.FormCreate(Sender);
  BendingForm2.FormCreate(Sender);
  
end;

procedure TFormPOPS.N20Click(Sender: TObject);
begin
  BitBtn1.Click;
end;

procedure TFormPOPS.N15Click(Sender: TObject);
begin
  CurveForm.Visible:=true;
end;

procedure TFormPOPS.SpotDiagram1Click(Sender: TObject);
begin
  SpotForm.Visible:=true;
end;

procedure TFormPOPS.N16Click(Sender: TObject);
begin
  LataralForm.Visible:=True;
end;

procedure TFormPOPS.N18Click(Sender: TObject);
begin
  BendingForm.Visible:=true;
end;

procedure TFormPOPS.N19Click(Sender: TObject);
begin
  BendingForm2.Visible:=true;
end;

procedure TFormPOPS.N21Click(Sender: TObject);
begin
  PlanForm.Visible:=True;
end;

procedure TFormPOPS.N31Click(Sender: TObject);
begin
  D3Vew.Visible:=True;
end;

procedure TFormPOPS.N22Click(Sender: TObject);
begin
  TScalingForm.Create(self);
end;

procedure TFormPOPS.Open2Click(Sender: TObject);
var InputFile:Textfile;
begin

OpticalSystem.initialize;

if OpenDialog1.Execute then
  begin
    Screen.Cursor:=crHourGlass;
    AssignFile(InputFile,OpenDialog1.FileName);
    Reset(InputFile);
    try
    OpticalSystem.InputFromTextFile(InputFile);
    finally
    System.CloseFile(InputFile);
    Screen.Cursor:=crDefault;
    end;
  end;

  AllDataFormRefresh;

  ParAxialDataForm.BitBtn2.Click;

  CurveForm.FormCreate(Sender);
  LataralForm.FormCreate(Sender);
  SpotForm.FormCreate(Sender);
  CoefficientForm.FormCreate(Sender);
  BendingForm.FormCreate(Sender);
  BendingForm2.FormCreate(Sender);

end;


procedure TFormPOPS.Save2Click(Sender: TObject);
var OutFile:Textfile;
begin
 if SaveDialog1.Execute then
  begin
    Screen.Cursor:=crHourGlass;
    AssignFile(OutFile,SaveDialog1.FileName);
    Rewrite(OutFile);
    try
    OpticalSystem.OutputToTextFile(OutFile);
    finally
    System.CloseFile(OutFile);
    Screen.Cursor:=crDefault;
    end;
  end;
end;

procedure TFormPOPS.N8Click(Sender: TObject);
var InputFile:file;
    OldOpticalMediumNumber: integer;
begin
 OldOpticalMediumNumber:=OpticalSystem.TotalSurfaceNumber;

if OpenDialog1.Execute then
  begin
    Screen.Cursor:=crHourGlass;
    AssignFile(InputFile,OpenDialog1.FileName);
    Reset(InputFile,1);
    try
    FinalOpt.InputFromFile(InputFile);
    finally
    System.CloseFile(InputFile);
    Screen.Cursor:=crDefault;
    end;
 // end;

  OpticalSystem.Prus(FinalOpt);
  OpticalSystem.OpticalMedium[OldOpticalMediumNumber].Distance
     :=strToFloat(InputBox(' ','ԊúH','0' ));

  end;

  AllDataFormRefresh;

  CurveForm.FormCreate(Sender);
  LataralForm.FormCreate(Sender);
  SpotForm.FormCreate(Sender);
  CoefficientForm.FormCreate(Sender);
  BendingForm.FormCreate(Sender);
  BendingForm2.FormCreate(Sender);

end;


procedure TFormPOPS.N23Click(Sender: TObject);
var InputFile:Textfile;
    OldOpticalMediumNumber: integer;
begin
 OldOpticalMediumNumber:=OpticalSystem.TotalSurfaceNumber;

if OpenDialog1.Execute then
  begin
    Screen.Cursor:=crHourGlass;
    AssignFile(InputFile,OpenDialog1.FileName);
    Reset(InputFile);
    try
     FinalOpt.InputFromTextFile(InputFile);
    finally
    System.CloseFile(InputFile);
    Screen.Cursor:=crDefault;
    end;
  end;
 // end;

  OpticalSystem.Prus(FinalOpt);
  OpticalSystem.OpticalMedium[OldOpticalMediumNumber].Distance
     :=strToFloat(InputBox(' ','ԊúH','0' ));

  
  AllDataFormRefresh;
 
  ParAxialDataForm.BitBtn1.Click;

  CurveForm.FormCreate(Sender);
  LataralForm.FormCreate(Sender);
  SpotForm.FormCreate(Sender);
  CoefficientForm.FormCreate(Sender);
  BendingForm.FormCreate(Sender);
  BendingForm2.FormCreate(Sender);

end;


procedure TFormPOPS.HelpContents1Execute(Sender: TObject);
const

	 	HELP_TAB = 15;
	 CONTENTS_ACTIVE = -3;
begin
  Application.HelpCommand(HELP_TAB, CONTENTS_ACTIVE);

end;



procedure TFormPOPS.Help1Click(Sender: TObject);
const

	 	HELP_TAB =15;
	 CONTENTS_ACTIVE = -3;
begin
  Application.HelpCommand(HELP_TAB, CONTENTS_ACTIVE);
end;

procedure TFormPOPS.N24Click(Sender: TObject);
begin
  OpticalSystem.Reverse;
  FormPOPS.DataIsChanged;
end;

procedure TFormPOPS.AllDataFormRefresh;
begin
  self.ReDraw;

  DataGridForm.RefreshDraw;

  MediumGridForm.RefreshDraw;
  AsphericalDataGrid.RefreshDraw;
  CoAxialForm.RefreshDraw;
  ApertureForm.RefreshDraw;
  UnitedDataForm.RefreshDraw;
 // LSMForm.RefreshDraw;

end;

procedure TFormPOPS.ReDraw;
begin
  Caption:=OpticalSystem.OpticalName;

  SpinEdit1.value:=OpticalSystem.TotalSurfaceNumber;
  SpinEdit3.value:=OpticalSystem.TotalSpectruNumber;
  SpinEdit2.value:=OpticalSystem.Stop;

  Edit1.Text:=OpticalSystem.OpticalName;

  CheckBox1.Checked:=OpticalSystem.SynmetrySwitch;
  CheckBox2.Checked:=OpticalSystem.AfocalSwitch;
  CheckBox6.Checked:=OpticalSystem.RayCheckSwitch;
  CheckBox3.Checked:=OpticalSystem.NAInputSwitch;
  CheckBox5.Checked:=OpticalSystem.FishEyeSwitch;
  CheckBox4.Checked:=OpticalSystem.MxSinSwitch;
end;

procedure TFormPOPS.AllGraphFormInitialize;//(Sender: TObject);
begin
 { CurveForm.FormCreate(Sender);
  LataralForm.FormCreate(Sender);
  SpotForm.FormCreate(Sender);
  CoefficientForm.FormCreate(Sender);
  BendingForm.FormCreate(Sender);
  BendingForm2.FormCreate(Sender);
  PlanForm.Initialize(Sender);
  D3Vew.FormCreate(Sender); }
end;

procedure TFormPOPS.DataIsChanged;
begin
  self.AllDataFormRefresh;
end;

procedure TFormPOPS.N25Click(Sender: TObject);
begin
   UnitedDataForm.visible:=true;
   UnitedDataForm.BitBtn4.Click;
end;

procedure TFormPOPS.N27Click(Sender: TObject);
begin
  LSMForm.Visible:=true;
end;

procedure TFormPOPS.Ver1Click(Sender: TObject);
begin
MessageDlg( 'Ver.0.2.4 łB',mtInformation, [mbOK], 0);
end;

procedure TFormPOPS.N28Click(Sender: TObject);
begin
  SPCForm.visible:=TRue;
end;

initialization
  OpticalSystem:=TOptSystem.Create;
  OpticalSystem.initialize;
  FinalOpt:=TOptSystem.Create;
  FinalOpt.initialize;

  OpticalSystem.TotalSurfaceNumber:=1;
  OpticalSystem.TotalSpectruNumber:=1;
  OpticalSystem.LastSpectru:=OpticalSystem.SpectruList[OpticalSystem.TotalSpectruNumber];

end.
