unit MediumDataGrid;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, ExtCtrls,
  MainForm, OptSurface,OptMedium;

type
  TMediumGridForm = class(TForm)
    Panel1: TPanel;
    DataGrid: TStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    BitBtn4: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure DataGridSetEditText(Sender: TObject; ACol, ARow: Integer;
      const Value: String);
    procedure DataGridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure DataGridDblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure DataGridClick(Sender: TObject);
    procedure DataGridKeyPress(Sender: TObject; var Key: Char);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private 錾 }
    COLnd,COLnC,COLnF,COLng,COLne,COLnh,COLni,COLnr,COLns,COLnt:integer;
    FlagDataDraw: Boolean;
    procedure DataDraw;
    procedure COLset;
    procedure DataFix;
    procedure RefractiveIndexFileIn;

  public
    { Public 錾 }
    procedure RefreshDraw;
  end;

var
  MediumGridForm: TMediumGridForm;

implementation

uses DataGrid, ParAxialForm, D3VewBrowser, PlanBrowser, GlassData,
  UnitedData;

{$R *.dfm}


procedure TMediumGridForm.COLset;
begin
 //'nt' 'ns' 'nr' 'nC' 'nd' 'ne' 'nF' 'ng' 'nh' 'ni'
 // nd,nC,nF,ng,ne,nh,ni,nr,ns,nt
  case OpticalSystem.TotalSpectruNumber of
    1:begin
        COLnd:=3;
      end;
    2:begin
        COLnC:=3;
        COLnd:=4;
      end;
    3:begin
        COLnc:=3;
        COLnd:=4;
        COLnF:=5;
      end;
    4:begin
        COLnc:=3;
        COLnd:=4;
        COLnF:=5;
        COLng:=6;
      end;
    5:begin
        COLnc:=3;
        COLnd:=4;
        COLne:=5;
        COLnF:=6;
        COLng:=7;
      end;
    6:begin
        COLnc:=3;
        COLnd:=4;
        COLne:=5;
        COLnF:=6;
        COLng:=7;
        COLnh:=8;
      end;
    7:begin
        COLnc:=3;
        COLnd:=4;
        COLne:=5;
        COLnF:=6;
        COLng:=7;
        COLnh:=8;
        COLni:=9;
      end;
    8:begin
        COLnr:=3;
        COLnc:=4;
        COLnd:=5;
        COLne:=6;
        COLnF:=7;
        COLng:=8;
        COLnh:=9;
        COLni:=10;
      end;
    9:begin
        COLns:=3;
        COLnr:=4;
        COLnc:=5;
        COLnd:=6;
        COLne:=7;
        COLnF:=8;
        COLng:=9;
        COLnh:=10;
        COLni:=11;
      end;
    10:begin
        COLnt:=3;
        COLns:=4;
        COLnr:=5;
        COLnc:=6;
        COLnd:=7;
        COLne:=8;
        COLnF:=9;
        COLng:=10;
        COLnh:=11;
        COLni:=12;
      end;
  end;


end;

procedure TMediumGridForm.DataDraw;
var row:integer;
    n:TSpectru;
begin
 DataGrid.Cells[1,0]:='ʊԊu';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if row=1 then begin
      if OpticalSystem.ObjectDistance<=-1e100 then begin
        DataGrid.Cells[1,row]:='INFINITY';
      end else begin
        DataGrid.Cells[1,row]:=FloatToStr(OpticalSystem.ObjectDistance);
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+1) then begin
        DataGrid.Cells[1,row]:=FloatToStr(OpticalSystem.BackFocus[nd]);
      end else begin
        DataGrid.Cells[1,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].Distance);
      end;
    end;
  end;

  DataGrid.Cells[2,0]:='KX';
  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    DataGrid.Cells[2,row]:=(OpticalSystem.OpticalMedium[row-1].GlassName);
  end;


  for n:=nd to OpticalSystem.LastSpectru do begin
     {'nt' 'ns' 'nr' 'nC' 'nd' 'ne' 'nF' 'ng' 'nh' 'ni'}
    case n of
       nd :begin
            DataGrid.Cells[COLnd,0]:='d ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLnd,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
       nC :begin
            DataGrid.Cells[COLnC,0]:='C ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLnC,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
       nF :begin
            DataGrid.Cells[COLnF,0]:='F ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLnF,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
       ng :begin
            DataGrid.Cells[COLng,0]:='g ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLng,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
       ne :begin
            DataGrid.Cells[COLne,0]:='e ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLne,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
       nh :begin
            DataGrid.Cells[COLnh,0]:='h ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLnh,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
       ni :begin
            DataGrid.Cells[COLni,0]:='i ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLni,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
       nr :begin
            DataGrid.Cells[COLnr,0]:='r ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLnr,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
       ns :begin
            DataGrid.Cells[COLns,0]:='s ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLns,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
       nt :begin
            DataGrid.Cells[COLnt,0]:='t ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              DataGrid.Cells[COLnt,row]:=FloatToStr(OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]);
            end;
           end;
    end;


  end;

end;

procedure TMediumGridForm.DataFix;
var row:integer;
    n:TSpectru;
begin
  if (FlagDataDraw=False) then begin
    exit;
  end;

  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin

    if row=1 then begin
      if DataGrid.Cells[1,row]='INFINITY' then begin
        OpticalSystem.ObjectDistance:=INFINITY;
      end else begin
        OpticalSystem.ObjectDistance:=StrToFloat(DataGrid.Cells[1,row]);
        D3Vew.FinitRayPointX:=OpticalSystem.ObjectDistance;
        PlanForm.FinitRayPointX:=OpticalSystem.ObjectDistance;
      end;
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+1) then begin
//        OpticalSystem.BackFocus[nd]:=StrToFloat(DataGrid.Cells[1,row]);
      end else begin
        OpticalSystem.OpticalMedium[row-1].Distance:=StrToFloat(DataGrid.Cells[1,row]);
      end;
    end;

    OpticalSystem.OpticalMedium[row-1].GlassName:=DataGrid.Cells[2,row];
  end;

  for n:=nd to OpticalSystem.LastSpectru do begin
     {'nt' 'ns' 'nr' 'nC' 'nd' 'ne' 'nF' 'ng' 'nh' 'ni'}
    case n of
       nd :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLnd,row]);
            end;
           end;
       nC :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLnC,row]);
            end;
           end;
       nF :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLnF,row]);
            end;
           end;
       ng :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLng,row]);
            end;
           end;
       ne :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLne,row]);
            end;
           end;
       nh :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLnh,row]);
            end;
           end;
       ni :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLni,row]);
            end;
           end;
       nr :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLnr,row]);
            end;
           end;
       ns :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLns,row]);
            end;
           end;
       nt :begin
            for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
              OpticalSystem.OpticalMedium[row-1].RefractiveIndex[n]:=StrToFloat(DataGrid.Cells[COLnt,row]);
            end;
           end;
       end;

    end;


end;


procedure TMediumGridForm.RefractiveIndexFileIn;
var InputFile:Textfile;
  aData:String;
  Medium: TOpticalMedium;
  i: integer;
  aName:string;
begin
  if DataGrid.Row>OpticalSystem.TotalSurfaceNumber+1 then exit;

  Medium:=OpticalSystem.OpticalMedium[DataGrid.Row-1];

  if OpenDialog1.Execute then
    begin
    Screen.Cursor:=crHourGlass;
    AssignFile(InputFile,OpenDialog1.FileName);
    Reset(InputFile);
    aName:=ExtractFileName(OpenDialog1.FileName);
    aName:=ChangeFileExt(aName, ' ');

    try
      for i:=1 to 23 do begin
        Readln(InputFile, aData);
        case i of
          1: Medium.GlassName:=TrimRight(aData);

          3: Medium.AbbeNumber:=StrToFloat(TrimRight(aData));

          5: Medium.RefractiveIndex[nt]:=StrToFloat(TrimRight(aData));

          7: Medium.RefractiveIndex[ns]:=StrToFloat(TrimRight(aData));

          9: Medium.RefractiveIndex[nr]:=StrToFloat(TrimRight(aData));

          11: Medium.RefractiveIndex[nC]:=StrToFloat(TrimRight(aData));

          13: Medium.RefractiveIndex[nd]:=StrToFloat(TrimRight(aData));

          15: Medium.RefractiveIndex[ne]:=StrToFloat(TrimRight(aData));

          17: Medium.RefractiveIndex[nF]:=StrToFloat(TrimRight(aData));

          19: Medium.RefractiveIndex[ng]:=StrToFloat(TrimRight(aData));

          21: Medium.RefractiveIndex[nh]:=StrToFloat(TrimRight(aData));

          23: Medium.RefractiveIndex[ni]:=StrToFloat(TrimRight(aData));
        end;
      end;
 
    finally
    System.CloseFile(InputFile);
    Screen.Cursor:=crDefault;
    end;
  end;
 

end;


procedure TMediumGridForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  visible:=true;
end;

procedure TMediumGridForm.BitBtn1Click(Sender: TObject);
var col,row:integer;
begin
  DataGrid.Font.Color:=clBlack;
  BitBtn2.Font.Color:=clBlack;
  
  for col:=0 to 12 do begin
    for row:=0 to 64+2 do begin
      DataGrid.Cells[col,row]:='';
    end;
  end;

  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if row=1 then begin
      DataGrid.Cells[0,row]:='_';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+1) then begin
        DataGrid.Cells[0,row]:='œ_ʋ';
      end else begin
        DataGrid.Cells[0,row]:=IntToStr(row-1) + '  Ԋu';
      end;
    end;
  end;

  self.COLset;
  self.DataDraw;
  FlagDataDraw:=true;
end;


procedure TMediumGridForm.BitBtn2Click(Sender: TObject);
begin
  self.DataFix;
  self.BitBtn1.Click;

  if (DataGridForm.GetFlagOfDataType='Radius') then begin
    DataGridForm.BitBtn1.Click;
    DataGridForm.BitBtn1.Click;
  end else begin
    DataGridForm.BitBtn2.Click;
    DataGridForm.BitBtn2.Click;
  end;
  
  if (UnitedDataForm.FlagOfDataType='Radius') then begin
    UnitedDataForm.BitBtn1.Click;
  end else begin
    UnitedDataForm.BitBtn2.Click;
  end;

  FormPOPS.DataIsChanged;
  
end;


procedure TMediumGridForm.BitBtn3Click(Sender: TObject);
begin
 { self.DataFix;
  self.RefractiveIndexFileIn;
  self.BitBtn1.Click;
  if (DataGridForm.GetFlagOfDataType='Radius') then begin
    DataGridForm.BitBtn1.Click;
    DataGridForm.BitBtn1.Click;
  end else begin
    DataGridForm.BitBtn2.Click;
    DataGridForm.BitBtn2.Click;
  end;}
end;


procedure TMediumGridForm.DataGridSetEditText(Sender: TObject; ACol,
  ARow: Integer; const Value: String);
begin
begin
  DataGrid.Font.Color:=clNavy;
  BitBtn2.Font.Color:=clRed;
  BitBtn4.Font.Color:=clRed;
end;

end;

procedure TMediumGridForm.DataGridSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
{  if aCol=2 then begin
    DataGrid.Options:=DataGrid.Options - [goEditing];
  end else begin
    DataGrid.Options:=DataGrid.Options + [goEditing];
  end;  }
end;

procedure TMediumGridForm.DataGridDblClick(Sender: TObject);
begin
  if DataGrid.Col=2 then begin
    Button1.Click;
  end;
end;

procedure TMediumGridForm.Button1Click(Sender: TObject);
begin
  GlassDataForm.SelectedDataIndex:=(DataGrid.Row )-1;
  GlassDataForm.Visible:=True;
  GlassDataForm.show;

end;

procedure TMediumGridForm.DataGridClick(Sender: TObject);
begin
   GlassDataForm.SelectedDataIndex:=DataGrid.Row-1;

   self.DataFix;
   FormPOPS.DataIsChanged;
end;

procedure TMediumGridForm.RefreshDraw;
var col,row:integer;
begin
  DataGrid.Font.Color:=clBlack;
  BitBtn2.Font.Color:=clBlack;
  
  for col:=0 to 12 do begin
    for row:=0 to 64+2 do begin
      DataGrid.Cells[col,row]:='';
    end;
  end;

  for row:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if row=1 then begin
      DataGrid.Cells[0,row]:='_';
    end else begin
      if (row=OpticalSystem.TotalSurfaceNumber+1) then begin
        DataGrid.Cells[0,row]:='œ_ʋ';
      end else begin
        DataGrid.Cells[0,row]:=IntToStr(row-1) + '  Ԋu';
      end;
    end;
  end;

  self.COLset;
  self.DataDraw;
  FlagDataDraw:=true;

  self.Caption:='ܗ'+'/'+OpticalSystem.OpticalName;

end;


procedure TMediumGridForm.DataGridKeyPress(Sender: TObject; var Key: Char);
begin
  if (Ord(Key) = VK_RETURN)  then begin
    self.DataFix;
    FormPOPS.DataIsChanged;
    // ʏEnterL[̏Ȃ悤ɃNAĂ܂B
    Key := #0;
  end;
end;

procedure TMediumGridForm.BitBtn4Click(Sender: TObject);
begin
  BitBtn2.Click;
  ParAxialDataForm.BitBtn1.Click;

  DataGrid.Font.Color:=clBlack;
  BitBtn2.Font.Color:=clBlack;
  BitBtn4.Font.Color:=clBlack;


end;

end.
