unit MayMath;

interface
  function DegreeToRadian(aNumber:extended):extended;
  function RadianToDegree(aNumber:extended):extended;
  function Tan(aNumber:extended):extended;
  function ArcSin(aNumber:extended):extended;
  function ArcCos(aNumber:extended):extended;
  function Pow(x:extended; y:extended):extended;
  function PowInt(x:extended; y:word):extended;
implementation
  function DegreeToRadian(aNumber:extended):extended;
  begin
    result:=( aNumber*pi/180 );
  end;

  function RadianToDegree(aNumber:extended):extended;
  begin
    result:=( aNumber*180/pi );
  end;


  function Tan(aNumber:extended):extended;
  begin
    result:=( sin(aNumber)/cos(aNumber) );
  end;

  function ArcSin(aNumber:extended):extended;
  begin
    if aNumber=1 then begin
      result:=PI/2;
    end else begin
      result:= arcTan (aNumber/sqrt (1-sqr (aNumber))) ;
    end;
  end;

  function ArcCos(aNumber:extended):extended;
  begin
    if aNumber=0 then begin
      result:=PI/2;
    end else begin
      result:= arcTan (sqrt (1-sqr (aNumber)) /aNumber) ;
    end;
  end;

  function Pow(x:extended; y:extended):extended;
  begin
    result:=exp( y * ln(x) );  { X  Y  }
  end;

  function PowInt(x:extended; y:word):extended;
  var i:integer;
      aValue:extended;
  begin
    if y=0 then begin
      result:=1;
      exit;
    end;
    aValue:=x;
    if y=1 then begin
      result:=aValue;
      exit;
    end else begin
      for i:=2 to y do begin
        aValue:=aValue*x;
      end;
    end;
    result:=aValue;  { X  Y  }
  end;

end.

