unit Ray;


interface
uses
 OptMedium,OptSurface;

type

  TParAxialRayArray=array[TMaxOptSurfaceRange,nd..nt]of extended;

  TParAxialRay=class
  private
    Fh                       :TParAxialRayArray;
    Fa                       :TParAxialRayArray;
    Fs                       :TParAxialRayArray;
    Fu                       :TParAxialRayArray;
    FObjectSideDistance      :extended;
    FReverseObjectDistance   :extended;

    function Geth(index1:TMaxOptSurfaceRange;index2:TSpectru):extended;
    procedure Seth(index1:TMaxOptSurfaceRange;index2:TSpectru;value:extended);

    function Geta(index1:TMaxOptSurfaceRange;index2:TSpectru):extended;
    procedure Seta(index1:TMaxOptSurfaceRange;index2:TSpectru;value:extended);

    function Gets(index1:TMaxOptSurfaceRange;index2:TSpectru):extended;
    procedure Sets(index1:TMaxOptSurfaceRange;index2:TSpectru;value:extended);

    function Getu(index1:TMaxOptSurfaceRange;index2:TSpectru):extended;
    procedure Setu(index1:TMaxOptSurfaceRange;index2:TSpectru;value:extended);

  public
    property h[index1:TMaxOptSurfaceRange;index2:TSpectru]:extended read Geth write Seth;
    property a[index1:TMaxOptSurfaceRange;index2:TSpectru]:extended read Geta write Seta;
    property s[index1:TMaxOptSurfaceRange;index2:TSpectru]:extended read Gets write Sets;
    property u[index1:TMaxOptSurfaceRange;index2:TSpectru]:extended read Getu write Setu;

    property ObjectSideDistance :extended read FObjectSideDistance
                                        write FObjectSideDistance;
    property ReverseObjectDistance :extended read FReverseObjectDistance
                                           write FReverseObjectDistance;
    procedure Initialize;
  end;

  TD3Ray=class
  private
    Fax,  Fay,  Faz         :extended;
    Faxi, Fayi, Fazi        :extended;
    Fdxi, Fdyi, Fdzi        :extended;
    Famx, Famy, Famz        :extended;
    Fal,  Fam,  Fan         :extended;
    Fdxia, Fdyia, Fdzia     :extended;
    Fxmd, Fdim              :extended;
    Fqntp, Fobjd            :extended;
    Fpi, Fqi, FdeltaQi, Fgi :extended;
    Fd12, FpathLength       :extended;
    Fvv, Fvf, Fcosi, Fcosid :extended;
    Fsini2, Fsinid2         :extended;
    FcofP1, FcofP2, FcofP3  :extended;
    Ffrnlbh                 :extended;
    Fh, Fhxv, Fhyv, Fhzv    :array[TMaxOptSurfaceRange]of extended;
    Fvdxi, Fvdyi, Fvdzi     :array[TMaxOptSurfaceRange]of extended;
    Fsinmx                  :array[TMaxOptSurfaceRange]of extended;
    FasSwitch                :boolean;
    Fvyhat, Fvhyi, Fuyi      :extended;
    Fvzhat, Fuzi             :extended;
    Fvdfy, Fvdfz, Fvdfy2     :extended;
    Fvdfz2, Fvdfyz           :extended;

    Frot, Fros               :extended;
    Fa11, Fa21, Fa12, Fa22   :extended;
    Fb11, Fb21, Fb12, Fb22   :extended;
    Fryi, Frzi, Fryzi        :extended;
    Fdq1yh, Fdq1zh           :extended;
    Fdq2yh, Fdq2zh           :extended;
    Fdr1yh, Fdr1zh           :extended;
    Fdr2yh, Fdr2zh           :extended;
    Ftas, Fsas               :extended;

    FK3dastFlag         :word;  // _vZĂ邩ǂ̔
                                //P̂Ƃl@ǐՎĂяoс{PB
    FIhightFlag         :TFlagValue;     //tlʂŌnC][ۂ̔
    FIeabsFlag          :TFlagValue;    //񋅖ʂł̒ߎŎ̔Ŏgp
    FEvold              :extended;       //񋅖ʂł̒ߎŋʂƔ񋅖ʂƂ̍


    function GetH(index:TMaxOptSurfaceRange):extended;
    procedure SetH(index:TMaxOptSurfaceRange; value:extended);

    function GetHxv(index:TMaxOptSurfaceRange):extended;
    procedure SetHxv(index:TMaxOptSurfaceRange; value:extended);

    function GetHyv(index:TMaxOptSurfaceRange):extended;
    procedure SetHyv(index:TMaxOptSurfaceRange; value:extended);

    function GetHzv(index:TMaxOptSurfaceRange):extended;
    procedure SetHzv(index:TMaxOptSurfaceRange; value:extended);

    function GetVdxi(index:TMaxOptSurfaceRange):extended;
    procedure SetVdxi(index:TMaxOptSurfaceRange; value:extended);

    function GetVdyi(index:TMaxOptSurfaceRange):extended;
    procedure SetVdyi(index:TMaxOptSurfaceRange; value:extended);

    function GetVdzi(index:TMaxOptSurfaceRange):extended;
    procedure SetVdzi(index:TMaxOptSurfaceRange; value:extended);

    function GetSinmx(index:TMaxOptSurfaceRange):extended;
    procedure SetSinmx(index:TMaxOptSurfaceRange; value:extended);

  public
    property ax:extended  read Fax write Fax;
    property ay:extended  read Fay write Fay;
    property az:extended  read Faz write Faz;

    property axi:extended  read Faxi write Faxi ;
    property ayi:extended  read Fayi write Fayi ;
    property azi:extended  read Fazi write Fazi ;

    property dxi:extended  read Fdxi write Fdxi ;
    property dyi:extended  read Fdyi write Fdyi ;
    property dzi:extended  read Fdzi write Fdzi ;

    property amx:extended  read Famx write Famx ;
    property amy:extended  read Famy write Famy ;
    property amz:extended  read Famz write Famz ;

    property al:extended   read Fal write Fal ;
    property am:extended   read Fam write Fam ;
    property an:extended    read Fan write Fan ;

    property dxia:extended  read Fdxia write Fdxia ;
    property dyia:extended  read Fdyia write Fdyia ;
    property dzia:extended  read Fdzia write Fdzia ;

    property xmd:extended   read Fxmd write Fxmd ;
    property dim:extended   read Fdim write Fdim ;

    property qntp:extended  read Fqntp write Fqntp ;
    property objd:extended  read Fobjd write Fobjd ;

    property pi:extended    read Fpi write Fpi ;
    property qi:extended    read Fqi write Fqi ;
    property deltaQi:extended read FdeltaQi write FdeltaQi ;
    property gi:extended      read Fgi write Fgi ;

    property d12:extended     read Fd12 write Fd12 ;
    property pathLength:extended read FpathLength write FpathLength ;

    property vv:extended read Fvv write Fvv ;
    property vf:extended  read Fvf write Fvf ;

    property cosi:extended read Fcosi write Fcosi ;
    property cosid:extended read Fcosid write Fcosid ;

    property sini2:extended read Fsini2 write Fsini2 ;
    property sinid2:extended read Fsinid2 write Fsinid2 ;

    property cofP1:extended  read FcofP1 write FcofP1 ;
    property cofP2:extended  read FcofP2 write FcofP2 ;
    property cofP3:extended  read FcofP3 write FcofP3 ;

    property frnlbh:extended read Ffrnlbh write Ffrnlbh ;

    property h[index:TMaxOptSurfaceRange]:extended read GetH write SetH;

    property hxv[index:TMaxOptSurfaceRange]:extended read GetHxv write SetHxv;
    property hyv[index:TMaxOptSurfaceRange]:extended read GetHyv write SetHyv;
    property hzv[index:TMaxOptSurfaceRange]:extended read GetHzv write SetHzv;

    property vdxi[index:TMaxOptSurfaceRange]:extended read GetVdxi write SetVdxi;
    property vdyi[index:TMaxOptSurfaceRange]:extended read GetVdyi write SetVdyi;
    property vdzi[index:TMaxOptSurfaceRange]:extended read GetVdzi write SetVdzi;
    property sinmx[index:TMaxOptSurfaceRange]:extended read GetSinmx write SetSinmx;

    property asSwitch:Boolean  read FasSwitch write FasSwitch ;

    property vyhat:extended      read Fvyhat write Fvyhat ;
    property vhyi:extended       read Fvhyi write Fvhyi ;
    property uyi:extended        read Fuyi write Fuyi ;

    property vzhat:extended      read Fvzhat write Fvzhat ;
    property uzi:extended        read Fuzi write Fuzi ;

    property vdfy:extended       read Fvdfy write Fvdfy ;
    property vdfz:extended       read Fvdfz write Fvdfz ;
    property vdfy2:extended      read Fvdfy2 write Fvdfy2 ;

    property vdfz2:extended      read Fvdfz2 write Fvdfz2 ;
    property vdfyz:extended      read Fvdfyz write Fvdfyz ;
    //tconv
    property rot:extended   read Frot write Frot ;
    property ros:extended   read Fros write Fros ;

    property a11:extended   read Fa11 write Fa11 ;
    property a21:extended   read Fa21 write Fa21 ;

    property a12:extended   read Fa12 write Fa12 ;
    property a22:extended   read Fa22 write Fa22 ;

    property b11:extended   read Fb11 write Fb11 ;
    property b21:extended   read Fb21 write Fb21 ;

    property b12:extended   read Fb12 write Fb12 ;
    property b22:extended   read Fb22 write Fb22 ;

    property ryi:extended   read Fryi write Fryi ;
    property rzi:extended   read Frzi write Frzi ;
    property ryzi:extended  read Fryzi write Fryzi ;

    property dq1yh:extended  read Fdq1yh write Fdq1yh ;
    property dq1zh:extended  read Fdq1zh write Fdq1zh ;

    property dq2yh:extended  read Fdq2yh write Fdq2yh ;
    property dq2zh:extended  read Fdq2zh write Fdq2zh ;

    property dr1yh:extended  read Fdr1yh write Fdr1yh ;
    property dr1zh:extended  read Fdr1zh write Fdr1zh ;

    property dr2yh:extended  read Fdr2yh write Fdr2yh ;
    property dr2zh:extended  read Fdr2zh write Fdr2zh ;

    property tas:extended    read Ftas write Ftas ;
    property sas:extended    read Fsas write Fsas ;

    property K3dastFlag:word read FK3dastFlag write FK3dastFlag;
    property IhightFlag:TFlagValue read FIhightFlag write FIhightFlag;

    property IeabsFlag:TFlagValue read FIeabsFlag write FIeabsFlag;
    property Evold:extended       read FEvold     write FEvold;

    function ConvertVecM(aFlagReverse:integer; aMatrix:TMatrix):boolean;
    function ConvertVecQ(aFlagReverse:integer; aMatrix:TMatrix):boolean;
    function ConvertVecRR( aFlagReverse:integer; aMatrix:TMatrix):boolean;
    procedure IntDataSet;
    procedure Initialize;
    procedure InitializeForSphericalAberration(aNumber:extended);
    procedure InitializeForSAFiniteCase( aNumber:extended; aFiniteX:extended; aFiniteY:extended; aFiniteZ:extended);
    procedure InitializeForAs;
    procedure InitializeForSagittarFiniteCase( aNumber:extended; aFiniteX:extended; aFiniteY:extended; aFiniteZ:extended);

  end;


implementation

procedure TParAxialRay.Initialize;
var
  k: integer;
  n: TSpectru;
begin
  for k:=1 to MaxOptSurface do begin
    for n:=nd to nt do begin
      Fh[k,n]:=0;
      Fa[k,n]:=0;
      Fs[k,n]:=0;
      Fu [k,n]:=0;
    end;
  end;
  FObjectSideDistance:=0;
  FReverseObjectDistance:=0;

end;

function TParAxialRay.Geth(index1:TMaxOptSurfaceRange;index2:TSpectru):extended;
begin
  result:=Fh[index1,index2];
end;

procedure TParAxialRay.Seth(index1:TMaxOptSurfaceRange;index2:TSpectru;value:extended);
begin
  Fh[index1,index2]:=value;
end;

function TParAxialRay.Geta(index1:TMaxOptSurfaceRange;index2:TSpectru):extended;
begin
  result:=Fa[index1,index2];
end;

procedure TParAxialRay.Seta(index1:TMaxOptSurfaceRange;index2:TSpectru;value:extended);
begin
  Fa[index1,index2]:=value;
end;

function TParAxialRay.Gets(index1:TMaxOptSurfaceRange;index2:TSpectru):extended;
begin
  result:=Fs[index1,index2];
end;

procedure TParAxialRay.Sets(index1:TMaxOptSurfaceRange;index2:TSpectru;value:extended);
begin
  Fs[index1,index2]:=value;
end;

function TParAxialRay.Getu(index1:TMaxOptSurfaceRange;index2:TSpectru):extended;
begin
  result:=Fu[index1,index2];
end;

procedure TParAxialRay.Setu(index1:TMaxOptSurfaceRange;index2:TSpectru;value:extended);
begin
  Fu[index1,index2]:=value;
end;

function TD3Ray.GetH(index:TMaxOptSurfaceRange):extended;
begin
  result:=Fh[index];
end;
procedure TD3Ray.SetH(index:TMaxOptSurfaceRange; value:extended);
begin
  Fh[index]:=value;
end;

function TD3Ray.GetHxv(index:TMaxOptSurfaceRange):extended;
begin
  result:=Fhxv[index];
end;
procedure TD3Ray.SetHxv(index:TMaxOptSurfaceRange; value:extended);
begin
  Fhxv[index]:=value;
end;

function TD3Ray.GetHyv(index:TMaxOptSurfaceRange):extended;
begin
  result:=Fhyv[index];
end;
procedure TD3Ray.SetHyv(index:TMaxOptSurfaceRange; value:extended);
begin
  Fhyv[index]:=value;
end;

function TD3Ray.GetHzv(index:TMaxOptSurfaceRange):extended;
begin
  result:=Fhzv[index];
end;
procedure TD3Ray.SetHzv(index:TMaxOptSurfaceRange; value:extended);
begin
  Fhzv[index]:=value;
end;

function TD3Ray.GetVdxi(index:TMaxOptSurfaceRange):extended;
begin
  result:=Fvdxi[index];
end;
procedure TD3Ray.SetVdxi(index:TMaxOptSurfaceRange; value:extended);
begin
  Fvdxi[index]:=value;
end;

function TD3Ray.GetVdyi(index:TMaxOptSurfaceRange):extended;
begin
  result:=Fvdyi[index];
end;
procedure TD3Ray.SetVdyi(index:TMaxOptSurfaceRange; value:extended);
begin
  Fvdyi[index]:=value;
end;

function TD3Ray.GetVdzi(index:TMaxOptSurfaceRange):extended;
begin
  result:=Fvdzi[index];
end;
procedure TD3Ray.SetVdzi(index:TMaxOptSurfaceRange; value:extended);
begin
  Fvdzi[index]:=value;
end;

function TD3Ray.GetSinmx(index:TMaxOptSurfaceRange):extended;
begin
  result:=Fsinmx[index];
end;
procedure TD3Ray.SetSinmx(index:TMaxOptSurfaceRange; value:extended);
begin
  Fsinmx[index]:=value;
end;


//*************** RayTrace Prucedures ********************

procedure TD3Ray.Initialize;
var i:integer;
begin
  Fax:=0;  Fay:=0;  Faz:=0;
    Faxi:=0; Fayi:=0; Fazi:=0;
    Fdxi:=0; Fdyi:=0; Fdzi:=0;
    Famx:=0; Famy:=0; Famz:=0;
    Fal:=0;  Fam:=0;  Fan:=0;
    Fdxia:=0; Fdyia:=0; Fdzia:=0;
    Fxmd:=0; Fdim:=0;
    Fqntp:=0; Fobjd:=0;
    Fpi:=0; Fqi:=0; FdeltaQi:=0; Fgi:=0;
    Fd12:=0; FpathLength:=0;
    Fvv:=0; Fvf:=0; Fcosi:=0; Fcosid:=0;
    Fsini2:=0; Fsinid2:=0;
    FcofP1:=0; FcofP2:=0; FcofP3:=0;
    Ffrnlbh:=0;
    for i:=1 to MaxOptSurface do begin
      Fh[i]:=0;
      Fhxv[i]:=0;
      Fhyv[i]:=0;
      Fhzv[i]:=0;
      Fvdxi[i]:=0;
      Fvdyi[i]:=0;
      Fvdzi[i]:=0;
      Fsinmx[i]:=0;
    end;
    FasSwitch:=False;
    Fvyhat:=0; Fvhyi:=0; Fuyi:=0;
    Fvzhat:=0; Fuzi:=0;
    Fvdfy:=0; Fvdfz:=0; Fvdfy2:=0;
    Fvdfz2:=0; Fvdfyz:=0;

    Frot:=0; Fros:=0;
    Fa11:=0; Fa21:=0; Fa12:=0; Fa22:=0;
    Fb11:=0; Fb21:=0; Fb12:=0; Fb22:=0;
    Fryi:=0; Frzi:=0; Fryzi:=0;
    Fdq1yh:=0; Fdq1zh:=0;
    Fdq2yh:=0; Fdq2zh:=0;
    Fdr1yh:=0; Fdr1zh:=0;
    Fdr2yh:=0; Fdr2zh:=0;
    Ftas:=0; Fsas:=0;

    FK3dastFlag:=0;
    FIhightFlag:=0;
    FIeabsFlag:=0;
    FEvold:=0;

end;

function TD3Ray.ConvertVecM(aFlagReverse:integer; aMatrix:TMatrix):boolean;// 3.11 CONVRT
var
  aStockX, aStockY, aStockZ:extended;
begin

  aStockX:=amx;
  aStockY:=amy;
  aStockZ:=amz;

  if aFlagReverse=0 then begin
    amx:=aMatrix[1,1]*aStockX + aMatrix[1,2]*aStockY + aMatrix[1,3]*aStockZ;
    amy:=aMatrix[2,1]*aStockX + aMatrix[2,2]*aStockY + aMatrix[2,3]*aStockZ;
    amz:=aMatrix[3,1]*aStockX + aMatrix[3,2]*aStockY + aMatrix[3,3]*aStockZ;
  end else begin
    amx:=aMatrix[1,1]*aStockX + aMatrix[2,1]*aStockY + aMatrix[3,1]*aStockZ;
    amy:=aMatrix[1,2]*aStockX + aMatrix[2,2]*aStockY + aMatrix[3,2]*aStockZ;
    amz:=aMatrix[1,3]*aStockX + aMatrix[2,3]*aStockY + aMatrix[3,3]*aStockZ;
  end;

  result:=True;

end;

function TD3Ray.ConvertVecQ(aFlagReverse:integer; aMatrix:TMatrix):boolean;
var
  aStockX, aStockY, aStockZ:extended;
begin

  aStockX:=dxi;
  aStockY:=dyi;
  aStockZ:=dzi;

  if aFlagReverse=0 then begin
    dxi:=aMatrix[1,1]*aStockX + aMatrix[1,2]*aStockY + aMatrix[1,3]*aStockZ;
    dyi:=aMatrix[2,1]*aStockX + aMatrix[2,2]*aStockY + aMatrix[2,3]*aStockZ;
    dzi:=aMatrix[3,1]*aStockX + aMatrix[3,2]*aStockY + aMatrix[3,3]*aStockZ;
  end else begin
    dxi:=aMatrix[1,1]*aStockX + aMatrix[2,1]*aStockY + aMatrix[3,1]*aStockZ;
    dyi:=aMatrix[1,2]*aStockX + aMatrix[2,2]*aStockY + aMatrix[3,2]*aStockZ;
    dzi:=aMatrix[1,3]*aStockX + aMatrix[2,3]*aStockY + aMatrix[3,3]*aStockZ;
  end;

  result:=True;

end;

function TD3Ray.ConvertVecRR( aFlagReverse:integer; aMatrix:TMatrix):boolean;
var
  aStockX, aStockY, aStockZ:extended;
begin

  aStockX:=ax;
  aStockY:=ay;
  aStockZ:=az;

  if aFlagReverse=0 then begin
    ax:=aMatrix[1,1]*aStockX + aMatrix[1,2]*aStockY + aMatrix[1,3]*aStockZ;
    ay:=aMatrix[2,1]*aStockX + aMatrix[2,2]*aStockY + aMatrix[2,3]*aStockZ;
    az:=aMatrix[3,1]*aStockX + aMatrix[3,2]*aStockY + aMatrix[3,3]*aStockZ;
  end else begin
    ax:=aMatrix[1,1]*aStockX + aMatrix[2,1]*aStockY + aMatrix[3,1]*aStockZ;
    ay:=aMatrix[1,2]*aStockX + aMatrix[2,2]*aStockY + aMatrix[3,2]*aStockZ;
    az:=aMatrix[1,3]*aStockX + aMatrix[2,3]*aStockY + aMatrix[3,3]*aStockZ;
  end;

  result:=True;

end;

procedure TD3Ray.IntDataSet; // 3.38 AST3D 27-39
begin

  dr1yh:=vyhat;
  dq1yh:=-1 * uyi;
  dr1zh:=0;
  dq1zh:=0;

  dr2yh:=0;
  dq2yh:=0;
  dr2zh:=vzhat;
  dq2zh:=-1 * uzi;

end;

procedure TD3Ray.InitializeForSphericalAberration(aNumber:extended);
begin
  ax:=0;
  ay:=aNumber;
  az:=0;

  dxi:=1;
  dyi:=0;
  dzi:=0;
end;

procedure TD3Ray.InitializeForSAFiniteCase( aNumber:extended; aFiniteX:extended; aFiniteY:extended; aFiniteZ:extended);
var
  aObex, aObey, aObez, aTobe, aTobei:extended;
begin

    ax:=0;
    ay:=aNumber;
    az:=0;
    aObex:=ax - aFiniteX + qntp;
    aObey:=ay - aFiniteY ;
    aObez:=az - aFiniteZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
        aTobe:=-1*aTobe;

    aTobei:=1 / aTobe;
    dxi:=aObex * aTobei;
    dyi:=aObey * aTobei;
    dzi:=aObez * aTobei;

end;


procedure TD3Ray.InitializeForSagittarFiniteCase( aNumber:extended; aFiniteX:extended; aFiniteY:extended; aFiniteZ:extended);
var
  aObex, aObey, aObez, aTobe, aTobei:extended;
begin

    ax:=0;
    ay:=0;
    az:=aNumber;
    aObex:=ax - aFiniteX + qntp;
    aObey:=ay - aFiniteY ;
    aObez:=az - aFiniteZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
        aTobe:=-1*aTobe;

    aTobei:=1 / aTobe;
    dxi:=aObex * aTobei;
    dyi:=aObey * aTobei;
    dzi:=aObez * aTobei;

end;

procedure TD3Ray.InitializeForAs;
begin
  vyhat:=1;
  vhyi:=0;
  uyi:=0;
  vzhat:=1;
  uzi:=0;
end;

end.

