unit ParAxialForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Grids, ComCtrls,
  MainForm, OptSurface,OptMedium,Ray,OptSystem;

type
  TParAxialDataForm = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    StringGrid1: TStringGrid;
    StringGrid2: TStringGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    ListBox1: TListBox;
    StringGrid3: TStringGrid;
    StringGrid4: TStringGrid;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
  private
    { Private 錾 }
    ROWnd,ROWnC,ROWnF,ROWng,ROWne,ROWnh,ROWni,ROWnr,ROWns,ROWnt:integer;
    COLnd,COLnC,COLnF,COLng,COLne,COLnh,COLni,COLnr,COLns,COLnt:integer;
    procedure ListBox1Draw;
    procedure ROWset;
    procedure Draw;
    procedure SagittaruDraw;
    procedure COLset;
    procedure HeightDraw;

  public
    { Public 錾 }
  end;

var
  ParAxialDataForm: TParAxialDataForm;
  aRay:TParAxialRay;

implementation

uses SpotBrowser, UnitedData, AspDataGrid, DataGrid, MediumDataGrid;

{$R *.dfm}


procedure TParAxialDataForm.FormCreate(Sender: TObject);
begin
  aRay:=TParAxialRay.Create;
end;

procedure TParAxialDataForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Visible:=false;
end;

procedure TParAxialDataForm.ListBox1Draw;
var
  aFNumber:extended;
begin
  aFNumber:=0;
  if (OpticalSystem.EffectiveAperture<>0) then begin
    if OpticalSystem.ObjectDistance<=INFINITY then begin
      aFNumber:=OpticalSystem.FocalLength[nd]/OpticalSystem.EffectiveAperture;
    end;
  end;

  with ListBox1 do
  begin
    Items.Clear;
    Items.Add('F = ' +  FloatToStrF(aFNumber,ffgeneral,7,4) );
    Items.Add('La = ' + FloatToStrF(OpticalSystem.EffectiveAperture,ffgeneral,7,4) );
    Items.Add(' '  );
    Items.Add('˓ = ' + FloatToStrF(OpticalSystem.EntrancePupil,ffgeneral,7,4) );
    Items.Add('ˏo = ' + FloatToStrF(OpticalSystem.ExitPupil,ffgeneral,7,4) );
    Items.Add(' '  );
    Items.Add('œ_   = ' + FloatToStrF(OpticalSystem.FocalLength[nd],ffgeneral,7,4) );
    Items.Add('BackFocus = ' + FloatToStrF(OpticalSystem.BackFocus[nd],ffgeneral,7,4) );



  end;
end;

procedure TParAxialDataForm.COLset;
begin
 //'nt' 'ns' 'nr' 'nC' 'nd' 'ne' 'nF' 'ng' 'nh' 'ni'
 // nd,nC,nF,ng,ne,nh,ni,nr,ns,nt
  case OpticalSystem.TotalSpectruNumber of
    1:begin
        COLnd:=1;
      end;
    2:begin
        COLnC:=1;
        COLnd:=2;
      end;
    3:begin
        COLnc:=1;
        COLnd:=2;
        COLnF:=3;
      end;
    4:begin
        COLnc:=1;
        COLnd:=2;
        COLnF:=3;
        COLng:=4;
      end;
    5:begin
        COLnc:=1;
        COLnd:=2;
        COLne:=3;
        COLnF:=4;
        COLng:=5;
      end;
    6:begin
        COLnc:=1;
        COLnd:=2;
        COLne:=3;
        COLnF:=4;
        COLng:=5;
        COLnh:=6;
      end;
    7:begin
        COLnc:=1;
        COLnd:=2;
        COLne:=3;
        COLnF:=4;
        COLng:=5;
        COLnh:=6;
        COLni:=7;
      end;
    8:begin
        COLnr:=1;
        COLnc:=2;
        COLnd:=3;
        COLne:=4;
        COLnF:=5;
        COLng:=6;
        COLnh:=7;
        COLni:=8;
      end;
    9:begin
        COLns:=1;
        COLnr:=2;
        COLnc:=3;
        COLnd:=4;
        COLne:=5;
        COLnF:=6;
        COLng:=7;
        COLnh:=8;
        COLni:=9;
      end;
    10:begin
        COLnt:=1;
        COLns:=2;
        COLnr:=3;
        COLnc:=4;
        COLnd:=5;
        COLne:=6;
        COLnF:=7;
        COLng:=8;
        COLnh:=9;
        COLni:=10;
      end;
  end;


end;


procedure TParAxialDataForm.ROWset;
begin
 //'nt' 'ns' 'nr' 'nC' 'nd' 'ne' 'nF' 'ng' 'nh' 'ni'
 // nd,nC,nF,ng,ne,nh,ni,nr,ns,nt
  case OpticalSystem.TotalSpectruNumber of
    1:begin
        ROWnd:=1;
      end;
    2:begin
        ROWnC:=1;
        ROWnd:=2;
      end;
    3:begin
        ROWnc:=1;
        ROWnd:=2;
        ROWnF:=3;
      end;
    4:begin
        ROWnc:=1;
        ROWnd:=2;
        ROWnF:=3;
        ROWng:=4;
      end;
    5:begin
        ROWnc:=1;
        ROWnd:=2;
        ROWne:=3;
        ROWnF:=4;
        ROWng:=5;
      end;
    6:begin
        ROWnc:=1;
        ROWnd:=2;
        ROWne:=3;
        ROWnF:=4;
        ROWng:=5;
        ROWnh:=6;
      end;
    7:begin
        ROWnc:=1;
        ROWnd:=2;
        ROWne:=3;
        ROWnF:=4;
        ROWng:=5;
        ROWnh:=6;
        ROWni:=7;
      end;
    8:begin
        ROWnr:=1;
        ROWnc:=2;
        ROWnd:=3;
        ROWne:=4;
        ROWnF:=5;
        ROWng:=6;
        ROWnh:=7;
        ROWni:=8;
      end;
    9:begin
        ROWns:=1;
        ROWnr:=2;
        ROWnc:=3;
        ROWnd:=4;
        ROWne:=5;
        ROWnF:=6;
        ROWng:=7;
        ROWnh:=8;
        ROWni:=9;
      end;
    10:begin
        ROWnt:=1;
        ROWns:=2;
        ROWnr:=3;
        ROWnc:=4;
        ROWnd:=5;
        ROWne:=6;
        ROWnF:=7;
        ROWng:=8;
        ROWnh:=9;
        ROWni:=10;
      end;
  end;

end;

procedure TParAxialDataForm.HeightDraw;
var row,col:integer;
    n:TSpectru;
begin
  self.ColSet;

  for col:=0 to 10 do begin
    for row:=0 to 64+2 do begin
      StringGrid3.Cells[col,row]:='';
      StringGrid4.Cells[col,row]:='';
    end;
  end;

  for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
    StringGrid3.Cells[0,row]:=IntToStr(row) + '  ';
    StringGrid4.Cells[0,row]:=IntToStr(row) + '  ';
  end;


  for n:=nd to OpticalSystem.LastSpectru do begin
     {'nt' 'ns' 'nr' 'nC' 'nd' 'ne' 'nF' 'ng' 'nh' 'ni'}
    case n of
       nd :begin
            StringGrid3.Cells[COLnd,0]:='d ';
            StringGrid4.Cells[COLnd,0]:='d ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLnd,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLnd,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
       nC :begin
            StringGrid3.Cells[COLnC,0]:='C ';
            StringGrid4.Cells[COLnC,0]:='C ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLnC,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLnC,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
       nF :begin
            StringGrid3.Cells[COLnF,0]:='F ';
            StringGrid4.Cells[COLnF,0]:='F ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLnF,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLnF,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
       ng :begin
            StringGrid3.Cells[COLng,0]:='g ';
            StringGrid4.Cells[COLng,0]:='g ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLng,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLng,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
       ne :begin
            StringGrid3.Cells[COLne,0]:='e ';
            StringGrid4.Cells[COLne,0]:='e ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLne,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLne,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
       nh :begin
            StringGrid3.Cells[COLnh,0]:='h ';
            StringGrid4.Cells[COLnh,0]:='h ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLnh,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLnh,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
       ni :begin
            StringGrid3.Cells[COLni,0]:='i ';
            StringGrid4.Cells[COLni,0]:='i ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLni,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLni,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
       nr :begin
            StringGrid3.Cells[COLnr,0]:='r ';
            StringGrid4.Cells[COLnr,0]:='r ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLnr,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLnr,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
       ns :begin
            StringGrid3.Cells[COLns,0]:='s ';
            StringGrid4.Cells[COLns,0]:='s ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLns,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLns,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
       nt :begin
            StringGrid3.Cells[COLnt,0]:='t ';
            StringGrid4.Cells[COLnt,0]:='t ';
            for row:=1 to OpticalSystem.TotalSurfaceNumber do begin
              StringGrid3.Cells[COLnt,row]:=FloatToStrF(aRay.h[row,n],ffgeneral,5,4);
              StringGrid4.Cells[COLnt,row]:=FloatToStrF(aRay.a[row,n],ffgeneral,5,4);
            end;
           end;
    end;


  end;

end;



procedure TParAxialDataForm.Draw;
var col,row,rowValue:integer;
    n:TSpectru;
begin
  
  for col:=0 to 6 do begin
    for row:=0 to 11 do begin
      StringGrid1.Cells[col,row]:='';
    end;
  end;

  for col:=1 to 5 do begin
    case col of
      1:StringGrid1.Cells[col,0]:='œ_';
      2:StringGrid1.Cells[col,0]:='BackFocus';
      3:StringGrid1.Cells[col,0]:='_';
      4:StringGrid1.Cells[col,0]:='BF';
      5:StringGrid1.Cells[col,0]:='_';
    end;
  end;

  self.ROWset;

  for n:=nd to OpticalSystem.LastSpectru do begin
     {'nt' 'ns' 'nr' 'nC' 'nd' 'ne' 'nF' 'ng' 'nh' 'ni'}
  
    case n of
       nd :begin
            rowValue:=ROWnd;
            StringGrid1.Cells[0,rowValue]:='d ';
           end;
       nC :begin
            rowValue:=ROWnC;
            StringGrid1.Cells[0,rowValue]:='C ';
           end;
       nF :begin
            rowValue:=ROWnF;
            StringGrid1.Cells[0,rowValue]:='F ';
           end;
       ng :begin
            rowValue:=ROWng;
            StringGrid1.Cells[0,rowValue]:='g ';
           end;
       ne :begin
            rowValue:=ROWne;
            StringGrid1.Cells[0,rowValue]:='e ';
           end;
       nh :begin
            rowValue:=ROWnh;
            StringGrid1.Cells[0,rowValue]:='h ';
           end;
       ni :begin
            rowValue:=ROWni;
            StringGrid1.Cells[0,rowValue]:='i ';
           end;
       nr :begin
            rowValue:=ROWnr;
            StringGrid1.Cells[0,rowValue]:='r ';
           end;
       ns :begin
            rowValue:=ROWns;
            StringGrid1.Cells[0,rowValue]:='s ';
           end;
       nt :begin
            rowValue:=ROWnt;
            StringGrid1.Cells[0,rowValue]:='t ';
           end;
    else
      rowValue:=1;
    end;

    for col:=1 to 5 do begin
      case col of
        1:StringGrid1.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.FocalLength[n],ffgeneral,7,4);
        2:StringGrid1.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.BackFocus[n],ffgeneral,7,4);
        3:StringGrid1.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.PrincipalPoint[n],ffgeneral,7,4);
        4:StringGrid1.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.ObjectSideBackFocus[n],ffgeneral,7,4);
        5:StringGrid1.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.ObjectSidePrincipalPoint[n],ffgeneral,7,4);
      end;
    end;


  end;

  self.Caption:='ߎl'+'/'+OpticalSystem.OpticalName;
end;

procedure TParAxialDataForm.SagittaruDraw;
var col,row,rowValue:integer;
    n:TSpectru;
begin

  for col:=0 to 4 do begin
    for row:=0 to 11 do begin
      StringGrid2.Cells[col,row]:='';
    end;
  end;

  for col:=1 to 3 do begin
    case col of
      1:StringGrid2.Cells[col,0]:='œ_';
      2:StringGrid2.Cells[col,0]:='BackFocus';
      3:StringGrid2.Cells[col,0]:='_';
 //     4:StringGrid2.Cells[col,0]:='BF';
 //     5:StringGrid2.Cells[col,0]:='_';
    end;
  end;

  self.ROWset;

  for n:=nd to OpticalSystem.LastSpectru do begin
     {'nt' 'ns' 'nr' 'nC' 'nd' 'ne' 'nF' 'ng' 'nh' 'ni'}
    
    case n of
       nd :begin
            rowValue:=ROWnd;
            StringGrid2.Cells[0,rowValue]:='d ';
           end;
       nC :begin
            rowValue:=ROWnC;
            StringGrid2.Cells[0,rowValue]:='C ';
           end;
       nF :begin
            rowValue:=ROWnF;
            StringGrid2.Cells[0,rowValue]:='F ';
           end;
       ng :begin
            rowValue:=ROWng;
            StringGrid2.Cells[0,rowValue]:='g ';
           end;
       ne :begin
            rowValue:=ROWne;
            StringGrid2.Cells[0,rowValue]:='e ';
           end;
       nh :begin
            rowValue:=ROWnh;
            StringGrid2.Cells[0,rowValue]:='h ';
           end;
       ni :begin
            rowValue:=ROWni;
            StringGrid2.Cells[0,rowValue]:='i ';
           end;
       nr :begin
            rowValue:=ROWnr;
            StringGrid2.Cells[0,rowValue]:='r ';
           end;
       ns :begin
            rowValue:=ROWns;
            StringGrid2.Cells[0,rowValue]:='s ';
           end;
       nt :begin
            rowValue:=ROWnt;
            StringGrid2.Cells[0,rowValue]:='t ';
           end;
    else
      rowValue:=1;
    end;

    for col:=1 to 3 do begin
      case col of
        1:StringGrid2.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.FocalLengthSagittaru[n],ffgeneral,7,4);
        2:StringGrid2.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.BackFocusSagittaru[n],ffgeneral,7,4);
        3:StringGrid2.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.PrincipalPointSagittaru[n],ffgeneral,7,4);
 //       4:StringGrid1.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.ObjectSideBackFocusSagittaru[n],ffgeneral,7,4);
//        5:StringGrid1.Cells[col,rowValue]:=FloatToStrF(OpticalSystem.ObjectSidePrincipalPointSagittaru[n],ffgeneral,7,4);
      end;
    end;


  end;

end;





procedure TParAxialDataForm.BitBtn1Click(Sender: TObject);
begin

  if OpticalSystem.parAxialTrace(FinalOpt)=false then begin
      exit;
  end;

  aRay.Initialize;
  aRay.ObjectSideDistance:=OpticalSystem.ObjectDistance;
  OpticalSystem.CulculateHightAlphaWith(aRay);

  OpticalSystem.FocusPlaneDistance:=OpticalSystem.BackFocus[nd];

  BitBtn2.Click;

  SpotForm.Edit15.Text:=FloatToStr(OpticalSystem.FocusPlaneDistance);

  FormPOPS.DataIsChanged;
  FormPOPS.ParAxialTraceFlag:=True;


  UnitedDataForm.BitBtn18.Font.Color:=clBlack;
  UnitedDataForm.BitBtn19.Font.Color:=clBlack;
  UnitedDataForm.BitBtn20.Font.Color:=clBlack;

  AsphericalDataGrid.BitBtn9.Font.Color:=clBlack;
  AsphericalDataGrid.BitBtn10.Font.Color:=clBlack;

  DataGridForm.BitBtn7.Font.Color:=clBlack;

  MediumGridForm.BitBtn4.Font.Color:=clBlack;



end;

procedure TParAxialDataForm.BitBtn2Click(Sender: TObject);
begin
  self.ListBox1Draw;
  self.Draw;
  self.SagittaruDraw;

  BitBtn5.Click;

end;

procedure TParAxialDataForm.BitBtn3Click(Sender: TObject);
begin
{  CoAxialIs:=False;

  for k:=1 to OpticalSystem.TotalSurfaceNumber do begin
    Surface:=OpticalSystem.OpticalSurface[k];

    if ( (Surface.TiltSwitch=False) and (Surface.SiftSwitch=False)
          and (Surface.BiasSwitch=False) )=True then
      CoAxialIs:=False
    else CoAxialIs:=True;

    if CoAxialIs=True then
      break;
  end;

  if CoAxialIs=True then begin
    OpticalSystem.ParAxialTraceNotSynmetryCase;
    OpticalSystem.FocusPlaneDistance:=OpticalSystem.BackFocus[nd];
  end;  }

  if OpticalSystem.SynmetrySwitch=true then begin
    OpticalSystem.ParAxialTraceNotSynmetryCase;
    OpticalSystem.FocusPlaneDistance:=OpticalSystem.BackFocus[nd];
  end;

  BitBtn4.Click;
end;


procedure TParAxialDataForm.BitBtn5Click(Sender: TObject);
begin
self.HeightDraw;

end;

procedure TParAxialDataForm.BitBtn6Click(Sender: TObject);
begin
BitBtn1.Click;

end;

procedure TParAxialDataForm.BitBtn4Click(Sender: TObject);
begin
 SagittaruDraw;

end;

end.
