unit PlanBrowser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls,
  MainForm, OptSystem, OptSurface, OptMedium, MayMath, Ray;

const
   MaxDivideNumber=30;
   SurfacePointNumber=MaxDivideNumber+1;
   CenterPoint=16;

type
  TPlanForm = class(TForm)
    Panel1: TPanel;
    PlanPaintBox: TPaintBox;
    Panel2: TPanel;
    ScrollBar1: TScrollBar;
    Edit1: TEdit;
    Label1: TLabel;
    ScrollBar2: TScrollBar;
    Edit2: TEdit;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Label3: TLabel;
    Button2: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Panel3: TPanel;
    ScrollBar3: TScrollBar;
    Edit3: TEdit;
    Edit4: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    Edit5: TEdit;
    SpinButton1: TSpinButton;
    Button3: TButton;
    SpinEdit2: TSpinEdit;
    Label10: TLabel;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Initialize(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ScrollBar3Change(Sender: TObject);
    procedure PlanPaintBoxMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PlanPaintBoxPaint(Sender: TObject);
    procedure SpinButton1DownClick(Sender: TObject);
    procedure SpinButton1UpClick(Sender: TObject);
    procedure SpinEdit2Change(Sender: TObject);
  private
    { Private 錾 }
    aSurfacePeakPoint: array[1..(MaxOptsurface+1),'X'..'Z'] of longint;
    aSurfacePeakPointTilted: array[1..(MaxOptsurface+1),'X'..'Z'] of longint;
    aSurfacePoint: array[1..(MaxOptSurface+1),1..SurfacePointNumber,'X'..'Z'] of longint;
    RayOriginX: array[1..(MaxOptSurface+1)] of longint;
    RayOriginY: array[1..(MaxOptSurface+1)] of longint;
    RayOriginZ: array[1..(MaxOptSurface+1)] of longint;

    PlanStartPoint: longint;
    PlanStartPointY: longint;
    PlanMagnification: Extended;
    PlanRayAngle: extended;
    RayAngleDecimal:extended;
    {procedure DrawRay(Height:extended);}

    RayNumber:integer;

    procedure DrawPrincipalRay;
    procedure Rotation(var aX:longint; var aY:longint; var aZ:longint; aMatrix:TMatrix; aFlag:integer);
    procedure Draw(Sender: TObject);
    procedure DrawRayUp;
    procedure DrawRayLow;
    procedure DrawUpperRay;
    procedure DrawLowerRay;

  public
    FinitRayPointX :  extended;
    FinitRayPointY :  extended;
    FinitRayPointZ :  extended;
  
  end;

var
  PlanForm: TPlanForm;
  {aFinalOpt: TOptSystem;}
implementation

{$R *.dfm}

procedure TPlanForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// Action:=caFree;
  PlanForm.Visible:=False;
end;

procedure TPlanForm.Initialize(Sender: TObject);
begin
  PlanStartPoint:=0;
  PlanStartPointY:=PlanPaintBox.Height div 2;
  PlanMagnification:=1;
  PlanRayAngle:=0;
  {aFinalOpt:=TOptSystem.Create;}
  FinitRayPointX:=OpticalSystem.ObjectDistance;
  FinitRayPointY :=0;
  FinitRayPointZ :=0;

  ScrollBar3.Position:=0;
  ScrollBar1.Position:=0;
  ScrollBar2.Position:=100;
  SpinEdit1.Value:=0;
  Edit5.Text:='0';

  RayNumber:=SpinEdit2.Value;
end;

procedure TPlanForm.ScrollBar1Change(Sender: TObject);
begin
  PlanStartPoint:=ScrollBar1.Position;
  Edit1.Text:=IntToStr(PlanStartPoint);
  Button1Click(Sender);
end;

procedure TPlanForm.ScrollBar2Change(Sender: TObject);
begin
  PlanMagnification:=ScrollBar2.Position/100;
  Edit2.Text:=FloatToStr(PlanMagnification);
  Button1Click(Sender);
end;

procedure TPlanForm.SpinEdit1Change(Sender: TObject);
begin
  PlanRayAngle:=SpinEdit1.Value;
end;

procedure TPlanForm.Rotation(var aX:longint; var aY:longint; var aZ:longint; aMatrix:TMatrix; aFlag:integer);
var
  aStockDataX, aStockDataY, aStockDataZ:longint;
begin

  aStockDataX:=aX;
  aStockDataY:=aY;
  aStockDataZ:=aZ;
  if aFlag=0 then begin
   aX:=trunc(aMatrix[1,1]*aStockDataX + aMatrix[1,2]*aStockDataY + aMatrix[1,3]*aStockDataZ);
   aY:=trunc(aMatrix[2,1]*aStockDataX + aMatrix[2,2]*aStockDataY + aMatrix[2,3]*aStockDataZ);
   aZ:=trunc(aMatrix[3,1]*aStockDataX + aMatrix[3,2]*aStockDataY + aMatrix[3,3]*aStockDataZ);
  end else begin
   aX:=trunc(aMatrix[1,1]*aStockDataX + aMatrix[2,1]*aStockDataY + aMatrix[3,1]*aStockDataZ);
   aY:=trunc(aMatrix[1,2]*aStockDataX + aMatrix[2,2]*aStockDataY + aMatrix[3,2]*aStockDataZ);
   aZ:=trunc(aMatrix[1,3]*aStockDataX + aMatrix[2,3]*aStockDataY + aMatrix[3,3]*aStockDataZ);
  end;

end;

procedure TPlanForm.Button1Click(Sender: TObject);
begin

   self.Draw(Sender);

  
end;

procedure TPlanForm.Draw(Sender: TObject);
var
  k, i, jj: integer;
  aStep, aC, aK, aDr, aC2: extended;
  aY, aZ, aX: extended;
  aN, aNn:extended;
  aSwell:extended;

  aBfl: longint;
  aTotalDistance:double;
  aTotalDistanceInt, aStockX,aStockY, aStockZ: longint;
  aMatrix: TMatrix;

  aPrincipalPoint, aObjectSidePrincipalPoint,
  anEntrancePupilPoint, anExitPupilPoint: longint;
begin

try
  aZ:=0;
  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if k<= OpticalSystem.TotalSurfaceNumber then begin
      aStep:=OpticalSystem.OpticalSurface[k].Diameter/MaxDivideNumber;
      aDr:=OpticalSystem.OpticalSurface[k].Diameter/2;
      aSwell:=OpticalSystem.OpticalSurface[k].Epsxyz(OpticalSystem.OpticalSurface[k].frenelZeroZorn,0);

      for i:=1 to SurfacePointNumber do begin
        aY:=aDr - aStep*(i-1);
        aSurfacePoint[k,i,'Y']:=trunc( aY*PlanMagnification );
        if OpticalSystem.OpticalSurface[k].frenelFlag=0 then begin
          aX:=OpticalSystem.OpticalSurface[k].Epsxyz(aY,aZ);
          aSurfacePoint[k,i,'X']:=trunc( aX *PlanMagnification  );
        end else begin

          if (OpticalSystem.OpticalSurface[k].frenelFlag=1)
              or (OpticalSystem.OpticalSurface[k].frenelFlag=2)
              or (OpticalSystem.OpticalSurface[k].frenelFlag=3)then begin
             if  abs(aY)<abs(OpticalSystem.OpticalSurface[k].frenelZeroZorn) then begin
               aX:=OpticalSystem.OpticalSurface[k].Epsxyz(aY,aZ);
               aSurfacePoint[k,i,'X']:=trunc( aX *PlanMagnification  );
             end else begin
               if aSwell>0 then begin
                 aX:=0;
               end else begin
                 aX:=aSwell;
               end;
               aSurfacePoint[k,i,'X']:=trunc( aX *PlanMagnification  );
             end;
          end;
          
        end;

        aSurfacePoint[k,i,'Z']:=0;
      end;
    end else begin
      aStep:=OpticalSystem.FocusPlane.Diameter/MaxDivideNumber;
      aDr:=OpticalSystem.FocusPlane.Diameter/2;
      for i:=1 to SurfacePointNumber do begin
        aY:=aDr - aStep*(i-1);
        aSurfacePoint[k,i,'Y']:=trunc( aY*PlanMagnification );

        aX:=OpticalSystem.FocusPlane.Epsxyz(aY,aZ); //*******2020/10/11
        aSurfacePoint[k,i,'X']:=trunc( aX *PlanMagnification  );

        aSurfacePoint[k,i,'Z']:=0;
      end;
    end;
  end;

  aBfl:=trunc( OpticalSystem.BackFocus[nd]*PlanMagnification );
  aTotalDistance:=0;
  aTotalDistanceInt:=0;
  aSurfacePeakPoint[1,'X']:=0;
  aSurfacePeakPoint[1,'Y']:=0;
  aSurfacePeakPoint[1,'Z']:=0;
  for k:=2 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if k<=OpticalSystem.TotalSurfaceNumber then begin
      aTotalDistance:=aTotalDistance+(OpticalSystem.OpticalMedium[k-1].Distance*PlanMagnification );
      aTotalDistanceInt:=trunc(aTotaldistance);    //UŉZĂ琮ɂȂƗݐό덷o2020/11/15
    end else begin
      aTotalDistance:=aTotalDistance+aBfl;
      aTotalDistanceInt:=trunc(aTotaldistance);
    end;
    aSurfacePeakPoint[k,'X']:=aTotalDistanceInt;
    aSurfacePeakPoint[k,'Y']:=0;
    aSurfacePeakPoint[k,'Z']:=0;
  end;

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    for i:=1 to SurfacePointNumber do begin
      aSurfacePoint[k,i,'X']:=aSurfacePoint[k,i,'X']+aSurfacePeakPoint[k,'X'];
      aSurfacePoint[k,i,'Y']:=aSurfacePoint[k,i,'Y']+aSurfacePeakPoint[k,'Y'];
      aSurfacePoint[k,i,'Z']:=aSurfacePoint[k,i,'Z']+aSurfacePeakPoint[k,'Z'];
    end;
  end;


// ****************************************************************************
  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if k<= OpticalSystem.TotalSurfaceNumber then begin
      if OpticalSystem.OpticalSurface[k].BiasSwitch=True then begin
        for i:=1 to SurfacePointNumber do begin
         aSurfacePoint[k,i,'Y']:=aSurfacePoint[k,i,'Y']
             + trunc(OpticalSystem.OpticalSurface[k].BiasSiftVector['Y']*PlanMagnification);
          aSurfacePoint[k,i,'X']:=aSurfacePoint[k,i,'X']
             + trunc(OpticalSystem.OpticalSurface[k].BiasSiftVector['X']*PlanMagnification);

        end;
      end;
    end else begin
      if OpticalSystem.FocusPlane.BiasSwitch=True then begin
        for i:=1 to SurfacePointNumber do begin
          aSurfacePoint[k,i,'Y']:=aSurfacePoint[k,i,'Y']
             + trunc(OpticalSystem.FocusPlane.BiasSiftVector['Y']*PlanMagnification);
          aSurfacePoint[k,i,'X']:=aSurfacePoint[k,i,'X']
             + trunc(OpticalSystem.FocusPlane.BiasSiftVector['X']*PlanMagnification);

        end;
      end;
    end;
  end;


  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    if k<= OpticalSystem.TotalSurfaceNumber then begin
      if OpticalSystem.OpticalSurface[k].BiasSwitch=True then begin
        for i:=1 to SurfacePointNumber do begin
          BiasMakeRotation( aMatrix, (OpticalSystem.OpticalSurface[k].PopBiasVector) );

          aStockX:=aSurfacePoint[k,CenterPoint,'X'];
          aStockY:=aSurfacePoint[k,CenterPoint,'Y'];
          aStockZ:=aSurfacePoint[k,CenterPoint,'Z'];

          aSurfacePoint[k,i,'X']:=aSurfacePoint[k,i,'X']-aStockX;
          aSurfacePoint[k,i,'Y']:=aSurfacePoint[k,i,'Y']-aStockY;
          aSurfacePoint[k,i,'Z']:=aSurfacePoint[k,i,'Z']-aStockZ;

          Rotation(aSurfacePoint[k,i,'X'],aSurfacePoint[k,i,'Y'],aSurfacePoint[k,i,'Z'],aMatrix,1);

          aSurfacePoint[k,i,'X']:=aSurfacePoint[k,i,'X']+aStockX;
          aSurfacePoint[k,i,'Y']:=aSurfacePoint[k,i,'Y']+aStockY;
          aSurfacePoint[k,i,'Z']:=aSurfacePoint[k,i,'Z']+aStockZ;

        end;
      end;
    end else begin
      if OpticalSystem.FocusPlane.BiasSwitch=True then begin
        for i:=1 to SurfacePointNumber do begin
          BiasMakeRotation( aMatrix, (OpticalSystem.FocusPlane.PopBiasVector) );

          aStockX:=aSurfacePoint[k,CenterPoint,'X'];
          aStockY:=aSurfacePoint[k,CenterPoint,'Y'];
          aStockZ:=aSurfacePoint[k,CenterPoint,'Z'];

          aSurfacePoint[k,i,'X']:=aSurfacePoint[k,i,'X']-aStockX;
          aSurfacePoint[k,i,'Y']:=aSurfacePoint[k,i,'Y']-aStockY;
          aSurfacePoint[k,i,'Z']:=aSurfacePoint[k,i,'Z']-aStockZ;;

          Rotation(aSurfacePoint[k,i,'X'],aSurfacePoint[k,i,'Y'],aSurfacePoint[k,i,'Z'],aMatrix,1);

          aSurfacePoint[k,i,'X']:=aSurfacePoint[k,i,'X']+aStockX;
          aSurfacePoint[k,i,'Y']:=aSurfacePoint[k,i,'Y']+aStockY;
          aSurfacePoint[k,i,'Z']:=aSurfacePoint[k,i,'Z']+aStockZ;

        end;
      end;
    end;
  end;

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].SiftSwitch=True then begin
      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
        for i:=1 to SurfacePointNumber do begin
          aSurfacePoint[jj,i,'X']:=aSurfacePoint[jj,i,'X']
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['X']*PlanMagnification);
          aSurfacePoint[jj,i,'Y']:=aSurfacePoint[jj,i,'Y']
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Y']*PlanMagnification);
          aSurfacePoint[jj,i,'Z']:=aSurfacePoint[jj,i,'Z']
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Z']*PlanMagnification);
        end;
      end;
    end;
  end else begin
    if OpticalSystem.FocusPlane.SiftSwitch=True then begin
      for i:=1 to SurfacePointNumber do begin
        aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'X']:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'X']
               +trunc(OpticalSystem.FocusPlane.SiftVector['X']*PlanMagnification);
        aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Y']:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Y']
               +trunc(OpticalSystem.FocusPlane.SiftVector['Y']*PlanMagnification);
        aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Z']:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Z']
               +trunc(OpticalSystem.FocusPlane.SiftVector['Z']*PlanMagnification);
      end;
    end;
  end;
  end;


  for k:=OpticalSystem.TotalSurfaceNumber+1 downto 1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].tiltSwitch=True then begin
      aStockX:=aSurfacePoint[k,CenterPoint,'X'];
      aStockY:=aSurfacePoint[k,CenterPoint,'Y'];
      aStockZ:=aSurfacePoint[k,CenterPoint,'Z'];
      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
        for i:=1 to SurfacePointNumber do begin
          aSurfacePoint[jj,i,'X']:=aSurfacePoint[jj,i,'X']-aStockX;
          aSurfacePoint[jj,i,'Y']:=aSurfacePoint[jj,i,'Y']-aStockY;
          aSurfacePoint[jj,i,'Z']:=aSurfacePoint[jj,i,'Z']-aStockZ;

          aMatrix:=OpticalSystem.OpticalSurface[k].popTiltMatrix;
          Rotation(aSurfacePoint[jj,i,'X'],aSurfacePoint[jj,i,'Y'],aSurfacePoint[jj,i,'Z'],aMatrix,1);

          aSurfacePoint[jj,i,'X']:=aSurfacePoint[jj,i,'X']+aStockX;
          aSurfacePoint[jj,i,'Y']:=aSurfacePoint[jj,i,'Y']+aStockY;
          aSurfacePoint[jj,i,'Z']:=aSurfacePoint[jj,i,'Z']+aStockZ;
        end;
      end;
    end;
  end else begin
    if OpticalSystem.FocusPlane.tiltSwitch=True then begin
      aStockX:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,CenterPoint,'X'];
      aStockY:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,CenterPoint,'Y'];
      aStockZ:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,CenterPoint,'Z'];
      for i:=1 to SurfacePointNumber do begin
        aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'X']:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'X']-aStockX;
        aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Y']:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Y']-aStockY;
        aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Z']:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Z']-aStockZ;

        aMatrix:=OpticalSystem.FocusPlane.popTiltMatrix;
        Rotation(aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'X'],aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Y'],aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Z'],aMatrix,1);

        aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'X']:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'X']+aStockX;
        aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Y']:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Y']+aStockY;
        aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Z']:=aSurfacePoint[OpticalSystem.TotalSurfaceNumber+1,i,'Z']+aStockZ;
      end;
    end;
  end;
  end;





  {*******************************************************************************}


  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    aSurfacePeakPointTilted[k,'X']:=aSurfacePoint[k,CenterPoint,'X'];
    aSurfacePeakPointTilted[k,'Y']:=aSurfacePoint[k,CenterPoint,'Y'];
    aSurfacePeakPointTilted[k,'Z']:=aSurfacePoint[k,CenterPoint,'Z'];
  end;

  PlanPaintBox.Canvas.Pen.Style:=psSolid;
  PlanPaintBox.Canvas.Pen.Color:=clGray;
  PlanPaintBox.Canvas.Rectangle(0,0,PlanPaintBox.width,PlanPaintBox.height);
  PlanPaintBox.Canvas.Pen.Color:=clSilver;
  PlanPaintBox.Canvas.MoveTo(0,PlanStartPointY);
  PlanPaintBox.Canvas.LineTo(PlanPaintBox.width,PlanStartPointY);

  PlanPaintBox.Canvas.Pen.Color:=clWhite;

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    PlanPaintBox.Canvas.MoveTo(PlanStartPoint + aSurfacePoint[k,1,'X'],PlanStartPointY - aSurfacePoint[k,1,'Y']);
    for i:=2 to SurfacePointNumber do begin
      PlanPaintBox.Canvas.LineTo(PlanStartPoint + aSurfacePoint[k,i,'X'],PlanStartPointY - aSurfacePoint[k,i,'Y']);
    end;
  end;
  for k:=1 to OpticalSystem.TotalSurfaceNumber-1 do begin
    aN:=OpticalSystem.OpticalMedium[k-1].refractiveindex[nd];
    aNn:=OpticalSystem.OpticalMedium[k].refractiveindex[nd];
    if ( (aN*aNn>0) and (aNn<>1) and (aNn<>-1 ) )then begin
      PlanPaintBox.Canvas.MoveTo(aSurfacePoint[k,1,'X']+PlanStartPoint,PlanStartPointY - aSurfacePoint[k,1,'Y']);
      PlanPaintBox.Canvas.LineTo(aSurfacePoint[k+1,1,'X']+PlanStartPoint,PlanStartPointY - aSurfacePoint[k+1,1,'Y']);
      PlanPaintBox.Canvas.MoveTo(aSurfacePoint[k,SurfacePointNumber,'X']+PlanStartPoint,PlanStartPointY - aSurfacePoint[k,SurfacePointNumber,'Y']);
      PlanPaintBox.Canvas.LineTo(aSurfacePoint[k+1,SurfacePointNumber,'X']+PlanStartPoint,PlanStartPointY - aSurfacePoint[k+1,SurfacePointNumber,'Y']);
    end;
  end;


  PlanPaintBox.Canvas.Pen.Color:=clSilver;
  for k:=1 to OpticalSystem.TotalSurfaceNumber do begin
    PlanPaintBox.Canvas.MoveTo(aSurfacePoint[k,CenterPoint,'X']+PlanStartPoint,PlanStartPointY - aSurfacePoint[k,CenterPoint,'Y'] );
    PlanPaintBox.Canvas.LineTo(aSurfacePoint[k+1,CenterPoint,'X']+PlanStartPoint,PlanStartPointY - aSurfacePoint[k+1,CenterPoint,'Y'] );
  end;

  PlanPaintBox.Canvas.Pen.Color:=clWhite;
  aPrincipalPoint:=PlanStartPoint + aSurfacePeakPoint[OpticalSystem.TotalSurfaceNumber,'X']
                   + trunc( (OpticalSystem.PrincipalPoint[nd])*PlanMagnification);
  aObjectSidePrincipalPoint:=PlanStartPoint + aSurfacePeakPoint[1,'X']
                   + trunc( (OpticalSystem.ObjectsidePrincipalPoint[nd])*PlanMagnification);
  anEntrancePupilPoint:=PlanStartPoint + aSurfacePeakPoint[1,'X']
                   + trunc( (OpticalSystem.EntrancePupil)*PlanMagnification);
  anExitPupilPoint:=PlanStartPoint + aSurfacePeakPoint[OpticalSystem.TotalSurfaceNumber,'X']
                   + trunc( (OpticalSystem.ExitPupil)*PlanMagnification);

  PlanPaintBox.Canvas.Pen.Color:=clRed;
  PlanPaintBox.Canvas.Pen.Style:=psDot;
  PlanPaintBox.Canvas.MoveTo(aPrincipalPoint,PlanStartPointY - 10);
  PlanPaintBox.Canvas.LineTo(aPrincipalPoint,PlanStartPointY + 10);

  PlanPaintBox.Canvas.Pen.Style:=psSolid;
  PlanPaintBox.Canvas.MoveTo(aObjectSidePrincipalPoint,PlanStartPointY - 10);
  PlanPaintBox.Canvas.LineTo(aObjectSidePrincipalPoint,PlanStartPointY + 10);

  PlanPaintBox.Canvas.Pen.Color:=clBlue;
  PlanPaintBox.Canvas.Pen.Style:=psSolid;
  PlanPaintBox.Canvas.MoveTo(anEntrancePupilPoint,PlanStartPointY - 10);
  PlanPaintBox.Canvas.LineTo(anEntrancePupilPoint,PlanStartPointY + 10);

  PlanPaintBox.Canvas.Pen.Style:=psDot;
  PlanPaintBox.Canvas.MoveTo(anExitPupilPoint,PlanStartPointY - 10);
  PlanPaintBox.Canvas.LineTo(anExitPupilPoint,PlanStartPointY + 10);

  PlanPaintBox.Canvas.Pen.Style:=psSolid;
  PlanPaintBox.Canvas.Pen.Color:=clWhite;

except

end;

self.Caption:='\}'+'/'+OpticalSystem.OpticalName;
end;

{*************************************************************************}

procedure TPlanForm.Button2Click(Sender: TObject);
begin
  DrawPrincipalRay;
//  DrawLowerRay;
 // DrawUpperRay;
  DrawRayUp;
  DrawRayLow;
end;

procedure TPlanForm.DrawRayLow;
var
  aRayStartX, aRayStartY, aStockX, aStockY: longint;
  aRayPointX: array[1..MaxOptSurface+1] of longint;
  aRayPointY: array[1..MaxOptSurface+1] of longint;
  aRayPointZ: array[1..MaxOptSurface+1] of longint;
  k,jj,g: integer;
  aRay, aFinalRay: TD3Ray;
  aObex,aObey,aObez,aTobe,aTobei,
  aY, aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW: extended;
  aMatrix: TMatrix;

begin
  aTanW:=Tan( DegreeToRadian(PlanRayAngle) );
  aRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;


  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


try
for g:=1 to RayNumber do begin
  aRay.initialize;

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;
    aY:=OpticalSystem.SearchLowerRay(aRay);
    aY:=aY - (aY/RayNUmber)*(g-1);
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
  end else begin
    aY:=OpticalSystem.SearchLowerRayInFinite(FinitRayPointX,FinitRayPointY,FinitRayPointZ);
    aY:=aY - (aY/RayNUmber)*(g-1);
    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
          aTobe:=-1*aTobe;
    aTobei:=1 / aTobe;
    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;
  end;

  OpticalSystem.RayTraceInAspherical(aRay,nd);

  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

  if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

  aSurfaceOrigin:=0;

  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;

    end;
    aRayPointX[k]:=trunc( (aRay.hxv[k]*PlanMagnification  + aSurfaceOrigin*PlanMagnification ) );
    aRayPointY[k]:=trunc( aRay.hyv[k]*PlanMagnification );
    aRayPointZ[k]:=trunc( aRay.hzv[k]*PlanMagnification );

  end;
  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;


  aFocusPointX:=aSurfaceOrigin + aBfl+ aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;


  aRayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*PlanMagnification );
  aRayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*PlanMagnification );
  aRayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*PlanMagnification );


  for k:=OpticalSystem.TotalSurfaceNumber+1 downto 1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].tiltSwitch=True then begin
      aMatrix:=OpticalSystem.OpticalSurface[k].popTiltMatrix;

      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
         aRayPointX[jj]:=aRayPointX[jj]-RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]-RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]-RayOriginZ[k];

         Rotation(aRayPointX[jj],aRayPointY[jj],aRayPointZ[jj],aMatrix,1);

         aRayPointX[jj]:=aRayPointX[jj]+RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]+RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]+RayOriginZ[k];

      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.TiltSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[ OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];

      aMatrix:=OpticalSystem.FocusPlane.popTiltMatrix;
      Rotation(aRayPointX[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointY[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointZ[OpticalSystem.TotalSurfaceNumber+1],aMatrix,1);

      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];
    end;
  end;
  end;

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].SiftSwitch=True then begin
      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
        aRayPointX[jj]:=aRayPointX[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['X']*PlanMagnification);
        aRayPointY[jj]:=aRayPointY[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Y']*PlanMagnification);
        aRayPointZ[jj]:=aRayPointZ[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Z']*PlanMagnification);
      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.SiftSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['X']*PlanMagnification);
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Y']*PlanMagnification);
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Z']*PlanMagnification);
    end;
  end;
  end;


  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    aRayPointX[k]:=PlanStartPoint + aRayPointX[k];
    aRayPointY[k]:=PlanStartPointY - aRayPointY[k];
    aRayPointZ[k]:=0;

  end;



  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    PlanPaintBox.Canvas.LineTo(aRayPointX[k],aRayPointY[k]);
  end;

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRayStartX:=aRayPointX[1] - 1000;
    aRayStartY:=aRayPointY[1] - trunc( 1000 * aTanW);
  end else begin
    aRayStartX:=trunc(FinitRayPointX*PlanMagnification)+PlanStartPoint;
    if aRayStartX<-20000 then aRayStartX:=-20000;
    aRayStartY:=PlanStartPointY - trunc(FinitRayPointY*PlanMagnification);
  end;

  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  PlanPaintBox.Canvas.LineTo(aRayStartX,aRayStartY);

end;

finally
aRay.free;
aFinalRay.free;

end;

end;


procedure TPlanForm.DrawRayUp;
var
  aRayStartX, aRayStartY, aStockX, aStockY: longint;
  aRayPointX: array[1..MaxOptSurface+1] of longint;
  aRayPointY: array[1..MaxOptSurface+1] of longint;
  aRayPointZ: array[1..MaxOptSurface+1] of longint;
  k,jj,g: integer;
  aRay, aFinalRay: TD3Ray;
  aObex,aObey,aObez,aTobe,aTobei,
  aY, aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW,aDistance: extended;
  aMatrix: TMatrix;

begin
  aTanW:=Tan( DegreeToRadian(PlanRayAngle) );
  aRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


try
for g:=1 to RayNumber do begin
  aRay.initialize;
  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;
    aY:=OpticalSystem.SearchUpperRay(aRay);
    aY:=aY - (aY/RayNumber)*(g-1);
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
  end else begin
    aY:=OpticalSystem.SearchUpperRayInFinite(FinitRayPointX,FinitRayPointY,FinitRayPointZ);
    aY:=aY - (aY/RayNumber)*(g-1);
    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
          aTobe:=-1*aTobe;
    aTobei:=1 / aTobe;
    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;
  end;

  OpticalSystem.RayTraceInAspherical(aRay,nd);

  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

  if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

   aSurfaceOrigin:=0;

  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;
    end;
    aRayPointX[k]:=trunc( (aRay.hxv[k]*PlanMagnification + aSurfaceOrigin*PlanMagnification) );
    aRayPointY[k]:=trunc( aRay.hyv[k]*PlanMagnification );
    aRayPointZ[k]:=trunc( aRay.hzv[k]*PlanMagnification );
  end;
  
  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;

  aFocusPointX:=aSurfaceOrigin + aBfl+ aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;

  aRayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*PlanMagnification );
  aRayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*PlanMagnification );
  aRayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*PlanMagnification );

  for k:=OpticalSystem.TotalSurfaceNumber+1 downto 1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].tiltSwitch=True then begin
      aMatrix:=OpticalSystem.OpticalSurface[k].popTiltMatrix;

      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
         aRayPointX[jj]:=aRayPointX[jj]-RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]-RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]-RayOriginZ[k];

         Rotation(aRayPointX[jj],aRayPointY[jj],aRayPointZ[jj],aMatrix,1);

         aRayPointX[jj]:=aRayPointX[jj]+RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]+RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]+RayOriginZ[k];

      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.TiltSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[ OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];

      aMatrix:=OpticalSystem.FocusPlane.popTiltMatrix;
      Rotation(aRayPointX[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointY[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointZ[OpticalSystem.TotalSurfaceNumber+1],aMatrix,1);

      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];
    end;
  end;
  end;

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].SiftSwitch=True then begin
      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
        aRayPointX[jj]:=aRayPointX[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['X']*PlanMagnification);
        aRayPointY[jj]:=aRayPointY[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Y']*PlanMagnification);
        aRayPointZ[jj]:=aRayPointZ[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Z']*PlanMagnification);
      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.SiftSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['X']*PlanMagnification);
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Y']*PlanMagnification);
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Z']*PlanMagnification);
    end;
  end;
  end;


  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    aRayPointX[k]:=PlanStartPoint + aRayPointX[k];
    aRayPointY[k]:=PlanStartPointY - aRayPointY[k];
    aRayPointZ[k]:=0;
  end;



  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    PlanPaintBox.Canvas.LineTo(aRayPointX[k],aRayPointY[k]);
  end;
  
  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRayStartX:=aRayPointX[1] - 1000;
    aRayStartY:=aRayPointY[1] - trunc( 1000 * aTanW);
  end else begin
    aRayStartX:=trunc(FinitRayPointX*PlanMagnification)+PlanStartPoint;
    if aRayStartX<-20000 then aRayStartX:=-20000;
    aRayStartY:=PlanStartPointY - trunc(FinitRayPointY*PlanMagnification);
  end;
  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  PlanPaintBox.Canvas.LineTo(aRayStartX,aRayStartY);

end;

finally
aRay.free;
aFinalRay.free;

end;

end;


procedure TPlanForm.DrawUpperRay;
var
  aRayStartX, aRayStartY, aStockX, aStockY: longint;
  aRayPointX: array[1..MaxOptSurface+1] of longint;
  aRayPointY: array[1..MaxOptSurface+1] of longint;
  aRayPointZ: array[1..MaxOptSurface+1] of longint;
  k,jj: integer;
  aRay, aFinalRay: TD3Ray;
  aObex,aObey,aObez,aTobe,aTobei,
  aY, aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW,aDistance: extended;
  aMatrix: TMatrix;

begin
  aTanW:=Tan( DegreeToRadian(PlanRayAngle) );
  aRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


try
  aRay.initialize;
  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;
    aY:=OpticalSystem.SearchUpperRay(aRay);
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
  end else begin
    aY:=OpticalSystem.SearchUpperRayInFinite(FinitRayPointX,FinitRayPointY,FinitRayPointZ);

    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
          aTobe:=-1*aTobe;
    aTobei:=1 / aTobe;
    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;
  end;

  OpticalSystem.RayTraceInAspherical(aRay,nd);

  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

  if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

   aSurfaceOrigin:=0;

  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;
    end;
    aRayPointX[k]:=trunc( (aRay.hxv[k]*PlanMagnification + aSurfaceOrigin*PlanMagnification) );
    aRayPointY[k]:=trunc( aRay.hyv[k]*PlanMagnification );
    aRayPointZ[k]:=trunc( aRay.hzv[k]*PlanMagnification );
  end;
  
  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;

  aFocusPointX:=aSurfaceOrigin + aBfl+ aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;

  aRayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*PlanMagnification );
  aRayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*PlanMagnification );
  aRayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*PlanMagnification );

  for k:=OpticalSystem.TotalSurfaceNumber+1 downto 1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].tiltSwitch=True then begin
      aMatrix:=OpticalSystem.OpticalSurface[k].popTiltMatrix;

      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
         aRayPointX[jj]:=aRayPointX[jj]-RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]-RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]-RayOriginZ[k];

         Rotation(aRayPointX[jj],aRayPointY[jj],aRayPointZ[jj],aMatrix,1);

         aRayPointX[jj]:=aRayPointX[jj]+RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]+RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]+RayOriginZ[k];

      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.TiltSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[ OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];

      aMatrix:=OpticalSystem.FocusPlane.popTiltMatrix;
      Rotation(aRayPointX[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointY[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointZ[OpticalSystem.TotalSurfaceNumber+1],aMatrix,1);

      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];
    end;
  end;
  end;

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].SiftSwitch=True then begin
      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
        aRayPointX[jj]:=aRayPointX[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['X']*PlanMagnification);
        aRayPointY[jj]:=aRayPointY[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Y']*PlanMagnification);
        aRayPointZ[jj]:=aRayPointZ[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Z']*PlanMagnification);
      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.SiftSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['X']*PlanMagnification);
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Y']*PlanMagnification);
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Z']*PlanMagnification);
    end;
  end;
  end;


  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    aRayPointX[k]:=PlanStartPoint + aRayPointX[k];
    aRayPointY[k]:=PlanStartPointY - aRayPointY[k];
    aRayPointZ[k]:=0;
  end;



  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    PlanPaintBox.Canvas.LineTo(aRayPointX[k],aRayPointY[k]);
  end;
  
  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRayStartX:=aRayPointX[1] - 1000;
    aRayStartY:=aRayPointY[1] - trunc( 1000 * aTanW);
  end else begin
    aRayStartX:=trunc(FinitRayPointX*PlanMagnification)+PlanStartPoint;
    if aRayStartX<-20000 then aRayStartX:=-20000;
    aRayStartY:=PlanStartPointY - trunc(FinitRayPointY*PlanMagnification);
  end;
  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  PlanPaintBox.Canvas.LineTo(aRayStartX,aRayStartY);



finally
aRay.free;
aFinalRay.free;

end;

end;


procedure TPlanForm.DrawLowerRay;
var
  aRayStartX, aRayStartY, aStockX, aStockY: longint;
  aRayPointX: array[1..MaxOptSurface+1] of longint;
  aRayPointY: array[1..MaxOptSurface+1] of longint;
  aRayPointZ: array[1..MaxOptSurface+1] of longint;
  k,jj: integer;
  aRay, aFinalRay: TD3Ray;
  aObex,aObey,aObez,aTobe,aTobei,
  aY, aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW: extended;
  aMatrix: TMatrix;

begin
  aTanW:=Tan( DegreeToRadian(PlanRayAngle) );
  aRay:=TD3Ray.create;
  aFinalRay:=TD3Ray.create;


  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;


try
  aRay.initialize;

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;
    aY:=OpticalSystem.SearchLowerRay(aRay);
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
  end else begin
    aY:=OpticalSystem.SearchLowerRayInFinite(FinitRayPointX,FinitRayPointY,FinitRayPointZ);

    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=0;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;
    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );
    if aObex<0 then
          aTobe:=-1*aTobe;
    aTobei:=1 / aTobe;
    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;
  end;

  OpticalSystem.RayTraceInAspherical(aRay,nd);

  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

  if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

  aSurfaceOrigin:=0;

  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;

    end;
    aRayPointX[k]:=trunc( (aRay.hxv[k]*PlanMagnification  + aSurfaceOrigin*PlanMagnification ) );
    aRayPointY[k]:=trunc( aRay.hyv[k]*PlanMagnification );
    aRayPointZ[k]:=trunc( aRay.hzv[k]*PlanMagnification );

  end;
  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;


  aFocusPointX:=aSurfaceOrigin + aBfl+ aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;


  aRayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*PlanMagnification );
  aRayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*PlanMagnification );
  aRayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*PlanMagnification );


  for k:=OpticalSystem.TotalSurfaceNumber+1 downto 1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].tiltSwitch=True then begin
      aMatrix:=OpticalSystem.OpticalSurface[k].popTiltMatrix;

      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
         aRayPointX[jj]:=aRayPointX[jj]-RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]-RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]-RayOriginZ[k];

         Rotation(aRayPointX[jj],aRayPointY[jj],aRayPointZ[jj],aMatrix,1);

         aRayPointX[jj]:=aRayPointX[jj]+RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]+RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]+RayOriginZ[k];

      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.TiltSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[ OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];

      aMatrix:=OpticalSystem.FocusPlane.popTiltMatrix;
      Rotation(aRayPointX[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointY[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointZ[OpticalSystem.TotalSurfaceNumber+1],aMatrix,1);

      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];
    end;
  end;
  end;

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].SiftSwitch=True then begin
      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
        aRayPointX[jj]:=aRayPointX[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['X']*PlanMagnification);
        aRayPointY[jj]:=aRayPointY[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Y']*PlanMagnification);
        aRayPointZ[jj]:=aRayPointZ[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Z']*PlanMagnification);
      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.SiftSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['X']*PlanMagnification);
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Y']*PlanMagnification);
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Z']*PlanMagnification);
    end;
  end;
  end;


  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    aRayPointX[k]:=PlanStartPoint + aRayPointX[k];
    aRayPointY[k]:=PlanStartPointY - aRayPointY[k];
    aRayPointZ[k]:=0;

  end;



  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    PlanPaintBox.Canvas.LineTo(aRayPointX[k],aRayPointY[k]);
  end;

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRayStartX:=aRayPointX[1] - 1000;
    aRayStartY:=aRayPointY[1] - trunc( 1000 * aTanW);
  end else begin
    aRayStartX:=trunc(FinitRayPointX*PlanMagnification)+PlanStartPoint;
    if aRayStartX<-20000 then aRayStartX:=-20000;
    aRayStartY:=PlanStartPointY - trunc(FinitRayPointY*PlanMagnification);
  end;

  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  PlanPaintBox.Canvas.LineTo(aRayStartX,aRayStartY);

finally
aRay.free;
aFinalRay.free;

end;

end;

procedure TPlanForm.DrawPrincipalRay;
var
  aRayStartX, aRayStartY, aStockX, aStockY: longint;
  aRayPointX: array[1..MaxOptSurface+1] of longint;
  aRayPointY: array[1..MaxOptSurface+1] of longint;
  aRayPointZ: array[1..MaxOptSurface+1] of longint;
  k,jj: integer;
  aRay, aFinalRay: TD3Ray;
  aObex,aObey,aObez,aTobe,aTobei,
  aY, aBfl, aFocusPointX, aFocusPointY,aFocusPointZ,aSurfaceOrigin, aTanW: extended;
  aMatrix: TMatrix;
begin
  PlanPaintBox.Canvas.Pen.Color:=clYellow;
  aTanW:=Tan( DegreeToRadian(PlanRayAngle) );
  aRay:=TD3Ray.create;

  aFinalRay:=TD3Ray.create;

  FinalOpt.Initialize;
  FinalOpt.TotalSurfaceNumber:=1;
  FinalOpt.TotalSpectruNumber:=1;
  FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] )*-1;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    FinalOpt.EntrancePupil:=(OpticalSystem.BackFocus[nd] );
  end;
  FinalOpt.OpticalSurface[1].CopyFrom(OpticalSystem.FocusPlane);
  FinalOpt.OpticalMedium[0].CopyFrom(OpticalSystem.OpticalMedium[OpticalSystem.totalSurfaceNumber]);
  FinalOpt.RayCheckSwitch:=False;

try
  aRay.initialize;
  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;
    aRay.dxi:=1 / ( sqrt( 1+(aTanW*aTanw) ) );
    aRay.dyi:=-1 * aRay.dxi*aTanW;
    aRay.dzi:=0;
    aRay.qntp:=OpticalSystem.EntrancePupil;

    OpticalSystem.CalculatePrincipalRay(aRay, PlanRayAngle);

    aRay.qntp:=OpticalSystem.EntrancePupil;

  end else begin

    aRay.qntp:=OpticalSystem.EntrancePupil;
    aRay.ax:=0;
    aRay.ay:=0;
    aRay.az:=0;

    aObex:=aRay.ax - (FinitRayPointX) + OpticalSystem.EntrancePupil;
    aObey:=aRay.ay - FinitRayPointY;
    aObez:=aRay.az - FinitRayPointZ;

    aTobe:=sqrt( aObex*aObex + aObey*aObey + aObez*aObez );

    if aObex<0 then
          aTobe:=-1*aTobe;

    aTobei:=1 / aTobe;

    aRay.dxi:=aObex * aTobei;
    aRay.dyi:=aObey * aTobei;
    aRay.dzi:=aObez * aTobei;

  end;

  OpticalSystem.RayTraceInAspherical(aRay,nd);

  aFinalRay.Initialize;
  aFinalRay.qntp:=FinalOpt.EntrancePupil;

  aFinalRay.ax:=aRay.ax;
  aFinalRay.ay:=aRay.ay;
  aFinalRay.az:=aRay.az;
  aFinalRay.dxi:=aRay.dxi;
  aFinalRay.dyi:=aRay.dyi;
  aFinalRay.dzi:=aRay.dzi;

  if aFinalRay.ay<>NULL then
    FinalOpt.RayTraceInAspherical(aFinalRay ,nd);

  aSurfaceOrigin:=0;
  RayOriginX[1]:=0;
  for k:=1 to OpticalSystem.TotalsurfaceNumber do begin
    if k>=2 then begin
      aSurfaceOrigin:=aSurfaceOrigin+OpticalSystem.OpticalMedium[k-1].Distance;
      RayOriginX[k]:=trunc(aSurfaceOrigin*PlanMagnification);
    end;
    aRayPointX[k]:=trunc( (aRay.hxv[k] + aSurfaceOrigin)*PlanMagnification );
    aRayPointY[k]:=trunc( aRay.hyv[k]*PlanMagnification );
    aRayPointZ[k]:=trunc( aRay.hzv[k]*PlanMagnification );

    RayOriginY[k]:=0;
    RayOriginZ[k]:=0;
  end;

  aBfl:=OpticalSystem.BackFocus[nd];
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]>0)
     and (OpticalSystem.BackFocus[nd]<0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;
  if( (OpticalSystem.OpticalMedium[opticalSystem.TotalSurfaceNumber].RefractiveIndex[nd]<0)
     and (OpticalSystem.BackFocus[nd]>0) )then begin
    aBfl:=OpticalSystem.BackFocus[nd]*-1;
  end;

  aFocusPointX:=aSurfaceOrigin + aBfl+ aFinalRay.ax;
  aFocusPointY:=aFinalRay.ay;
  aFocusPointZ:=aFinalRay.az;

  RayOriginX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( (aSurfaceOrigin + aBfl)*PlanMagnification );

  aRayPointX[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointX*PlanMagnification );
  aRayPointY[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointY*PlanMagnification );
  aRayPointZ[OpticalSystem.TotalsurfaceNumber+1]:=trunc( aFocusPointZ*PlanMagnification );

  RayOriginY[OpticalSystem.TotalsurfaceNumber+1]:=0;
  RayOriginZ[OpticalSystem.TotalsurfaceNumber+1]:=0;


  for k:=OpticalSystem.TotalSurfaceNumber+1 downto 1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].tiltSwitch=True then begin
      aMatrix:=OpticalSystem.OpticalSurface[k].popTiltMatrix;

      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
         aRayPointX[jj]:=aRayPointX[jj]-RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]-RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]-RayOriginZ[k];

         Rotation(aRayPointX[jj],aRayPointY[jj],aRayPointZ[jj],aMatrix,1);

         aRayPointX[jj]:=aRayPointX[jj]+RayOriginX[k];
         aRayPointY[jj]:=aRayPointY[jj]+RayOriginY[k];
         aRayPointZ[jj]:=aRayPointZ[jj]+RayOriginZ[k];

      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.TiltSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[ OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            -RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];

      aMatrix:=OpticalSystem.FocusPlane.popTiltMatrix;
      Rotation(aRayPointX[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointY[OpticalSystem.TotalSurfaceNumber+1],
               aRayPointZ[OpticalSystem.TotalSurfaceNumber+1],aMatrix,1);

      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginX[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginY[OpticalSystem.TotalSurfaceNumber+1];
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
            +RayOriginZ[OpticalSystem.TotalSurfaceNumber+1];
    end;
  end;
  end;

  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
  if k<=OpticalSystem.TotalSurfaceNumber then begin
    if OpticalSystem.OpticalSurface[k].SiftSwitch=True then begin
      for jj:=k to OpticalSystem.TotalSurfaceNumber+1 do begin
        aRayPointX[jj]:=aRayPointX[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['X']*PlanMagnification);
        aRayPointY[jj]:=aRayPointY[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Y']*PlanMagnification);
        aRayPointZ[jj]:=aRayPointZ[jj]
               +trunc(OpticalSystem.OpticalSurface[k].SiftVector['Z']*PlanMagnification);
      end;
    end;
  end else begin
    if OpticalSystem.focusPlane.SiftSwitch=True then begin
      aRayPointX[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointX[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['X']*PlanMagnification);
      aRayPointY[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointY[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Y']*PlanMagnification);
      aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]:=aRayPointZ[OpticalSystem.TotalSurfaceNumber+1]
               +trunc(OpticalSystem.FocusPlane.SiftVector['Z']*PlanMagnification);
    end;
  end;
  end;

  for k:=1 to OpticalSystem.TotalsurfaceNumber+1 do begin
    aRayPointX[k]:=PlanStartPoint + aRayPointX[k];
    aRayPointY[k]:=PlanStartPointY - aRayPointY[k];
    aRayPointZ[k]:=0;
  end;



  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  for k:=1 to OpticalSystem.TotalSurfaceNumber+1 do begin
    PlanPaintBox.Canvas.LineTo(aRayPointX[k],aRayPointY[k]);
  end;

  if OpticalSystem.ObjectDistance<=INFINITY then begin
    aRayStartX:=aRayPointX[1] - 1000;
    aRayStartY:=aRayPointY[1] - trunc( 1000 * aTanW);
  end else begin
    aRayStartX:=trunc(FinitRayPointX*PlanMagnification)+PlanStartPoint;
    if aRayStartX<-20000 then aRayStartX:=-20000;
    aRayStartY:=PlanStartPointY - trunc(FinitRayPointY*PlanMagnification);
  end;



  PlanPaintBox.Canvas.MoveTo(aRayPointX[1],aRayPointY[1]);
  PlanPaintBox.Canvas.LineTo(aRayStartX,aRayStartY);

finally
aRay.free;
aFinalRay.free;

PlanPaintBox.Canvas.Pen.Color:=clWhite;
end;

end;



procedure TPlanForm.ScrollBar3Change(Sender: TObject);
begin
  PlanStartPointY:=(PlanPaintBox.Height div 2) - ScrollBar3.Position;
  Button1Click(Sender);
end;

procedure TPlanForm.PlanPaintBoxMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  aPointX, aPointY:extended;
  aMouthPointX, aMouthPointY: integer;
begin
  aMouthPointX:=X - PlanStartPoint;
  aPointX:=aMouthPointX / PlanMagnification;
  Edit3.Text:=FloatToStr( aPointX );

  aMouthPointY:=PlanStartPointY - Y;
  aPointY:=aMouthPointY / PlanMagnification;
  Edit4.Text:=FloatToStr( aPointY );


end;


procedure TPlanForm.PlanPaintBoxPaint(Sender: TObject);
begin
   self.Draw(Sender);
end;

procedure TPlanForm.SpinButton1DownClick(Sender: TObject);
begin
   if (RayAngleDecimal=0) or (RayAngleDecimal<=0.9) then  begin
     RayAngleDecimal:=RayAngleDecimal-0.1;
     Edit5.text:=FloatToStr(RayAngleDecimal);
     PlanRayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if (RayAngleDecimal>0) and (RayAngleDecimal<0.1) then  begin
     RayAngleDecimal:=0.0;
     Edit5.text:=FloatToStr(RayAngleDecimal);
     PlanRayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if RayAngleDecimal<-0.9 then  begin
     RayAngleDecimal:=-0.9;
     Edit5.text:=FloatToStr(RayAngleDecimal);
     PlanRayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if (RayAngleDecimal<0) and (RayAngleDecimal>-0.1)then  begin
     RayAngleDecimal:=0.0;
     Edit5.text:=FloatToStr(RayAngleDecimal);
     PlanRayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
end;

procedure TPlanForm.SpinButton1UpClick(Sender: TObject);
begin
  if (RayAngleDecimal=0) or (RayAngleDecimal>=-0.9) then  begin
     RayAngleDecimal:=RayAngleDecimal+0.1;
     Edit5.text:=FloatToStr(RayAngleDecimal);
     PlanRayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if (RayAngleDecimal>0) and (RayAngleDecimal<0.1) then  begin
     RayAngleDecimal:=0.0;
     Edit5.text:=FloatToStr(RayAngleDecimal);
     PlanRayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if RayAngleDecimal>0.9 then  begin
     RayAngleDecimal:=0.9;
     Edit5.text:=FloatToStr(RayAngleDecimal);
     PlanRayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;
  if (RayAngleDecimal<0) and (RayAngleDecimal>-0.1)then  begin
     RayAngleDecimal:=0.0;
     Edit5.text:=FloatToStr(RayAngleDecimal);
     PlanRayAngle:=SpinEdit1.Value+RayAngleDecimal;
  end;


end;



procedure TPlanForm.SpinEdit2Change(Sender: TObject);
begin
  RayNumber:=SpinEdit2.Value;
end;

end.
