unit halting;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,Math;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Button1: TButton;
    Memo1: TMemo;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    nC1,nd1,nF1,nC2,nd2,nF2 :double;
    V1,V2 :double;
    Phai1,Phai2 :double;
    A,C,D,E,F :double;
    alpha, beta,gamma:double;
    U1Plus,U1Minus,U2Plus,U2Minus :double;
    r1,r2,r3,r4 :double;
    r1D,r2D,r3D,r4D :double;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.Button1Click(Sender: TObject);
begin

  nC1:=strToFloat(Edit1.Text);
  nd1:=strToFloat(Edit2.Text);
  nF1:=strToFloat(Edit3.Text);

  nC2:=strToFloat(Edit4.Text);
  nd2:=strToFloat(Edit5.Text);
  nF2:=strToFloat(Edit6.Text);

  V1:=(nd1-1)/(nF1-nC1);
  V2:=(nd2-1)/(nF2-nC2);

  Phai1:=V1/(V1-V2);
  Phai2:=V2/(V2-V1);

  A:=nd1*(nd1+2)/Phai1;
  C:=nd2*(nd2+2)/Phai2;
  D:=-2*nd1*Phai1;
  E:=-2*nd2*(2-Phai2);
  F:=sqr( nd1/(nd1-1) ) * Power(Phai1,3) + sqr( nd2/(nd2-1) ) * Power(Phai2,3);

  alpha:=sqr(nd1+1)*C + sqr(nd2+1)*A;
  beta:=sqr(nd1+1)*E - (nd1+1)*(nd2+1)*D - 2*(nd2+1)*A;
  gamma:=sqr(nd1+1)*F + (nd1+1)*D + A;

  U2Plus:= ( -1*beta+sqrt(beta*beta-4*alpha*gamma) ) / (2*alpha);
  U2Minus:=( -1*beta-sqrt(beta*beta-4*alpha*gamma) ) / (2*alpha);

  U1Plus:= ( 1-(nd2+1)*U2Plus  )/(nd1+1);
  U1Minus:=( 1-(nd2+1)*U2Minus )/(nd1+1);

  r1:=1/( (nd1/2)*( U1Plus/Phai1+Phai1/(nd1-1) ) );
  r2:=1/( (nd1/2)*( U1Plus/Phai1-Phai1/(nd1-1) )+Phai1 );
  r3:=1/( (nd2/2)*( U2Plus/Phai2+Phai2/(nd2-1) )+Phai1 );
  r4:=1/( (nd2/2)*( U2Plus/Phai2-Phai2/(nd2-1) )+1 );

  r1D:=1/( (nd1/2)*( U1Minus/Phai1+Phai1/(nd1-1) ) );
  r2D:=1/( (nd1/2)*( U1Minus/Phai1-Phai1/(nd1-1) )+Phai1 );
  r3D:=1/( (nd2/2)*( U2Minus/Phai2+Phai2/(nd2-1) )+Phai1 );
  r4D:=1/( (nd2/2)*( U2Minus/Phai2-Phai2/(nd2-1) )+1 );

  Memo1.Lines.Add('`');
  Memo1.Lines.add('r1=' + FloatToStr((r1)) );
  Memo1.Lines.Add('r2=' + FloatToStr((r2)) );
  Memo1.Lines.add('r3=' + FloatToStr((r3)) );
  Memo1.Lines.Add('r4=' + FloatToStr((r4)) );
  Memo1.Lines.Add(#13#10);
  
  Memo1.Lines.Add('a');
  Memo1.Lines.add('r1B=' + FloatToStr((r1D)));
  Memo1.Lines.Add('r2B=' + FloatToStr((r2D)));
  Memo1.Lines.add('r3B=' + FloatToStr((r3D)));
  Memo1.Lines.Add('r4B=' + FloatToStr((r4D)));
  Memo1.Lines.Add(#13#10);



end;

end.
