unit OptSystem;


interface

uses
  OptSurface,OptMedium,Ray,MayMath,Dialogs,SysUtils;

const
  NULL=1.23456789e4000; { NULL gpȂRay ax ay az  dxi dyi dzi ׂ̂ĂA
                   0.0  ɂ@łǂB}
  MaxSANumber=40;
  MaxAngleNumber=40;

type
  TCoefficientArray=array[1..3] of extended;
  TAnserArray=array[1..3] of extended;
  TCof=array[1..MaxOptSurface+1,1..7] of extended;
  TTtg=array[1..MaxOptSurface+1,1..2] of extended;
  TSA=array[nd..nt,1..MaxSANumber] of extended;
  TOSC=array[1..MaxSANumber] of extended;
  TMAS=array[1..MaxAngleNumber] of extended;
  TSAS=array[1..MaxAngleNumber] of extended;
  TDIS=array[1..MaxAngleNumber] of extended;
  TMAG=array[nd..nt,1..MaxAngleNumber] of extended;

  TOptSystem=class
  private
    FOpticalName         :Shortstring;
    FTotalSurfaceNumber  :TMaxOptSurfaceRange;
    FTotalSpectruNumber  :TMaxSpectruNumberRange;
    FOpticalSurface      :array[TMaxOptSurfaceRange] of TOpticalSurface;
    FOpticalMedium       :array[TMaxMediumNumberRange] of TOpticalMedium;
    FSpectruList         :array[TMaxSpectruNumberRange] of TSpectru;
    FFirstSpectru        :TSpectru;
    FLastSpectru         :Tspectru;
    FSpectruString       :array[TMaxSpectruNumberRange] of shortstring;{f[^\ɂȂ̂ŃNXϐɂȂĂ悢?}
    FEffectiveAperture   :extended;
    FStop                :TMaxOptSurfaceRange;
    FEntrancePupil       :extended;
    FExitPupil           :extended;

    FObjectPlane         :TOpticalSurface;
    FObjectDistance      :extended;
    FFocusPlaneDistance  :extended;
    FFocusPlane          :TOpticalSurface;

    FBackFocus           :TRefrectiveIndexArray;
    FObjectSideBackFocus :TRefrectiveIndexArray;
    FPrincipalPoint      :TRefrectiveIndexArray;
    FObjectSidePrincipalPoint             :TRefrectiveIndexArray;
    FFocalLength                          :TRefrectiveIndexArray;

    FBackFocusSagittaru                   :TRefrectiveIndexArray;
    FObjectSideBackFocusSagittaru         :TRefrectiveIndexArray;
    FPrincipalPointSagittaru              :TRefrectiveIndexArray;
    FObjectSidePrincipalPointSagittaru    :TRefrectiveIndexArray;
    FFocalLengthSagittaru                 :TRefrectiveIndexArray;

    FAfocalSwitch       :boolean;
    FSynmetrySwitch     :boolean;
    FMxsinSwitch        :boolean;
    FRayCheckSwitch     :boolean;
    FNaInputSwitch      :boolean;
    FFishEyeSwitch      :boolean;

    FCenterBrockSwitch  :boolean;         //t@Cł͕ۑAǂݍ݂Ȃ

    function GetTotalSurfaceNumber:TMaxOptSurfaceRange; virtual;
    procedure SetTotalSurfaceNumber(value:TMaxOptSurfaceRange); virtual;

    function GetOpticalSurface(index:TMaxOptSurfaceRange):TOpticalSurface;
    procedure SetOpticalSurface(index:TMaxOptSurfaceRange;surface:TopticalSurface);

    function GetOpticalMedium(index:TMaxMediumNumberRange):TOpticalMedium;
    procedure SetOpticalMedium(index:TMaxMediumNumberRange;medium:TOpticalMedium);

    function GetSpectruList(index:TMaxSpectruNumberRange):TSpectru;
    procedure SetSpectruList(index:TMaxSpectruNumberRange;value:TSpectru);

    function GetSpectruString(index:TMaxSpectruNumberRange):ShortString;
    procedure SetSpectruString(index:TMaxSpectruNumberRange;value:shortstring);

    function GetBackFocus(index:TSpectru):extended;
    procedure SetBackFocus(index:TSpectru; value:extended);

    function GetObjectSideBackFocus(index:TSpectru):extended;
    procedure SetObjectSideBackFocus(index:TSpectru; value:extended);

    function GetPrincipalPoint(index:TSpectru):extended;
    procedure SetPrincipalPoint(index:TSpectru; value:extended);

    function GetObjectSidePrincipalPoint(index:TSpectru):extended;
    procedure SetObjectSidePrincipalPoint(index:TSpectru; value:extended);

    function GetFocalLength(index:TSpectru):extended;
    procedure SetFocalLength(index:TSpectru; value:extended);

    function GetBackFocusSagittaru(index:TSpectru):extended;
    procedure SetBackFocusSagittaru(index:TSpectru; value:extended);

    function GetObjectSideBackFocusSagittaru(index:TSpectru):extended;
    procedure SetObjectSideBackFocusSagittaru(index:TSpectru; value:extended);

    function GetPrincipalPointSagittaru(index:TSpectru):extended;
    procedure SetPrincipalPointSagittaru(index:TSpectru; value:extended);

    function GetObjectSidePrincipalPointSagittaru(index:TSpectru):extended;
    procedure SetObjectSidePrincipalPointSagittaru(index:TSpectru; value:extended);

    function GetFocalLengthSagittaru(index:TSpectru):extended;
    procedure SetFocalLengthSagittaru(index:TSpectru; value:extended);

    function AsphericalTrace(var Ray:TD3Ray; color:TSpectru):boolean;{ 3.8 BTRACE }
    function SurfaceSpace(var Ray:TD3Ray; k:integer):boolean; { 3.87 BTRACE 64-70 }
    function ComputeVectorM(var Ray:TD3Ray; k:integer):boolean; { 3.8 BTRACE 71-85 }
    function AxisTiltSift(var Ray:TD3Ray; k:integer):boolean; { 3.13 AXSHTL }
    function AxisBiasStart(var Ray:TD3Ray; k:integer):boolean; { 3.14 HENSST }
    function FrlCylAspTransact(var Ray:TD3Ray; k:integer; color:TSpectru):boolean;
    function NormalizeVectorE(var Ray:TD3Ray; k:integer):boolean; { 3.8 BTRACE 180-185 }
    function IntersectionStock(var Ray:TD3Ray; k:integer):boolean; {3.8 BTRACE 187-193 }
    function Raycheck(var Ray:TD3Ray; k:integer):boolean; {3.8 BTRACE 194-198 }
    function OpticalPathLength(var Ray:TD3Ray; k:integer; color:TSpectru):boolean;{3.8 BTRACE 200-209 }
    function ComputeSinCos(var Ray:TD3Ray; k:integer; color:TSpectru):boolean;{ 3.8 BTRACE 210-226 }
    function StockDataRab(var Ray:TD3Ray; k:integer):boolean; {3.8 BTRACE 227-233}
    function ComputeVectorQ(var Ray:TD3Ray; k:integer):boolean; { 3.8 BTRACE 235-258 }
    function RefractionStock(var Ray:TD3Ray; k:integer):boolean; { 3.8 BTRACE 255-258 }
    function FrenelEnd(var Ray:TD3Ray; k:integer):boolean; { 3.19 FRNLED }
    function AxisBiasEnd(var Ray:TD3Ray; k:integer):boolean; { 3.15 HENSED }
    function FrenelStart(var Ray:TD3Ray; k:integer; color:TSpectru):boolean;{ 3.18 FRNST }
    function CylindoricalRensCof(var Ray:TD3Ray; k:integer):boolean; { 3.20 CYLCOF }
    function CylinderSurfaceIntersection(var Ray:TD3Ray; k:integer):boolean;{ 3.8 BTRACE 132-157 }
    function ApproximateIntersection(var Ray:TD3Ray; k:integer):boolean; { 3.22 KJNIPT }
    function AsphericalIntersectionPoint(var Ray:TD3Ray; k:integer):boolean;{ 3.24 ASPIPT }
    function ComputeIntersectionNormalCase(var Ray:TD3Ray; k:integer):boolean;{ 3.8 BTRACE 125-170 }
    function RoundCheck(var Ray:TD3Ray; k:integer):boolean;{ 3.9 RAYCHK }
    function RectCheck(var Ray:TD3Ray; k:integer):boolean;{ 3.10 SQPCHK }
    function OvalCheck(var Ray:TD3Ray; k:integer):boolean;{ 3.10 SQPCHK }
    function CylindoricalRensE(var Ray:TD3Ray; k:integer):boolean; { 3.21 CYLNOR }
    function AsphericalCompute(var Ray:TD3Ray; k:integer):boolean; { 3.25 ASPhCL }
    function ToricCompute(var Ray:TD3Ray; k:integer):boolean; { 3.26 TORIC }
    function HsaspCompute(var Ray:TD3Ray; k:integer):boolean; { 3.29 HSASP }
    function CaseEvenTerm(var Ray:TD3Ray; aVconic:extended; aY2z2:extended; aVbri:extended; k:integer ):extended;
          { 3.25 ASPHCL 50-77 }
    function CaseOddTerm(var Ray:TD3Ray; aVconic:extended; aY2z2:extended; aVbri:extended; k:integer ):extended;
         { 3.25 ASPHCL 78-111 }
    function SuccessiveApproximation(var Ray:TD3Ray; aXnd:extended; k:integer):boolean;{ 3.23 SUCAPR }
    function CaseOf3dAs(var Ray:TD3Ray; k:integer; anAlpha:extended):boolean;{ 3.18 FRNLST  137-162 }
    function Astigmatizum(var Ray:TD3Ray; k:integer):boolean; { 3.31 ASTNYU  }
    function AstigmatizumLast(var Ray:TD3Ray):boolean; { 3.32 ASTLST }
    function ComputRotRos(var Ray:TD3Ray; k:integer):boolean; { 3.30 CPROT }
    function AsTraceInMeridional(var Ray:TD3Ray):boolean; { 3.31 ASTNYU 42-50 }
    function AsTrace3d(var Ray:TD3Ray; k:integer):boolean; { 3.38 AST3D }
    function AsTrace3dLast(var Ray:TD3Ray):boolean;{ 3.42 AST3D2 }
    function CalculateDifferentialCoeffitient(var Ray:TD3Ray ):boolean; {3.38 AST3D 205-217 }
    function AsTraceDifferential(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.37 ASTPOW }
    function DiffFrenel(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.37 ASTPOW 48- }
    function DiffAspherical(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.33 BIBASP }
    function DiffCylinder(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.35  BIBCYL }
    function DiffHiOrder(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.36 HOSPOW }
    function CalculateRyiRzi(var Ray:TD3Ray; aT:TMatrix):boolean;{ 3.37 ASTPOW 78-91 }

    function ParAxialTraceSynmetry:boolean;
    function ParAxialTraceNotSynmetry:boolean;
    function ParAxialReverseTrace:boolean;
    function NonAberrationSurface(var Ray:TD3Ray; k:integer):boolean;
//    function ParAxialRverseTraceNotSynmetry:boolean;

{  function SearchUpperRay(a3DRay:TD3Ray):extended;
  function SearchLowerRay(a3DRay:TD3Ray):extended;  }
  {procedure CalculatePrincipalRay(var aRay:TD3Ray; anAngle:extended);}


  public

    property OpticalName         :Shortstring
                                 read FOpticalName write FOpticalName;
    property TotalSurfaceNumber  :TMaxOptSurfaceRange
                                 read GetTotalSurfaceNumber write SetTotalSurfaceNumber;
    property TotalSpectruNumber  :TMaxSpectruNumberRange
                                 read FTotalSpectruNumber write FTotalSpectruNumber;
    property OpticalSurface[index:TMaxOptSurfaceRange] :TOpticalSurface
                                 read GetOpticalSurface write SetOpticalSurface;
    property OpticalMedium[index: TMaxMediumNumberRange] : TOpticalMedium
                                 read GetOpticalMedium write SetOpticalMedium;
    property SpectruList[index: TMaxSpectruNumberRange] : TSpectru
                                 read GetSpectruList write SetSpectruList;
    property FirstSpectru        :TSpectru
                                 read FFirstSpectru write FFirstSpectru;
    property LastSpectru         :TSpectru
                                 read FLastSpectru write FLastSpectru;
    property SpectruString[index: TMaxSpectruNumberRange]: shortstring
                                 read GetSpectruString write SetSpectruString;
    property EffectiveAperture   :extended
                                 read FEffectiveAperture write FEffectiveAperture;
    property Stop                :TMaxOptSurfaceRange
                                 read FStop write FStop;
    property EntrancePupil       :extended
                                 read FEntrancePupil write FEntrancePupil;
    property ExitPupil           :extended
                                 read FExitPupil write FExitPupil ;
    property ObjectPlane         :TOpticalSurface
                                 read FObjectPlane write FObjectPlane;
    property ObjectDistance      :extended
                                 read FObjectDistance write FObjectDistance;
    property FocusPlaneDistance  :extended
                                 read FFocusPlaneDistance write FFocusPlaneDistance;
    property FocusPlane          :TOpticalSurface
                                 read FFocusPlane write FFocusPlane;
    property BackFocus[index: TSpectru]:extended
                                 read GetBackFocus write SetBackFocus;
    property ObjectSideBackFocus[index: TSpectru]:extended
                                 read GetObjectSideBackFocus write SetObjectSideBackFocus;
    property PrincipalPoint[index: TSpectru]:extended
                                 read GetPrincipalPoint write SetPrincipalPoint;
    property ObjectSidePrincipalPoint[index: TSpectru]:extended
                                 read GetObjectSidePrincipalPoint write SetObjectSidePrincipalPoint;
    property FocalLength[index: TSpectru]:extended
                                 read GetFocalLength write SetFocalLength;
    property BackFocusSagittaru[index: TSpectru]:extended
                                 read GetBackFocusSagittaru write SetBackFocusSagittaru;
    property ObjectSideBackFocusSagittaru[index: TSpectru]:extended
                                 read  GetObjectSideBackFocusSagittaru write  SetObjectSideBackFocusSagittaru;
    property PrincipalPointSagittaru[index: TSpectru]:extended
                                 read GetPrincipalPointSagittaru write SetPrincipalPointSagittaru;
    property ObjectSidePrincipalPointSagittaru[index: TSpectru]:extended
                                 read GetObjectSidePrincipalPointSagittaru write SetObjectSidePrincipalPointSagittaru;
    property FocalLengthSagittaru[index: TSpectru]:extended
                                 read GetFocalLengthSagittaru write SetFocalLengthSagittaru;
    property AfocalSwitch       :boolean
                                 read FAfocalSwitch write FAfocalSwitch;
    property SynmetrySwitch     :boolean
                                 read FSynmetrySwitch write FSynmetrySwitch;
    property MxsinSwitch        :boolean
                                 read FMxsinSwitch write FMxsinSwitch;
    property RayCheckSwitch     :boolean
                                 read FRayCheckSwitch write FRayCheckSwitch;
    property NaInputSwitch      :boolean
                                 read FNaInputSwitch write FNaInputSwitch;
    property FishEyeSwitch      :boolean
                                 read FFishEyeSwitch write FFishEyeSwitch;
    property CenterBrockSwitch :boolean
                                 read FCenterBrockSwitch write FCenterBrockSwitch;

    constructor Create; virtual;
    procedure Initialize; virtual;

    function SynmetrySerch:boolean;
    procedure OutputToFile(var OutputFile:file);
    procedure InputFromFile(var InputFile:file);
    procedure CopyFrom(aOpt:TOptSystem);
    procedure InputFromTextFile(var InputFile:Text);
    procedure OutputToTextFile(var OutputFile:Text);

    procedure CalculatePower;
    procedure CalculateExchangeDistance;
    procedure CulculateReverseHightAlphWith(var aRay:TParAxialRay);
    procedure CulculateHightAlphaWith(var aRay:TParAxialRay);
    procedure CalculateEffectiveAperture;
    procedure CalculateEntrancePupil(aFrontGroup:TOptSystem);
    procedure CalculateExitPupil(aRearGroup:TOptSystem);

    function ParAxialTrace(aOptSys:TOptSystem):boolean;
    procedure RayTraceInAspherical(var Ray:TD3Ray; Color:TSpectru);
    procedure ParAxialTraceNotSynmetryCase;
    procedure CalculatePupil;
    procedure Prus( PrusOpt:TOptSystem);

    function Search(aRay:TD3Ray; aSurface:integer; aNumber:extended):extended;
    function SearchUpperRay(a3DRay:TD3Ray):extended;
    function SearchLowerRay(a3DRay:TD3Ray):extended;
    procedure CalculatePrincipalRay(var aRay:TD3Ray; anAngle:extended);
    procedure CalculateSagitalRayPrus(var aRay:TD3Ray; anAngle:extended);
    function SearchLowerRayInFinite(aDistance:extended;aFinitRayY:extended;aFinitRayZ:extended):extended;
    function SearchUpperRayInFinite(aDistance:extended;aFinitRayY:extended;aFinitRayZ:extended):extended;
    function SurchSagittarRayPrusFinite(aFinitRayX:extended;aFinitRayY:extended;aFinitRayZ:extended):extended;
    function SurchSagittarRayMinusFinite(aFinitRayX:extended;aFinitRayY:extended;aFinitRayZ:extended):extended;

    procedure CaluculateWorldCoordinates(magnification:extended);
    procedure CaluculateWorldCoordinatesInReal;
    procedure ConvertWorldCoordinatesRealToInt(magnification:extended);


    procedure TransferVewCoordinates;
    procedure TransferInVewCoordinates(aX:integer; aY:integer; aZ:integer);
    procedure RotationInWorldCoordinates(Rx:extended; Ry:extended; Rz:extended);
    procedure CalculateSagitalRayMinus(var aRay:TD3Ray; anAngle:extended);
    Procedure CaluculateCoefficient( var Cof:TCof; var Ttg:TTtg);

    procedure CalculateSphericalAberration( var SA:TSA; var OSC:TOSC);
    procedure CalculateAS( var MAS:TMAS; var SAS:TSAS  ;InputAngle:extended );
    procedure CalculateDistortion( var DIS:TDIS; InputAngle:extended);
    procedure CalculateCromaticMagnification( var MAG: TMAG; InputAngle:extended);
    procedure Reverse;
  end;

  function Quad(var anAnserArray:TAnserArray; aCoefficientArray:TCoefficientArray; aFlagQuad:integer):boolean;
  function Cptrad(aVyoko:extended; aVtate:extended; aReverseFlag:integer):extended;
  function Pai2Change(aVrad:extended):extended;
  function Chengent(aVrad:extended; aB11i:extended; aB12i:extended; aB21i:extended; aB22i:extended):extended;

implementation


  function TOptSystem.GetTotalSurfaceNumber:TMaxOptSurfaceRange;
  begin
    result:=FTotalSurfaceNumber;
  end;

  procedure TOptSystem.SetTotalSurfaceNumber(value:TMaxOptSurfaceRange);
  begin
    FTotalsurfaceNumber:=Value;
  end;

  function TOptSystem.GetOpticalSurface(index:TMaxOptSurfaceRange):TOpticalSurface;
  begin
    result:=FOpticalSurface[index];
  end;

  function TOptSystem.GetOpticalMedium(index:TMaxMediumNumberRange):TOpticalMedium;
  begin
    result:=FOpticalMedium[index];
  end;

  function TOptSystem.GetSpectruList(index:TMaxSpectruNumberRange):TSpectru;
  begin
    result:=FSpectruList[index];
  end;

  function TOptSystem.GetSpectruString(index:TMaxSpectruNumberRange):shortString;
  begin
    result:=FSpectruString[index];
  end;

  procedure TOptSystem.SetOpticalSurface(index:TMaxOptSurfaceRange;surface:TopticalSurface);
  begin
    FOpticalSurface[index]:=surface;
  end;

  procedure TOptSystem.SetOpticalMedium(index:TMaxMediumNumberRange;medium:TOpticalMedium);
  begin
    FOpticalMedium[index]:=medium;
  end;

  procedure TOptSystem.SetSpectruList(index:TMaxSpectruNumberRange;value:TSpectru);
  begin
    FSpectruList[index]:=value;
  end;

  procedure TOptSystem.SetSpectruString(index:TMaxSpectruNumberRange;value:shortstring);
  begin
    FSpectruString[index]:=value;
  end;


  function TOptSystem.GetBackFocus(index:TSpectru):extended;
  begin
    result:=FBackFocus[index];
  end;

  procedure TOptSystem.SetBackFocus(index:TSpectru; value:extended);
  begin
    FBackFocus[index]:=value;
  end;

  function TOptSystem.GetObjectSideBackFocus(index:TSpectru):extended;
  begin
    result:=FObjectSideBackFocus[index];
  end;

  procedure TOptSystem.SetObjectSideBackFocus(index:TSpectru; value:extended);
  begin
    FObjectSideBackFocus[index]:=value;
  end;

  function TOptSystem.GetPrincipalPoint(index:TSpectru):extended;
  begin
    result:=FPrincipalPoint[index];
  end;

  procedure TOptSystem.SetPrincipalPoint(index:TSpectru; value:extended);
  begin
    FPrincipalPoint[index]:=value;
  end;

  function TOptSystem.GetObjectSidePrincipalPoint(index:TSpectru):extended;
  begin
    result:=FObjectsidePrincipalPoint[index];
  end;

  procedure TOptSystem.SetObjectSidePrincipalPoint(index:TSpectru; value:extended);
  begin
    FObjectsidePrincipalPoint[index]:=value;
  end;

  function TOptSystem.GetFocalLength(index:TSpectru):extended;
  begin
    result:=FFocalLength[index];
  end;

  procedure TOptSystem.SetFocalLength(index:TSpectru; value:extended);
  begin
    FFocalLength[index]:=value;
  end;

  function TOptSystem.GetBackFocusSagittaru(index:TSpectru):extended;
  begin
    result:=FBackFocusSagittaru[index];
  end;

  procedure TOptSystem.SetBackFocusSagittaru(index:TSpectru; value:extended);
  begin
    FBackFocusSagittaru[index]:=value;
  end;

  function TOptSystem.GetObjectSideBackFocusSagittaru(index:TSpectru):extended;
  begin
    result:=FObjectSideBackFocusSagittaru[index];
  end;

  procedure TOptSystem.SetObjectSideBackFocusSagittaru(index:TSpectru; value:extended);
  begin
    FObjectSideBackFocusSagittaru[index]:=value;
  end;

  function TOptSystem.GetPrincipalPointSagittaru(index:TSpectru):extended;
  begin
    result:=FPrincipalPointSagittaru[index];
  end;

  procedure TOptSystem.SetPrincipalPointSagittaru(index:TSpectru; value:extended);
  begin
    FPrincipalPointSagittaru[index]:=value;
  end;

  function TOptSystem.GetObjectSidePrincipalPointSagittaru(index:TSpectru):extended;
  begin
    result:=FObjectsidePrincipalPointSagittaru[index];
  end;

  procedure TOptSystem.SetObjectSidePrincipalPointSagittaru(index:TSpectru; value:extended);
  begin
    FObjectsidePrincipalPointSagittaru[index]:=value;
  end;

  function TOptSystem.GetFocalLengthSagittaru(index:TSpectru):extended;
  begin
    result:=FFocalLengthSagittaru[index];
  end;

  procedure TOptSystem.SetFocalLengthSagittaru(index:TSpectru; value:extended);
  begin
    FFocalLengthSagittaru[index]:=value;
  end;

  constructor TOptSystem.Create;
    var i:integer;
  begin
    inherited Create;

    for i:=1 to MaxOptSurface do
    begin
      OpticalSurface[i] := TOpticalSurface.Create;
    end;

    for i:=0 to (MaxOptSurface) do
    begin
      OpticalMedium[i] := TOpticalMedium.Create;
    end;

    ObjectPlane:=TOpticalSurface.Create;
    FocusPlane:=TOpticalSurface.Create;
  end;

  procedure TOptSystem.Initialize;
  var
    i:integer;
    n:TSpectru;
  begin
    OpticalName         :='OptName';
    TotalSurfaceNumber  :=MaxOptSurface;
    TotalSpectruNumber  :=MaxSpectruNumber;

    for i:=1 to TotalSurfaceNumber do
    begin
      OpticalSurface[i].Initialize;
    end;

    for i:=0 to (TotalSurfaceNumber) do
    begin
     OpticalMedium[i].Initialize;
    end;

    SpectruList[1]:=nd; SpectruList[2]:=nC; SpectruList[3]:=nF;
    SpectruList[4]:=ng; SpectruList[5]:=ne; SpectruList[6]:=nh;
    SpectruList[7]:=ni; SpectruList[8]:=nr; SpectruList[9]:=ns;
    SpectruList[10]:=nt;

    FirstSpectru:=nd;
    LastSpectru:=nt;

    SpectruString[1]:='nd'; SpectruString[2]:='nC'; SpectruString[3]:='nF';
    SpectruString[4]:='ng'; SpectruString[5]:='ne'; SpectruString[6]:='nh';
    SpectruString[7]:='ni'; SpectruString[8]:='nr'; SpectruString[9]:='ns';
    SpectruString[10]:='nt';

    EffectiveAperture   :=0.0;
    Stop                :=1;
    EntrancePupil       :=0.0;
    ExitPupil           :=0.0;

    ObjectPlane.Initialize;
    ObjectDistance      :=-1.0e100;
    FocusPlaneDistance  :=0.0;
    FocusPlane.Initialize;

    for n:=nd to nt do
    begin
      BackFocus[n]                            :=0.0;
      ObjectSideBackFocus[n]                  :=0.0;
      PrincipalPoint[n]                       :=0.0;
      ObjectSidePrincipalPoint[n]             :=0.0;
      FocalLength[n]                          :=0.0;

      BackFocusSagittaru[n]                   :=0.0;
      ObjectSideBackFocusSagittaru[n]         :=0.0;
      PrincipalPointSagittaru[n]              :=0.0;
      ObjectSidePrincipalPointSagittaru[n]    :=0.0;
      FocalLengthSagittaru[n]                 :=0.0;
    end;

    AfocalSwitch       :=False;
    SynmetrySwitch     :=False;
    MxsinSwitch        :=False;
    RayCheckSwitch     :=True;
    NaInputSwitch      :=False;
    FishEyeSwitch      :=False;
    CenterBrockSwitch   :=False;
  end;

  procedure TOptSystem.InputFromFile(var InputFile:file);
  var
    i:integer;
    n:TSpectru;
  begin

    BlockRead(InputFile, FOpticalName,         SizeOf(FOpticalName) );
    BlockRead(InputFile, FTotalSurfaceNumber,  SizeOf(FTotalSurfaceNumber) );
    BlockRead(InputFile, FTotalSpectruNumber,  SizeOf(FTotalSpectruNumber) );

    for i:=1 to TotalSurfaceNumber do
    begin
      OpticalSurface[i].InputFromFile(InputFile);
    end;

    for i:=0 to (TotalSurfaceNumber) do
    begin
     FOpticalMedium[i].InputFromFile(InputFile);
    end;

    for i:=1 to 10 do
    begin
    BlockRead(InputFile,FSpectruList[i], SizeOf(FSpectruList[i]) );
    end;

    BlockRead(InputFile, FFirstSpectru, SizeOf(FirstSpectru) );
    BlockRead(InputFile, FLastSpectru, SizeOf(FLastSpectru) );

    for i:=1 to MaxSpectruNumber do
    begin
    BlockRead(InputFile,FSpectruString[i], SizeOf(FSpectruString[i]) );
    end;

    BlockRead(InputFile, FEffectiveAperture,  SizeOf(FEffectiveAperture) );
    BlockRead(InputFile, FStop,  SizeOf(FStop) );
    BlockRead(InputFile, FEntrancePupil,  SizeOf(FEntrancePupil) );
    BlockRead(InputFile, FExitPupil,  SizeOf(FExitPupil  ) );

    FObjectPlane.InputFromFile(InputFile);
    BlockRead(InputFile, FObjectDistance,  SizeOf(FObjectDistance) );
    BlockRead(InputFile, FFocusPlaneDistance,  SizeOf(FFocusPlaneDistance) );
    FFocusPlane.InputFromFile(InputFile);

    for n:=nd to nt do
    begin
      BlockRead(InputFile, FBackFocus[n],  SizeOf(FBackFocus[n]) );
      BlockRead(InputFile, FObjectSideBackFocus[n] ,  SizeOf(FObjectSideBackFocus[n] ) );
      BlockRead(InputFile, FPrincipalPoint[n],  SizeOf(FPrincipalPoint[n]) );
      BlockRead(InputFile, FObjectSidePrincipalPoint[n],  SizeOf(FObjectSidePrincipalPoint[n]) );
      BlockRead(InputFile, FFocalLength[n],  SizeOf(FFocalLength[n]) );

      BlockRead(InputFile, FBackFocusSagittaru[n],  SizeOf(FBackFocusSagittaru[n]) );
      BlockRead(InputFile, FObjectSideBackFocusSagittaru[n],  SizeOf(FObjectSideBackFocusSagittaru[n]) );
      BlockRead(InputFile, FPrincipalPointSagittaru[n],  SizeOf(FPrincipalPointSagittaru[n]) );
      BlockRead(InputFile, FObjectSidePrincipalPointSagittaru[n],  SizeOf(FObjectSidePrincipalPointSagittaru[n]) );
      BlockRead(InputFile, FFocalLengthSagittaru[n],  SizeOf(FFocalLengthSagittaru[n]) );
    end;

    BlockRead(InputFile, FAfocalSwitch ,  SizeOf(FAfocalSwitch ) );
    BlockRead(InputFile, FSynmetrySwitch,  SizeOf(FSynmetrySwitch) );
    BlockRead(InputFile, FMxsinSwitch,  SizeOf(FMxsinSwitch) );
    BlockRead(InputFile, FRayCheckSwitch,  SizeOf(FRayCheckSwitch) );
    BlockRead(InputFile, FNaInputSwitch,  SizeOf(FNaInputSwitch) );
    BlockRead(InputFile, FFishEyeSwitch,  SizeOf(FFishEyeSwitch) );

  end;

  procedure TOptSystem.InputFromTextFile(var InputFile:Text);
  var
    i:integer;
    n:TSpectru;
    s:shortString;
  begin

    Readln(InputFile, FOpticalName);
    Readln(InputFile, FTotalSurfaceNumber);
    Readln(InputFile, FTotalSpectruNumber);

    for i:=1 to TotalSurfaceNumber do
    begin
      OpticalSurface[i].InputFromTextFile(InputFile);
    end;

    for i:=0 to (TotalSurfaceNumber) do
    begin
     FOpticalMedium[i].InputFromTextFile(InputFile);
    end;

    Readln(InputFile,s);
    if (s='nd') then
      FFirstSpectru:=nd
      else if (s='nC') then
        FFirstSpectru:=nC
        else if (s='nF') then
          FFirstSpectru:=nF
          else if (s='ng') then
           FFirstSpectru:=ng
            else if (s='ne') then
              FFirstSpectru:=ne
              else if (s='nh') then
                FFirstSpectru:=nh
                else if (s='ni') then
                  FFirstSpectru:=ni
                  else if (s='nr') then
                    FFirstSpectru:=nr
                    else if (s='ns') then
                      FFirstSpectru:=ns
                      else if (s='nt') then
                        FFirstSpectru:=nt;

    Readln(InputFile,s);
    if (s='nd') then
      FLastSpectru:=nd
      else if (s='nC') then
        FLastSpectru:=nC
        else if (s='nF') then
          FLastSpectru:=nF
          else if (s='ng') then
           FLastSpectru:=ng
            else if (s='ne') then
              FLastSpectru:=ne
              else if (s='nh') then
                FLastSpectru:=nh
                else if (s='ni') then
                  FLastSpectru:=ni
                  else if (s='nr') then
                    FLastSpectru:=nr
                    else if (s='ns') then
                      FLastSpectru:=ns
                      else if (s='nt') then
                        FLastSpectru:=nt;

    for i:=1 to MaxSpectruNumber do
    begin
    Readln(InputFile,FSpectruString[i]);
    end;

    Readln(InputFile, FEffectiveAperture);
    Readln(InputFile, FStop);
    Readln(InputFile, FEntrancePupil);
    Readln(InputFile, FExitPupil);

    FObjectPlane.InputFromTextFile(InputFile);
    Readln(InputFile, FObjectDistance);
    Readln(InputFile, FFocusPlaneDistance);
    FFocusPlane.InputFromTextFile(InputFile);

    for n:=nd to nt do
    begin
      Readln(InputFile, FBackFocus[n]);
      Readln(InputFile, FObjectSideBackFocus[n] );
      Readln(InputFile, FPrincipalPoint[n]);
      Readln(InputFile, FObjectSidePrincipalPoint[n]);
      Readln(InputFile, FFocalLength[n]);

      Readln(InputFile, FBackFocusSagittaru[n]);
      Readln(InputFile, FObjectSideBackFocusSagittaru[n]);
      Readln(InputFile, FPrincipalPointSagittaru[n]);
      Readln(InputFile, FObjectSidePrincipalPointSagittaru[n]);
      Readln(InputFile, FFocalLengthSagittaru[n] );
    end;

    Readln(InputFile,s);
      if (s='FALSE') then
        FAfocalSwitch:=False
        else
          FAfocalSwitch:=True;

    Readln(InputFile,s);
      if (s='FALSE') then
        FSynmetrySwitch:=False
        else
          FSynmetrySwitch:=True;

    Readln(InputFile,s);
      if (s='FALSE') then
        FMxsinSwitch:=False
        else
          FMxsinSwitch:=True;

    Readln(InputFile,s);
      if (s='FALSE') then
        FRayCheckSwitch:=False
        else
          FRayCheckSwitch:=True;

    Readln(InputFile,s);
      if (s='FALSE') then
        FNaInputSwitch:=False
        else
          FNaInputSwitch:=True;

    Readln(InputFile,s);
      if (s='FALSE') then
        FFishEyeSwitch:=False
        else
          FFishEyeSwitch:=True;

  end;



  procedure TOptSystem.OutputToFile(var OutputFile:file);
  var
    i:integer;
    n:TSpectru;
  begin

    BlockWrite(OutputFile, FOpticalName,         SizeOf(FOpticalName) );
    BlockWrite(OutputFile, FTotalSurfaceNumber,  SizeOf(FTotalSurfaceNumber) );
    BlockWrite(OutputFile, FTotalSpectruNumber,  SizeOf(FTotalSpectruNumber) );

    for i:=1 to TotalSurfaceNumber do
    begin
      FOpticalSurface[i].OutputToFile(OutputFile);
    end;

    for i:=0 to (TotalSurfaceNumber) do
    begin
     FOpticalMedium[i].OutputToFile(OutputFile);
    end;

    for i:=1 to 10 do
    begin
    BlockWrite(OutputFile,FSpectruList[i], SizeOf(FSpectruList[i]) );
    end;


    BlockWrite(OutputFile, FFirstSpectru, SizeOf(FFirstSpectru) );
    BlockWrite(OutputFile, FLastSpectru, SizeOf(FLastSpectru) );

    for i:=1 to MaxSpectruNumber do
    begin
    BlockWrite(OutputFile,FSpectruString[i], SizeOf(FSpectruString[i]) );
    end;

    BlockWrite(OutputFile, FEffectiveAperture,  SizeOf(FEffectiveAperture) );
    BlockWrite(OutputFile, FStop,  SizeOf(FStop) );
    BlockWrite(OutputFile, FEntrancePupil,  SizeOf(FEntrancePupil) );
    BlockWrite(OutputFile, FExitPupil,  SizeOf(FExitPupil  ) );

    FObjectPlane.OutputToFile(OutputFile);
    BlockWrite(OutputFile, FObjectDistance,  SizeOf(FObjectDistance) );
    BlockWrite(OutputFile, FocusPlaneDistance,  SizeOf(FFocusPlaneDistance) );
    FFocusPlane.OutputToFile(OutputFile);

    for n:=nd to nt do
    begin
      BlockWrite(OutputFile, FBackFocus[n],  SizeOf(FBackFocus[n]) );
      BlockWrite(OutputFile, FObjectSideBackFocus[n] ,  SizeOf(FObjectSideBackFocus[n] ) );
      BlockWrite(OutputFile, FPrincipalPoint[n],  SizeOf(FPrincipalPoint[n]) );
      BlockWrite(OutputFile, FObjectSidePrincipalPoint[n],  SizeOf(FObjectSidePrincipalPoint[n]) );
      BlockWrite(OutputFile, FFocalLength[n],  SizeOf(FFocalLength[n]) );

      BlockWrite(OutputFile, FBackFocusSagittaru[n],  SizeOf(FBackFocusSagittaru[n]) );
      BlockWrite(OutputFile, FObjectSideBackFocusSagittaru[n],  SizeOf(FObjectSideBackFocusSagittaru[n]) );
      BlockWrite(OutputFile, FPrincipalPointSagittaru[n],  SizeOf(FPrincipalPointSagittaru[n]) );
      BlockWrite(OutputFile, FObjectSidePrincipalPointSagittaru[n],  SizeOf(FObjectSidePrincipalPointSagittaru[n]) );
      BlockWrite(OutputFile, FFocalLengthSagittaru[n],  SizeOf(FFocalLengthSagittaru[n]) );
    end;

    BlockWrite(OutputFile, FAfocalSwitch ,  SizeOf(FAfocalSwitch ) );
    BlockWrite(OutputFile, FSynmetrySwitch,  SizeOf(FSynmetrySwitch) );
    BlockWrite(OutputFile, FMxsinSwitch,  SizeOf(FMxsinSwitch) );
    BlockWrite(OutputFile, FRayCheckSwitch,  SizeOf(FRayCheckSwitch) );
    BlockWrite(OutputFile, FNaInputSwitch,  SizeOf(FNaInputSwitch) );
    BlockWrite(OutputFile, FFishEyeSwitch,  SizeOf(FFishEyeSwitch) );

  end;

  procedure TOptSystem.OutputToTextFile(var OutputFile:Text);
  var
    i:integer;
    n:TSpectru;
  begin

    Writeln(OutputFile, FOpticalName);
    Writeln(OutputFile, FTotalSurfaceNumber);
    Writeln(OutputFile, FTotalSpectruNumber);

    for i:=1 to TotalSurfaceNumber do
    begin
      OpticalSurface[i].OutputToTextFile(OutputFile);
    end;

    for i:=0 to (TotalSurfaceNumber) do
    begin
     FOpticalMedium[i].OutputToTextFile(OutputFile);
    end;


    if (FFirstSpectru=nd) then
      Writeln(OutputFile,'nd')
      else if (FFirstSpectru=nC) then
        Writeln(OutputFile,'nC')
        else if (FFirstSpectru=nF) then
          Writeln(OutputFile,'nF')
          else if (FFirstSpectru=ng) then
           Writeln(OutputFile,'ng')
            else if (FFirstSpectru=ne) then
              Writeln(OutputFile,'ne')
              else if (FFirstSpectru=nh) then
                Writeln(OutputFile,'nh')
                else if (FFirstSpectru=ni) then
                  Writeln(OutputFile,'ni')
                  else if (FFirstSpectru=nr) then
                    Writeln(OutputFile,'nr')
                    else if (FFirstSpectru=ns) then
                      Writeln(OutputFile,'ns')
                      else if (FFirstSpectru=nt) then
                        Writeln(OutputFile,'nt');

    if (FLastSpectru=nd) then
      Writeln(OutputFile,'nd')
      else if (FLastSpectru=nC) then
        Writeln(OutputFile,'nC')
        else if (FLastSpectru=nF) then
          Writeln(OutputFile,'nF')
          else if (FLastSpectru=ng) then
           Writeln(OutputFile,'ng')
            else if (FLastSpectru=ne) then
              Writeln(OutputFile,'ne')
              else if (FLastSpectru=nh) then
                Writeln(OutputFile,'nh')
                else if (FLastSpectru=ni) then
                  Writeln(OutputFile,'ni')
                  else if (FLastSpectru=nr) then
                    Writeln(OutputFile,'nr')
                    else if (FLastSpectru=ns) then
                      Writeln(OutputFile,'ns')
                      else if (FLastSpectru=nt) then
                        Writeln(OutputFile,'nt');

    for i:=1 to MaxSpectruNumber do
    begin
    Writeln(OutputFile,FSpectruString[i]);
    end;

    Writeln(OutputFile, FEffectiveAperture);
    Writeln(OutputFile, FStop);
    Writeln(OutputFile, FEntrancePupil);
    Writeln(OutputFile, FExitPupil);

    FObjectPlane.OutputToTextFile(OutputFile);
    Writeln(OutputFile, FObjectDistance);
    Writeln(OutputFile, FFocusPlaneDistance);
    FFocusPlane.OutputToTextFile(OutputFile);

    for n:=nd to nt do
    begin
      Writeln(OutputFile, FBackFocus[n]);
      Writeln(OutputFile, FObjectSideBackFocus[n] );
      Writeln(OutputFile, FPrincipalPoint[n]);
      Writeln(OutputFile, FObjectSidePrincipalPoint[n]);
      Writeln(OutputFile, FFocalLength[n]);

      Writeln(OutputFile, FBackFocusSagittaru[n]);
      Writeln(OutputFile, FObjectSideBackFocusSagittaru[n]);
      Writeln(OutputFile, FPrincipalPointSagittaru[n]);
      Writeln(OutputFile, FObjectSidePrincipalPointSagittaru[n]);
      Writeln(OutputFile, FFocalLengthSagittaru[n] );
    end;

    Writeln(OutputFile,FAfocalSwitch);

    Writeln(OutputFile,FSynmetrySwitch);

    Writeln(OutputFile,FMxsinSwitch);

    Writeln(OutputFile, FRayCheckSwitch);

    Writeln(OutputFile,FNaInputSwitch);

    Writeln(OutputFile,FFishEyeSwitch);

  end;




  function TOptSystem.SynmetrySerch:boolean;
  var Surface:TOpticalSurface;
      CoAxialIs:boolean;
      k:integer;
  begin

    CoAxialIs:=False;
    for k:=0 to (TotalSurfaceNumber+1) do begin
      if k=0 then
        Surface:=ObjectPlane
        else if k>(TotalSurfaceNumber) then
          Surface:=FocusPlane
          else
            Surface:=OpticalSurface[k];

      if ( (Surface.TiltSwitch=False) and (Surface.SiftSwitch=False)
          and (Surface.BiasSwitch=False){ and (Surface.CylinderFlag=0)} )=True then
          CoAxialIs:=False
        else CoAxialIs:=True;

      if CoAxialIs=True then
        break;
    end;

    result:=CoAxialIs;

  end;

procedure TOptSystem.Reverse;
 var
    aStockOpt:TOptSystem;
    i:integer;

 begin
   aStockOpt:=TOptSystem.Create;
   aStockOpt.Initialize;
   aStockOpt.CopyFrom(self);

   for i:=1 to TotalSurfaceNumber do begin
     self.OpticalSurface[i].CopyFrom(aStockOpt.OpticalSurface[(TotalSurfaceNumber-(i-1))]);
   end;

   for i:=1 to TotalSurfaceNumber do begin
     self.OpticalSurface[i].Curvature:=self.OpticalSurface[i].Curvature*-1;
   end;
    for i:=1 to TotalSurfaceNumber do begin
     self.OpticalSurface[i].Radius:=self.OpticalSurface[i].Radius*-1;
   end;

   for i:=0 to TotalSurfaceNumber do begin
     self.OpticalMedium[i].CopyFrom(aStockOpt.OpticalMedium[(TotalSurfaceNumber-i)]);
   end;

   aStockOpt.Free;
 end;

procedure TOptSystem.CopyFrom(aOpt:TOptSystem);
 var
    i:integer;
    n:TSpectru;
  begin
    OpticalName         :=aOpt.OpticalName;
    TotalSurfaceNumber  :=aOpt.TotalSurfaceNumber;
    TotalSpectruNumber  :=aOpt.TotalSpectruNumber;

    for i:=1 to MaxOptSurface do
    begin
      OpticalSurface[i].CopyFrom(aOpt.OpticalSurface[i]);
    end;

    for i:=0 to (MaxOptSurface) do
    begin
     OpticalMedium[i].CopyFrom(aOpt.OpticalMedium[i]);
    end;

    SpectruList[1]:=aOpt.SpectruList[1];
    SpectruList[2]:=aOpt.SpectruList[2];
    SpectruList[3]:=aOpt.SpectruList[3];
    SpectruList[4]:=aOpt.SpectruList[4];
    SpectruList[5]:=aOpt.SpectruList[5];
    SpectruList[6]:=aOpt.SpectruList[6];
    SpectruList[7]:=aOpt.SpectruList[7];
    SpectruList[8]:=aOpt.SpectruList[8];
    SpectruList[9]:=aOpt.SpectruList[9];
    SpectruList[10]:=aOpt.SpectruList[10];

    FirstSpectru:=aOpt.FirstSpectru;
    LastSpectru:=aOpt.LastSpectru;

    SpectruString[1]:=aOpt.SpectruString[1];
    SpectruString[2]:=aOpt.SpectruString[2];
    SpectruString[3]:=aOpt.SpectruString[3];
    SpectruString[4]:=aOpt.SpectruString[4];
    SpectruString[5]:=aOpt.SpectruString[5];
    SpectruString[6]:=aOpt.SpectruString[6];
    SpectruString[7]:=aOpt.SpectruString[7];
    SpectruString[8]:=aOpt.SpectruString[8];
    SpectruString[9]:=aOpt.SpectruString[9];
    SpectruString[10]:=aOpt.SpectruString[10];

    EffectiveAperture   :=aOpt.EffectiveAperture;
    Stop                :=aOpt.Stop;
    EntrancePupil       :=aOpt.EntrancePupil;
    ExitPupil           :=aOpt.ExitPupil;

    ObjectPlane.CopyFrom(aOpt.ObjectPlane);
    ObjectDistance      :=aOpt.ObjectDistance;
    FocusPlaneDistance  :=aOpt.FocusPlaneDistance;
    FocusPlane.CopyFrom(aOpt.FocusPlane);

    for n:=nd to nt do
    begin
      BackFocus[n]                            :=aOpt.BackFocus[n]  ;
      ObjectSideBackFocus[n]                  :=aOpt.ObjectSideBackFocus[n] ;
      PrincipalPoint[n]                       :=aOpt.PrincipalPoint[n]  ;
      ObjectSidePrincipalPoint[n]             :=aOpt.ObjectSidePrincipalPoint[n];
      FocalLength[n]                          :=aOpt.FocalLength[n];

      BackFocusSagittaru[n]                   :=aOpt.BackFocusSagittaru[n];
      ObjectSideBackFocusSagittaru[n]         :=aOpt.ObjectSideBackFocusSagittaru[n];
      PrincipalPointSagittaru[n]              :=aOpt.PrincipalPointSagittaru[n];
      ObjectSidePrincipalPointSagittaru[n]    :=aOpt.ObjectSidePrincipalPointSagittaru[n];
      FocalLengthSagittaru[n]                 :=aOpt.FocalLengthSagittaru[n] ;
    end;

    AfocalSwitch       :=aOpt.AfocalSwitch;
    SynmetrySwitch     :=aOpt.SynmetrySwitch;
    MxsinSwitch        :=aOpt.MxsinSwitch;
    RayCheckSwitch     :=aOpt.RayCheckSwitch;
    NaInputSwitch      :=aOpt.NaInputSwitch;
    FishEyeSwitch      :=aOpt.FishEyeSwitch;

  end;


{ ************* Raytrace ******************}

procedure TOptSystem.CalculatePower;
var
  aN,aNN:extended;
  k:integer;
  i:TSpectru;
begin
  for k:=1 to TotalSurfaceNumber do begin
    for i:=nd to LastSpectru do begin
      aN:= OpticalMedium[k-1].RefractiveIndex[i];
      aNN:=OpticalMedium[k].RefractiveIndex[i];
      OpticalSurface[k].CalculatePower(aN,aNN,i);
    end;
  end;
end;

procedure TOptSystem.CalculateExchangeDistance;
var
  aN:extended;
  k:integer;
  i:TSpectru;
begin
  for k:=1 to TotalSurfaceNumber do begin
     for i:=nd to LastSpectru do begin
       aN:=OpticalMedium[k-1].RefractiveIndex[i];
       OpticalMedium[k-1].CalculateExchangeDistance(aN, i);
     end;
  end;
end;

function TOptSystem.ParAxialTrace(aOptSys:TOptSystem):boolean;
begin
  self.CalculatePower;
  self.CalculateExchangeDistance;
  
  if self.ParAxialTraceSynmetry=false then begin
    result:=false;
    exit;
  end;

  if self.ParAxialReverseTrace=false then begin
    result:=false;
    exit;
  end;

  self.CalculateEffectiveAperture;

  self.CalculateEntrancePupil(aOptSys);
  self.CalculateExitPupil(aOptSys);

  result:=true;
end;

procedure TOptSystem.RayTraceInAspherical(var Ray:TD3Ray; Color:TSpectru);
begin
  self.AsphericalTrace(Ray,Color);
end;

procedure TOptSystem.ParAxialTraceNotSynmetryCase;
begin
  self.ParAxialTraceNotSynmetry;
end;

procedure TOptSystem.CalculateEffectiveAperture;
var
  anInitiPoint: array[1..1000] of extended;
  aStep, aDr, aDeltaStep, anUpperPoint, {aLowerPoint,} aCenterPoint: extended;
  aRay:TD3Ray;
  k: integer;
begin
  aCenterPoint:=0;  {}
  aRay:=TD3Ray.Create;
try
  aRay.initialize;
  aRay.qntp:=EntrancePupil;

  aDr:=opticalSurface[1].Diameter;
  aStep:=aDr/2/1000;
  for k:=1 to 1000 do begin
    anInitiPoint[k]:= aDr/2 - (aStep * (k - 1)) ;
  end;

  for k:=1 to 1000 do begin
    if (objectDistance<-1.0e10) then begin
      aRay.InitializeForSphericalAberration(anInitiPoint[k]);
    end else begin
      aRay.InitializeForSAFiniteCase(anInitiPoint[k], ObjectDistance,anInitiPoint[k],0);
    end;

    self.RayTraceInAspherical(aRay, nd);

    if k=1 then begin
      if (aRay.ay<>NULL) then begin
        EffectiveAperture:=anInitiPoint[k] * 2;
        exit;
      end;
    end;

    if (aRay.ay<>NULL) then begin
      anUpperPoint:=anInitiPoint[k - 1];
      aDeltaStep:=aStep;

      while aDeltaStep>1e-10 do begin
        aDeltaStep:=aDeltaStep / 2;
        aCenterPoint:=anUpperPoint - aDeltaStep;
        if (objectDistance<-1.0e10) then begin
          aRay.InitializeForSphericalAberration(aCenterPoint);
        end else begin
          aRay.InitializeForSAFiniteCase(aCenterPoint, objectDistance,0,0);
        end;
        self.RayTraceInAspherical(aRay, nd);
        if aRay.ay = NULL then begin
          anUpperPoint:=aCenterPoint;
        end;
      end;

      EffectiveAperture:=aCenterPoint * 2;
      exit;
    end;  { if end }

  end;  { k : For Loop end }

finally
  aRay.Free;
end;

end;

function TOptSystem.ParAxialTraceSynmetry:boolean;
var
   Ray:TParAxialRay;
   aH,aH1,aHk:extended;  {RayHight}
   anAlpha:extended;     {Exchanged  VergesAngle}
   anA1,anAk:extended;   {VergesAngle Initial and Finaldata}
   aN1,aNk:extended;  {ReflactiveIndex}
   aPower,anE:extended;  {Power and ExchangedDistance}
   aFl,aBfl,anOh:extended;  {Focal Length,BackFocas,PrincipalPoint}
   aCylind:Integer;     {Cylind Flag}
   a1000:extended;      {Diopter}
   i:TSpectru;
   k:integer;

begin
  a1000:=-0.001;
  Ray:=TParAxialRay.Create;
Try
 try
  Ray.Initialize;
  Ray.ObjectSideDistance:=ObjectDistance;

  for aCylind:=1 to 2 do begin
    for i:=nd to LastSpectru do begin
      aN1:=OpticalMedium[0].RefractiveIndex[i];
      aNk:=OpticalMedium[TotalSurfaceNumber].RefractiveIndex[i];
      if ((Ray.ObjectSideDistance) < -1.0e10) then begin
        anAlpha:=0;
        aH:=1;
      end else begin
        aH:=1;
        anAlpha:=( aH / (Ray.ObjectSideDistance)) * aN1;
      end;
      Ray.a[1,i]:=anAlpha; Ray.h[1,i]:=aH;
      for k:=1 to TotalSurfaceNumber do begin
        if aCylind=1 then begin
          aPower:=OpticalSurface[k].Power[i];
          if OpticalSurface[k].CylinderAngle=90 then
            aPower:=OpticalSurface[k].PowerZ[i];
        end else begin
          aPower:=OpticalSurface[k].PowerZ[i];
          if OpticalSurface[k].CylinderAngle=90 then
            aPower:=OpticalSurface[k].Power[i];
        end;
        anE:=OpticalMedium[k].ExchangeDistance[i];
        anAlpha:=anAlpha + (aH * aPower);
        Ray.a[k+1,i]:=anAlpha;
        if k < TotalSurfaceNumber then begin
          aH:=aH - (anE * anAlpha);
          Ray.h[k+1,i]:=aH;
        end;
      end;              {  Surface Loop End  }
      aH1:=Ray.h[1,i];
      aHk:=Ray.h[totalSurfaceNumber,i];
      anA1:=Ray.a[1,i];
      anAk:=Ray.a[totalSurfaceNumber+1,i];
      if AfocalSwitch=False{abs(anAk) > 1.0e-10} then begin    {  Afocal Case Deverge  }
        aBfl:=aHk / (anAk/aNk);
        if aCylind=1 then
          BackFocus[i]:=aBfl
        else
          BackFocusSagittaru[i]:=aBfl;
        if (Ray.ObjectSideDistance) < -1.0e10 then begin
          aFl:=aH1 / anAk;
          anOh:=aNk*( ( aHk - aH1 ) / anAk );
          if aCylind=1 then begin
            FocalLength[i]:=aFl;
            PrincipalPoint[i]:=anOh;
          end else begin
            FocalLengthSagittaru[i]:=aFl;
            PrincipalPointSagittaru[i]:=anOh;
          end;
        end else begin  {  Object Distance Deverge  }
            aFl:=anA1 / anAk;
            anOh:=0;          { I woud like to use "nil" . But *** }
            if aCylind=1 then begin
              FocalLength[i]:=aFl;
              PrincipalPoint[i]:=anOh;
            end else begin
              FocalLengthSagittaru[i]:=aFl;
              PrincipalPointSagittaru[i]:=anOh;
            end;
        end;           {  Object Distance Deverge End  }
      end else begin   {  Afocal Case Deverge  }
        if abs(aHk) > 1.0e-10 then begin
          aBfl:=( (anAk /aNk) /aHk )*a1000;
          aFl:=(aH1*aN1) / (aHk*aNk);
          anOh:=0 ;
          if aCylind=1 then begin
            BackFocus[i]:=aBfl;
            FocalLength[i]:=aFl;
            PrincipalPoint[i]:=anOh;
          end else begin
            BackFocusSagittaru[i]:=aBfl;
            FocalLengthSagittaru[i]:=aFl;
            PrincipalPointSagittaru[i]:=anOh;
          end;
        end;
      end;             {  Afocal Case Deverge End  }
    end;              {  Spectru Loop End  }
  end;                {  Cylinder Loop End  }

 result:=true;
 except 
   MessageDlg('ߎǐՂo܂łBwf[^mFĉB',mtInformation,[mbOk], 0);
   result:=false;
 end;

finally

    Ray.Free;

end;

end;

procedure TOptSystem.CulculateHightAlphaWith(var aRay:TParAxialRay);
var
  aH, aH1, aHk, anAlpha, anA1, anAk,  aN1, aNk,
  aPower, anE, aFl, aBfl, anOh, a1000:extended;
  n:TSpectru;
  k, aCylind:integer;
begin

a1000:=-1/1000;
for aCylind:=1 to 2do begin
  for n:=nd to LastSpectru do begin
    aN1:=OpticalMedium[0].RefractiveIndex[n];
    aNk:=OpticalMedium[TotalSurfaceNumber].RefractiveIndex[n];

    if (aRay.ObjectSideDistance < -1.0e10) then begin
      anAlpha:=0;
      aH:=1;
    end else begin
      aH:=1;
      anAlpha:=( aH / (aRay.ObjectSideDistance)) * aN1;
    end;

    aRay.a[1, n]:=anAlpha;
    aRay.h[1, n]:=aH;

    for k:=1 to TotalSurfaceNumber do begin
      if aCylind=1 then begin
        aPower:=OpticalSurface[k].Power[n];
        if OpticalSurface[k].CylinderAngle=90 then
          aPower:=OpticalSurface[k].PowerZ[n];
      end else begin
        aPower:=OpticalSurface[k].PowerZ[n];
        if OpticalSurface[k].CylinderAngle=90 then
          aPower:=OpticalSurface[k].Power[n];
      end;

      anE:=OpticalMedium[k].ExchangeDistance[n];
      anAlpha:=anAlpha + (aH * aPower);
      aRay.a[k+1, n]:=anAlpha;
      if (k < totalSurfaceNumber) then begin
        aH:=aH - (anE * anAlpha);
        aRay.h[k+1, n]:=aH;
      end;
    end;

    aH1:=aRay.h[1, n];
    aHk:=aRay.h[totalSurfaceNumber, n];
    anA1:=aRay.a[1,n];
    anAk:=aRay.a[totalSurfaceNumber+1, n];

    if AfocalSwitch=False {abs(anAk) > 1.0e-10} then begin
      aBfl:=aHk / (anAk/aNk);
      if aCylind=1 then
          BackFocus[n]:=aBfl
        else
          BackFocusSagittaru[n]:=aBfl;

      if (aRay.ObjectSideDistance) < -1.0e10 then begin
        aFl:=aH1 / anAk;
        anOh:=aNk*( ( aHk - aH1 ) / anAk );
        if aCylind=1 then  begin
          FocalLength[n]:=aFl;
          PrincipalPoint[n]:=anOh;
        end else begin
          FocalLengthSagittaru[n]:=aFl;
          PrincipalPointSagittaru[n]:=anOh;
        end;
      end else begin
        aFl:=anA1 / anAk;
        anOh:=0;
        if aCylind=1 then begin
          FocalLength[n]:=aFl;
          PrincipalPoint[n]:=anOh;
        end else begin
          FocalLengthSagittaru[n]:=aFl;
          PrincipalPointSagittaru[n]:=anOh;
        end;
      end;

    end else begin
      if abs(aHk) > 1.0e-10 then begin
        aBfl:=( (anAk /aNk) /aHk )*a1000;
        aFl:=(aH1*aN1) / (aHk*aNk);
        anOh:=0;
        if aCylind=1 then begin
          BackFocus[n]:=aBfl;
          FocalLength[n]:=aFl;
          PrincipalPoint[n]:=anOh;
        end else begin
          BackFocusSagittaru[n]:=aBfl;
          FocalLengthSagittaru[n]:=aFl;
          PrincipalPointSagittaru[n]:=anOh;
        end;
      end;
    end;

  end; { Spectru end }

end;  { Cylinder end  }

end;


function TOptSystem.ParAxialReverseTrace:boolean;
var
  aRay:TParAxialRay;
  aH, aH1, aHk, anAlpha, anA1, {anAk,} aN1, aNk,
  aPower, anE,  aBfl, anOh:extended;
  n:TSpectru;
  k, aCylind:integer;
begin

  aRay:=TParAxialRay.create;

Try

try
  aRay.ReverseObjectDistance:=(-1 * INFINITY);
 for aCylind:=1 to 2 do begin
  for n:=nd to LastSpectru do begin
    aN1:=opticalMedium[0].RefractiveIndex[n];
    aNk:=opticalMedium[totalSurfaceNumber].RefractiveIndex[n];

    if abs(aRay.ReverseObjectDistance) > 1.0e10 then begin
      anAlpha:=0;
      aH:=1;
    end else begin
      aH:=1;
      anAlpha:=( aH / aRay.ReverseObjectDistance) * aNk;
    end;

    aRay.a[totalSurfaceNumber+1, n]:=anAlpha;
    aRay.h[totalSurfaceNumber, n]:=aH;

    for k:=totalSurfaceNumber downto 1 do begin
      if aCylind=1 then begin
        aPower:=OpticalSurface[k].Power[n];
        if OpticalSurface[k].CylinderAngle=90 then
          aPower:=OpticalSurface[k].PowerZ[n];
      end else begin
        aPower:=OpticalSurface[k].PowerZ[n];
        if OpticalSurface[k].CylinderAngle=90 then
          aPower:=OpticalSurface[k].Power[n];
      end;


      anE:=opticalMedium[k-1].ExchangeDistance[n];
      anAlpha:=anAlpha + (aH * aPower);
      aRay.a[k,n]:=anAlpha;
      if (k > 1) then begin
        aH:=aH - (anE * anAlpha);
        aRay.h[k - 1,n]:=aH;
      end;
    end;

    aH1:=aRay.h[1,n];
    aHk:=aRay.h[totalSurfaceNumber, n];
    anA1:=aRay.a[1,n] * -1;

    if AfocalSwitch=False{abs(anA1) > 1.0e-10} then begin
      aBfl:=aH1/ (anA1/aN1);
      if aCylind=1 then
        ObjectSideBackFocus[n]:=aBfl
      else
        ObjectSideBackFocusSagittaru[n]:=aBfl;

      if abs(aRay.ReverseObjectDistance) > 1.0e10 then begin
        anOh:=aN1*( ( aH1 - aHk ) / anA1 );
        if aCylind=1 then
          ObjectSidePrincipalPoint[n]:=anOh
        else
          ObjectSidePrincipalPointSagittaru[n]:=anOh;
      end;
    end else begin
      if abs(aH1) > 1.0e-10 then begin
        aBfl:=( (anA1 /aN1) /aH1 )*0.0001;
        if aCylind=1 then
          ObjectSideBackFocus[n]:=aBfl
        else
          ObjectSideBackFocusSagittaru[n]:=aBfl;
      end;

      anOh:=0;
      if aCylind=1 then
        ObjectSidePrincipalPoint[n]:=anOh
      else
        ObjectSidePrincipalPointSagittaru[n]:=anOh;

    end;

  end;
end;{ Cylinder end }

result:=true;
except
   MessageDlg('tߎǐՂo܂łB'
   ,mtInformation,[mbOk], 0);
   result:=false;
end;



Finally
  aRay.Free;
end;

end;

procedure TOptSystem.CulculateReverseHightAlphWith(var aRay:TParAxialRay);
var
  aH, aH1, aHk, anAlpha, anA1, {anAk,} aN1, aNk,
  aPower, anE,  aBfl, anOh:extended;
  n:TSpectru;
  k, aCylind:integer;
begin

for aCylind:=1 to 2 do begin
  for n:=nd to LastSpectru do begin
    aN1:=opticalMedium[0].RefractiveIndex[n];
    aNk:=opticalMedium[totalSurfaceNumber].RefractiveIndex[n];

    if abs(aRay.ReverseObjectDistance) > 1.0e10 then begin
      anAlpha:=0;
      aH:=1;
    end else begin
      aH:=1;
      anAlpha:=( aH / aRay.ReverseObjectDistance) * aNk;
    end;

    aRay.a[totalSurfaceNumber+1, n]:=anAlpha;
    aRay.h[totalSurfaceNumber, n]:=aH;

    for k:=totalSurfaceNumber downto 1 do begin
      if aCylind=1 then begin
        aPower:=OpticalSurface[k].Power[n];
        if OpticalSurface[k].CylinderAngle=90 then
          aPower:=OpticalSurface[k].PowerZ[n];
      end else begin
        aPower:=OpticalSurface[k].PowerZ[n];
        if OpticalSurface[k].CylinderAngle=90 then
          aPower:=OpticalSurface[k].Power[n];
      end;

      anE:=opticalMedium[k-1].ExchangeDistance[n];
      anAlpha:=anAlpha + (aH * aPower);
      aRay.a[k,n]:=anAlpha;
      if (k > 1) then begin
        aH:=aH - (anE * anAlpha);
        aRay.h[k - 1,n]:=aH;
      end;
    end;

    aH1:=aRay.h[1,n];
    aHk:=aRay.h[totalSurfaceNumber, n];
    anA1:=aRay.a[1,n] * -1;

    if AfocalSwitch=False{abs(anA1) > 1.0e-10} then begin
      aBfl:=aH1/ (anA1/aN1);
      if aCylind=1 then
        BackFocus[n]:=aBfl
      else
        BackFocusSagittaru[n]:=aBfl;

      if abs(aRay.ReverseObjectDistance) > 1.0e10 then begin
        anOh:=aN1*( ( aH1 - aHk ) / anA1 );
        if aCylind=1 then
          ObjectSidePrincipalPoint[n]:=anOh
        else
          ObjectSidePrincipalPointSagittaru[n]:=anOh;
      end;

    end else begin

      if abs(aH1) > 1.0e-10 then begin
        aBfl:=( (anA1 /aN1) /aH1 )*0.0001;
        if aCylind=1 then
          ObjectSideBackFocus[n]:=aBfl
        else
          ObjectSideBackFocusSagittaru[n]:=aBfl;
      end;

    end;

  end;
end;

end;

function TOptSystem.ParAxialTraceNotSynmetry:boolean;
var
  aRay:TD3Ray;
  anAyd, anAzd, anEy, anEz, anEyd, anEzd, aYzi,
  aQyd, aQzd, aV1sdl, aV2sdl, anUe, anAlpha, anAlpha1,
  aNN, aN1, aFl, aBfl, a1000, aHhv, aIntUy {aIntUz}:extended;
  meriSagi:integer;
  n:TSpectru;
begin
  a1000:=-1/1000;
  anEy:=0;
  anEz:=0;
  aFl:=0;
  aBfl:=0;
  aRay:=TD3Ray.create;
try
  aRay.initialize;
  aRay.qntp:=EntrancePupil;

  if ObjectDistance<-1.0e10 then begin
    aIntUy:=0;
    {aIntUz:=0;}
  end else begin
    aIntUy:=-1 / ( EntrancePupil - ObjectDistance  );
  {  aIntUz:=aIntUy;}
  end;

  for merisagi:=1 to 2 do begin
    for n:=nd to LastSpectru do begin
      aRay.ax:=0;
      aRay.ay:=0;
      aRay.az:=0;
      aRay.dxi:=1;
      aRay.dyi:=0;
      aRay.dzi:=0;
      aRay.vyhat:=1;
      aRay.vzhat:=1;
      aRay.uyi:=aIntUy;
      aRay.uzi:=aIntUy;
      aRay.dxia:=aRay.dxi;
      aRay.asSwitch:=True;

      self.AsphericalTrace(aRay, n);

      aN1:=OpticalMedium[0].RefractiveIndex[n];
      aNN:=OpticalMedium[totalSurfaceNumber].refractiveIndex[n];
      if meriSagi=1 then begin
        anEy:=1;
        anEz:=0;
      end;
      if meriSagi=2 then begin
        anEy:=0;
        anEz:=1;
      end;

      anAyd:=aRay.b11*anEy  +  aRay.b12*anEz;
      anAzd:=aRay.b21*anEy  +  aRay.b22*anEz;
      aQyd:=aRay.a11*anEy  +  aRay.a12*anEz;
      aQzd:=aRay.a21*anEy  +  aRay.a22*anEz;
      aV1sdl:=-1*( anAyd*aQyd + anAzd*aQzd ) * (aRay.dxi);
      aV2sdl:=(aQyd*aQyd) + (aQzd*aQzd);
      aYzi:=1 /  sqrt(anAyd*anAyd + anAzd*anAzd);
      anEyd:=anAyd * aYzi;
      anEzd:=anAzd * aYzi;
      anUe:=(-1*aQyd*anEyd) - (aQzd*anEzd);
      anAlpha:=anUe*aNN;

      if AfocalSwitch=False then begin
        if abs(aV2sdl)>1.0e-30 then begin
          aBfl:=(aV1sdl/aV2sdl);
        end;
        if abs(anAlpha)<1.0e-30 then begin

        end;
        if ObjectDistance<-1.0e10 then begin
          aFl:=aRay.dxia/(anAlpha*aRay.dxi);
        end else begin
          if NaInputSwitch=True then begin
            anAlpha1:=aN1/(ObjectDistance - (ObjectDistance + EntrancePupil) );
          end else begin
            anAlpha1:=aN1;
          end;
            aFl:=(anAlpha1*aRay.dxia)/(anAlpha*aRay.dxi);
        end;
      end else begin  {  Afocalcase }
        if abs(aV1sdl)>1.0e-30 then begin
          aBfl:=aV2sdl/aV1sdl*a1000;
        end;
        aHhv:=(anAyd*anEyd) + (anAzd*anEzd);
        if abs(aHhv)>1.0e-30 then begin
          aFl:= aN1/(aNN*aHhv);
        end;
      end;

      if meriSagi=1 then begin
        BackFocus[n]:=aBfl;
        FocalLength[n]:=aFl;
        ObjectSideBackFocus[n]:=0;
        if ObjectDistance<-1.0e10 then begin
          PrincipalPoint[n]:=abs(aBfl) - abs(aFl);
          ObjectSidePrincipalPoint[n]:=0;
        end else begin
          PrincipalPoint[n]:=0;
          ObjectSidePrincipalPoint[n]:=0;
        end;
      end;

      if meriSagi=2 then begin
        BackFocusSagittaru[n]:=aBfl;
        FocalLengthSagittaru[n]:=aFl;
        ObjectSideBackFocusSagittaru[n]:=0;
        if ObjectDistance<-1.0e10 then begin
          PrincipalPointSagittaru[n]:=abs(aBfl) - abs(aFl);
          ObjectSidePrincipalPointSagittaru[n]:=0;
        end else begin
          PrincipalPointSagittaru[n]:=0;
          ObjectSidePrincipalPointSagittaru[n]:=0;
        end;
      end;

    end; { Spectru end }

  end; { meridional sagital end }
finally
  aRay.Free;
end;
result:=True;
end;

//function TOptSystem.ParAxialRverseTraceNotSynmetry:boolean;
{var
 aRay:TD3Ray;
  anAyd, anAzd, anEy, anEz, anEyd, anEzd, aYzi,
  aQyd, aQzd, aV1sdl, aV2sdl, anUe, anAlpha, anAlpha1,
  aNN, aN1, aFl, aBfl, anOh, a1000, aHhv, aIntUy, aIntUz:extended;
  meriSagi:integer;
  n:TSpectru; }
//begin
{  a1000:=-1/1000; }{@AsphericalTrace(aRay, n); @tǐՂłȂ̂
  @@@@@@@@@@Ȃɂ@lȂs\B@}
{  aRay:=TD3Ray.create;
try
  aRay.initialize;
  aRay.qntp:=EntrancePupil;

  if ObjectDistance<-1.0e10 then begin
    aIntUy:=0;
    aIntUz:=0;
  end else begin
    aIntUy:=-1 / ( EntrancePupil - ObjectDistance  );
    aIntUz:=aIntUy;
  end;

  for merisagi:=1 to 2 do begin
    for n:=nd to LastSpectru do begin
      aRay.ax:=0;
      aRay.ay:=0;
      aRay.az:=0;
      aRay.dxi:=1;
      aRay.dyi:=0;
      aRay.dzi:=0;
      aRay.vyhat:=1;
      aRay.vzhat:=1;
      aRay.uyi:=aIntUy;
      aRay.uzi:=aIntUy;
      aRay.dxia:=aRay.dxi;
      aRay.asSwitch:=True;

      self.AsphericalTrace(aRay, n);

      aN1:=OpticalMedium[0].RefractiveIndex[n];
      aNN:=OpticalMedium[totalSurfaceNumber].refractiveIndex[n];
      if meriSagi=1 then begin
        anEy:=1;
        anEz:=0;
      end;
      if meriSagi=2 then begin
        anEy:=0;
        anEz:=1;
      end;

      anAyd:=aRay.b11*anEy  +  aRay.b12*anEz;
      anAzd:=aRay.b21*anEy  +  aRay.b22*anEz;
      aQyd:=aRay.a11*anEy  +  aRay.a12*anEz;
      aQzd:=aRay.a21*anEy  +  aRay.a22*anEz;
      aV1sdl:=-1*( anAyd*aQyd + anAzd*aQzd ) * (aRay.dxi);
      aV2sdl:=(aQyd*aQyd) + (aQzd*aQzd);
      aYzi:=1 /  sqrt(anAyd*anAyd + anAzd*anAzd);
      anEyd:=anAyd * aYzi;
      anEzd:=anAzd * aYzi;
      anUe:=(-1*aQyd*anEyd) - (aQzd*anEzd);
      anAlpha:=anUe*aNN;

      if AfocalSwitch=False then begin
        if abs(aV2sdl)>1.0e-30 then begin
          aBfl:=(aV1sdl/aV2sdl);
        end;
        if abs(anAlpha)<1.0e-30 then begin

        end;
        if ObjectDistance<-1.0e10 then begin
          aFl:=aRay.dxia/(anAlpha*aRay.dxi);
        end else begin
          if NaInputSwitch=True then begin
            anAlpha1:=aN1/(ObjectDistance - (ObjectDistance + EntrancePupil) );
          end else begin
            anAlpha1:=aN1;
          end;
            aFl:=(anAlpha1*aRay.dxia)/(anAlpha*aRay.dxi);
        end;
      end else begin
        if abs(aV1sdl)>1.0e-30 then begin
          aBfl:=aV2sdl/aV1sdl*a1000;
        end;
        aHhv:=(anAyd*anEyd) + (anAzd*anEzd);
        if abs(aHhv)>1.0e-30 then begin
          aFl:= aN1/(aNN*aHhv);
        end;
      end;

      if meriSagi=1 then begin
        BackFocus[n]:=aBfl;
        FocalLength[n]:=aFl;
        ObjectSideBackFocus[n]:=0;
        if ObjectDistance<-1.0e10 then begin
          PrincipalPoint[n]:=abs(aBfl) - abs(aFl);
          ObjectSidePrincipalPoint[n]:=0;
        end else begin
          PrincipalPoint[n]:=0;
          ObjectSidePrincipalPoint[n]:=0;
        end;
      end;

      if meriSagi=2 then begin
        BackFocusSagittaru[n]:=aBfl;
        FocalLengthSagittaru[n]:=aFl;
        ObjectSideBackFocusSagittaru[n]:=0;
        if ObjectDistance<-1.0e10 then begin
          PrincipalPointSagittaru[n]:=abs(aBfl) - abs(aFl);
          ObjectSidePrincipalPointSagittaru[n]:=0;
        end else begin
          PrincipalPointSagittaru[n]:=0;
          ObjectSidePrincipalPointSagittaru[n]:=0;
        end;
      end;

    end;

  end;
finally
  aRay.Free;
end;   }
//result:=True;
//end;

procedure TOptSystem.CalculateSagitalRayMinus(var aRay:TD3Ray; anAngle:extended);
var
  aStep, aDr:extended;
  anInitiPoint:array[1..801] of extended;
  aRadian, aY:extended;
  k:integer;
begin
  aRadian:=DegreeToRadian(anAngle);
  aRay.ax:=0;
  aRay.ay:=0;
  aRay.az:=0;
  aRay.dxi:= 1 / sqrt( 1 + (tan(aRadian)*tan(aRadian)) );
  aRay.dyi:= -1  *(aRay.dxi) * tan(aRadian) ;
  aRay.dzi:=0;

  if Stop=1 then begin
    aY:=0;
  end else begin
    aY:=self.Search(aRay, stop, 0);
  end;

  aDr:=OpticalSurface[1].Diameter * 4;

  if OpticalSurface[1].ApertureFigure=Rect then begin
    aDr:=OpticalSurface[1].ApertureZ * 4;
  end;
  if OpticalSurface[1].ApertureFigure=Oval then begin
    aDr:=OpticalSurface[1].ApertureZ* 4;
  end;
  if OpticalSurface[1].ApertureFigure=UpperOval then begin
    aDr:=OpticalSurface[1].ApertureZ * 4;
  end;

  aStep:=aDr/2/400;
  for k:=1 to 801 do begin
    anInitiPoint[k]:=(-1*aDr/2) + (aStep * (k - 1));
  end;

  for k:=1 to 801 do begin
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=anInitiPoint[k];
    aRay.dxi:= 1 / sqrt( 1 + (tan(aRadian)*tan(aRadian)) );
    aRay.dyi:= -1  *(aRay.dxi) * tan(aRadian) ;
    aRay.dzi:=0;
    self.AsphericalTrace(aRay, nd);
    if aRay.ay <> NULL then begin
      aRay.ax:=0;
      aRay.ay:=aY;
      aRay.az:=anInitiPoint[k];
      aRay.dxi:= 1 / sqrt( 1 + (tan(aRadian)*tan(aRadian)) );
      aRay.dyi:= -1  *(aRay.dxi) * tan(aRadian) ;
      aRay.dzi:=0;
      exit;
    end;
  end;

end;

procedure TOptSystem.CalculateSagitalRayPrus(var aRay:TD3Ray; anAngle:extended);
var
  aStep, aDr:extended;
  anInitiPoint:array[1..801] of extended;
  aRadian, aY:extended;
  k:integer;
begin
  aRadian:=DegreeToRadian(anAngle);
  aRay.ax:=0;
  aRay.ay:=0;
  aRay.az:=0;
  aRay.dxi:= 1 / sqrt( 1 + (tan(aRadian)*tan(aRadian)) );
  aRay.dyi:= -1  *(aRay.dxi) * tan(aRadian) ;
  aRay.dzi:=0;

  if Stop=1 then begin
    aY:=0;
  end else begin
    aY:=self.Search(aRay, stop, 0);
  end;


  aDr:=OpticalSurface[1].Diameter * 4;

  if OpticalSurface[1].ApertureFigure=Rect then begin
    aDr:=OpticalSurface[1].ApertureZ * 4;
  end;
  if OpticalSurface[1].ApertureFigure=Oval then begin
    aDr:=OpticalSurface[1].ApertureZ* 4;
  end;
  if OpticalSurface[1].ApertureFigure=UpperOval then begin
    aDr:=OpticalSurface[1].ApertureZ * 4;
  end;

  aStep:=aDr/2/400;
  for k:=1 to 801 do begin
    anInitiPoint[k]:=aDr/2 - (aStep * (k - 1));
  end;

  for k:=1 to 801 do begin
    aRay.ax:=0;
    aRay.ay:=aY;
    aRay.az:=anInitiPoint[k];
    aRay.dxi:= 1 / sqrt( 1 + (tan(aRadian)*tan(aRadian)) );
    aRay.dyi:= -1  *(aRay.dxi) * tan(aRadian) ;
    aRay.dzi:=0;
    self.AsphericalTrace(aRay, nd);
    if aRay.ay <> NULL then begin
      aRay.ax:=0;
      aRay.ay:=aY;
      aRay.az:=anInitiPoint[k];
      aRay.dxi:= 1 / sqrt( 1 + (tan(aRadian)*tan(aRadian)) );
      aRay.dyi:= -1  *(aRay.dxi) * tan(aRadian) ;
      aRay.dzi:=0;
      exit;
    end;
  end;

end;

function TOptSystem.SurchSagittarRayPrusFinite(aFinitRayX:extended;aFinitRayY:extended;aFinitRayZ:extended):extended;
var
  aStep, aDr:extended;
  anInitiPoint:array[1..801] of extended;
  aRay:TD3Ray;
  k:integer;
begin
  aRay:=TD3Ray.create;
try
  aRay.Initialize;
  aRay.qntp:=EntrancePupil;

  aDr:=OpticalSurface[1].Diameter * 4;

  if OpticalSurface[1].ApertureFigure=Rect then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;
  if OpticalSurface[1].ApertureFigure=Oval then begin
    aDr:=OpticalSurface[1].ApertureY* 4;
  end;
  if OpticalSurface[1].ApertureFigure=UpperOval then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;


  aStep:=aDr/2/400;
  for k:=1 to 801 do begin
    anInitiPoint[k]:=(aDr/2) - (aStep * (k - 1));
  end;

  for k:=1 to 801 do begin

    aRay.InitializeForSagittarFiniteCase(anInitiPoint[k],aFinitRayX,aFinitRayY,aFinitRayZ);

    self.AsphericalTrace(aRay, nd);
    if aRay.ay <> NULL then begin
      result:=anInitiPoint[k];
      exit;
    end;
  end;
finally
  aRay.Free;
end;
  result:=0;
end;

function TOptSystem.SurchSagittarRayMinusFinite(aFinitRayX:extended;aFinitRayY:extended;aFinitRayZ:extended):extended;
var
  aStep, aDr:extended;
  anInitiPoint:array[1..801] of extended;
  aRay:TD3Ray;
  k:integer;
begin
  aRay:=TD3Ray.create;
try
  aRay.Initialize;
  aRay.qntp:=EntrancePupil;

  aDr:=OpticalSurface[1].Diameter * 4;

  if OpticalSurface[1].ApertureFigure=Rect then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;
  if OpticalSurface[1].ApertureFigure=Oval then begin
    aDr:=OpticalSurface[1].ApertureY* 4;
  end;
  if OpticalSurface[1].ApertureFigure=UpperOval then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;


  aStep:=aDr/2/400;
  for k:=1 to 801 do begin
    anInitiPoint[k]:=(-1*aDr/2) + (aStep * (k - 1));
  end;

  for k:=1 to 801 do begin

    aRay.InitializeForSagittarFiniteCase(anInitiPoint[k],aFinitRayX,aFinitRayY,aFinitRayZ);

    self.AsphericalTrace(aRay, nd);
    if aRay.ay <> NULL then begin
      result:=anInitiPoint[k];
      exit;
    end;
  end;
finally
  aRay.Free;
end;
  result:=0;
end;


procedure TOptSystem.CalculatePrincipalRay(var aRay:TD3Ray; anAngle:extended);
var
  aRadian, aY:extended;
begin
  aRadian:=DegreeToRadian(anAngle);
  aRay.ax:=0;
  aRay.ay:=0;
  aRay.az:=0;
  aRay.dxi:= 1 / sqrt( 1 + (tan(aRadian)*tan(aRadian)) );
  aRay.dyi:= -1  *(aRay.dxi) * tan(aRadian) ;
  aRay.dzi:=0;

  if Stop=1 then begin
    exit;
  end else begin
      aY:=self.Search(aRay, stop, 0);

      aRadian:=DegreeToRadian(anAngle);
      aRay.ax:=0;
      aRay.ay:=aY;
      aRay.az:=0;
      aRay.dxi:= 1 / sqrt( 1 + (tan(aRadian)*tan(aRadian)) );
      aRay.dyi:= -1  *(aRay.dxi) * tan(aRadian) ;
      aRay.dzi:=0;
  end;

end;

function TOptSystem.SearchLowerRay(a3DRay:TD3Ray):extended;
var
  aStep, aDr:extended;
  anInitiPoint:array[1..801] of extended;
  aRay:TD3Ray;
  k:integer;
begin
  aRay:=TD3Ray.create;
try
  aRay.Initialize;
  aRay.qntp:=EntrancePupil;


  aDr:=OpticalSurface[1].Diameter * 4;

  if OpticalSurface[1].ApertureFigure=Rect then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;
  if OpticalSurface[1].ApertureFigure=Oval then begin
    aDr:=OpticalSurface[1].ApertureY* 4;
  end;
  if OpticalSurface[1].ApertureFigure=UpperOval then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;


  aStep:=aDr/2/400;
  for k:=1 to 801 do begin
    anInitiPoint[k]:=(-1*aDr/2) + (aStep * (k - 1));
  end;

  for k:=1 to 801 do begin
    aRay.InitializeForSphericalAberration(anInitiPoint[k]);
    aRay.dxi:= a3DRay.dxi;
    aRay.dyi:= a3DRay.dyi;
    aRay.dzi:=0;
    self.AsphericalTrace(aRay, nd);
    if aRay.ay <> NULL then begin
      result:=anInitiPoint[k];
      exit;
    end;
  end;
finally
  aRay.Free;
end;
  result:=0;
end;


function TOptSystem.SearchLowerRayInFinite(aDistance:extended;aFinitRayY:extended;aFinitRayZ:extended):extended;
var
  aStep, aDr:extended;
  anInitiPoint:array[1..801] of extended;
  aRay:TD3Ray;
  k:integer;
begin
  aRay:=TD3Ray.create;
try
  aRay.Initialize;
  aRay.qntp:=EntrancePupil;

  aDr:=OpticalSurface[1].Diameter * 4;

  if OpticalSurface[1].ApertureFigure=Rect then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;
  if OpticalSurface[1].ApertureFigure=Oval then begin
    aDr:=OpticalSurface[1].ApertureY* 4;
  end;
  if OpticalSurface[1].ApertureFigure=UpperOval then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;


  aStep:=aDr/2/400;
  for k:=1 to 801 do begin
    anInitiPoint[k]:=(-1*aDr/2) + (aStep * (k - 1));
  end;

  for k:=1 to 801 do begin

    aRay.InitializeForSAFiniteCase(anInitiPoint[k],aDistance,aFinitRayY,aFinitRayZ);

    self.AsphericalTrace(aRay, nd);
    if aRay.ay <> NULL then begin
      result:=anInitiPoint[k];
      exit;
    end;
  end;
finally
  aRay.Free;
end;
  result:=0;
end;

function TOptSystem.SearchUpperRayInFinite(aDistance:extended;aFinitRayY:extended;aFinitRayZ:extended):extended;
var
  aStep, aDr:extended;
  anInitiPoint:array[1..801] of extended;
  aRay:TD3Ray;
  k:integer;
begin
  aRay:=TD3Ray.create;
try
  aRay.Initialize;
  aRay.qntp:=EntrancePupil;

  aDr:=OpticalSurface[1].Diameter * 4;

  if OpticalSurface[1].ApertureFigure=Rect then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;
  if OpticalSurface[1].ApertureFigure=Oval then begin
    aDr:=OpticalSurface[1].ApertureY* 4;
  end;
  if OpticalSurface[1].ApertureFigure=UpperOval then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;


  aStep:=aDr/2/400;
  for k:=1 to 801 do begin
    anInitiPoint[k]:=(aDr/2) - (aStep * (k - 1));
  end;

  for k:=1 to 801 do begin

    aRay.InitializeForSAFiniteCase(anInitiPoint[k],aDistance,aFinitRayY,aFinitRayZ);

    self.AsphericalTrace(aRay, nd);
    if aRay.ay <> NULL then begin
      result:=anInitiPoint[k];
      exit;
    end;
  end;
finally
  aRay.Free;
end;
  result:=0;
end;



function TOptSystem.SearchUpperRay(a3DRay:TD3Ray):extended;
var
  aStep, aDr:extended;
  anInitiPoint: array[1..801] of extended;
  aRay:TD3Ray;
  k:integer;
begin
  aRay:=TD3Ray.create;
try
  aRay.Initialize;
   aRay.qntp:=EntrancePupil;

  aDr:=OpticalSurface[1].Diameter * 4;

  if OpticalSurface[1].ApertureFigure=Rect then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;
  if OpticalSurface[1].ApertureFigure=Oval then begin
    aDr:=OpticalSurface[1].ApertureY* 4;
  end;
  if OpticalSurface[1].ApertureFigure=UpperOval then begin
    aDr:=OpticalSurface[1].ApertureY * 4;
  end;           { ǂ̂炢̒l@K@H@}


  aStep:=aDr/2/400;
  for k:=1 to 801 do begin
    anInitiPoint[k]:= aDr/2 - (aStep * (k - 1));
  end;

  for k:=1 to 801 do begin
    aRay.InitializeForSphericalAberration(anInitiPoint[k]);
    aRay.dxi:= a3DRay.dxi;
    aRay.dyi:= a3DRay.dyi;
    aRay.dzi:=0;
    self.AsphericalTrace(aRay, nd);
    if (aRay.ay <> NULL) then begin
      result:=anInitiPoint[k];
      exit;
    end;
  end;
finally
  aRay.free;
end;
  result:=0;
end;

function TOptSystem.Search(aRay:TD3Ray; aSurface:integer; aNumber:extended):extended;
var
  a3dRay:TD3Ray;
  aDeltaStep,
  anUpperPoint, aLowerPoint,
  aCenterPoint:extended;
  j: longint;
begin
  anUpperPoint:=self.SearchUpperRay(aRay);
  aLowerPoint:=self.SearchLowerRay(aRay);

  a3dRay:=TD3Ray.create;
try
  aDeltaStep:=abs( (anUpperPoint - aLowerPoint) / 2 );
  aCenterPoint:=anUpperPoint - aDeltaStep;
  a3dRay.Initialize;
  a3dRay.qntp:=EntrancePupil;
  a3dRay.ax:=aRay.ax;
  a3dRay.ay:=aCenterPoint;
  a3dRay.az:=aRay.az;
  a3dRay.dxi:=aRay.dxi;
  a3dRay.dyi:=aRay.dyi;
  a3dRay.dzi:=aRay.dzi;
  self.AsphericalTrace(a3dRay, nd);

  if (aNumber < a3dRay.h[aSurface]) then
    anUpperPoint:=aCenterPoint;

  if (aNumber > a3dRay.h[aSurface]) then
    aLowerPoint:=aCenterPoint;

  j:=0;
  while abs(aNumber - a3dRay.h[aSurface]) > 0.01 do begin
  j:=j+1;
    aDeltaStep:=abs( (anUpperPoint - aLowerPoint) / 2 );
    aCenterPoint:=anUpperPoint - aDeltaStep;
    a3dRay.Initialize;
    a3dRay.qntp:=EntrancePupil;
    a3dRay.ax:=aRay.ax;
    a3dRay.ay:=aCenterPoint;
    a3dRay.az:=aRay.az;
    a3dRay.dxi:=aRay.dxi;
    a3dRay.dyi:=aRay.dyi;
    a3dRay.dzi:=aRay.dzi;
    self.AsphericalTrace(a3dRay, nd);

    if (aNumber < a3dRay.h[aSurface]) then
      anUpperPoint:=aCenterPoint;

    if (aNumber > a3dRay.h[aSurface]) then
      aLowerPoint:=aCenterPoint;

    if (aNumber = a3dRay.h[aSurface]) then begin
      result:=aCenterPoint;
      exit;
    end;
  if j>2000 then
    break;
  end;
  result:=aCenterPoint;

finally
  a3dRay.Free;
end;
end;

procedure TOptSystem.CalculateEntrancePupil(aFrontGroup:TOptSystem);
var
 { aFrontGroup:TOptSystem;}
  aRay1:TParAxialRay;
  aH1Front, anA1Front, {aHkFront,} {anAkFront,}
  aN1Front,{ aNkFront,} aStopPointForEntrance:extended;
begin
  if stop<=1 then begin
    EntrancePupil:=0;
    OpticalMedium[0].Distance:=entrancePupil;
    exit;
  end;

  { " stop>=totalSurfaceNumber ifTrue:["
        aStopPointForEntrance:=-1e-8.
   " ]ifFalse:[
        aStopPointForEntrance:=((self opticalMedium at:stop) distance) * -1.
    ]. "}

  aStopPointForEntrance:=-1e-8;
  {aFrontGroup:=TOptSystem.create;}
  aRay1:=TParAxialRay.create;
try
  aFrontGroup.CopyFrom(self);
  aFrontGroup.OpticalName:='front';
  aFrontGroup.TotalSurfaceNumber:=stop;
  aFrontGroup.TotalSpectruNumber:=1;

  aRay1.ReverseObjectDistance:=aStopPointForEntrance;

  aN1Front:=aFrontGroup.OpticalMedium[0].RefractiveIndex[nd];
{  aNkFront:=aFrontGroup.OpticalMedium[aFrontGroup.totalSurfaceNumber ].RefractiveIndex[nd];}

  aFrontGroup.CalculatePower;
  aFrontGroup.CalculateExchangeDistance;
  aFrontGroup.CulculateReverseHightAlphWith(aRay1);

  aH1Front:=aRay1.h[1,nd];
  anA1Front:=aRay1.a[1,nd] *  -1 ;
  EntrancePupil:=aH1Front/(anA1Front/ aN1Front);

  OpticalMedium[0].Distance:=EntrancePupil;
finally
  {aFrontGroup.Free;}
  aRay1.Free;
end;

end;

procedure TOptSystem.CalculateExitPupil( aRearGroup:TOptSystem);
var
  {aRearGroup:TOptSystem;}
  aRay2:TParAxialRay;
  aStopPointForExit, {aH1Rear,} {anA1Rear,} aHkRear, anAkRear,
 { aN1Rear,} aNkRear:extended;
  k:integer;
begin

  if Stop>=totalSurfaceNumber then begin
    ExitPupil:=0;
    exit;
  end;

  aStopPointForExit:=0;

{  aRearGroup:=TOptSystem.create;}

  aRay2:=TParAxialRay.create;
try
  aRearGroup.CopyFrom(self);
  aRearGroup.OpticalName:='rear';
  aRearGroup.TotalSpectruNumber:=1;

  if (stop<>1) then begin
    for k:=2 to Stop do begin
      aStopPointForExit:=aStopPointForExit + OpticalMedium[k-1].Distance;
    end;
  end else begin
    aStopPointForExit:=1e-8;
  end;

  if (stop<>1) then begin
    for k:=1 to Stop do begin
      aRearGroup.OpticalMedium[k-1].RefractiveIndex[nd]:=1.0;
    end;
  end;

  aRay2.ObjectSideDistance:=aStopPointForExit;

  aRearGroup.CalculatePower;
  aRearGroup.CalculateExchangeDistance;

  aRearGroup.CulculateHightAlphaWith(aRay2);

{  aN1Rear:=aRearGroup.OpticalMedium[0].RefractiveIndex[nd];}
  aNkRear:=aRearGroup.OpticalMedium[aRearGroup.TotalSurfaceNumber].RefractiveIndex[nd];

{  aH1Rear:=aRay2.h[1, nd];}
  aHkRear:=aRay2.h[aRearGroup.TotalSurfaceNumber, nd];
{  anA1Rear:=aRay2.a[1, nd];}
  anAkRear:=aRay2.a[aRearGroup.TotalSurfaceNumber+1, nd];

  ExitPupil:=aHkRear / (anAkRear/aNkRear);

finally
  aRay2.Free;
 { aRearGroup.Free;}
end;

end;

procedure TOptSystem.CalculatePupil;  {  SłȂ@}
var
  aRay:TD3Ray;
  anAngle:extended;
begin
  EntrancePupil:=0;
  ExitPupil:=0;
  anAngle:=-1;
  aRay:=TD3Ray.create;
try
  aRay.Initialize;
  self.CalculatePrincipalRay(aRay, anAngle);
  self.AsphericalTrace(aRay, nd);
  EntrancePupil:=aRay.hyv[1]/tan(degreeToRadian(anAngle)) + aRay.hxv[1];
  ExitPupil:=-1*((aRay.hyv[TotalSurfaceNumber]*aRay.vdxi[TotalSurfaceNumber+1]) / aRay.vdyi[TotalSurfaceNumber+1]
              - aRay.hxv[TotalSurfaceNumber]);
finally
  aRay.free;
end;
end;



function TOptSystem.NonAberrationSurface(var Ray:TD3Ray; k:integer):boolean;
var
  aRisnC, aAm2, aC, aDeltaqi, aSqi213, aDsqa,aH,aG,aGD ,aNn,aN1,aN2,aL
  ,aTanC:extended;
begin

  aC:=0;
  if OpticalSurface[k].ConicSwitch=true then begin
    aRisnC:=( (OpticalSurface[k].ConicCoefficient) - 1.0 ) * aC;
  end else begin
    aRisnC:=( (1.0) - 1.0 ) * aC;
  end;
  aAm2:=sqr(Ray.amx) + sqr(Ray.amy) + sqr(Ray.amz);

  Ray.cofP1:= aC + aRisnC * (Ray.dxi*Ray.dxi);
  Ray.cofP2:= Ray.dxi - aRisnC * Ray.amx * Ray.dxi;
  Ray.cofP3:= aAm2 * aC - (2.0 * Ray.amx) + aRisnC * (Ray.amx*Ray.amx) ;

  if ( abs(Ray.cofP3)<1.0e-30 ) then begin
    aDeltaqi:=0;
    Ray.qi:=( Ray.qi + aDeltaqi );

    Ray.axi:=( Ray.amx + (aDeltaqi * Ray.dxi));
    Ray.ayi:=( Ray.amy + (aDeltaqi * Ray.dyi));
    Ray.azi:=( Ray.amz + (aDeltaqi * Ray.dzi));
  end else begin
    aSqi213:=(Ray.cofP2*Ray.cofP2) - (Ray.cofP1*Ray.cofP3);
    if aSqi213<0 then begin
      result:=False;        { "no intersection"  }
      exit;
    end;

    aDsqa:=sqrt(aSqi213);
    if ( (FishEyeSwitch=False) and (Ray.dxi<0) ) then
      aDsqa:=-1 * aDsqa;

    aDeltaqi:=Ray.cofP3 / (Ray.cofP2 + aDsqa);
    Ray.qi:=( Ray.qi + aDeltaqi );

    Ray.axi:=( Ray.amx + (aDeltaqi * Ray.dxi));
    Ray.ayi:=( Ray.amy + (aDeltaqi * Ray.dyi));
    Ray.azi:=( Ray.amz + (aDeltaqi * Ray.dzi));
  end;

  if (RayCheckSwitch=True) then begin       {194-199}
    if (self.Raycheck(Ray, k)=False) then begin
      Ray.ay:=NULL;
      result:=False;
      exit;
    end;
  end;

  if OpticalSurface[k].ConicSwitch=true then begin
    Ray.al:=( 1.0 - ( (OpticalSurface[k].ConicCoefficient)*Ray.axi*aC ) );
  end else begin
    Ray.al:=( 1.0 - ( (1.0)*Ray.axi*aC ) );
  end;
  Ray.am:=( -1*Ray.ayi*aC );
  Ray.an:=( -1*Ray.azi*aC );



  //**************************************************************************
  NormalizeVectorE(Ray,k);
  InterSectionStock(Ray,k);

  //Os\

  aN1:=OpticalMedium[k-1].RefractiveIndex[nd];
  aN2:=OpticalMedium[k].RefractiveIndex[nd];

  aTanC:=sqrt(Ray.dyi*Ray.dyi + Ray.dzi*Ray.dzi)/Ray.dxi;
  aH:=sqrt( Ray.ayi*Ray.ayi + Ray.azi*Ray.azi);
  if abs(aTanC)<1.0e-30 then begin
    aGD:=(1/self.OpticalSurface[k].Power[nd])*abs(aN2);
    Ray.ax:= Ray.axi;
    Ray.ay:= Ray.ayi;
    Ray.az:= Ray.azi;

    aL:=sqrt(aGD*aGD+Ray.ayi*Ray.ayi+Ray.azi*Ray.azi);

    Ray.dxi:=(aGD-0)/aL;
    Ray.dyi:=(0-Ray.ay)/aL;
    Ray.dzi:=(0-Ray.az)/aL;

    Ray.dxia:= Ray.dxi;
    Ray.dyia:= Ray.dyi;
    Ray.dzia:= Ray.dzi;

  end else begin
   if abs(aH)<1.0e-30 then begin
     aGD:=(1/self.OpticalSurface[k].Power[nd])*abs(aN2);
     Ray.ax:= Ray.axi;
     Ray.ay:= Ray.ayi;
     Ray.az:= Ray.azi;
     Ray.dxia:= Ray.dxi;
     Ray.dyia:= Ray.dyi;
     Ray.dzia:= Ray.dzi;

   end else begin
    aG:= -1*aN1/(aH/ aTanC);
    aGD:=(aG+(self.OpticalSurface[k].Power[nd]))/aN2;
    aGD:=1/aGD;

    Ray.ax:= Ray.axi;
    Ray.ay:= Ray.ayi;
    Ray.az:= Ray.azi;

    aL:=sqrt(aGD*aGD+Ray.ayi*Ray.ayi+Ray.azi*Ray.azi);

    Ray.dxi:=(aGD)/aL;
    Ray.dyi:=(-Ray.ay)/aL;
    Ray.dzi:=(-Ray.az)/aL;

    Ray.dxia:= Ray.dxi;
    Ray.dyia:= Ray.dyi;
    Ray.dzia:= Ray.dzi;


   end;
  end;

  aNn:=OpticalMedium[k-1].RefractiveIndex[nd];

  Ray.pathLength:=aGD*abs(aNn);


  self.RefractionStock(Ray, k);


  result:=True;
end;

{************** Method From 'Lens Optics' ******************}

function TOptSystem.AsphericalTrace(var Ray:TD3Ray; color:TSpectru):boolean;{ 3.8 BTRACE }
var
  k:integer;
begin
   Ray.k3dastFlag:=0;

  for k:=1 to TotalSurfaceNumber do begin
    Ray.IhightFlag:=0;
    self.SurfaceSpace(Ray, k);  {63-70}
    self.ComputeVectorM(Ray ,k); {71-85}

    //if opticalSurface[k].FrenelFlag=3 then begin

    //  if self.NonAberrationSurface(Ray,k)=False then begin
    //    result:=False;
    //    exit;
    //  end;

    //end else begin

      if ( (opticalSurface[k].TiltSwitch=True) or (opticalSurface[k].SiftSwitch=True) ) then
        self.AxisTiltSift(Ray ,k);   {86-91}

      if OpticalSurface[k].BiasSwitch=True then
        self.AxisBiasStart(Ray,k);   {91-96}


      if (self.FrlCylAspTransact(Ray, k, color)=False) then begin
        Ray.ay:=NULL;
        result:=False;
        exit;
      end;

      self.NormalizeVectorE(Ray, k);  {180-185}
      self.IntersectionStock(Ray, k);  {187-193}

      if (RayCheckSwitch=True) then begin       {194-199}
        if (self.Raycheck(Ray, k)=False) then begin
          Ray.ay:=NULL;
          result:=False;
          exit;
        end;
      end;

      self.OpticalPathLength(Ray, k, color);             {200-209}
      if (self.ComputeSinCos(Ray, k, color)=False) then begin   {210-226}
        Ray.ay:=NULL;
        result:=False;  { "totalreflection"  }
        exit;
      end;

      if (mxsinSwitch=True) then
        self.StockDataRab(Ray, k);  {227-233}

      self.ComputeVectorQ(Ray, k);  {235-253}
      self.RefractionStock(Ray, k); {255-258}

      if (Ray.asSwitch=True) then
        self.Astigmatizum(Ray, k);   {260-264}


      if(OpticalSurface[k].FrenelFlag<>0) then begin
        self.FrenelEnd(Ray,k);           {268}
        self.IntersectionStock(Ray, k);
      end;

      if(OpticalSurface[k].BiasSwitch=True) then  {273}
        self.AxisBiasEnd(Ray, k);                 {292}

   // end;


    if (Ray.asSwitch=True) then
      self.AstigmatizumLast(Ray);


  end;

  result:=True;

end;


function TOptSystem.SurfaceSpace(var Ray:TD3Ray; k:integer):boolean; { 3.87 BTRACE 64-70 }
begin

  if (k=1) then begin
    Ray.dim:=-1*EntrancePupil;

    if (NaInputSwitch=True) then
      Ray.dim:=0;

    result:=True;
    exit;
  end else begin
      Ray.dim:=OpticalMedium[k-1].Distance;
      result:=True;
      exit;
  end;

  result:=False;

end;

function TOptSystem.ComputeVectorM(var Ray:TD3Ray; k:integer):boolean; { 3.8 BTRACE 71-85 }
begin

  Ray.xmd:=Ray.ax - Ray.dim;
  Ray.pi:=( (-1 * Ray.xmd * Ray.dxi) - (Ray.ay * Ray.dyi) - (Ray.az * Ray.dzi) );
  Ray.amx:=( Ray.xmd + (Ray.pi * Ray.dxi) );
  Ray.amy:=( Ray.ay + (Ray.pi * Ray.dyi) );
  Ray.amz:=( Ray.az + (Ray.pi * Ray.dzi) );
  Ray.qi:=( Ray.pi );

  result:=True;

end;

function TOptSystem.AxisTiltSift(var Ray:TD3Ray; k:integer):boolean; { 3.13 AXSHTL }
var
  aFlagReverse:integer;
  aMatrix:TMatrix;
  aDelm:extended;
begin

  if OpticalSurface[k].SiftSwitch=True then begin
    Ray.amx:=Ray.amx - ( OpticalSurface[k].SiftVector['X'] );
    Ray.amy:=Ray.amy - ( OpticalSurface[k].SiftVector['Y'] );
    Ray.amz:=Ray.amz - ( OpticalSurface[k].SiftVector['Z'] );
  end;
  if OpticalSurface[k].TiltSwitch=True then begin
    aFlagReverse:=0;
    aMatrix:=OpticalSurface[k].PopTiltMatrix;
    Ray.ConvertVecM(aFlagReverse, aMatrix);
    Ray.ConvertVecQ(aFlagReverse, aMatrix);
  end;

  aDelm:=( -1*((Ray.amx*Ray.dxi) + (Ray.amy*Ray.dyi) + (Ray.amz*Ray.dzi)) );
  Ray.qi:=( Ray.qi + aDelm );

  Ray.amx:=( Ray.amx + (aDelm*Ray.dxi) );
  Ray.amy:=( Ray.amy + (aDelm*Ray.dyi) );
  Ray.amz:=( Ray.amz + (aDelm*Ray.dzi) );

  result:=True;

end;

function TOptSystem.AxisBiasStart(var Ray:TD3Ray; k:integer):boolean; { 3.14 HENSST }
var
  aMatrix:TMatrix;
  aDelm:extended;
  aFlagReverse:integer;
  aTiltX, aTiltY, aTiltZ:extended;
begin

  aFlagReverse:=0;
  BiasMakeRotation( aMatrix, (OpticalSurface[k].PopBiasVector) );
  aTiltX:=OpticalSurface[k].BiasSiftVector['X'];
  aTiltY:=OpticalSurface[k].BiasSiftVector['Y'];
  aTiltZ:=OpticalSurface[k].BiasSiftVector['Z'];

  Ray.amx:=Ray.amx - aTiltX;
  Ray.amy:=Ray.amy - aTiltY;
  Ray.amz:=Ray.amz - aTiltZ;

  Ray.ConvertVecM(aFlagReverse, aMatrix);
  Ray.ConvertVecQ(aFlagReverse, aMatrix);

  aDelm:=( -1*((Ray.amx*Ray.dxi) + (Ray.amy*Ray.dyi) + (Ray.amz*Ray.dzi)) );
  Ray.qi:=( Ray.qi + aDelm );

  Ray.amx:=( Ray.amx + (aDelm*Ray.dxi) );
  Ray.amy:=( Ray.amy + (aDelm*Ray.dyi) );
  Ray.amz:=( Ray.amz + (aDelm*Ray.dzi) );

  result:=True;

end;

function TOptSystem.FrlCylAspTransact(var Ray:TD3Ray; k:integer; color:TSpectru):boolean;
var anApproxFlag:integer;
begin

  if OpticalSurface[k].FrenelFlag<>0 then begin
    if ( self.FrenelStart(Ray, k, color)=False ) then begin
      result:=False;
      exit;
    end;                                 {"no intersection in frenel"  }

    if ( (OpticalSurface[k].FrenelFlag=1) and (Ray.IhightFlag<>0) ) then begin
      result:=True;
      exit;
    end;
  end;

  if( (OpticalSurface[k].CylinderFlag=1) or (OpticalSurface[k].CylinderFlag= 2) ) then begin
    self.CylindoricalRensCof(Ray, k);
    if (self.CylinderSurfaceIntersection(Ray, k)=False) then begin
      result:=False;
      exit;                   { "no intersection"  }
    end;
    result:=True;
    exit;
  end;

  anApproxFlag:=0;
  if( (OpticalSurface[k].ApproxChangeFlag<>0) and (OpticalSurface[k].HiOrderSwitch=True) ) then
    anApproxFlag:=1;

  if( (OpticalSurface[k].ApproxChangeFlag<>0) and (OpticalSurface[k].AspFlag<>0) ) then
    anApproxFlag:=1;

  if( OpticalSurface[k].CylinderFlag=3 ) then
    anApproxFlag:=1;

  if (anApproxFlag<>0) then begin
    self.ApproximateIntersection(Ray, k);

    if( ((OpticalSurface[k].HiOrderSwitch=True)or(OpticalSurface[k].CylinderFlag=3))or(OpticalSurface[k].AspFlag<>0) )
      then begin
      if(self.AsphericalIntersectionPoint(Ray, k)=False) then begin
        result:=False;
        exit;
      end;
    end;

    result:=True;
    exit;
  end;

  if( self.ComputeIntersectionNormalCase(Ray, k)=False )then begin
     result:=False;
     exit;
  end;

  result:=True;

end;

function TOptSystem.NormalizeVectorE(var Ray:TD3Ray; k:integer):boolean; { 3.8 BTRACE 180-185 }
var
  aOm1:extended;
begin
  aOm1:= 1.0 /  ( sqrt((Ray.al*Ray.al)+(Ray.am*Ray.am)+(Ray.an*Ray.an)) );
  Ray.al:=Ray.al * aOm1;
  Ray.am:=Ray.am * aOm1;
  Ray.an:=Ray.an * aOm1;
  result:=True;
end;

function TOptSystem.IntersectionStock(var Ray:TD3Ray; k:integer):boolean; {3.8 BTRACE 187-193 }
begin
  Ray.h[k]:=Ray.ayi;
  Ray.hxv[k]:=Ray.axi;
  Ray.hyv[k]:=Ray.ayi;
  Ray.hzv[k]:=Ray.azi;

  result:=True;
end;

function TOptSystem.Raycheck(var Ray:TD3Ray; k:integer):boolean; {3.8 BTRACE 194-198 }
var
  aJudge:boolean;
  anAperShape:TFigure;
begin
  aJudge:=True;
  anAperShape:=OpticalSurface[k].ApertureFigure;

  if (anAperShape= Round) then
    aJudge:=( self.RoundCheck(Ray, k) );

  if (anAperShape= Rect) then
    aJudge:=( self.RectCheck(Ray, k) );

  if ((anAperShape= Oval) or (anAperShape= UpperOval)) then
    aJudge:=( self.OvalCheck(Ray, k) );

  result:=aJudge;

end;

function TOptSystem.OpticalPathLength(var Ray:TD3Ray; k:integer; color:TSpectru):boolean;{3.8 BTRACE 200-209 }
var
  aPath, aNn:extended;
begin

  aNn:=OpticalMedium[k-1].RefractiveIndex[color];
  aPath:=Ray.qi * abs(aNn);
  Ray.pathLength:=Ray.pathLength + aPath;

  Ray.ax:= Ray.axi;
  Ray.ay:= Ray.ayi;
  Ray.az:= Ray.azi;

  result:=True;

end;

function TOptSystem.ComputeSinCos(var Ray:TD3Ray; k:integer; color:TSpectru):boolean;{ 3.8 BTRACE 210-226 }
var
  aN1,aN2:extended;
begin

  aN1:=OpticalMedium[k-1].RefractiveIndex[color];
  aN2:=OpticalMedium[k].RefractiveIndex[color];
  Ray.vv:= aN1 / aN2;

   { if( Opt->flag_reflection[i] !!= 0 )
        [
        Ray->vv = -1.0;
        ]
   }
   Ray.vf:= abs( Ray.vv );

   Ray.cosi:=( (Ray.dxi * Ray.al) + (Ray.dyi * Ray.am) + (Ray.dzi * Ray.an) );
   Ray.sini2:=( 1.0 - (Ray.cosi * Ray.cosi)  );
   Ray.sinid2:=( Ray.vv * Ray.vv * Ray.sini2 );
   Ray.d12:=( 1.0 - Ray.sinid2 );

   if ( Ray.d12 < 0 ) then begin
     result:=False;   { "totalreflection"  }
     exit;
   end;

   result:=True;

end;


function TOptSystem.StockDataRab(var Ray:TD3Ray; k:integer):boolean; {3.8 BTRACE 227-233}
begin

{ sinmx AȂł邩ȂBՊEp̃TCȂB
@Ȃ sinmx  ́Asurface ̃NXϐɂׂȂB}

if ( Ray.sini2 > Ray.sinmx[k] ) then
  Ray.sinmx[k]:=Ray.sini2;


if ( Ray.sinid2 > Ray.sinmx[k] ) then
  Ray.sinmx[k]:=Ray.sinid2;

result:=True;

end;

function TOptSystem.ComputeVectorQ(var Ray:TD3Ray; k:integer):boolean; { 3.8 BTRACE 235-258 }
begin

  Ray.cosid:= sqrt(Ray.d12);

  if ( Ray.cosi < 0 ) then
    Ray.cosid:= -1 * Ray.cosid;

  if ( Ray.vv < 0 ) then
    Ray.cosid:= -1 * Ray.cosid;

  Ray.gi:=( Ray.cosid - (Ray.cosi * Ray.vf) );

  Ray.dxia:= Ray.dxi;
  Ray.dyia:= Ray.dyi;
  Ray.dzia:= Ray.dzi;

  Ray.dxi:=( (Ray.vf * Ray.dxi) + (Ray.gi * Ray.al) );
  Ray.dyi:=( (Ray.vf * Ray.dyi) + (Ray.gi * Ray.am) );
  Ray.dzi:=( (Ray.vf * Ray.dzi) + (Ray.gi * Ray.an) );

  result:=True;

end;

function TOptSystem.RefractionStock(var Ray:TD3Ray; k:integer):boolean; { 3.8 BTRACE 255-258 }
begin

  Ray.vdxi[k+1]:= Ray.dxi;
  Ray.vdyi[k+1]:= Ray.dyi;
  Ray.vdzi[k+1]:= Ray.dzi;

  result:=True;

end;

function TOptSystem.FrenelEnd(var Ray:TD3Ray; k:integer):boolean; { 3.19 FRNLED }
var
  aFrnlbk:extended;
begin

  aFrnlbk:=OpticalSurface[k].FrenelBack;

  if (Ray.IhightFlag= 0) then begin
    result:=True;
    exit;
  end;

  if (OpticalSurface[k].FrenelFlag= 1 ) then begin
    result:=True;
    exit;
  end;

  Ray.ax:=Ray.ax + aFrnlbk;

  Ray.axi:=Ray.ax;

  result:=True;

end;

function TOptSystem.AxisBiasEnd(var Ray:TD3Ray; k:integer):boolean; { 3.15 HENSED }
var
  aT:TMatrix;
  aTiltX, aTiltY, aTiltZ:extended;
  aFlagReverse:integer;
begin

  aFlagReverse:=1;
  BiasMakeRotation( aT, (opticalSurface[k].PopBiasVector) );

  Ray.ConvertVecRR( aFlagReverse, aT);

  aTiltX:=OpticalSurface[k].BiasSiftVector['X'];
  aTiltY:=OpticalSurface[k].BiasSiftVector['Y'];
  aTiltZ:=OpticalSurface[k].BiasSiftVector['Z'];

  Ray.ax:=Ray.ax + aTiltX;
  Ray.ay:=Ray.ay + aTiltY;
  Ray.az:=Ray.az + aTiltZ;

  Ray.ConvertVecQ( aFlagReverse, aT);

  Ray.hxv[k]:=Ray.ax;
  Ray.hyv[k]:=Ray.ay;
  Ray.hzv[k]:=Ray.az;

  result:=True;

end;

function TOptSystem.FrenelStart(var Ray:TD3Ray; k:integer; color:TSpectru):boolean;{ 3.18 FRNST }
var
  aPower, aVhzero, aPitch, aDzero, aSwell, aTay, aTaz,
  aVcent, aVhzone, aJzone, aFrnlbk, aVl, aVh1, anEpsl,
  anAlpha, anAlpha2, aValc, aQa, aQbd, aQb, aQc,
  anEx, anEy, anEz, aVn1, anAy2, anAz2, anAyz2,
  aVdsq, aYz231, aVdsqi                        :extended;
  aFlagQuad:integer;
  aCoefficientArray:TCoefficientArray;
  anAnserArray:TAnserArray;
  temp1,temp2:extended;


begin

  aFlagQuad:= -1;
  aVhzero:= opticalSurface[k].frenelZeroZorn;
  aPitch:= opticalSurface[k].frenelPich;
  aPower:= opticalSurface[k].power[color];
  aDzero:=0.0;
  aSwell:=-1*( OpticalSurface[k].Epsxyz(aVhzero, aDzero) );
  if aPower <= 0.0 then
    aSwell:=0.0;


  aVl:= ( (-1*aSwell) - (Ray.amx) ) / Ray.dxi;
  aTay:= Ray.amy + (aVl * Ray.dyi);
  aTaz:= Ray.amz + (aVl * Ray.dzi);
  aVcent:=sqrt( (aTay*aTay) + (aTaz*aTaz) );

  if aVcent <= aVhzero then begin
    Ray.IhightFlag:= 0;
    result:=True;
    exit;
  end;

  Ray.IhightFlag:= 1;
  aJzone:=int( ( aVcent - aVhzero ) / aPitch );
  aVhzone:= aVhzero + ((aJzone+1) * aPitch);

  if ( OpticalSurface[k].FrenelFlag= 2 ) then begin
    aFrnlbk:=-1*( OpticalSurface[k].Epsxyz(aVhzone, aDzero ) ) - aSwell;
    OpticalSurface[k].FrenelBack:=aFrnlbk;
    aVl:= aFrnlbk * Ray.dxi;

    Ray.qi:=(Ray.qi + aVl);
    Ray.amx:=( Ray.amx + (aVl * Ray.dxi) - aFrnlbk );
    Ray.amy:=( Ray.amy + (aVl * Ray.dyi) );
    Ray.amz:=( Ray.amz + (aVl * Ray.dzi) );
    result:=True;
    exit;
  end;

  aVl:=-1 * (Ray.amx /Ray.dxi);
  Ray.qi:=( Ray.qi + aVl);
  Ray.ax:=( 0.0 );
  Ray.ay:=( Ray.amy + (aVl*Ray.dyi) );
  Ray.az:=( Ray.amz + (aVl*Ray.dzi) );

  aVh1:=aVhzone - aPitch;
  anEpsl:=-1*( OpticalSurface[k].Epsxyz(aVhzone, aDzero) ) + ( OpticalSurface[k].Epsxyz(aVh1, aDzero) );

  if anEpsl=0 then begin
    result:=False;
    exit;
  end;
  
  anAlpha:=-1*anEpsl / aPitch;
  anAlpha2:=anAlpha * anAlpha;
  aValc:= aVhzone + (aSwell / anAlpha);

  aQa:=(Ray.dxi*Ray.dxi) - (anAlpha2 * ( (Ray.dyi*Ray.dyi) + (Ray.dzi*Ray.dzi) ) );
  aQbd:=(anAlpha * aValc * Ray.dxi) - (anAlpha2 * ( (Ray.ay*Ray.dyi) + (Ray.az*Ray.dzi) ) );
  aQb:=aQbd * 2.0;
  aQc:=anAlpha2 * ( (aValc*aValc) - (Ray.ay*Ray.ay) - (Ray.az*Ray.az) );

  aCoefficientArray[1]:=aQa;
  aCoefficientArray[2]:=aQb;
  aCoefficientArray[3]:=aQc;

  if Quad(anAnserArray, aCoefficientArray, aFlagQuad) =False then begin
    result:=False;
    exit;
  end;

  aVl:=anAnserArray[2];    {"ans1" }
  if ( abs(anAnserArray[3]) < abs(anAnserArray[2]) ) then
    aVl:=anAnserArray[3];


  Ray.ax:=( Ray.ax + (aVl * Ray.dxi) );
  Ray.ay:=( Ray.ay + (aVl * Ray.dyi) );
  Ray.az:=( Ray.az + (aVl * Ray.dzi) );
  Ray.axi:=( Ray.ax );
  Ray.ayi:=( Ray.ay );
  Ray.azi:=( Ray.az );
  Ray.qi:=( Ray.qi + aVl );

  anEx:= -1*( Ray.ax + (anAlpha * aValc) );
  anEy:= anAlpha2 * Ray.ay;
  anEz:= anAlpha2 * Ray.az;
  aVn1:= 1.0 / ( sqrt((anEx*anEx) + (anEy*anEy) + (anEz*anEz)) );
  Ray.al:=(anEx * aVn1);
  Ray.am:=(anEy * aVn1);
  Ray.an:=(anEz * aVn1);

  if Ray.asSwitch=False then begin
    result:=True;
    exit;
  end;

  self.CaseOf3dAs(Ray, k, anAlpha);

  result:=True;
end;

function TOptSystem.CylindoricalRensCof(var Ray:TD3Ray; k:integer):boolean; { 3.20 CYLCOF }
var
  aValcz, aValqz, aValmz:extended;
begin

  if(OpticalSurface[k].CylinderFlag = 2) then begin
    aValcz:= OpticalSurface[k].CylinderCz;
    aValqz:= Ray.dzi;
    aValmz:= Ray.amz;
  end else begin
    aValcz:= OpticalSurface[k].Curvature;
    aValqz:= Ray.dyi;
    aValmz:= Ray.amy;
  end;

  Ray.cofP1:= ( Ray.dxi*Ray.dxi + aValqz*aValqz ) * aValcz;
  Ray.cofP2:= Ray.dxi -  (Ray.amx*Ray.dxi + aValmz*aValqz) * aValcz;
  Ray.cofP3:=(Ray.amx*Ray.amx + aValmz*aValmz ) * aValcz - (2.0*Ray.amx);

  result:=True;

end;

function TOptSystem.CylinderSurfaceIntersection(var Ray:TD3Ray; k:integer):boolean;{ 3.8 BTRACE 132-157 }
var
  aDeltaqi, aSqi213, aDsqa:extended;
begin

  if(Ray.cofP3<1.0e-30) then begin
    aDeltaqi:=0;
    Ray.qi:=( Ray.qi + aDeltaqi );

    Ray.axi:=( Ray.amx + (aDeltaqi * Ray.dxi));
    Ray.ayi:=( Ray.amy + (aDeltaqi * Ray.dyi));
    Ray.azi:=( Ray.amz + (aDeltaqi * Ray.dzi));
  end else begin
    aSqi213:=(Ray.cofP2*Ray.cofP2) - (Ray.cofP1*Ray.cofP3);
    if  aSqi213<0 then begin
      result:=False;      {"no intersection"  }
      exit;
    end;

    aDsqa:=sqrt(aSqi213);
    if (fishEyeSwitch=False) and (Ray.dxi<0) then
      aDsqa:=-1 * aDsqa;

    aDeltaqi:=Ray.cofP3 / (Ray.cofP2 + aDsqa);
    Ray.qi:=( Ray.qi + aDeltaqi );

    Ray.axi:=( Ray.amx + (aDeltaqi * Ray.dxi));
    Ray.ayi:=( Ray.amy + (aDeltaqi * Ray.dyi));
    Ray.azi:=( Ray.amz + (aDeltaqi * Ray.dzi));
  end;

  self.CylindoricalRensE(Ray, k);

  result:=True;

end;

function TOptSystem.ApproximateIntersection(var Ray:TD3Ray; k:integer):boolean; { 3.22 KJNIPT }
var
  aDelqi:extended;
begin

  if (OpticalSurface[k].ApproxChangeFlag <= 2 ) then begin
    aDelqi:= -1 * Ray.amx / Ray.dxi;
    Ray.qi:=( Ray.qi + aDelqi );
    Ray.axi:=0.0;
    Ray.ayi:=( Ray.amy + (aDelqi * Ray.dyi) );
    Ray.azi:=( Ray.amz + (aDelqi * Ray.dzi) );
  end else begin
    Ray.axi:=( Ray.amx );
    Ray.ayi:=( Ray.amy );
    Ray.azi:=( Ray.amz );
  end;

  result:=True;

end;

function TOptSystem.AsphericalIntersectionPoint(var Ray:TD3Ray; k:integer):boolean;{ 3.24 ASPIPT }
begin

  if (OpticalSurface[k].AspFlag <> 0 ) then begin
    if ( (self.AsphericalCompute(Ray, k)) =False ) then begin
      result:=False;    {"no intersection point " }
      exit;
    end;
  end;

  if (OpticalSurface[k].CylinderFlag <> 0) then begin
    if ( (self.ToricCompute(Ray, k)) =False ) then begin
      result:=False;    {"no intersection point " }
      exit;
    end;
  end;

  if (OpticalSurface[k].HiOrderSwitch =True) then begin
    if( (self.HsaspCompute(Ray, k)) =False) then begin
       result:=False;    {"no intersection point " }
       exit;
    end;
  end;

  result:=True;

end;

function TOptSystem.ComputeIntersectionNormalCase(var Ray:TD3Ray; k:integer):boolean;{ 3.8 BTRACE 125-170 }
var
  aRisnC, aAm2, aC, aDeltaqi, aSqi213, aDsqa:extended;
begin

  aC:=OpticalSurface[k].Curvature;
  if OpticalSurface[k].ConicSwitch=true then begin
    aRisnC:=( (OpticalSurface[k].ConicCoefficient) - 1.0 ) * aC;
  end else begin
    aRisnC:=( (1.0) - 1.0 ) * aC;
  end;
  aAm2:=sqr(Ray.amx) + sqr(Ray.amy) + sqr(Ray.amz);

  Ray.cofP1:= aC + aRisnC * (Ray.dxi*Ray.dxi);
  Ray.cofP2:= Ray.dxi - aRisnC * Ray.amx * Ray.dxi;
  Ray.cofP3:= aAm2 * aC - (2.0 * Ray.amx) + aRisnC * (Ray.amx*Ray.amx) ;

  if ( abs(Ray.cofP3)<1.0e-30 ) then begin
    aDeltaqi:=0;
    Ray.qi:=( Ray.qi + aDeltaqi );

    Ray.axi:=( Ray.amx + (aDeltaqi * Ray.dxi));
    Ray.ayi:=( Ray.amy + (aDeltaqi * Ray.dyi));
    Ray.azi:=( Ray.amz + (aDeltaqi * Ray.dzi));
  end else begin
    aSqi213:=(Ray.cofP2*Ray.cofP2) - (Ray.cofP1*Ray.cofP3);
    if aSqi213<0 then begin
      result:=False;        { "no intersection"  }
      exit;
    end;

    aDsqa:=sqrt(aSqi213);
    if ( (FishEyeSwitch=False) and (Ray.dxi<0) ) then
      aDsqa:=-1 * aDsqa;

    aDeltaqi:=Ray.cofP3 / (Ray.cofP2 + aDsqa);
    Ray.qi:=( Ray.qi + aDeltaqi );

    Ray.axi:=( Ray.amx + (aDeltaqi * Ray.dxi));
    Ray.ayi:=( Ray.amy + (aDeltaqi * Ray.dyi));
    Ray.azi:=( Ray.amz + (aDeltaqi * Ray.dzi));
  end;

  if OpticalSurface[k].ConicSwitch=true then begin
    Ray.al:=( 1.0 - ( (OpticalSurface[k].ConicCoefficient)*Ray.axi*aC ) );
  end else begin
    Ray.al:=( 1.0 - ( (1.0)*Ray.axi*aC ) );
  end;
  Ray.am:=( -1*Ray.ayi*aC );
  Ray.an:=( -1*Ray.azi*aC );

  result:=True;

end;


function TOptSystem.RoundCheck(var Ray:TD3Ray; k:integer):boolean;{ 3.9 RAYCHK }
var
  aZcirc, aR, aBr:extended;
begin

  aR:=OpticalSurface[k].Diameter / 2;
  aBr:=OpticalSurface[k].ApertureBrockout / 2;

  aZcirc:=(Ray.ayi*Ray.ayi) + (Ray.azi*Ray.azi);

  if ( aZcirc > (aR*aR) ) then begin
    result:=False;
    exit;
  end;

  if self.CenterBrockSwitch=true then begin
    if ( OpticalSurface[k].ApertureBrockout>0 )then begin
      if ( aZcirc < (aBr*aBr) ) then begin
        result:=False;
        exit;
      end;
    end;
  end;

  result:=True;

end;

function TOptSystem.RectCheck(var Ray:TD3Ray; k:integer):boolean;{ 3.10 SQPCHK }
var
 aHy, aHz, aQtayi, aQtazi, aTayi, aTazi:extended;
begin

  aHy:= OpticalSurface[k].ApertureY / 2;
  aHz:= OpticalSurface[k].ApertureZ / 2;
  aQtayi:= Ray.ayi - OpticalSurface[k].ApertureSiftY;
  aQtazi:= Ray.azi - OpticalSurface[k].ApertureSiftZ;
  aTayi:= (aQtayi * OpticalSurface[k].ApertureCos) + (aQtazi * OpticalSurface[k].ApertureSin);
  aTazi:= (-1 * aQtayi * OpticalSurface[k].ApertureSin) + (aQtazi * OpticalSurface[k].ApertureCos);

  if ( (abs(aHy) < 1.0e-30) or (abs(aHz) < 1.0e-30) ) then begin
    result:=False;
    exit;
  end;
  if ( (abs(aTayi) > aHy) or (abs(aTazi) > aHz) ) then begin
    result:=False;
    exit;
  end;

  result:=True;

end;

function TOptSystem.OvalCheck(var Ray:TD3Ray; k:integer):boolean;{ 3.10 SQPCHK }
var
  aHy, aHz, aQtayi, aQtazi, aTayi, aTazi, aVtay, aVtaz, aZyzv:extended;
begin

  aHy:=opticalSurface[k].apertureY / 2;
  aHz:=opticalSurface[k].apertureZ / 2;
  aQtayi:=Ray.ayi - opticalSurface[k].apertureSiftY;
  aQtazi:=Ray.azi - opticalSurface[k].apertureSiftZ;
  aTayi:=(aQtayi * opticalSurface[k].apertureCos) + (aQtazi * opticalSurface[k].apertureSin);
  aTazi:=(-1 * aQtayi * opticalSurface[k].apertureSin) + (aQtazi * opticalSurface[k].apertureCos);
  aVtay:= aTayi / aHy;
  aVtaz:= aTazi / aHz;
  aZyzv:= (aVtay * aVtay) + (aVtaz * aVtaz);

  if ( aZyzv > 1.0 ) then  begin
    result:=False;
    exit;
  end;

  if ( OpticalSurface[k].ApertureFigure =UpperOval ) then begin
    if ( aTayi < 0.0 ) then begin
      result:=False;
      exit;
    end;
  end;

  result:=True;

end;

function TOptSystem.CylindoricalRensE(var Ray:TD3Ray; k:integer):boolean; { 3.21 CYLNOR }
var
 aC, aCz:extended;
begin

  aC:=OpticalSurface[k].Curvature;
  aCz:=OpticalSurface[k].CylinderCz;

  if ( OpticalSurface[k].CylinderFlag = 1 ) then begin
    Ray.al:=( 1.0 - (Ray.axi * aC ) );
    Ray.am:=( -1 * Ray.ayi * aC  );
    Ray.an:=( 0.0 );
  end else begin
    Ray.al:=( 1.0 - (Ray.axi * aCz));
    Ray.am:=0.0;
    Ray.an:=( -1 * Ray.azi * aCz );
  end;

  result:=True;

end;

function TOptSystem.AsphericalCompute(var Ray:TD3Ray; k:integer):boolean; { 3.25 ASPhCL }
var
  aC, aC2av, aY2z2, aBvals, aBval, aVbri, aVconic, aXnd:extended;
  jj:integer;
begin

  aC:=OpticalSurface[k].Curvature;
  if  OpticalSurface[k].ConicSwitch=true then begin
    aC2av:=aC * aC * OpticalSurface[k].ConicCoefficient;
  end else begin
    aC2av:=aC * aC * 1.0;
  end;
  Ray.IeabsFlag:= 1;
  Ray.Evold:= 1.0e10;

  for jj:=1 to 200 do begin
    aY2z2:=sqr(Ray.ayi) + sqr(Ray.azi);
    aBvals:= 1.0 - (aY2z2 * aC2av);
    if ( aBvals < 0 ) then begin
      result:=False;  {"no intersection point" }
      exit;
    end;
    aBval:=sqrt(aBvals);
    aVbri:= aC / aBval;
    aVconic:= aY2z2 * aC / (1.0 + aBval);
    if ( OpticalSurface[k].AspFlag = 1 ) then
      aXnd:= self.CaseEvenTerm(Ray, aVconic, aY2z2, aVbri, k )
    else
      aXnd:= self.CaseOddTerm(Ray, aVconic, aY2z2, aVbri, k );

    if ( Ray.IeabsFlag = 0 ) then begin
      result:=True;
      exit;
    end;

    self.SuccessiveApproximation(Ray, aXnd, k);
  end;

  result:=False;     {  "no intersection point "  }

end;

function TOptSystem.ToricCompute(var Ray:TD3Ray; k:integer):boolean; { 3.26 TORIC }
var
  aCosst, aSinst, aValcy, aValcz, aValcyz, aAyib, aAzib:extended;
  aD12, aDsq12, aAlpha, aQ12, aBunsi, aXnd, aAmb, aBnb:extended;
  jj:integer;
begin

  aCosst:= OpticalSurface[k].CylinderCos;
  aSinst:= OpticalSurface[k].CylinderSin;
  aValcy:= OpticalSurface[k].Curvature;     //~`g͂邩H
  aValcz:= OpticalSurface[k].CylinderCz;
  aValcyz:= aValcz * aValcy;
  Ray.IeabsFlag:= 1;
  Ray.Evold:= 1.0e10;

  for jj:=1 to 200 do begin
    aAyib:= (Ray.ayi * aCosst) + (Ray.azi * aSinst);
    aAzib:= (-1 * Ray.ayi * aSinst) + (Ray.azi * aCosst);
    aD12:= 1.0 - ( sqr(aAyib*aValcy) );
    if ( aD12 < 0 ) then begin
      result:=False;    { "no intersection point "  }
      exit;
    end;
    aDsq12:= sqrt( aD12);
    aAlpha:= 1.0 / ( 1.0 + aDsq12 );
    aQ12:=sqr( 1.0 - (aAyib*aAyib)*aValcyz*aAlpha ) -  sqr(aAzib*aValcz) ;
    if ( aQ12 < 0 )then begin
      result:=False;    { "no intersection point "  }
      exit;
    end;
    aBunsi:= ( 2.0 * sqr(aAyib) * aValcy * aAlpha )
             - ( (aAyib*aAyib*aAyib*aAyib ) * aValcyz * aValcy * sqr(aAlpha) )
             + ( sqr(aAzib) * aValcz );
    aXnd:= aBunsi / ( 1.0 + sqrt(aQ12) );
    aAmb:= ( ((aValcz - aValcy) / aDsq12) - aValcz ) * aAyib;
    aBnb:= -1 * aAzib * aValcz;

    Ray.al:=( 1.0 - (aValcz * aXnd) );
    Ray.am:=( (aAmb * aCosst) - (aBnb * aSinst) );
    Ray.an:=( (aAmb * aSinst) + (aBnb * aCosst) );
    if ( Ray.IeabsFlag = 0 ) then begin
      result:=True;
      exit;
    end;
    self.SuccessiveApproximation(Ray, aXnd, k);
  end;

  result:=False; { "no intersection point " }

end;

function TOptSystem.HsaspCompute(var Ray:TD3Ray; k:integer):boolean; { 3.29 HSASP }
var
  aNpowy, aNpowz:array[byte] of word;
  aHoscf:array[byte]of extended;
  aMpn, aNpy, aNpz, aNpym1, aNpzm1:word;
  aRmax, aHsvcos, aHsvsin, aRmpn,
  aVy, aVz, aVqy, aVqz, aVey, aVez, aVt,
  aSumx, aHsq, aBvals, aBval, aBiby, aBibz, aVpowy, aVpowz, aC:extended;
  jj,kk, aNterm:integer;
begin

  aRmax:=OpticalSurface[k].Diameter / 2;
  aNterm:=OpticalSurface[k].HighOrderTerm;
  aC:=OpticalSurface[k].Curvature;

  for jj:=1 to aNterm do begin
    aNpowy[jj]:=trunc(OpticalSurface[k].HighOrderPowerY[jj]);
    aNpowz[jj]:=trunc(OpticalSurface[k].HighOrderPowerZ[jj]);
    aRmpn:=1.0;
    aMpn:=aNpowy[jj] + aNpowz[jj];
    if (aMpn<>0) then begin
      aRmpn:=Pow(aRmax,aMpn);    { ( aRmax raisedTo:aMpn ) }
    end;
    aHoscf[jj]:=(OpticalSurface[k].HighOrderCoefficient[jj]) / aRmpn;
  end;

  aHsvcos:=OpticalSurface[k].HighOrderCos;
  aHsvsin:=OpticalSurface[k].HighOrderSin;
  aVy:=(Ray.ayi*aHsvcos) +  (Ray.azi*aHsvsin);
  aVz:=(-1*Ray.ayi*aHsvsin) + (Ray.azi*aHsvcos);
  aVqy:=(Ray.dyi*aHsvcos) +  (Ray.dzi*aHsvsin);
  aVqz:=(-1*Ray.dyi*aHsvsin) + (Ray.dzi*aHsvcos);

  for jj:=1 to 300 do begin
    aHsq:=sqr(aVy)  + sqr(aVz);
    aBvals:=1.0 - (aHsq * sqr(aC));
    if ( aBvals < 0 ) then begin
      result:=False;      { "no intersection"  }
      exit;
    end;
    aBval:=sqrt(aBvals);
    aSumx:=aC * aHsq / (1.0+aBval);
    Ray.al:=1.0;
    aVey:= -1 * aVy * aC / aBval;
    aVez:= -1 * aVz * aC  / aBval;

    for kk:=1 to aNterm do begin
      aNpy:=aNpowy[kk];
      aVpowy:=1.0;
      if (aNpy <> 0) then begin
        aVpowy:=PowInt(aVy,aNpy);{ ( aVy raisedTo:aNpy ) }
      end;

      if (aNpy = 0) then begin
        aBiby:= 0.0;
      end else begin
        if ( aNpy = 1 ) then begin
          aBiby:= 1.0;
        end else begin
          aNpym1:=aNpy - 1;
          aBiby:=aNpy * PowInt(aVy,aNpym1); { ( aVy raisedTo:aNpym1 ) }
        end;
      end;

      aNpz:=aNpowz[kk];
      aVpowz:=1.0;
      if ( aNpz<> 0 ) then begin
        aVpowz:=PowInt(aVz,aNpz);   { ( aVz raisedTo:aNpz )  }
      end;

      if ( aNpz = 0 ) then begin
        aBibz:= 0.0;
      end else begin
        if ( aNpz = 1 ) then begin
          aBibz:= 1.0;
        end else begin
          aNpzm1:=aNpz - 1;
          aBibz:=aNpz * PowInt(aVz,aNpzm1); { ( aVz raisedTo:aNpzm1 ) }
        end;
      end;

      aSumx:=aSumx + (aHoscf[kk] * aVpowy * aVpowz);
      aVey:=aVey - (aHoscf[kk] * aBiby * aVpowz);
      aVez:=aVez - (aHoscf[kk] * aVpowy * aBibz);
    end;

    aVt:=( aSumx - Ray.axi ) / ( Ray.dxi + (aVqy*aVey) + (aVqz*aVez) );
    Ray.axi:=( Ray.axi + (aVt * Ray.dxi) );
    aVy:=aVy + (aVt * aVqy);
    aVz:= aVz + (aVt * aVqz);
    if ( abs( aVt ) < 1.0e-10 ) then begin
      Ray.ayi:=( (aVy*aHsvcos) +  (aVz*aHsvsin * -1) );
      Ray.azi:=( (-1*aVy*aHsvsin*-1) + (aVz*aHsvcos));
      Ray.am:=( (aVey*aHsvcos) +  (aVez*aHsvsin * -1) );
      Ray.an:=( (-1*aVey*aHsvsin*-1) + (aVez*aHsvcos));
      result:=True;
      exit;
    end;

  end;

  result:=False;

end;


function TOptSystem.CaseEvenTerm(var Ray:TD3Ray; aVconic:extended; aY2z2:extended; aVbri:extended; k:integer ):extended;
var                             { 3.25 ASPHCL 50-77 }
  aVh1, aVh2, aXsum, aSum1, aXnd, aAsp:extended;
  jj:integer;
begin

  aVh1:=1.0;
  aXsum:=0.0;
  aVh2:=1.0;
  aSum1:=0.0;

  for jj:=1 to(OpticalSurface[k].AsphericalTerm) do begin
    aAsp:=OpticalSurface[k].AsphericalCoefficient[jj];
    aVh1:=aVh1 * aY2z2;
    aXsum:=aXsum + (aAsp * aVh1);
    aSum1:=aSum1 + (jj * aAsp * aVh2);
    aVh2:=aVh2 * aY2z2;
  end;

  Ray.al:=1.0;
  Ray.am:=( (-1 * Ray.ayi * aVbri) - (2.0 * Ray.ayi * aSum1) );
  Ray.an:=(  (-1 * Ray.azi * aVbri) - (2.0 * Ray.azi * aSum1));

  aXnd:=aVconic + aXsum;
  result:=aXnd;

end;

function TOptSystem.CaseOddTerm(var Ray:TD3Ray; aVconic:extended; aY2z2:extended; aVbri:extended; k:integer ):extended;
var                             { 3.25 ASPHCL 78-111 }
  aVh1, aVh2, aXsum, aSum1, aXnd, aHval, aAsp:extended;
  jj:integer;
begin

  aHval:= sqrt(aY2z2);
  aVh1:= aHval;
  aXsum:= 0.0;
  aVh2:= 1.0;
  aSum1:= 0.0;

  for jj:=1 to(OpticalSurface[k].AsphericalTerm) do begin
    aAsp:=OpticalSurface[k].AsphericalCoefficient[jj];
    aVh1:= aVh1 * aHval;
    aXsum:= aXsum + (aAsp * aVh1);
    aSum1:= aSum1 + ((jj+1) * aAsp * aVh2);
    aVh2:= aVh2 * aHval;
  end;

  Ray.al:=( 1.0 );
  Ray.am:=( (-1 * Ray.ayi * aVbri) - (Ray.ayi * aSum1) );
  Ray.an:=( (-1 * Ray.azi * aVbri) - (Ray.azi * aSum1) );

  aXnd:= aVconic + aXsum;
  result:=aXnd;

end;

function TOptSystem.SuccessiveApproximation(var Ray:TD3Ray; aXnd:extended; k:integer):boolean;{ 3.23 SUCAPR }
var
  aEun, aE:extended;
begin

  if( OpticalSurface[k].ApproxChangeFlag <= 1 ) then begin
    aEun:= (Ray.dxi*Ray.al) + (Ray.dyi*Ray.am) + (Ray.dzi*Ray.an);
    if ( abs(aEun) < 1.0e-10 ) then begin
      result:=False;
      exit;
    end;
    aE:= Ray.al * ( aXnd - Ray.axi ) / aEun;
  end else begin
    aE:= ( aXnd - Ray.axi ) * Ray.dxi;
  end;

  if ( abs(aE) < 1.0e-14 ) then begin
        Ray.IeabsFlag:= 0;
  end;

  Ray.axi:=( Ray.axi + (aE * Ray.dxi) );
  Ray.ayi:=( Ray.ayi + (aE * Ray.dyi) );
  Ray.azi:=( Ray.azi + (aE * Ray.dzi) );

  Ray.qi:=( Ray.qi + aE );

  if ( OpticalSurface[k].ApproxChangeFlag = 2 ) then begin
    if( abs(aE) > Ray.Evold ) then begin
      result:=False;
      exit;
    end;
    Ray.Evold:=abs( aE );
    result:=True;
    exit;
  end;

  result:=True;

end;

function Quad(var anAnserArray:TAnserArray; aCoefficientArray:TCoefficientArray; aFlagQuad:integer):boolean;{ 2.1 QUAD }
var
  anAm20, anAm30, aVmax, anAa, anAa2, aBb, aCc,
  anA, aB, aC, anAns, anAns1, anAns2,
  aDhan, aCcaa, aSs, aD:extended;

begin

  anA:=aCoefficientArray[1];
  aB:=aCoefficientArray[2];
  aC:=aCoefficientArray[3];

  anAm20:= 1.0e-20;
  anAm30:= 1.0e-30;
  aVmax:= abs(anA);
  if (abs(aB) > aVmax) then
    aVmax:= abs(aB);

  if (abs(aC) > aVmax ) then
    aVmax:= abs(aC);

  if( aVmax < anAm30 ) then begin
    result:=False;
    exit;
  end;

  anAa:= anA / aVmax;
  anAa2:= anAa*2;
  aBb:= aB / aVmax;
  aCc:= aC / aVmax;

  if( (abs(anAa) < anAm20) and (abs(aBb) < anAm20) ) then begin
    result:=False;
    exit;
  end;

  if ( abs(anAa) < anAm20 ) then begin
    anAns:= -1* aCc / aBb;
    anAns1:= anAns;
    anAns2:= anAns;
    anAnserArray[1]:=anAns;
    anAnserArray[2]:=anAns1;
    anAnserArray[3]:=anAns2;
    result:=True;
    exit;
  end;

  aD:=(aBb * aBb) - (4.0 * anAa * aCc);
  aDhan:= aD / ( anAa2*anAa2 );
  if ( aD < (-1*anAm20) ) then begin
    result:=False;
    exit;
  end;

  if ( abs(aDhan) < anAm20 ) then begin
    anAns:= -1 * aBb / anAa2;
    anAns1:= anAns;
    anAns2:= anAns;
    anAnserArray[1]:=anAns;
    anAnserArray[2]:=anAns1;
    anAnserArray[3]:=anAns2;
    result:=True;
    exit;
  end;

  if ( abs(aBb) < anAm20 ) then begin
    aCcaa:= -1 * aCc / anAa;
    anAns1:= sqrt( aCcaa );
    anAns2:= -1 * anAns1;
    anAns:=  anAns1;
    if ( aFlagQuad = 1 ) then begin
      anAns:= anAns2;
    end;
    anAnserArray[1]:=anAns;
    anAnserArray[2]:=anAns1;
    anAnserArray[3]:=anAns2;
    result:=True;
    exit;
  end;

  if ( aBb < 0.0 ) then begin
    aSs:= -1 * aBb + sqrt(aD);
    anAns1:= aSs / anAa2;
    anAns2:= aCc / anAa / anAns1;
  end else begin
    aSs:= -1*aBb - sqrt(aD);
    anAns2:= aSs / anAa2;
    anAns1:= aCc / anAa / anAns2;
  end;

  anAns:= anAns1;
  if ( aFlagQuad = 1 ) then begin
    anAns:= anAns2;
  end;
  anAnserArray[1]:=anAns;
  anAnserArray[2]:=anAns1;
  anAnserArray[3]:=anAns2;
  result:=True;
  exit;

end;

function TOptSystem.CaseOf3dAs(var Ray:TD3Ray; k:integer; anAlpha:extended):boolean;{ 3.18 FRNLST  137-162 }
var
  anAy2, anAz2, anAyz2, aVdsq, aVdsqi, aYz231:extended;
begin

  if Ray.K3dastFlag=0 then begin
    Ray.rot:= 0;
    Ray.ros:= Ray.al * anAlpha / abs(Ray.ay);
  end else begin
    anAy2:= Ray.ayi * Ray.ayi;
    anAz2:= Ray.azi * Ray.azi;
    anAyz2:= anAy2 + anAz2;

    aVdsq:= sqrt(anAyz2);
    aYz231:= 1.0 / ( anAyz2 * aVdsq );

    aVdsqi:= 1.0 / aVdsq;
    Ray.vdfy:=(anAlpha * Ray.ayi * aVdsqi);
    Ray.vdfz:=( anAlpha * Ray.azi * aVdsqi);
    Ray.vdfy2:=( anAlpha * anAz2 * aYz231);
    Ray.vdfz2:=( anAlpha * anAy2 * aYz231);
    Ray.vdfyz:=( -1 * anAlpha * Ray.ayi * Ray.azi * aYz231);
  end;

  result:=True;

end;

function TOptSystem.Astigmatizum(var Ray:TD3Ray; k:integer):boolean; { 3.31 ASTNYU  }
var
  aFlag:integer;
begin

  aFlag:=0;
  if ( (Ray.K3dastFlag<>0) or (OpticalSurface[k].BiasSwitch=True)
      or (OpticalSurface[k].CylinderFlag<>0)  ) then begin
    aFlag:=1;
  end;

  if ( (OpticalSurface[k].TiltSwitch=True) or (OpticalSurface[k].SiftSwitch=True)  ) then begin
    aFlag:=1;
  end;

  if ( OpticalSurface[k].HiOrderSwitch=True ) then begin
    aFlag:=1;
  end;

  if ( aFlag<>0 ) then begin
    Ray.K3dastFlag:=(Ray.K3dastFlag + 1);
  end;

  if ( Ray.K3dastFlag=0 ) then begin
    self.ComputRotRos(Ray, k);
    self.AsTraceInMeridional(Ray);
  end else begin
    self.AsTrace3d(Ray, k);
  end;

  result:=True;

end;

function TOptSystem.AstigmatizumLast(var Ray:TD3Ray):boolean; { 3.32 ASTLST }
var
  a1000:extended;
begin

  a1000:=-1/1000;
  if( Ray.K3dastFlag=0 ) then begin
    if( AfocalSwitch=True ) then begin
      Ray.tas:=a1000*Ray.uyi/( (Ray.vyhat*Ray.dxi)+(Ray.ax*Ray.uyi) );
      Ray.sas:=a1000*Ray.uzi/( (Ray.vzhat*Ray.dxi)+(Ray.ax*Ray.uzi) );
    end else begin

      if Ray.uyi=0 then begin
        Ray.tas:=0;
      end else begin
        Ray.tas:=( (Ray.vyhat/Ray.uyi) * Ray.dxi ) + Ray.ax;
      end;
      if Ray.uzi=0 then begin
        Ray.sas:=0;
      end else begin
        Ray.sas:=( (Ray.vzhat/Ray.uzi) * Ray.dxi ) + Ray.ax;
      end;

    end;
  end else begin
    self.AsTrace3dLast(Ray);
  end;

  result:=True;
end;


function TOptSystem.ComputRotRos(var Ray:TD3Ray; k:integer):boolean; { 3.30 CPROT }
var
  aC, aY2z2, anAval, aBval,
  anAc1, anAc2, aVh1, aSum1, aVh2, aSum2, anAsp, aHval:extended;
  jj:integer;
begin

  aC:=OpticalSurface[k].Curvature;
  Ray.rot:=aC;
  Ray.ros:=aC;
  if ( (OpticalSurface[k].ConicSwitch=False)and(OpticalSurface[k].AspFlag=0)  )then begin  //conicCoefficient=1
    result:=True;
    exit;
  end;

  aY2z2:=sqr(Ray.ayi);
  if OpticalSurface[k].ConicSwitch=true then begin
    anAval:=OpticalSurface[k].ConicCoefficient;
  end else begin
    anAval:=1.0;
  end;
  aBval:=sqrt( 1.0 - (anAval*aY2z2*(aC*aC)) );
  Ray.vdfy2:=aC / (aBval*aBval*aBval);
  Ray.vdfz2:=aC / aBval;

  if(OpticalSurface[k].AspFlag=0) then begin
    Ray.rot:=Pow(Ray.al,3) * Ray.vdfy2;
    Ray.ros:=Ray.al * Ray.vdfz2;
    result:=True;
    exit;
  end;

  if (OpticalSurface[k].AspFlag=1) then begin
    anAc1:=OpticalSurface[k].AsphericalCoefficient[1];
    if (OpticalSurface[k].AsphericalTerm=1) then begin
      anAc2:=0;
    end else begin
      anAc2:=OpticalSurface[k].AsphericalCoefficient[2];
    end;
    aVh1:=aY2z2;
    aSum1:=anAc1 + (2 * anAc2 * aVh1);
    aVh2:=1;
    aSum2:=2 * anAc2;

    for jj:=3 to (OpticalSurface[k].AsphericalTerm) do begin
      anAsp:=OpticalSurface[k].AsphericalCoefficient[jj];
      aVh1:=aVh1 * aY2z2;
      aSum1:=aSum1 + (jj * anAsp * aVh1);
      aVh2:=aVh2 * aY2z2;
      aSum2:=aSum2 + (jj * (jj - 1) * anAsp * aVh2);
    end;

    Ray.vdfy2:=Ray.vdfy2 + (2 * aSum1) + (4 * sqr(Ray.ayi) * aSum2);
    Ray.vdfz2:=Ray.vdfz2 + (2 * aSum1);
  end else begin
    aHval:=sqrt(aY2z2);
    anAc1:=OpticalSurface[k].AsphericalCoefficient[1];
    if (OpticalSurface[k].AsphericalTerm=1) then begin
      anAc2:=0;
    end else begin
      anAc2:=OpticalSurface[k].AsphericalCoefficient[2];
    end;
    aVh1:=aHval;
    aSum1:=(2 * anAc1) + (3 * anAc2 * aVh1);
    aVh2:=1;
    aSum2:=0;

    for jj:=3 to (OpticalSurface[k].AsphericalTerm) do begin
      anAsp:=OpticalSurface[k].AsphericalCoefficient[jj];
      aVh1:=aVh1 * aHval;
      aSum1:=aSum1 + ((jj + 1) * anAsp * aVh1);
      aSum2:=aSum2 + ((jj - 1) * (jj + 1) * anAsp * aVh2);
      aVh2:=aVh2 * aHval;
    end;

    Ray.vdfy2:=Ray.vdfy2 + aSum1 + (aSum2 * aY2z2);
    if (aY2z2 > 1e-20) then
      Ray.vdfy2:=Ray.vdfy2 + (3 * anAc2 * aY2z2 / aHval);
    Ray.vdfz2:=Ray.vdfz2 + aSum1;

  end;
    Ray.rot:=Pow(Ray.al,3) * Ray.vdfy2;
    Ray.ros:=Ray.al * Ray.vdfz2;
    result:=True;

end;

function TOptSystem.AsTraceInMeridional(var Ray:TD3Ray):boolean; { 3.31 ASTNYU 42-50 }
begin

  Ray.vyhat:= Ray.vyhat - (Ray.qi * Ray.uyi);
  Ray.vhyi:= Ray.vyhat /  Ray.cosi;
  Ray.uyi:= ( Ray.vf * Ray.cosi * Ray.uyi +  Ray.gi * Ray.rot * Ray.vhyi ) /  Ray.cosid ;
  Ray.vyhat:= Ray.vhyi * Ray.cosid;
  Ray.vzhat:= Ray.vzhat - ( Ray.qi * Ray.uzi);
  Ray.uzi:=Ray.uzi * Ray.vf + Ray.gi * Ray.ros * Ray.vzhat;

  result:=True;  {  ł́Avf ł͂Ȃ@vv ł@}

end;

function TOptSystem.AsTrace3d(var Ray:TD3Ray; k:integer):boolean; { 3.38 AST3D }
var
  aVector:TVector;
  aT,aTh,aThd,aThti,aThdti:TMatrix;
  aQxwa, aQywa, aQzwa, aQyxa, aQzxa, aQxwi, aQxwia, aQxw, aQyw, aQzw,
  aDqyh, aDqzh, aDryh, aDrzh, aDqyw, aDqzw, aDqxw,
  aDrx1, aDry1, aDrz1,
  aDryw, aDrzw:extended;
  jj, mm, pp:integer;
begin

  if (Ray.k3dastFlag=1) then
    Ray.IntDataSet;

  aVector['X']:=Ray.al;
  aVector['Y']:=Ray.am;
  aVector['Z']:=Ray.an;

  BiasMakeRotation(aT, aVector);

  self.AsTraceDifferential(Ray, k, aT);

  aQxwa:=Ray.cosi;
  aQxwia:=1 / aQxwa;
  aQywa:=(aT[2,1] * Ray.dxia) + (aT[2,2] * Ray.dyia) + (aT[2,3] * Ray.dzia);
  aQzwa:=(aT[3,1] * Ray.dxia) + (aT[3,2] * Ray.dyia) + (aT[3,3] * Ray.dzia);
  aQyxa:=aQywa * aQxwia;
  aQzxa:=aQzwa * aQxwia;

  aQxw:=Ray.cosid;
  aQxwi:=1 / aQxw;
  aQyw:=(aT[2,1] * Ray.dxi) + (aT[2,2] * Ray.dyi) + (aT[2,3] * Ray.dzi);
  aQzw:=(aT[3,1] * Ray.dxi) + (aT[3,2] * Ray.dyi) + (aT[3,3] * Ray.dzi);

  aVector['X']:=Ray.dxia;
  aVector['Y']:=Ray.dyia;
  aVector['Z']:=Ray.dzia;

  BiasMakeRotation(aTh, aVector);

  aVector['X']:=Ray.dxi;
  aVector['Y']:=Ray.dyi;
  aVector['Z']:=Ray.dzi;

  BiasMakeRotation(aThd, aVector);

  for jj:=1 to 3 do begin
    for mm:=1 to 3 do begin
      aThti[jj,mm]:=0;
      aThdti[jj,mm]:=0;
      for pp:=1 to 3 do begin
        aThti[jj,mm]:= aThti[jj,mm] + ( aTh[jj,pp]*aT[mm,pp]);
        aThdti[jj,mm]:= aThdti[jj,mm] + (aThd[jj,pp]*aT[mm,pp] );
      end;
    end;
  end;

  for jj:=1 to 2 do begin
    if jj=1 then begin
      aDqyh:=Ray.dq1yh;
      aDqzh:=Ray.dq1zh;
      aDryh:=Ray.dr1yh;
      aDrzh:=Ray.dr1zh;
    end else begin
      aDqyh:=Ray.dq2yh;
      aDqzh:=Ray.dq2zh;
      aDryh:=Ray.dr2yh;
      aDrzh:=Ray.dr2zh;
    end;

    aDryh:=aDryh + (Ray.qi*aDqyh);
    aDrzh:=aDrzh + (Ray.qi*aDqzh);
    aDqyw:=(aThti[2,2]*aDqyh) + (aThti[3,2]*aDqzh);
    aDqzw:=(aThti[2,3]*aDqyh) + (aThti[3,3]*aDqzh);

    aDrx1:=(aThti[2,1]*aDryh) + (aThti[3,1]*aDrzh);
    aDry1:=(aThti[2,2]*aDryh) + (aThti[3,2]*aDrzh);
    aDrz1:=(aThti[2,3]*aDryh) + (aThti[3,3]*aDrzh);

    aDryw:=aDry1 - (aDrx1 * aQyxa);
    aDrzw:=aDrz1 - (aDrx1 * aQzxa);

    Ray.vf:=abs(Ray.vv);
    aDqyw:=Ray.vf*aDqyw -  Ray.gi*(aDryw*Ray.ryi + aDrzw*Ray.ryzi);
    aDqzw:=Ray.vf*aDqzw -  Ray.gi*(aDrzw*Ray.rzi + aDryw*Ray.ryzi);

    aDqxw:=-1 * (aQyw*aDqyw + aQzw*aDqzw) * aQxwi;
    aDqyh:=(aThdti[2,1]*aDqxw)+(aThdti[2,2]*aDqyw)+(aThdti[2,3]*aDqzw);
    aDqzh:=(aThdti[3,1]*aDqxw)+(aThdti[3,2]*aDqyw)+(aThdti[3,3]*aDqzw);

    aDryh:=(aThdti[2,2]*aDryw)+(aThdti[2,3]*aDrzw);
    aDrzh:=(aThdti[3,2]*aDryw)+(aThdti[3,3]*aDrzw);

    if (jj=1) then begin
      Ray.dq1yh:=aDqyh;
      Ray.dq1zh:=aDqzh;
      Ray.dr1yh:=aDryh;
      Ray.dr1zh:=aDrzh;
    end else begin
      Ray.dq2yh:=aDqyh;
      Ray.dq2zh:=aDqzh;
      Ray.dr2yh:=aDryh;
      Ray.dr2zh:=aDrzh;
    end;

  end;

  if (k=TotalSurfaceNumber) then
    self.CalculateDifferentialCoeffitient(Ray);

  result:=True;

end;

function TOptSystem.AsTrace3dLast(var Ray:TD3Ray):boolean;{ 3.42 AST3D2 }
var
  aBdet, aBdetI, aB11i, aB12i, aB21i, aB22i,
  {aT1221,} aVmax, aRadph1, aVpai90, aRadph2,
  aVt, aVyoko, aVtate,  aCieta2, aCieta,
  aVcos, aVsin, aVtemp,
  a1000, aT11, aT12, {aT21,} aT22:extended;
  aReverseFlag:integer;
begin

  aVpai90:= pi /2;
  aBdet:= (Ray.b11*Ray.b22) - (Ray.b12*Ray.b21);
  if (abs(aBdet) < 1e-30) then begin
    result:=False;
    exit;
  end;

  aBdetI:=1 / aBdet;

  aB11i:=Ray.b22 * aBdetI;
  aB12i:=-1 * Ray.b12 * aBdetI;
  aB21i:=-1 * Ray.b21 * aBdetI;
  aB22i:=Ray.b11 * aBdetI;

  aT11:=-1 * ( (Ray.a11*aB11i) + (Ray.a12*aB21i) );
  aT12:=-1 * ( (Ray.a11*aB12i) + (Ray.a12*aB22i) );
{  aT21:=-1 * ( (Ray.a21*aB11i) + (Ray.a22*aB21i) );}
  aT22:=-1 * ( (Ray.a21*aB12i) + (Ray.a22*aB22i) );

{  aT1221:=aT12 - aT21;}
  aVmax:=abs(aT11);
  if( abs(aT12) > aVmax )then
     aVmax:=abs(aT12);
  if( abs(aT22) > aVmax )then
     aVmax:=abs(aT22);

  aRadph1:=-1 * aVpai90;
  Ray.rzi:=aT22;
  aRadph2:=0;
  Ray.ryi:=aT11;
  aVt:=aT12 / aVmax;
  if( abs(aVt) >= 1e-10 ) then begin
    aReverseFlag:=1;
    aVyoko:=2*aT12;
    aVtate:=aT11 - aT22;
    aCieta2:=( Cptrad(aVyoko, aVtate, aReverseFlag) );
    aCieta2:=( Pai2Change(aCieta2) );
    aCieta:=aCieta2 / 2;

    aVcos:=cos(aCieta);
    aVsin:=sin(aCieta);
    aRadph1:=aCieta - aVpai90;
    Ray.rzi:=(sqr(aVsin)*aT11) - (2*aVsin*aVcos*aT12) + (sqr(aVcos)*aT22);
    aRadph2:=aCieta;
    Ray.ryi:=(sqr(aVcos)*aT11) + (2*aVsin*aVcos*aT12) + (sqr(aVsin)*aT22);
    aRadph1:= Chengent(aRadph1, aB11i, aB12i, aB21i, aB22i);
    aRadph2:= Chengent(aRadph2, aB11i, aB12i, aB21i, aB22i);
  end;
  aRadph1:=Pai2Change(aRadph1);
  aRadph2:=Pai2Change(aRadph2);
  if( abs(aRadph1) < abs(aRadph2) ) then begin
 {   aVtemp:=aRadph1;}
 {   aRadph1:=aRadph2;}
{    aRadph2:=aVtemp;}
    aVtemp:=Ray.ryi;
    Ray.ryi:=Ray.rzi;
    Ray.rzi:=aVtemp;
  end;
  a1000:=-1/1000;
  if( AfocalSwitch <>True ) then begin
    Ray.sas:=Ray.ax + ( (1/Ray.rzi) * Ray.dxi );
    Ray.tas:=Ray.ax + ( (1/Ray.ryi) * Ray.dxi );
  end else begin
    Ray.sas:=Ray.rzi / ( (Ray.rzi*Ray.ax) + Ray.dxi ) * a1000;
    Ray.tas:=Ray.ryi / ( (Ray.ryi*Ray.ax) + Ray.dxi ) * a1000;
  end;

  result:=True;

end;


function TOptSystem.CalculateDifferentialCoeffitient(var Ray:TD3Ray ):boolean; {3.38 AST3D 205-217 }
begin

  Ray.a11:=Ray.dq1yh;
  Ray.a21:=Ray.dq1zh;
  Ray.a12:=Ray.dq2yh;
  Ray.a22:=Ray.dq2zh;

  Ray.b11:=Ray.dr1yh;
  Ray.b21:=Ray.dr1zh;
  Ray.b12:=Ray.dr2yh;
  Ray.b22:=Ray.dr2zh;

  result:=True;
end;

function TOptSystem.AsTraceDifferential(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.37 ASTPOW }
begin

  Ray.ryi:=OpticalSurface[k].Curvature;
  Ray.rzi:=OpticalSurface[k].Curvature;
  Ray.ryzi:=0;

  if (OpticalSurface[k].FrenelFlag=1) and (Ray.IhightFlag<>0) then begin
    self.DiffFrenel(Ray, k, aT);
    result:=True;
    exit;
  end;

  if (OpticalSurface[k].AspFlag<>0) then begin
    self.DiffAspherical(Ray, k, aT);
    result:=True;
    exit;
  end;

  if (OpticalSurface[k].CylinderFlag<>0) then begin
    self.DiffCylinder(Ray, k, aT);
    result:=True;
    exit;
  end;

  if (OpticalSurface[k].HiOrderSwitch=True) then begin
    self.DiffHiOrder(Ray, k, aT);
    result:=True;
    exit;
  end;

  result:=True;

end;

function Cptrad(aVyoko:extended; aVtate:extended; aReverseFlag:integer):extended; { 3.39 CPTRAD }
var
  aCptrad, aVabs2, aVnorm, aTv:extended;
begin

  aCptrad:=0;
  aVabs2:=(aVyoko*aVyoko) + (aVtate*aVtate);
  if (aVabs2<1e-30) then begin
    result:=aCptrad;
    exit;
  end;

  aVnorm:=sqrt(aVabs2);

  if aReverseFlag=0 then begin
    aTv:=aVyoko/aVnorm;
    aCptrad:=ArcCos(aTv); {  arcCos  }
    if aVtate<0 then
      aCptrad:=-1 * aCptrad;
  end else begin
    aTv:=aVtate/aVnorm;
    aCptrad:=ArcCos(aTv);  {  arcCos  }
    if aVyoko<0 then
      aCptrad:=-1 * aCptrad;
  end;

  result:=aCptrad

end;

function Pai2Change(aVrad:extended):extended; { 3.40 PAI2CH }
var
  aVpai90, aVpai, aIip:extended;
begin

  aVpai90:=DegreeToRadian(90);
  aVpai:=DegreeToRadian(180);

  if (abs(aVrad) <= aVpai90) then begin
    result:=aVrad;
    exit;
  end;

  if (abs(aVrad) > aVpai) then begin
    aIip:=int(aVrad / aVpai);
    aVrad:=aVrad - (aIip * aVpai);
    if (abs(aVrad) <= aVpai90) then begin
      result:=aVrad;
      exit;
    end;
  end;

  if (aVrad > aVpai90) then
    aVrad:=aVrad - aVpai
  else
    aVrad:=aVrad + aVpai;

  result:=aVrad;

end;

function Chengent(aVrad:extended; aB11i:extended; aB12i:extended; aB21i:extended; aB22i:extended):extended;{3.41 CHGENT}
var
  aReverseFlag:integer;
  aVcos, aVsin, aVtate, aVyoko, aVtemp:extended;
begin

  aReverseFlag:=1;
  aVcos:=cos(aVrad);
  aVsin:=sin(aVrad);

  aVtate:=(aB11i*aVcos) + (aB12i*aVsin);
  aVyoko:=(aB21i*aVcos) + (aB22i*aVsin);

  aVtemp:=Cptrad(aVyoko, aVtate, aReverseFlag);

  result:=aVtemp;

end;

function TOptSystem.DiffFrenel(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.37 ASTPOW 48- }
begin

  self.CalculateRyiRzi(Ray, aT);

  result:=True;

end;

function TOptSystem.DiffAspherical(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.33 BIBASP }
var
  aC, aConic, aVy2,  aVz2,  aVyz,
  aY2z2, aValbri, aValab3,
  aVh1, aSum1, aVh2,  aSum2, aAsp, aHval, aSanash:extended;
  jj:integer;
begin

  aC:=OpticalSurface[k].Curvature;
  if OpticalSurface[k].ConicSwitch=true then begin
    aConic:=OpticalSurface[k].ConicCoefficient;
  end else begin
    aConic:=1.0;
  end;

  aVy2:=Ray.ayi*Ray.ayi;
  aVz2:=Ray.azi*Ray.azi;
  aVyz:=Ray.ayi*Ray.azi;
  aY2z2:=Ray.ayi*Ray.ayi + Ray.azi*Ray.azi;
  aValbri:=aC / sqrt( 1 - aConic*aY2z2*(aC*aC) );
  Ray.vdfy:=Ray.ayi*aValbri;
  Ray.vdfz:=Ray.azi*aValbri;
  aValab3:=aConic * Pow(aValbri, 3);
  Ray.vdfy2:=aValbri + (aValab3 * aVy2);
  Ray.vdfz2:=aValbri + (aValab3 * aVz2);
  Ray.vdfyz:=aVyz * aValab3;

  if (OpticalSurface[k].AspFlag=0) then begin
  {  self.CalculateRyiRzi(Ray, aT);
    result:=True;}
  end;

  if (OpticalSurface[k].AspFlag=1) then begin
    aVh1:=aY2z2;
    aSum1:=OpticalSurface[k].AsphericalCoefficient[1] + ( 2*OpticalSurface[k].AsphericalCoefficient[2]*aVh1 );
    aVh2:=1;
    aSum2:=2*OpticalSurface[k].AsphericalCoefficient[2];
    for jj:=3 to OpticalSurface[k].AsphericalTerm do begin
      aAsp:=OpticalSurface[k].AsphericalCoefficient[jj];
      aVh1:=aVh1 * aY2z2;
      aSum1:=aSum1 + (jj * aAsp * aVh1);
      aVh2:=aVh2 * aY2z2;
      aSum2:=aSum2 + (jj * (jj - 1) * aAsp * aVh2);
    end;
    Ray.vdfy:=Ray.vdfy + (2*Ray.ayi*aSum1);
    Ray.vdfz:=Ray.vdfz + (2*Ray.azi*aSum1);
    Ray.vdfy2:=Ray.vdfy2 + (2*aSum1) + (4*sqr(Ray.ayi)*aSum2);
    Ray.vdfyz:=Ray.vdfyz + (4*Ray.ayi*Ray.azi*aSum2);
    Ray.vdfz2:=Ray.vdfz2 + (2*aSum1) + (4*sqr(Ray.azi)*aSum2);
  end else begin
    aHval:=sqrt(aY2z2);
    aVh1:=aHval;
    aSum1:=2*OpticalSurface[k].AsphericalCoefficient[1] + 3*OpticalSurface[k].AsphericalCoefficient[2]*aVh1;
    aVh2:=1;
    aSum2:=0;
    for jj:=3 to OpticalSurface[k].AsphericalTerm do begin
      aAsp:=OpticalSurface[k].AsphericalCoefficient[jj];
      aVh1:=aVh1 * aHval;
      aSum1:=aSum1 + ( (jj+1) * aAsp * aVh1 );
      aSum2:=aSum2 + ( (jj - 1) * (jj + 1) * aAsp * aVh2 );
      aVh2:=aVh2 * aHval;
    end;
    Ray.vdfy:=Ray.vdfy + (Ray.ayi*aSum1);
    Ray.vdfz:=Ray.vdfz + (Ray.azi*aSum1);
    Ray.vdfy2:=Ray.vdfy2 + aSum1 + (aVy2*aSum2);
    Ray.vdfyz:=Ray.vdfyz + (aVyz*aSum2);
    Ray.vdfz2:=Ray.vdfz2 + aSum1 + (aVz2*aSum2);
    if (aY2z2 > 1e-20) then begin
      aSanash:=3*OpticalSurface[k].AsphericalCoefficient[2]/aHval;
      Ray.vdfy2:=Ray.vdfy2 + (aVy2*aSanash);
      Ray.vdfyz:=Ray.vdfyz + (aVyz*aSanash);
      Ray.vdfz2:=Ray.vdfz2 + (aVz2*aSanash);
    end;
  end;

  self.CalculateRyiRzi(Ray,aT);
  result:=True;

end;

function TOptSystem.DiffCylinder(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.35  BIBCYL }
var
  aTconv:TMatrix;
  aSinst, aCosst, aValcy, aValcz, aValcyz,
  aByi, aBzi, aByi2, aValk, aVald, aValb,
  aDksdy, aDdsdy, aDbsdy:extended;
begin

  aSinst:=OpticalSurface[k].CylinderSin;
  aCosst:=OpticalSurface[k].CylinderCos;
  CulculateTconvBy(aTconv, aSinst, aCosst, aT);
  aValcy:=OpticalSurface[k].Curvature;
  aValcz:=OpticalSurface[k].CylinderCz;
  aValcyz:=aValcy * aValcz;

  aByi:=(Ray.ayi * aCosst) + (Ray.azi * aSinst);
  aBzi:=(-1 * Ray.ayi * aSinst) + (Ray.azi * aCosst);
  aByi2:=aByi * aByi;

  aValk:=sqrt( 1 - sqr(aByi*aValcy) );
  aVald:=1 - ( aValcyz * aByi2 / (1+aValk) );
  aValb:=sqrt( sqr(aVald) - sqr(aBzi*aValcz) );

  aDksdy:=-1 * aByi * sqr(aValcy) / aValk;
  aDdsdy:=-1 * aByi * aValcyz / aValk;
  aDbsdy:=-1 * aVald * aByi *aValcyz / aValb / aValk;

  Ray.vdfy:=aVald * aByi * aValcy / (aValb*aValk);
  Ray.vdfz:=aBzi * aValcz / aValb;

  Ray.vdfy2:=aValcy *
            (   (aDdsdy*aByi+aVald) *aValb*aValk
             - aVald*aByi* (aDbsdy*aValk+aValb*aDksdy)  )
            / sqr(aValb*aValk);

  Ray.vdfz2:=aValcz/aValb
            + sqr(aBzi) * Pow(aValcz,3) / Pow(aValb,3);

  Ray.vdfyz:=-1 * aBzi * aValcz * aDbsdy / sqr(aValb);

  self.CalculateRyiRzi(Ray,aTconv);
  result:=True;

end;

function TOptSystem.DiffHiOrder(var Ray:TD3Ray; k:integer; aT:TMatrix):boolean;{ 3.36 HOSPOW }
var
  aC, aConic, aHsvcos, aHsvsin:extended;
  aTconv:TMatrix;
  aBayi, aBazi, aBiby, aBiby2, aVy2, aVz2, aVyz, aY2z2:extended;
  aValbri, aValab3:extended;
  aNterm:byte;
  aNpowy, aNpowz, aHoscf:TCoefficient;
  aRmpn, aMpn, aRmax:extended;
  aVpowy, aVpowz:extended;
  aNpy, aNpz, aNpym1, aNpzm1, aNpzm, aNpzm2, aNpym2,
  aBibz, aBibz2:extended;
  jj:integer;
begin

  aC:=OpticalSurface[k].Curvature;
  if OpticalSurface[k].ConicSwitch=true then begin
    aConic:=OpticalSurface[k].ConicCoefficient;
  end else begin
    aConic:=1.0;
  end;
  aRmax:=OpticalSurface[k].Diameter / 2;
  aHsvcos:=OpticalSurface[k].HighOrderCos;
  aHsvsin:=OpticalSurface[k].HighOrderSin;

  CulculateTconvBy(aTconv, aHsvcos, aHsvsin, aT);

  aBayi:=(Ray.ayi * aHsvcos) + (Ray.azi * aHsvsin);     {3.36 HOSPOW 27}
  aBazi:=(-1 * Ray.ayi * aHsvsin) + (Ray.azi * aHsvcos);

  aVy2:=sqr(aBayi);
  aVz2:=sqr(aBazi);
  aVyz:=aBayi * aBazi;
  aY2z2:=sqr(aBayi) + sqr(aBazi);

  aValbri:=aC / sqrt( 1 - aConic * aY2z2 * (aC*aC) );

  Ray.vdfy:=aBayi * aValbri;
  Ray.vdfz:=aBazi * aValbri;

  aValab3:=aConic * Pow(aValbri,3);
  Ray.vdfy2:=aValbri + (aValab3 * aVy2);
  Ray.vdfz2:=aValbri + (aValab3 * aVz2);
  Ray.vdfyz:=aVyz * aValab3;

  aNterm:=OpticalSurface[k].HighOrderTerm;

  for jj:=1 to aNterm do begin     {3.29 HSASP 28-44}
    aNpowy[jj]:=OpticalSurface[k].HighOrderPowerY[jj];
    aNpowz[jj]:=OpticalSurface[k].HighOrderPowerZ[jj];
    aRmpn:=1.0;
    aMpn:=aNpowy[jj] + aNpowz[jj];
    if aMpn<>0 then begin
      aRmpn:=Pow(aRmax, aMpn);
    end;
    aHoscf[jj]:=OpticalSurface[k].HighOrderCoefficient[jj] / aRmpn;
  end;


  for jj:=1 to aNterm do begin
    aNpy:=aNpowy[jj];
    aVpowy:=1;
    if (aNpy<>0) then begin
      aVpowy:=Pow(aBayi, aNpy);
    end;
    if (aNpy=0) then begin
      aBiby:=0;
    end else begin
      if (aNpy=1) then begin
        aBiby:=1;
      end else begin
        aNpym1:=aNpy - 1;
        aBiby:=aNpy * Pow(aBayi, aNpym1);
      end;
    end;

    if (aNpy<=1) then begin
      aBiby2:=0;
    end else begin
      if (aNpy=2) then begin
        aBiby2:=2;
      end else begin
        aNpym2:=aNpy - 2;
        aBiby2:=aNpy * (aNpy - 1) * Pow(aBayi, aNpym2);
      end;
    end;

    aNpz:=aNpowz[jj];
    aVpowz:=1;
    if (aNpz<>0) then begin
      aVpowz:=Pow(aBazi, aNpz);
    end;
    if (aNpz=0) then begin
      aBibz:=0;
    end else begin
      if (aNpz=1) then begin
        aBibz:=1;
      end else begin
        aNpzm1:=aNpz - 1;
        aBibz:=aNpz * Pow(aBazi, aNpzm1);
      end;
    end;

    if (aNpz<=1) then begin
      aBibz2:=0;
    end else begin
      if (aNpz=2) then begin
        aBibz2:=2;
      end else begin
        aNpzm2:=aNpz - 2;
        aBibz2:=aNpz * (aNpz - 1) * Pow(aBazi, aNpzm2);
      end;
    end;

    Ray.vdfy:=Ray.vdfy + aHoscf[jj]*aBiby*aVpowz;
    Ray.vdfz:=Ray.vdfz + aHoscf[jj]*aBibz*aVpowy;
    Ray.vdfy2:=Ray.vdfy2 + aHoscf[jj]*aBiby2*aVpowz;
    Ray.vdfz2:=Ray.vdfz2 + aHoscf[jj]*aBibz2*aVpowy;
    Ray.vdfyz:=Ray.vdfyz + aHoscf[jj]*aBiby*aBibz;

  end;

  self.CalculateRyiRzi(Ray,aTconv);
  result:=True;

end;

function TOptSystem.CalculateRyiRzi(var Ray:TD3Ray; aT:TMatrix):boolean;{ 3.37 ASTPOW 78-91 }
var
  aT11yz:extended;
begin

  aT11yz:=aT[1,1]  - Ray.vdfy * aT[1,2] - Ray.vdfz * aT[1,3];
  Ray.ryi:=(  Ray.vdfy2*sqr(aT[2,2])
            + 2*Ray.vdfyz*aT[2,3]*aT[2,2]
            + Ray.vdfz2*sqr(aT[2,3])  ) / aT11yz;

  Ray.rzi:=( Ray.vdfz2*sqr(aT[3,3])
            + Ray.vdfy2*sqr(aT[3,2])
            + 2*Ray.vdfyz*aT[3,3]*aT[3,2] ) / aT11yz;

  Ray.ryzi:=( Ray.vdfy2*aT[3,2]*aT[2,2]
            + Ray.vdfyz*( aT[3,3]*aT[2,2]+aT[2,3] )
            + Ray.vdfz2*aT[2,3]*aT[3,3]  ) / aT11yz;
  result:=True;

end;

//*****************************************************************************

procedure TOptSystem.TransferVewCoordinates;
var
  i,k :integer;
begin
  for k:=1 to self.TotalSurfaceNumber do begin
    for i:=1 to MaxCurveLine do begin
      self.OpticalSurface[k].MeridionalLine[i,'Z']:=-self.OpticalSurface[k].MeridionalLine[i,'Z'];
      self.OpticalSurface[k].SagittalLine[i,'Z']:=-self.OpticalSurface[k].SagittalLine[i,'Z'];
    end;
    for i:=1 to MaxOutLine do begin
      self.OpticalSurface[k].OutLine[i,'Z']:=-self.OpticalSurface[k].OutLine[i,'Z'];
    end;
  end;

  for i:=1 to MaxCurveLine do begin
    self.FocusPlane.MeridionalLine[i,'Z']:=-self.FocusPlane.MeridionalLine[i,'Z'];
    self.FocusPlane.SagittalLine[i,'Z']:=-self.FocusPlane.SagittalLine[i,'Z'];

    self.ObjectPlane.MeridionalLine[i,'Z']:=-self.ObjectPlane.MeridionalLine[i,'Z'];
    self.ObjectPlane.SagittalLine[i,'Z']:=-self.ObjectPlane.SagittalLine[i,'Z'];
  end;

  for i:=1 to MaxOutLine do begin
    self.FocusPlane.OutLine[i,'Z']:=-self.FocusPlane.OutLine[i,'Z'];
    self.ObjectPlane.OutLine[i,'Z']:=-self.FocusPlane.OutLine[i,'Z'];
  end;


end;

procedure TOptSystem.TransferInVewCoordinates(aX:integer; aY:integer; aZ:integer);
var
  i,k :integer;
begin
  for k:=1 to self.TotalSurfaceNumber do begin
    for i:=1 to MaxCurveLine do begin
      self.OpticalSurface[k].MeridionalLine[i,'X']:=self.OpticalSurface[k].MeridionalLine[i,'X']+aX;
      self.OpticalSurface[k].MeridionalLine[i,'Y']:=self.OpticalSurface[k].MeridionalLine[i,'Y']+aY;
      self.OpticalSurface[k].MeridionalLine[i,'Z']:=self.OpticalSurface[k].MeridionalLine[i,'Z']+aZ;

      self.OpticalSurface[k].SagittalLine[i,'X']:=self.OpticalSurface[k].SagittalLine[i,'X']+aX;
      self.OpticalSurface[k].SagittalLine[i,'Y']:=self.OpticalSurface[k].SagittalLine[i,'Y']+aY;
      self.OpticalSurface[k].SagittalLine[i,'Z']:=self.OpticalSurface[k].SagittalLine[i,'Z']+aZ;

    end;
    for i:=1 to MaxOutLine do begin
      self.OpticalSurface[k].OutLine[i,'X']:=self.OpticalSurface[k].OutLine[i,'X']+aX;
      self.OpticalSurface[k].OutLine[i,'Y']:=self.OpticalSurface[k].OutLine[i,'Y']+aY;
      self.OpticalSurface[k].OutLine[i,'Z']:=self.OpticalSurface[k].OutLine[i,'Z']+aZ;
    end;
  end;

  for i:=1 to MaxCurveLine do begin
    self.FocusPlane.MeridionalLine[i,'X']:=self.FocusPlane.MeridionalLine[i,'X']+aX;
    self.FocusPlane.MeridionalLine[i,'Y']:=self.FocusPlane.MeridionalLine[i,'Y']+aY;
    self.FocusPlane.MeridionalLine[i,'Z']:=self.FocusPlane.MeridionalLine[i,'Z']+aZ;

    self.FocusPlane.SagittalLine[i,'X']:=self.FocusPlane.SagittalLine[i,'X']+aX;
    self.FocusPlane.SagittalLine[i,'Y']:=self.FocusPlane.SagittalLine[i,'Y']+aY;
    self.FocusPlane.SagittalLine[i,'Z']:=self.FocusPlane.SagittalLine[i,'Z']+aZ;

    self.ObjectPlane.MeridionalLine[i,'X']:=self.ObjectPlane.MeridionalLine[i,'X']+aX;
    self.ObjectPlane.MeridionalLine[i,'Y']:=self.ObjectPlane.MeridionalLine[i,'Y']+aY;
    self.ObjectPlane.MeridionalLine[i,'Z']:=self.ObjectPlane.MeridionalLine[i,'Z']+aZ;

    self.ObjectPlane.SagittalLine[i,'X']:=self.ObjectPlane.SagittalLine[i,'X']+aX;
    self.ObjectPlane.SagittalLine[i,'Y']:=self.ObjectPlane.SagittalLine[i,'Y']+aY;
    self.ObjectPlane.SagittalLine[i,'Z']:=self.ObjectPlane.SagittalLine[i,'Z']+aZ;
  end;

  for i:=1 to MaxOutLine do begin
    self.FocusPlane.OutLine[i,'X']:=self.FocusPlane.OutLine[i,'X']+aX;
    self.FocusPlane.OutLine[i,'Y']:=self.FocusPlane.OutLine[i,'Y']+aY;
    self.FocusPlane.OutLine[i,'Z']:=self.FocusPlane.OutLine[i,'Z']+aZ;

    self.ObjectPlane.OutLine[i,'X']:=self.FocusPlane.OutLine[i,'X']+aX;
    self.ObjectPlane.OutLine[i,'Y']:=self.FocusPlane.OutLine[i,'Y']+aY;
    self.ObjectPlane.OutLine[i,'Z']:=self.FocusPlane.OutLine[i,'Z']+aZ;
  end;


end;

procedure TOptSystem.RotationInWorldCoordinates(Rx:extended; Ry:extended; Rz:extended);
var
  X, Y, Z: integer;
  Xx,Xy,Xz, Yx,Yy,Yz, Zx,Zy,Zz:extended;
  k,i:integer;
begin
  Rx:=-Rx;
  Ry:=-Ry;
  Rz:=-Rz;

  Xx:= cos(Ry)*cos(Rz)+sin(Rx)*sin(Ry)*sin(Rz) ;
  Xy:= cos(Rx)*sin(Rz) ;
  Xz:= -sin(Ry)*cos(Rz)+sin(Rx)*cos(Ry)*sin(Rz) ;

  Yx:= -cos(Ry)*sin(Rz)+sin(Rx)*sin(Ry)*cos(Rz);
  Yy:= cos(Rx)*cos(Rz);
  Yz:= sin(Ry)*sin(Rz)+sin(Rx)*cos(Ry)*cos(Rz);

  Zx:= cos(Rx)*sin(Ry);
  Zy:= -sin(Rx);
  Zz:= cos(Rx)*cos(Ry);

  for k:=1 to self.TotalSurfaceNumber do begin
    for i:=1 to MaxCurveLine do begin
      X:=trunc(self.OpticalSurface[k].MeridionalLine[i,'X']*Xx+
         self.OpticalSurface[k].MeridionalLine[i,'Y']*Xy+
         self.OpticalSurface[k].MeridionalLine[i,'Z']*Xz);

      Y:=trunc(self.OpticalSurface[k].MeridionalLine[i,'X']*Yx+
         self.OpticalSurface[k].MeridionalLine[i,'Y']*Yy+
         self.OpticalSurface[k].MeridionalLine[i,'Z']*Yz);

      Z:=trunc(self.OpticalSurface[k].MeridionalLine[i,'X']*Zx+
         self.OpticalSurface[k].MeridionalLine[i,'Y']*Zy+
         self.OpticalSurface[k].MeridionalLine[i,'Z']*Zz);

      self.OpticalSurface[k].MeridionalLine[i,'X']:=X;
      self.OpticalSurface[k].MeridionalLine[i,'Y']:=Y;
      self.OpticalSurface[k].MeridionalLine[i,'Z']:=Z;


      X:=trunc(self.OpticalSurface[k].SagittalLine[i,'X']*Xx+
         self.OpticalSurface[k].SagittalLine[i,'Y']*Xy+
         self.OpticalSurface[k].SagittalLine[i,'Z']*Xz);

      Y:=trunc(self.OpticalSurface[k].SagittalLine[i,'X']*Yx+
         self.OpticalSurface[k].SagittalLine[i,'Y']*Yy+
         self.OpticalSurface[k].SagittalLine[i,'Z']*Yz);

      Z:=trunc(self.OpticalSurface[k].SagittalLine[i,'X']*Zx+
         self.OpticalSurface[k].SagittalLine[i,'Y']*Zy+
         self.OpticalSurface[k].SagittalLine[i,'Z']*Zz);

      self.OpticalSurface[k].SagittalLine[i,'X']:=X;
      self.OpticalSurface[k].SagittalLine[i,'Y']:=Y;
      self.OpticalSurface[k].SagittalLine[i,'Z']:=Z;
    end;
    for i:=1 to MaxOutLine do begin
      X:=trunc(self.OpticalSurface[k].OutLine[i,'X']*Xx+
         self.OpticalSurface[k].OutLine[i,'Y']*Xy+
         self.OpticalSurface[k].OutLine[i,'Z']*Xz);

      Y:=trunc(self.OpticalSurface[k].OutLine[i,'X']*Yx+
         self.OpticalSurface[k].OutLine[i,'Y']*Yy+
         self.OpticalSurface[k].OutLine[i,'Z']*Yz);

      Z:=trunc(self.OpticalSurface[k].OutLine[i,'X']*Zx+
         self.OpticalSurface[k].OutLine[i,'Y']*Zy+
         self.OpticalSurface[k].OutLine[i,'Z']*Zz);

      self.OpticalSurface[k].OutLine[i,'X']:=X;
      self.OpticalSurface[k].OutLine[i,'Y']:=Y;
      self.OpticalSurface[k].OutLine[i,'Z']:=Z;
    end;
  end;

  for i:=1 to MaxCurveLine do begin
    X:=trunc(self.FocusPlane.MeridionalLine[i,'X']*Xx+
       self.FocusPlane.MeridionalLine[i,'Y']*Xy+
       self.FocusPlane.MeridionalLine[i,'Z']*Xz);

    Y:=trunc(self.FocusPlane.MeridionalLine[i,'X']*Yx+
       self.FocusPlane.MeridionalLine[i,'Y']*Yy+
       self.FocusPlane.MeridionalLine[i,'Z']*Yz);

    Z:=trunc(self.FocusPlane.MeridionalLine[i,'X']*Zx+
       self.FocusPlane.MeridionalLine[i,'Y']*Zy+
       self.FocusPlane.MeridionalLine[i,'Z']*Zz);

    self.FocusPlane.MeridionalLine[i,'X']:=X;
    self.FocusPlane.MeridionalLine[i,'Y']:=Y;
    self.FocusPlane.MeridionalLine[i,'Z']:=Z;

    X:=trunc(self.FocusPlane.SagittalLine[i,'X']*Xx+
      self.FocusPlane.SagittalLine[i,'Y']*Xy+
      self.FocusPlane.SagittalLine[i,'Z']*Xz);

    Y:=trunc(self.FocusPlane.SagittalLine[i,'X']*Yx+
       self.FocusPlane.SagittalLine[i,'Y']*Yy+
       self.FocusPlane.SagittalLine[i,'Z']*Yz);

    Z:=trunc(self.FocusPlane.SagittalLine[i,'X']*Zx+
       self.FocusPlane.SagittalLine[i,'Y']*Zy+
       self.FocusPlane.SagittalLine[i,'Z']*Zz);

    self.FocusPlane.SagittalLine[i,'X']:=X;
    self.FocusPlane.SagittalLine[i,'Y']:=Y;
    self.FocusPlane.SagittalLine[i,'Z']:=Z;

    X:=trunc(self.ObjectPlane.MeridionalLine[i,'X']*Xx+
       self.ObjectPlane.MeridionalLine[i,'Y']*Xy+
       self.ObjectPlane.MeridionalLine[i,'Z']*Xz);

    Y:=trunc(self.ObjectPlane.MeridionalLine[i,'X']*Yx+
       self.ObjectPlane.MeridionalLine[i,'Y']*Yy+
       self.ObjectPlane.MeridionalLine[i,'Z']*Yz);

    Z:=trunc(self.ObjectPlane.MeridionalLine[i,'X']*Zx+
       self.ObjectPlane.MeridionalLine[i,'Y']*Zy+
       self.ObjectPlane.MeridionalLine[i,'Z']*Zz);

    self.ObjectPlane.MeridionalLine[i,'X']:=X;
    self.ObjectPlane.MeridionalLine[i,'Y']:=Y;
    self.ObjectPlane.MeridionalLine[i,'Z']:=Z;

    X:=trunc(self.ObjectPlane.SagittalLine[i,'X']*Xx+
       self.ObjectPlane.SagittalLine[i,'Y']*Xy+
       self.ObjectPlane.SagittalLine[i,'Z']*Xz);

    Y:=trunc(self.ObjectPlane.SagittalLine[i,'X']*Yx+
       self.ObjectPlane.SagittalLine[i,'Y']*Yy+
       self.ObjectPlane.SagittalLine[i,'Z']*Yz);

    Z:=trunc(self.ObjectPlane.SagittalLine[i,'X']*Zx+
       self.ObjectPlane.SagittalLine[i,'Y']*Zy+
       self.ObjectPlane.SagittalLine[i,'Z']*Zz);
    self.ObjectPlane.SagittalLine[i,'X']:=X;
    self.ObjectPlane.SagittalLine[i,'Y']:=Y;
    self.ObjectPlane.SagittalLine[i,'Z']:=Z;
  end;

  for i:=1 to MaxOutLine do begin
    X:=trunc(self.FocusPlane.OutLine[i,'X']*Xx+
       self.FocusPlane.OutLine[i,'Y']*Xy+
       self.FocusPlane.OutLine[i,'Z']*Xz);

    Y:=trunc(self.FocusPlane.OutLine[i,'X']*Yx+
       self.FocusPlane.OutLine[i,'Y']*Yy+
       self.FocusPlane.OutLine[i,'Z']*Yz);

    Z:=trunc(self.FocusPlane.OutLine[i,'X']*Zx+
       self.FocusPlane.OutLine[i,'Y']*Zy+
       self.FocusPlane.OutLine[i,'Z']*Zz);

    self.FocusPlane.OutLine[i,'X']:=X;
    self.FocusPlane.OutLine[i,'Y']:=Y;
    self.FocusPlane.OutLine[i,'Z']:=Z;

    X:=trunc(self.FocusPlane.OutLine[i,'X']*Xx+
       self.FocusPlane.OutLine[i,'Y']*Xy+
       self.FocusPlane.OutLine[i,'Z']*Xz);

    Y:=trunc(self.FocusPlane.OutLine[i,'X']*Yx+
       self.FocusPlane.OutLine[i,'Y']*Yy+
       self.FocusPlane.OutLine[i,'Z']*Yz);

    Z:=trunc(self.FocusPlane.OutLine[i,'X']*Zx+
       self.FocusPlane.OutLine[i,'Y']*Zy+
       self.FocusPlane.OutLine[i,'Z']*Zz);
    self.ObjectPlane.OutLine[i,'X']:=X;
    self.ObjectPlane.OutLine[i,'Y']:=Y;
    self.ObjectPlane.OutLine[i,'Z']:=Z;
  end;


end;


procedure TOptSystem.CaluculateWorldCoordinates(magnification:extended);
var
 aTotalDistance, aObjDistance, aBfl: longint;
 aStock: array['X'..'Z'] of longint;
 aValue: array['X'..'Z'] of longint;
 k ,i, jj:integer;
 m:char;
 aMatrix:TMatrix;

begin
  self.ObjectPlane.CulculateSurfacePoint(Magnification);
  for k:=1 to self.TotalSurfaceNumber do begin
    self.OpticalSurface[k].CulculateSurfacePoint(Magnification);
  end;
  self.FocusPlane.CulculateSurfacePoint(Magnification);

  aObjDistance:=0{trunc( self.ObjectDistance*Magnification )};
  aBfl:=trunc( self.BackFocus[nd]*Magnification );

  for i:=1 to MaxcurveLine do begin
    self.ObjectPlane.MeridionalLine[i,'X']:=self.ObjectPlane.MeridionalLine[i,'X']-aObjDistance;
    self.ObjectPlane.SagittalLine[i,'X']:=self.ObjectPlane.SagittalLine[i,'X']-aObjDistance;
  end;
  for i:=1 to MaxOutLine do begin
    self.ObjectPlane.OutLine[i,'X']:=self.ObjectPlane.OutLine[i,'X']-aObjDistance;
  end;

  aTotalDistance:=0;
  for k:=2 to self.TotalSurfaceNumber do begin
    aTotalDistance:=aTotalDistance+
                    trunc(self.OpticalMedium[k-1].Distance*Magnification );
    for i:=1 to MaxCurveLine do begin
      self.OpticalSurface[k].MeridionalLine[i,'X']:=self.OpticalSurface[k].MeridionalLine[i,'X']+aTotalDistance;
      self.OpticalSurface[k].SagittalLine[i,'X']:=self.OpticalSurface[k].SagittalLine[i,'X']+aTotalDistance;
    end;
    for i:=1 to MaxOutLine do begin
      self.OpticalSurface[k].OutLine[i,'X']:=self.OpticalSurface[k].OutLine[i,'X']+aTotalDistance;
    end;
  end;
  aTotalDistance:=aTotalDistance+aBfl;
  for i:=1 to MaxCurveLine do begin
    self.FocusPlane.MeridionalLine[i,'X']:=self.FocusPlane.MeridionalLine[i,'X']+aTotalDistance;
    self.FocusPlane.SagittalLine[i,'X']:=self.FocusPlane.SagittalLine[i,'X']+aTotalDistance;
  end;
  for i:=1 to MaxOutLine do begin
    self.FocusPlane.OutLine[i,'X']:=self.FocusPlane.OutLine[i,'X']+aTotalDistance;
  end;

  //*********************************************************************
  for k:=1 to self.TotalSurfaceNumber+1 do begin
  if k<=totalSurfaceNumber then begin
    if self.OpticalSurface[k].SiftSwitch=True then begin
      for jj:=k to self.TotalSurfaceNumber+1 do begin
        if jj<=totalSurfaceNumber then begin
          for i:=1 to MaxCurveLine do begin
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].MeridionalLine[i,m]:=OpticalSurface[jj].MeridionalLine[i,m]
               +trunc(self.OpticalSurface[k].SiftVector[m]*Magnification);
              OpticalSurface[jj].SagittalLine[i,m]:=OpticalSurface[jj].SagittalLine[i,m]
               +trunc(self.OpticalSurface[k].SiftVector[m]*Magnification);
            end;
          end;
          for i:=1 to MaxOutLine do begin
            for m:='X' to 'Z' do begin
            OpticalSurface[jj].OutLine[i,m]:=OpticalSurface[jj].OutLine[i,m]
               +trunc(self.OpticalSurface[k].SiftVector[m]*Magnification);
            end;
          end;

        end else begin
          for i:=1 to MaxCurveLine do begin
            for m:='X' to 'Z' do begin
              FocusPlane.MeridionalLine[i,m]:= FocusPlane.MeridionalLine[i,m]
               +trunc( self.OpticalSurface[k].SiftVector[m]*Magnification);
              FocusPlane.SagittalLine[i,m]:= FocusPlane.SagittalLine[i,m]
               +trunc( self.OpticalSurface[k].SiftVector[m]*Magnification);
            end;
          end;
          for i:=1 to MaxOutLine do begin
            for m:='X' to 'Z' do begin
              FocusPlane.OutLine[i,m]:= FocusPlane.OutLine[i,m]
               +trunc( self.OpticalSurface[k].SiftVector[m]*Magnification);
            end;
          end;
        end;
      end;
    end;
  end else begin
    if self.FocusPlane.SiftSwitch=True then begin
      for i:=1 to MaxCurveLine do begin
        for m:='X' to 'Z' do begin
          FocusPlane.MeridionalLine[i,m]:=FocusPlane.MeridionalLine[i,m]
               +trunc(self.FocusPlane.SiftVector[m]*Magnification);
          FocusPlane.SagittalLine[i,m]:=FocusPlane.SagittalLine[i,m]
               +trunc(self.FocusPlane.SiftVector[m]*Magnification);
        end;
      end;
      for i:=1 to MaxOutLine do begin
        for m:='X' to 'Z' do begin
          FocusPlane.OutLine[i,m]:=FocusPlane.OutLine[i,m]
               +trunc(self.FocusPlane.SiftVector[m]*Magnification);
        end;
      end;
    end;
  end;
  end;

//**************** Tilt ***************************************

  for k:=self.TotalSurfaceNumber+1 downto 1 do begin

  if k<=totalsurfaceNumber then begin
    if self.OpticalSurface[k].tiltSwitch=True then begin

      for m:='X' to 'Z' do begin
        aStock[m]:=OpticalSurface[k].MeridionalLine[(MaxCurveLine div 2)+1 ,m];
      end;
      aMatrix:=self.OpticalSurface[k].popTiltMatrix;

      for jj:=self.TotalSurfaceNumber+1 downto k do begin
        if jj<=totalsurfaceNumber then begin
          for i:=1 to MaxCurveLine do begin
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].MeridionalLine[i,m]:=OpticalSurface[jj].MeridionalLine[i,m]-aStock[m];
              OpticalSurface[jj].SagittalLine[i,m]:=OpticalSurface[jj].SagittalLine[i,m]-aStock[m];
            end;

            for m:='X' to 'Z' do begin
              aValue[m]:=OpticalSurface[jj].MeridionalLine[i,m];
            end;
            Rotation( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].MeridionalLine[i,m]:=aValue[m];
            end;

            for m:='X' to 'Z' do begin
              aValue[m]:=OpticalSurface[jj].SagittalLine[i,m];
            end;
            Rotation( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].SagittalLine[i,m]:=aValue[m];
            end;

            for m:='X' to 'Z' do begin
              OpticalSurface[jj].MeridionalLine[i,m]:=OpticalSurface[jj].MeridionalLine[i,m]+aStock[m];
              OpticalSurface[jj].SagittalLine[i,m]:=OpticalSurface[jj].SagittalLine[i,m]+aStock[m];
            end;

          end;
          for i:=1 to MaxOutLine do begin
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].OutLine[i,m]:=OpticalSurface[jj].OutLine[i,m]-aStock[m];
            end;

            for m:='X' to 'Z' do begin
              aValue[m]:=OpticalSurface[jj].OutLine[i,m];
            end;
            Rotation( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].OutLine[i,m]:=aValue[m];
            end;

            for m:='X' to 'Z' do begin
              OpticalSurface[jj].OutLine[i,m]:=OpticalSurface[jj].OutLine[i,m]+aStock[m];
            end;
          end;
        end else begin
          for i:=1 to MaxCurveLine do begin
            for m:='X' to 'Z' do begin
              FocusPlane.MeridionalLine[i,m]:=FocusPlane.MeridionalLine[i,m]-aStock[m];
              FocusPlane.SagittalLine[i,m]:=FocusPlane.SagittalLine[i,m]-aStock[m];
            end;
            for m:='X' to 'Z' do begin
              aValue[m]:= FocusPlane.MeridionalLine[i,m];
            end;
            Rotation( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              FocusPlane.MeridionalLine[i,m]:=aValue[m];
            end;
            for m:='X' to 'Z' do begin
              aValue[m]:= FocusPlane.SagittalLine[i,m];
            end;
            Rotation( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
            FocusPlane.SagittalLine[i,m]:=aValue[m];
            end;
            for m:='X' to 'Z' do begin
              FocusPlane.MeridionalLine[i,m]:=FocusPlane.MeridionalLine[i,m]+aStock[m];
              FocusPlane.SagittalLine[i,m]:=FocusPlane.SagittalLine[i,m]+aStock[m];
            end;
          end;
          for i:=1 to MaxOutLine do begin
            for m:='X' to 'Z' do begin
              FocusPlane.OutLine[i,m]:=FocusPlane.OutLine[i,m]-aStock[m];
            end;
            for m:='X' to 'Z' do begin
              aValue[m]:=FocusPlane.OutLine[i,m];
            end;
            Rotation( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              FocusPlane.OutLine[i,m]:=aValue[m];
            end;
            for m:='X' to 'Z' do begin
              FocusPlane.OutLine[i,m]:=FocusPlane.OutLine[i,m]+aStock[m];
            end;
          end;

        end;

      end;

    end;
  end else begin
    if self.FocusPlane.tiltSwitch=True then begin
      for m:='X' to 'Z' do begin
        aStock[m]:=FocusPlane.MeridionalLine[(MaxCurveLine div 2)+1,m];
      end;
      aMatrix:=self.FocusPlane.popTiltMatrix;
      for i:=1 to MaxCurveLine do begin
        for m:='X' to 'Z' do begin
          FocusPlane.MeridionalLine[i,m]:=FocusPlane.MeridionalLine[i,m]-aStock[m];
          FocusPlane.SagittalLine[i,m]:=FocusPlane.SagittalLine[i,m]-aStock[m];
        end;
        for m:='X' to 'Z' do begin
          aValue[m]:= FocusPlane.MeridionalLine[i,m];
        end;
        Rotation( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
        for m:='X' to 'Z' do begin
          FocusPlane.MeridionalLine[i,m]:=aValue[m];
        end;
        for m:='X' to 'Z' do begin
          aValue[m]:= FocusPlane.SagittalLine[i,m];
        end;
        Rotation( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
        for m:='X' to 'Z' do begin
          FocusPlane.SagittalLine[i,m]:=aValue[m];
        end;
        for m:='X' to 'Z' do begin
          FocusPlane.MeridionalLine[i,m]:=FocusPlane.MeridionalLine[i,m]+aStock[m];
          FocusPlane.SagittalLine[i,m]:=FocusPlane.SagittalLine[i,m]+aStock[m];
        end;
      end;
      for i:=1 to MaxOutLine do begin
        for m:='X' to 'Z' do begin
          FocusPlane.OutLine[i,m]:=FocusPlane.OutLine[i,m]-aStock[m];
        end;
        for m:='X' to 'Z' do begin
          aValue[m]:= FocusPlane.OutLine[i,m];
        end;
        Rotation( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
        for m:='X' to 'Z' do begin
          FocusPlane.OutLine[i,m]:=aValue[m];
        end;
        for m:='X' to 'Z' do begin
          FocusPlane.OutLine[i,m]:=FocusPlane.OutLine[i,m]+aStock[m];
        end;
      end;
    end;
  end;
  end;

end;

procedure TOptSystem.CaluculateWorldCoordinatesInReal;
var
 aTotalDistance, aObjDistance, aBfl, aSwell,aY, aSetBack: extended;
 anEdgeAdd: array[TMaxOptSurfaceRange] of extended;
 aStock: array['X'..'Z'] of extended;
 aValue: array['X'..'Z'] of extended;
 k ,i, jj:integer;
 m:char;
 aMatrix:TMatrix;

begin
  self.ObjectPlane.CulculateSurfacePointInReal;
  for k:=1 to self.TotalSurfaceNumber do begin
    self.OpticalSurface[k].CulculateSurfacePointInReal;
  end;
  self.FocusPlane.CulculateSurfacePointInReal;

  aObjDistance:=0;
  aBfl:=self.BackFocus[nd];

  for i:=1 to MaxcurveLine do begin
    self.ObjectPlane.MLineReal[i,'X']:=self.ObjectPlane.MLineReal[i,'X']-aObjDistance;
    self.ObjectPlane.SLineReal[i,'X']:=self.ObjectPlane.SLineReal[i,'X']-aObjDistance;
  end;
  for i:=1 to MaxOutLine do begin
    self.ObjectPlane.OLineReal[i,'X']:=self.ObjectPlane.OLineReal[i,'X']-aObjDistance;
  end;

  for k:=1 to self.TotalSurfaceNumber do begin
    if (self.OpticalSurface[k].frenelFlag=0)or(self.OpticalSurface[k].frenelFlag=3) then begin
      anEdgeAdd[k]:= 0;
    end;
    if (self.OpticalSurface[k].frenelFlag=1)or (self.OpticalSurface[k].frenelFlag=2) then begin
      aY:=self.OpticalSurface[k].MLineReal[1,'Y'];
      aSwell:=self.OpticalSurface[k].Epsxyz(OpticalSurface[k].FrenelZeroZorn,0);
      aSetBack:=self.OpticalSurface[k].Epsxyz(abs(aY),0);
      if aSwell<0 then
        anEdgeAdd[k]:= aSetBack-aSwell
       else
        anEdgeAdd[k]:= aSetBack;
    end;
  end;

  
  aTotalDistance:=0;

  for i:=1 to MaxOutLine do begin
    self.OpticalSurface[1].OLineReal[i,'X']:=self.OpticalSurface[1].OLineReal[i,'X']+aTotalDistance
                                                 -anEdgeAdd[1];
  end;
  

  for k:=2 to self.TotalSurfaceNumber do begin
    aTotalDistance:=aTotalDistance+self.OpticalMedium[k-1].Distance;
    for i:=1 to MaxCurveLine do begin
      self.OpticalSurface[k].MLineReal[i,'X']:=self.OpticalSurface[k].MLineReal[i,'X']+aTotalDistance;
      self.OpticalSurface[k].SLineReal[i,'X']:=self.OpticalSurface[k].SLineReal[i,'X']+aTotalDistance;
    end;
    for i:=1 to MaxOutLine do begin
      self.OpticalSurface[k].OLineReal[i,'X']:=self.OpticalSurface[k].OLineReal[i,'X']+aTotalDistance
                                                 -anEdgeAdd[k];
    end;
  end;
  aTotalDistance:=aTotalDistance+aBfl;
  for i:=1 to MaxCurveLine do begin
    self.FocusPlane.MLineReal[i,'X']:=self.FocusPlane.MLineReal[i,'X']+aTotalDistance;
    self.FocusPlane.SLineReal[i,'X']:=self.FocusPlane.SLineReal[i,'X']+aTotalDistance;
  end;
  for i:=1 to MaxOutLine do begin
    self.FocusPlane.OLineReal[i,'X']:=self.FocusPlane.OLineReal[i,'X']+aTotalDistance;
  end;

  //*********************************************************************
  for k:=1 to self.TotalSurfaceNumber+1 do begin
  if k<=totalSurfaceNumber then begin
    if self.OpticalSurface[k].SiftSwitch=True then begin
      for jj:=k to self.TotalSurfaceNumber+1 do begin
        if jj<=totalSurfaceNumber then begin
          for i:=1 to MaxCurveLine do begin
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].MLineReal[i,m]:=OpticalSurface[jj].MLineReal[i,m]
               +self.OpticalSurface[k].SiftVector[m];
              OpticalSurface[jj].SLineReal[i,m]:=OpticalSurface[jj].SLineReal[i,m]
               +self.OpticalSurface[k].SiftVector[m];
            end;
          end;
          for i:=1 to MaxOutLine do begin
            for m:='X' to 'Z' do begin
            OpticalSurface[jj].OLineReal[i,m]:=OpticalSurface[jj].OLineReal[i,m]
               +self.OpticalSurface[k].SiftVector[m];
            end;
          end;

        end else begin
          for i:=1 to MaxCurveLine do begin
            for m:='X' to 'Z' do begin
              FocusPlane.MLineReal[i,m]:= FocusPlane.MLineReal[i,m]
               + self.OpticalSurface[k].SiftVector[m];
              FocusPlane.SLineReal[i,m]:= FocusPlane.SLineReal[i,m]
               + self.OpticalSurface[k].SiftVector[m];
            end;
          end;
          for i:=1 to MaxOutLine do begin
            for m:='X' to 'Z' do begin
              FocusPlane.OLineReal[i,m]:= FocusPlane.OLineReal[i,m]
               + self.OpticalSurface[k].SiftVector[m];
            end;
          end;
        end;
      end;
    end;
  end else begin
    if self.FocusPlane.SiftSwitch=True then begin
      for i:=1 to MaxCurveLine do begin
        for m:='X' to 'Z' do begin
          FocusPlane.MLineReal[i,m]:=FocusPlane.MLineReal[i,m]
               +self.FocusPlane.SiftVector[m];
          FocusPlane.SLineReal[i,m]:=FocusPlane.SLineReal[i,m]
               +self.FocusPlane.SiftVector[m];
        end;
      end;
      for i:=1 to MaxOutLine do begin
        for m:='X' to 'Z' do begin
          FocusPlane.OLineReal[i,m]:=FocusPlane.OLineReal[i,m]
               +self.FocusPlane.SiftVector[m];
        end;
      end;
    end;
  end;
  end;

//**************** Tilt ***************************************

  for k:=self.TotalSurfaceNumber+1 downto 1 do begin

  if k<=totalsurfaceNumber then begin
    if self.OpticalSurface[k].tiltSwitch=True then begin

      for m:='X' to 'Z' do begin
        aStock[m]:=OpticalSurface[k].MLineReal[(MaxCurveLine div 2)+1 ,m];
      end;
      aMatrix:=self.OpticalSurface[k].popTiltMatrix;

      for jj:=k to self.TotalSurfaceNumber+1 do begin

        if jj<=totalsurfaceNumber then begin
          for i:=1 to MaxCurveLine do begin
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].MLineReal[i,m]:=OpticalSurface[jj].MLineReal[i,m]-aStock[m];
              OpticalSurface[jj].SLineReal[i,m]:=OpticalSurface[jj].SLinereal[i,m]-aStock[m];
            end;

            for m:='X' to 'Z' do begin
              aValue[m]:=OpticalSurface[jj].MLineReal[i,m];
            end;
            RotationReal( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].MLineReal[i,m]:=aValue[m];
            end;

            for m:='X' to 'Z' do begin
              aValue[m]:=OpticalSurface[jj].SLineReal[i,m];
            end;
            RotationReal( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].SLineReal[i,m]:=aValue[m];
            end;

            for m:='X' to 'Z' do begin
              OpticalSurface[jj].MLineReal[i,m]:=OpticalSurface[jj].MLineReal[i,m]+aStock[m];
              OpticalSurface[jj].SLineReal[i,m]:=OpticalSurface[jj].SLineReal[i,m]+aStock[m];
            end;

          end;
          for i:=1 to MaxOutLine do begin
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].OLineReal[i,m]:=OpticalSurface[jj].OLineReal[i,m]-aStock[m];
            end;

            for m:='X' to 'Z' do begin
              aValue[m]:=OpticalSurface[jj].OLineReal[i,m];
            end;
            RotationReal( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              OpticalSurface[jj].OLineReal[i,m]:=aValue[m];
            end;

            for m:='X' to 'Z' do begin
              OpticalSurface[jj].OLineReal[i,m]:=OpticalSurface[jj].OLineReal[i,m]+aStock[m];
            end;
          end;
        end else begin
          for i:=1 to MaxCurveLine do begin
            for m:='X' to 'Z' do begin
              FocusPlane.MLineReal[i,m]:=FocusPlane.MLineReal[i,m]-aStock[m];
              FocusPlane.SLineReal[i,m]:=FocusPlane.SLineReal[i,m]-aStock[m];
            end;
            for m:='X' to 'Z' do begin
              aValue[m]:= FocusPlane.MLineReal[i,m];
            end;
            RotationReal( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              FocusPlane.MLineReal[i,m]:=aValue[m];
            end;
            for m:='X' to 'Z' do begin
              aValue[m]:= FocusPlane.SLineReal[i,m];
            end;
            RotationReal( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
            FocusPlane.SLineReal[i,m]:=aValue[m];
            end;
            for m:='X' to 'Z' do begin
              FocusPlane.MLineReal[i,m]:=FocusPlane.MLineReal[i,m]+aStock[m];
              FocusPlane.SLineReal[i,m]:=FocusPlane.SLineReal[i,m]+aStock[m];
            end;
          end;
          for i:=1 to MaxOutLine do begin
            for m:='X' to 'Z' do begin
              FocusPlane.OLineReal[i,m]:=FocusPlane.OLineReal[i,m]-aStock[m];
            end;
            for m:='X' to 'Z' do begin
              aValue[m]:=FocusPlane.OLineReal[i,m];
            end;
            RotationReal( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
            for m:='X' to 'Z' do begin
              FocusPlane.OLineReal[i,m]:=aValue[m];
            end;
            for m:='X' to 'Z' do begin
              FocusPlane.OLineReal[i,m]:=FocusPlane.OLineReal[i,m]+aStock[m];
            end;
          end;

        end;

      end;

    end;
  end else begin
    if self.FocusPlane.tiltSwitch=True then begin
      for m:='X' to 'Z' do begin
        aStock[m]:=FocusPlane.MLineReal[(MaxCurveLine div 2)+1,m];
      end;
      aMatrix:=self.FocusPlane.popTiltMatrix;
      for i:=1 to MaxCurveLine do begin
        for m:='X' to 'Z' do begin
          FocusPlane.MLineReal[i,m]:=FocusPlane.MLineReal[i,m]-aStock[m];
          FocusPlane.SLineReal[i,m]:=FocusPlane.SLineReal[i,m]-aStock[m];
        end;
        for m:='X' to 'Z' do begin
          aValue[m]:= FocusPlane.MLineReal[i,m];
        end;
        RotationReal( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
        for m:='X' to 'Z' do begin
          FocusPlane.MLineReal[i,m]:=aValue[m];
        end;
        for m:='X' to 'Z' do begin
          aValue[m]:= FocusPlane.SLineReal[i,m];
        end;
        RotationReal( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
        for m:='X' to 'Z' do begin
          FocusPlane.SLineReal[i,m]:=aValue[m];
        end;
        for m:='X' to 'Z' do begin
          FocusPlane.MLineReal[i,m]:=FocusPlane.MLineReal[i,m]+aStock[m];
          FocusPlane.SLineReal[i,m]:=FocusPlane.SLineReal[i,m]+aStock[m];
        end;
      end;
      for i:=1 to MaxOutLine do begin
        for m:='X' to 'Z' do begin
          FocusPlane.OLineReal[i,m]:=FocusPlane.OLineReal[i,m]-aStock[m];
        end;
        for m:='X' to 'Z' do begin
          aValue[m]:= FocusPlane.OLineReal[i,m];
        end;
        RotationReal( aValue['X'],aValue['Y'],aValue['Z'],aMatrix,1);
        for m:='X' to 'Z' do begin
          FocusPlane.OLineReal[i,m]:=aValue[m];
        end;
        for m:='X' to 'Z' do begin
          FocusPlane.OLineReal[i,m]:=FocusPlane.OLineReal[i,m]+aStock[m];
        end;
      end;
    end;
  end;
  end;

end;

procedure TOptSystem.ConvertWorldCoordinatesRealToInt(magnification:extended);
var
 k , i:integer;
 m:char;
begin

  for k:=1 to totalSurfaceNumber+1 do begin
    for i:=1 to MaxCurveLine do begin
      for m:='X' to 'Z' do begin
        self.OpticalSurface[k].MeridionalLine[i,m]:=trunc(self.OpticalSurface[k].MLineReal[i,m]*magnification);
        self.OpticalSurface[k].SagittalLine[i,m]:=trunc(self.OpticalSurface[k].SLineReal[i,m]*magnification);
      end;
    end;
    for i:=1 to MaxOutLine do begin
      for m:='X' to 'Z' do begin
        self.OpticalSurface[k].OutLine[i,m]:=trunc(self.OpticalSurface[k].OLineReal[i,m]*magnification);
      end;
    end;
  end;

  for i:=1 to MaxCurveLine do begin
    for m:='X' to 'Z' do begin
        self.FocusPlane.MeridionalLine[i,m]:=trunc(self.FocusPlane.MLineReal[i,m]*magnification);
        self.FocusPlane.SagittalLine[i,m]:=trunc(self.FocusPlane.SLineReal[i,m]*magnification);
    end;
  end;
  for i:=1 to MaxOutLine do begin
    for m:='X' to 'Z' do begin
        self.FocusPlane.OutLine[i,m]:=trunc(self.FocusPlane.OLineReal[i,m]*magnification);
    end;
  end;

end;



procedure TOptSystem.Prus( PrusOpt:TOptSystem);
var
 OldSurfaceNumber, k: integer;
begin

  OldSurfaceNumber:=self.TotalsurfaceNumber;
  self.TotalSurfaceNumber:=TotalSurfaceNumber+PrusOpt.TotalSurfaceNumber;

  for k:=OldSurfaceNumber+1 to TotalSurfaceNumber do begin
     self.OpticalSurface[k].CopyFrom( PrusOpt.OpticalSurface[k-OldSurfaceNumber] );
  end;

  for k:=OldSurfaceNumber+1 to totalSurfaceNumber+1 do begin
     self.OpticalMedium[k].CopyFrom( PrusOpt.OpticalMedium[k-OldSurfaceNumber] );
  end;

  self.FocusPlane.CopyFrom( PrusOpt.FocusPlane);
end;


procedure TOptSystem.CaluculateCoefficient(var Cof:TCof; var Ttg:TTtg);
var
  Um, Up, Hm, Hp: extended;
  AlInv, Al, Ce, Cekj,
  Ani, Anid, Aninv, Andinv, An2, An2d,
  De, Pow,
  Umd, Upd, Hq, BHq, Hdn, BHdn,Pl: extended;
  k,i: integer;
  Dldg, Hmdu:extended;
  Ala,Al2,Alb,Alc,Bnu,Cnu,
  Ce3,Ce5,Cfan,Cfbn,Cfcn:extended;
  Psi,Hm2,Hm3,Hm4,Hp2,Hp3,Hp4,
  Hmp,Hmp22,Hmp13,Hmp31,H40p,H31p,H22p,H13p,H04p: extended;
  aSpectru:TSpectru;
  aCCoff:extended;
begin
  Al:=self.FocalLength[nd];
  AlInv:=1 / Al;
  Ala:=Al;
  Al2:=Al*Al;
  Alb:=Ala*Al2;
  Alc:=Alb*Al2;

  Um:=0;
  Up:=-1;

  Um:=Um * self.OpticalMedium[0].refractiveIndex[nd];
  Up:=Up * self.OpticalMedium[0].refractiveIndex[nd];

  Hm:=1;
  Hp:=Up*(self.EntrancePupil/Al);

  Cof[self.TotalSurfaceNumber+1,7]:=Al;  //coefficientFoculLength

  for k:=1 to self.TotalSurfaceNumber do begin
    if OpticalSurface[k].ConicSwitch=True then begin
      aCCoff:=OpticalSurface[k].ConicCoefficient;
    end else begin
      aCCoff:=1.0;
    end;

    Ce:=( self.OpticalSurface[k].Curvature + self.OpticalSurface[k].AsphericalCoefficient[1]*2 )*Al;
    Cekj:=self.OpticalSurface[k].Curvature * Al;
    Ani:=self.OpticalMedium[k-1].refractiveIndex[nd];
    Anid:=self.OpticalMedium[k].refractiveIndex[nd];
    Aninv:=1/Ani;
    Andinv:=1/Anid;
    An2:=Ani*Ani;
    An2d:=Anid*Anid;

    De:=self.OpticalMedium[k].Distance*Alinv*Andinv;
    Pow:=( Anid-Ani)*Ce;

    Umd:=Um + Hm * Pow;
    Upd:=Up + Hp * Pow;

    Hq:=Hm * Ani * Ce - Um;
    BHq:=Hp * Ani * Ce - Up;
    Hdn:=Umd / An2d - Um / An2;
    BHdn:=Upd / An2d - Up / An2;
    Pl:=Pow * Aninv * Andinv;

    if self.TotalSpectruNumber>1 then begin
     case self.TotalSpectruNumber of
      2..3: aSpectru:=nC;
     else
      aSpectru:=ng;
     end;
      Dldg:=self.OpticalMedium[k].RefractiveIndex[aSpectru]*Andinv
            - self.OpticalMedium[k-1].RefractiveIndex[aSpectru]*Aninv;
      Hmdu:=Hm*Dldg;
      Ttg[k,1]:= Hmdu * Hq;
      Ttg[k,2]:= Hmdu * Bhq;
    end;

    Cof[k,1]:=Hm * (Hq*Hq) * Hdn;
    Cof[k,2]:=Hm * Hq * BHq * Hdn;
    Cof[k,3]:=Hm * (BHq*BHq) * Hdn;
    Cof[k,4]:=Pl;
    Cof[k,5]:=Hp * (BHq*BHq) * Hdn + BHq * BHdn;
    Cof[k,6]:=Cof[k,3] + Pl;

    Bnu:=0;
    Cnu:=0;
    if( (self.OpticalSurface[k].AspFlag<>0) or (self.OpticalSurface[k].ConicSwitch=True) )then begin
      if (self.OpticalSurface[k].ConicSwitch=True) then begin
        Ce3:=Ce*Ce*Ce;
        Bnu:=( aCCoff - 1 ) * Ce3;
        Ce5:=Ce*Ce*Ce*Ce*Ce;
        Cnu:=((aCCoff*aCCoff) - 1 ) * Ce5;
      end;
      if self.OpticalSurface[k].AspFlag<>0 then begin
         Cfan:=self.OpticalSurface[k].AsphericalCoefficient[1]*Ala;
         Cfbn:=self.OpticalSurface[k].AsphericalCoefficient[2]*Alb;
         Bnu:=Bnu+8*Cfbn-2*Cfan*(4*(Cfan*Cfan)+3*Ce*Cekj);
         Cfcn:=self.OpticalSurface[k].AsphericalCoefficient[3]*Alc;
         Cnu:=Cnu+16*Cfcn-2*Cfan*( 16*(Cfan*Cfan*Cfan*Cfan)+20*(Cfan*Cfan)*Ce*Cekj+5*((Ce*Cekj)*(Ce*Cekj)) );

      end;
      Psi:=(Anid-Ani)*Bnu;
      Hm2:=(Hm*Hm);
      Hm3:=Hm2*Hm;
      Hm4:=Hm3*Hm;
      Hp2:=(Hp*Hp);
      Hp3:=Hp2*Hp;
      Hp4:=Hp3*Hp;
      Hmp31:=Hm3*Hp;
      Hmp22:=Hm2*Hp2;
      Hmp13:=Hm*Hp3;
      H40p:=Hm4*Psi;
      H31p:=Hmp31*Psi;
      H22p:=Hmp22*Psi;
      H13p:=Hmp13*Psi;
      H04p:=Hp4*Psi;
      Cof[k,1]:=Cof[k,1]+H40p;
      Cof[k,2]:=Cof[k,2]+H31p;
      Cof[k,3]:=Cof[k,3]+H22p;

      Cof[k,5]:=Cof[k,5]+H31p;
    end;

    Um:=Umd;
    Up:=Upd;

    Hm:=Hm - De * Um;
    Hp:=Hp - De * Up;

  end;

  for i:=1 to 6 do begin
    Cof[TotalSurfaceNumber+1,i]:=0;
    for k:=1 to TotalSurfaceNumber do begin
      Cof[TotalSurfaceNumber+1,i]:=Cof[TotalSurfaceNumber+1,i] + Cof[k,i];
    end;
  end;
  for i:=1 to 2 do begin
    Ttg[TotalSurfaceNumber+1,i]:=0;
    for k:=1 to TotalSurfaceNumber do begin
      Ttg[TotalSurfaceNumber+1,i]:=Ttg[TotalSurfaceNumber+1,i] + Ttg[k,i];
    end;
  end;

end;


procedure TOptSystem.CalculateSphericalAberration( var SA:TSA; var OSC:TOSC);
var
  a3DRay:TD3Ray;
  aDr, aStep, aInitiDataAy, aInitiDataDxi,
  aFl:extended;
  n:TSpectru;
  k:integer;
begin

  aFl:=self.FocalLength[nd];

  if self.EffectiveAperture=0 then begin
    aDr:=self.OpticalSurface[1].Diameter;
  end else begin
    aDr:=self.EffectiveAperture;
  end;

  aStep:=aDr/2/(MaxSANumber-1);

  a3DRay:=TD3Ray.create;
try
  for n:=nd to self.LastSpectru do begin
    for k:=2 to MaxSANumber do begin
      a3DRay.Initialize;
      a3DRay.qntp:=self.EntrancePupil;
      if self.ObjectDistance<-1.0e10 then begin
        a3DRay.InitializeForSphericalAberration(aStep*(k - 1));
      end else begin
        a3DRay.InitializeForSAFiniteCase((aStep*(k - 1)), self.objectDistance,0,0);
      end;

      aInitiDataAy:=a3DRay.ay;
      aInitiDataDxi:=a3DRay.dxi;
      self.RayTraceInAspherical(a3DRay, n);

      if a3DRay.ay{ax} = NULL then begin

        //SA[n, k]:=0;
        SA[n, k]:=NULL;

        if n=nd then OSC[k]:=NULL;

      end else begin

        SA[n,k]:={abs} (a3DRay.ax-(a3DRay.dxi/a3DRay.dyi*a3DRay.ay))
                                   -{abs} ( self.BackFocus[nd]);


  {      if self.OpticalMedium[self.TotalSurfaceNumber].RefractiveIndex[nd]<0 then begin
          SA[n,k]:=-1*SA[n,k];   //E̎
        end;   } //E̎ɖ߂2022/5/11


        if n=nd then begin
          if self.ObjectDistance<-1.0e10 then begin
            OSC[k]:=(-1.0 * aInitiDataAy *aInitiDataDxi/(a3DRay.dyi)) - aFl;
            OSC[1]:=0;
          end else begin
            OSC[k]:=0;
          end;
        end;

      end;

    end;

    SA[n,1]:={abs} (self.BackFocus[n])  - {abs} (self.backFocus[nd]);
{    if self.OpticalMedium[self.TotalSurfaceNumber].RefractiveIndex[nd]<0 then begin
      SA[n,1]:=-1*SA[n,1];   //E̎
    end;   }

    if n=nd then begin
      if self.ObjectDistance<-1.0e10 then begin
        OSC[1]:=0;
      end else begin
        OSC[1]:=0;
      end;
    end;

  end;
finally
  a3DRay.Free;
end;

end;


procedure TOptSystem.CalculateAS( var MAS:TMAS; var SAS:TSAS ;InputAngle:extended);
var
  anAngle:array[1..MaxAngleNumber] of extended;
  a3DRay:TD3Ray;
  k:integer;
begin
  a3DRay:=TD3Ray.create;
try
  for k:=1 to MaxAngleNumber do begin
    if k=1 then
      anAngle[1]:=0
    else
      anAngle[k]:=InputAngle * ((k-1)/(MaxAngleNumber-1));
  end;

  for k:=2 to MaxAngleNumber do begin
    a3DRay.initialize;
    a3DRay.qntp:=self.EntrancePupil;

    self.CalculatePrincipalRay(a3DRay,anAngle[k]);

    a3DRay.asSwitch:=true;
    a3DRay.InitializeForAs;
    self.RayTraceInAspherical(a3DRay,nd);

    MAS[k]:={abs} (a3DRay.tas) - {abs} (self.BackFocus[nd]);
    SAS[k]:={abs} (a3DRay.sas) - {abs} (self.BackFocus[nd]);
  end;

  MAS[1]:=0;
  SAS[1]:=0;
finally
a3DRay.free;
end;

end;


procedure TOptSystem.CalculateDistortion( var DIS:TDIS; InputAngle:extended);
var
  anAngle:array[1..MaxAngleNumber] of extended;
  aY, aYbar:array[1..MaxAngleNumber] of extended;
  a3DRay:TD3Ray;
  k:integer;
  aBfl:extended;
  aFl:extended;
begin
  aBfl:=self.BackFocus[nd];
  aFl:=self.FocalLength[nd];
  a3DRay:=TD3Ray.create;
try
  for k:=1 to MaxAngleNumber do begin
    if k=1 then
      anAngle[1]:=0
    else
      anAngle[k]:=InputAngle * ((k-1)/(MaxAngleNumber-1));
  end;

  for k:=2 to MaxAngleNumber do begin
    aYbar[k]:= aFl * tan( degreeToRadian(anAngle[k]) );
  end;

  for k:=2 to MaxAngleNumber do begin
    a3DRay.initialize;
    a3DRay.qntp:=self.EntrancePupil;
    self.CalculatePrincipalRay(a3DRay,anAngle[k]);

    self.RayTraceInAspherical(a3DRay,nd);

    aY[k]:=a3DRay.ay + (a3DRay.dyi/a3DRay.dxi) * (aBfl - a3DRay.ax);
    if abs(aYbar[k])>1.0e-30 then
      DIS[k]:= ( abs(aY[k]) - abs(aYbar[k]) ) / abs(aYbar[k]) * 100;
  end;

  DIS[1]:=0;

finally
  a3DRay.free;
end;

end;


procedure TOptSystem.CalculateCromaticMagnification( var MAG: TMAG; InputAngle:extended);
var
  a3DRay:TD3Ray;
  aBfl,aY:extended;
  anAngle:array[1..MaxAngleNumber] of extended;
  aYnd:array[1..MaxAngleNumber] of extended;
  n:TSpectru;
  k:integer;
begin
  aBfl:=self.BackFocus[nd];

  for k:=1 to MaxAngleNumber do begin
    if k=1 then
      anAngle[1]:=0
    else
      anAngle[k]:=InputAngle * ((k-1)/(MaxAngleNumber-1));
  end;

  a3DRay:=TD3Ray.create;
try
  for k:=2 to MaxAngleNumber do begin
    a3DRay.initialize;
    a3DRay.qntp:=self.EntrancePupil;
    self.CalculatePrincipalRay(a3DRay,anAngle[k]);
    self.RayTraceInAspherical(a3DRay,nd);
    aYnd[k]:=a3DRay.ay + (a3DRay.dyi/a3DRay.dxi) * (aBfl - a3DRay.ax);
  end;

  for n:=nd to self.LastSpectru do begin
    MAG[n,1]:=0;
    for k:=2 to MaxAngleNumber do begin
      if n=nd then begin
        MAG[n,k]:=0;
      end else begin
        a3DRay.initialize;
        a3DRay.qntp:=self.EntrancePupil;
        self.CalculatePrincipalRay(a3DRay,anAngle[k]);
        self.RayTraceInAspherical(a3DRay,n);
        aY:=a3DRay.ay + (a3DRay.dyi/a3DRay.dxi) * (aBfl - a3DRay.ax);
        MAG[n,k]:=aY - aYnd[k];
      end;
    end;
  end;

finally
  a3DRay.Free;
end;

end;

end.


 